'use strict';
angular.module('bamboo.attendance').service('CardApi', function($state, $stateParams, $rootScope, ApiService, CommonService, $filter) {
  var self = this;
  this.delRecord = function(id) {
    CommonService.showDeleteConfirm(function() {
      var params = {
        id: id,
        action: 'delcardrecord'
      };
      ApiService.post('/accesscard', params).then(function(result) {
        console.log(result);
        if (result.data.success) {
          CommonService.showNoBlockSuccess('Delete Successfully!');
          $state.reload();
        } else {
          $scope.error = "Delete failed: " + result.data.error;
        }
      });
    });
  }
  this.Api = function(info, callback) {
    function handleData(data) {
      if (!callback) {
        CommonService.showNoBlockInfo($filter('trans')({
          eng: 'Update Successful!',
          chn: '更新成功'
        }));
        $state.reload();
      } else {
        callback(data);
      }
    }
    ApiService.post('/accesscard', info).then(function(result) {
      if (result.data.success) {
        handleData(result.data.data);
      } else {
        CommonService.showError($filter('trans')({
          eng: 'Update Fail!',
          chn: '无法更新！'
        }) + result.data.error);
        console.log(result);
      }
    });
  };
});