'use strict';
angular.module('bamboo.attendance').controller('attendanceListCtrl', function($scope, ApiService, $stateParams, CardApi, CommonService, ionicDatePicker, utilService, $translate) {
  var self = this;
  $scope.items = [];
  this.id = $stateParams.classid;
  this.day = new Date();
  this.appears = 0;
  self.tab = true;
  console.log($stateParams);

  self.presentCount = 0;
  self.absentCount = 0;

  function getItems() {
    var info = {
      classId: self.id,
      day: self.day.toISOString().substring(0, 10),
      action: "getclassuserdaystatus"
    };
    console.log(info);
    CardApi.Api(info, function(data) {
      self.users = data.items;
      self.appears = 0;
      console.log(self.users);
      angular.forEach(self.users, function(item) {
        item.avatarUrl = CommonService.getAvatarSrc(item);
        item.present = false;
        if (item.records) {
          if (item.records.length) {
            self.appears++;
            self.presentCount++;
          }
          angular.forEach(item.records, function(record) {
            //console.log(record);
            switch (record.type) {
              case '1':
                if (!item.in) {
                  item.in = [];
                }
                item.in.push(record);
                item.present = true;
                break;
              default:
                if (!item.out) {
                  item.out = [];
                }
                item.out.push(record);
                item.present = true;

                break;
            }
          })
        } else {
          self.absentCount++;
        }
      })
      console.log(self.users);
      self.counter = data.counter;
    });
  }

  $scope.$on('$stateChangeSuccess', function() {
    getItems();
  });

  var enMonthsList = ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"];
  var tranMonthsList = enMonthsList.map(function(m) {
    return $translate.instant(m);
  });
  var enWeeksList = ["SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"];
  var tranWeeksList = enWeeksList.map(function(m) {
    return $translate.instant(m);
  });
  console.log(tranMonthsList);

  var ipObj1 = {
    callback: function(val) { //Mandatory
      console.log('Return value from the datepicker popup is : ' + val, new Date(val));
      self.day = new Date(val);
      self.tab = true;
      getItems();
    },
    showTodayButton: true,
    titleLabel: $translate.instant('Select a Date'),
    setLabel: $translate.instant('Set'),
    todayLabel: $translate.instant('Today'),
    closeLabel: $translate.instant('Close'),
    mondayFirst: false,
    weeksList: tranWeeksList,
    monthsList: tranMonthsList,
    from: new Date(2016, 1, 1), //Optional
    to: new Date(2018, 10, 30), //Optional
    inputDate: new Date(), //Optional
    closeOnSelect: false, //Optional
    templateType: 'popup' //Optional
  };


  $scope.openDatePicker = function() {
    ionicDatePicker.openDatePicker(ipObj1);
  };
  utilService.watchScroll($scope);
});