'use strict';
angular.module('bamboo.attendance').controller('myAttendanceListCtrl', function($scope, ApiService, $stateParams, CardApi, CommonService, ionicDatePicker, loginService, utilService, $translate) {
  var self = this;
  $scope.items = [];
  this.userId = loginService.user._id;
  console.log(loginService.user);
  this.day = new Date();
  this.appears = 0;
  self.tab = true;
  console.log($stateParams);
  console.log(loginService);
  $scope.displayedItems = [];
  self.presentCount = 0;
  self.absentCount = 0;
  var page = 0;
  var pagesize = 10;

  function proceed() {
    var info = {
      start: page * pagesize,
      limit: pagesize,
      day: self.day.toISOString().substring(0, 10),
      action: "getusercardrecords",
      userId: self.userId,
    };
    console.log(info);
    var time;
    CardApi.Api(info, function(data) {
      var displayedItems = data.items;
      console.log(data);
      angular.forEach(displayedItems, function(item) {
        if (item.type == '1') {
          item.direction = 'In';
        } else {
          item.direction = 'Out';
        }
        item.present = true;

        if (item.records && item.records.length) {
          self.presentCount++;
        } else {
          self.absentCount++;
        }
      })
      if (time) {
        search.time = time;
      }
      $scope.total = data.counter;
      $scope.displayedItems = $scope.displayedItems.concat(displayedItems);
      console.log($scope.displayedItems);
      page++;
      $scope.moreData = $scope.displayedItems.length < $scope.total;

      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  $scope.getItems = function() {
    if (self.userId) {
      proceed();
    } else {
      ApiService.get('/profile/' + uid).then(function(result) {
        if (result.data.success) {
          self.userId = result.data.data.id;
          proceed();
        }
      });
    }
  }

  $scope.$on('$stateChangeSuccess', function() {
    $scope.getItems();
    console.log("--------stateChangeSuccess---------");
  });

  var enMonthsList = ["Jan", "Feb", "March", "April", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"];
  var tranMonthsList = enMonthsList.map(function(m) {
    return $translate.instant(m);
  });
  var enWeeksList = ["SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"];
  var tranWeeksList = enWeeksList.map(function(m) {
    return $translate.instant(m);
  });
  console.log(tranMonthsList);
  var ipObj1 = {
    callback: function(val) { //Mandatory
      console.log('Return value from the datepicker popup is : ' + val, new Date(val));
      self.day = new Date(val);
      self.tab = true;
      $scope.getItems();
    },
    showTodayButton: true,
    titleLabel: $translate.instant('Select a Date'),
    setLabel: $translate.instant('Set'),
    todayLabel: $translate.instant('Today'),
    closeLabel: $translate.instant('Close'),
    mondayFirst: false,
    weeksList: tranWeeksList,
    monthsList: tranMonthsList,
    from: new Date(2016, 1, 1), //Optional
    to: new Date(2018, 10, 30), //Optional
    inputDate: new Date(), //Optional
    closeOnSelect: false, //Optional
    templateType: 'popup' //Optional
  };

  $scope.openDatePicker = function() {
    ionicDatePicker.openDatePicker(ipObj1);
  };
  utilService.watchScroll($scope);
});