angular.module('bamboo.blog').service('TopicApi', function($state, $stateParams, $rootScope, ApiService, CommonService, $filter) {
    var self = this;
    this.get = function(url, callback) {
      ApiService.get(url).then(function(result) {
        if (result.data.success) {
          // console.log(result);
          callback(result.data.data);
        } else {
          console.log(result.data);
          $state.go('index.404');
        }
      });
    };

    this.post = function(url, info,callback) {
      ApiService.post(url, info).then(function(result) {
        if (result.data.success) {
          if(callback){
            callback(result.data.data);
          }else{
            CommonService.showInfo($filter('trans')('Update Successful!'));
            $state.reload();
          }
        } else {
          CommonService.showError($filter('trans')('Update Fail!'));
          console.log(result.data);
        }
      });
    };

    this.put = function(url, info) {
      ApiService.put(url, info).then(function(result) {
        if (result.data.success) {
          CommonService.showInfo($filter('trans')('Update Successful!'));
          $state.reload();
        } else {
          CommonService.showError($filter('trans')('Update Fail!'));
          console.log(result.data);
        }
      });
    };

    this.ForumApi = function(info, callback) {
      function handleData(data) {
        if (!callback) {
          //CommonService.showInfo($filter('trans')('Update Successful!'));
          $state.reload();
        } else {
          callback(data);
        }
      }
      ApiService.post('/mvtopics', info).then(function(result) {
        if (result.data.success) {
          handleData(result.data);
        } else {
          //CommonService.showError($filter('trans')('Update Fail!') + result.data.error);
          console.log(result);
        }
      });
    };
    this.BlogApi = function(info, callback) {
      function handleData(data) {
        if (!callback) {
          //CommonService.showInfo($filter('trans')('Update Successful!'));
          $state.reload();
        } else {
          callback(data);
        }
      }
      ApiService.post('/blogs', info).then(function(result) {
        if (result.data.success) {
          handleData(result.data);
        } else {
          //CommonService.showError($filter('trans')('Update Fail!') + result.data.error);
          console.log(result);
        }
      });
    };
    this.BBSApi = function(info, callback) {
      function handleData(data) {
        if (!callback) {
          CommonService.showInfo($filter('trans')('Update Successful!'));
          $state.reload();
        } else {
          callback(data);
        }
      }
      ApiService.post('/bbstopics', info).then(function(result) {
        console.log("successbbs")
        if (result.data.success) {
          handleData(result.data);
        } else {
          CommonService.showError($filter('trans')('Update Fail!') + result.data.error);
          console.log(result);
        }
      });
    };
  });
