'use strict';
angular.module('bamboo.blog').controller('BlogListCtrl', function($scope, $state, ApiService, CommonService, $stateParams, utilService) {
    var _self = this;
    console.log("---- Blog list -----");
    var _tab = $scope.tabSelect = $stateParams.tab;
    console.log($state.current.name);
    if ($state.current.name == 'app.myspace.blogs') {
        $scope.tabSelect = "My Blogs";
    }
    $scope.getText = function(string) {
        if (!string) return string;
        return string.replace(/<[^>]*>/g, "")
    }
    this.page = 0;
    //this.searchmethod = null;
    this.moreData = false;
    $scope.blogs = [];

    this.nextPage = function() {
        _self.page++;
        getInfo(_self.page);
        console.log("--- next page --");
    };
    /* pending backend support 
      this.searchByName = function(q) {
        console.log("--- by name " + q);
        _self.searchmethod = null;
        if (q) {
          _self.searchmethod = {
            searchname: q
          };
        }
        $scope.blogs = [];
        _self.page = 0;
        getInfo(0);
      };*/



    function getInfo(page) {
        var info = {
                action: "getblogs",
                start: page * 6,
                tab: _tab,
                limit: 6, // page size
            }
            //if (_self.searchmethod) {
            //info.search = _self.searchmethod;
            //info.search = tab;
            //}
        if (_tab) {
            info.search = { tab: _tab };
        }
        console.log(info);
        if ($state.current.name == 'app.myspace.blogs') {
            info.action = "getmyblogs";
            delete info.tab;
        }
        CommonService.showLoading();
        console.log(info);
        ApiService.post("/blogs", info).then(function(result) {
            CommonService.stopLoading();
            console.log("-- blog topic list ---");
            console.log(result.data);
            if (result.data.success) {
                angular.forEach(result.data.data.items, function(topic, index) {
                        //console.log(topic);
                        var author = {
                            id: topic.author_id,
                            avatar: topic.user.avatar,
                        }
                        topic.author_url = CommonService.getAvatarSrc(author);
                    })
                    //$scope.options=ApiService.blogcategory;
                $scope.blogs = $scope.blogs.concat(result.data.data.items);
                $scope.totalcounter = result.data.data.counter;
                _self.moreData = (($scope.totalcounter - $scope.blogs.length) > 0);
            }
            console.log($scope.totalcounter, $scope.blogs.length, _self.moreData);
            $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    }
    getInfo(0);
    utilService.watchScroll($scope);
});