'use strict';
angular.module('bamboo.blog').controller('BlogItemCtrl', function ($scope, $cordovaFileTransfer, $cordovaCamera, ApiService, loginService, CommonService, $stateParams, $state, TopicApi) {
  var _self = this;
  this.id = $stateParams.id;
  this.mvsubject = {};
  this._userdata = {};
  this.page = 0;
  this.replies = [];
  this.attachmentsURL = ApiService.SHOST + "/blogs/attachments/";
  if (window.cordova) {
    this.device = true;
  }
  this.getSelectionText = function() {
    var text = "";
    if (window.getSelection) {
        text = window.getSelection().toString();
    } else if (document.selection && document.selection.type != "Control") {
        text = document.selection.createRange().text;
    }
    console.log(text);
   // CommonService.showInfo(text);
  };

  this.deletereply=function (id) {
    var info={
      reply_id:id,
    }
    ApiService.post("/deleteblogreply",info).then(function(result){
       if (result.data.success) {
          $state.reload();
       }
    })
  }
  this.showdialog = function (item) {
    CommonService.showHTMLDialog($scope, item.content);
  }
  loginService.getLoginInfo().then(function () {
    var result = loginService.user;
    
    if (result) {
      _self.allowcomment=true;
      _self.userid=loginService.user._id;
      var author = {
        id: result._id,
        avatar: result.avatar,
      }
      $scope.user_avatar = CommonService.getAvatarSrc(author);
    }
  });
  ApiService.get('/blogs/' + _self.id).then(function(_result) {
  //ApiService.get('/fullblogs/' + _self.id).then(function (_result) {
    if (_result.data.success) {
      $scope.topic = _result.data.data;    
      $scope.detailName = $scope.topic.title;
      $scope.allowcomment = $scope.topic.allowcomment;
      _self.page = 0;
      _self.pageChanged(0);
      // post-processing of author's avatar
      // angular.forEach($scope.topic.replies, function (reply, index) {
      //   var author = {
      //     id: reply.author._id,
      //     avatar: reply.author.avatar,
      //   }
      //   if(reply.author_id===_self.userid){
      //     reply.deleteflag=true;
      //   }
      //   reply.content=CommonService.replaceImgLink(reply.content);
      //   reply.avatar_url = CommonService.getAvatarSrc(author);
      // })
      // console.log($scope.topic);
    } else {
      console.log(_result.data.error);
    }
  });

  this.nextPage = function() {
    _self.page++;
    _self.pageChanged(_self.page);
    console.log("--- next page --");
  };

  this.pageChanged = function(page) {
    console.log(page);
    var info = {
      tid: _self.id,
      start: page * 6,
      limit: 6,
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post('/getblogreplies', info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        console.log(result.data.data);
        _self.totalCount = result.data.data.counter;
        _self.moreData = ((_self.totalCount - _self.replies.length) > 0);
        var replys = result.data.data.items;
        // angular.forEach(replys, function(reply, index) {
        //   var author = {
        //     id: reply.user._id,
        //     avatar: reply.user.avatar,
        //   }
        //   reply.avatar_url = CommonService.getAvatarSrc(author);
        // })
        _self.replies = _self.replies.concat(replys);
      }
    });
    $scope.$broadcast('scroll.infiniteScrollComplete');
  }


  this.good = function (id, flag) {
    var params = {
      id: id,
      is_good: flag,
      action: "good",
    };
    TopicApi.BlogApi(params, function (result) {
      $state.reload();
    });
  };

  this.addReply = function (id) {
    console.log($scope.r_content);
    console.log(_self);
    if (!_self.r_content || _self.r_content.length < 10) {      
      $scope.rerror = "Reply length can not less than 10.";
      return;
    }
    var params = {
      r_content: _self.r_content,
      topic_id: id,
      files: _self.attachmentFiles
    };
    CommonService.showLoading();
    console.log(params);
    ApiService.put('/blogreplies', params).then(function (result) {
      // console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log("--- refresh ");
        $state.reload();
      } else {
        $scope.error = result.data.error;
      }
    });
  };

  var forumurl = ApiService.PSURL + '/forum/' + _self.id + "/";
  var PictureUrl = "public/" + ApiService.RES + "/forum/" + _self.id + "/"

  this.accesscamera = function (fileflag) {

    var url = '/forum/' + _self.id + "/"
    CommonService.shotandUpload(url, fileflag, function (url) {
      _self.r_content = '<img src="' + url + '" width="100%"/>';
      _self.addReply(_self.id);
    });
  }

  this.download = function(url, name) {
    console.log(url);
    CommonService.downloadFileByUrl(url, name, function() {
      console.log('success');
      CommonService.showInfo('Download Success!');
    });
  }

  this.attachmentFiles = [];
  this.replyAttachmentURL = ApiService.SHOST + "/blogs/" + _self.id + "/";
  this.videoRecord = function() {
    var url = "blogs/" + _self.id + "/";
    CommonService.recordVideoAndUpload(url, function(res) { 
      console.log(res);
      _self.attachmentFiles.push(res.result);
    });
  }

  this.addAttachment = function(fileflag) {
    var url = "blogs/" + _self.id + "/";
    CommonService.attachmentUpload(url, fileflag, function(res) {
      console.log(res);
      _self.attachmentFiles.push(res.result);
    });
  }

  this.deleteAttach = function(index) {
    CommonService.showConfirm('Are you sure to delete this attachment?',function(){
        _self.attachmentFiles.splice(index, 1);
    });    
  }

})
