'use strict';
angular.module('bamboo.class').controller('ClassGalleryCtrl', function($scope, $stateParams, loginService, ApiService, $sce, CommonService, DlgService, $ionicPopover, $localstorage) {
  var self = this;
  self.id = $stateParams.id;
  self.imgBaseUrl = ApiService.SHOST + '/advinfo/';
  var tmp = {};
  console.log(loginService.user);
  self.role = $localstorage.get('role');
  console.log(self.role);
  $scope.items = [{
      src: 'http://www.wired.com/images_blogs/rawfile/2013/11/offset_WaterHouseMarineImages_62652-2-660x440.jpg',
      sub: 'This is a <b>subtitle</b>'
    },
    // {
    //   src: 'http://www.gettyimages.co.uk/CMS/StaticContent/1391099215267_hero2.jpg',
    //   sub: '' /* Not showed */
    // },
    // {
    //   src: 'http://www.hdwallpapersimages.com/wp-content/uploads/2014/01/Winter-Tiger-Wild-Cat-Images.jpg',
    //   thumb: 'http://www.gettyimages.co.uk/CMS/StaticContent/1391099215267_hero2.jpg'
    // }
  ]
  $ionicPopover.fromTemplateUrl('app/component/photopopover.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });
  getInfo(URL);

  function getInfo() {
    ApiService.get("/album/" + self.id).then(function(result) {
      console.log(result);
      if (result.data.success) {
        self.item = result.data.data;
        tmp = angular.copy(self.item);
        if (self.item.photos) {
          self.albums = self.item.photos.map(function(o) {
            return {
              src: self.imgBaseUrl + o.photo,
              photo: o.photo,
              //   thumbUrl: self.imgBaseUrl + o.photo,
              sub: o.name,
              type: 'image'
            }
          });
          console.log(self.albums);
        }
        if (self.item.videos) {
          self.videos = self.item.videos.map(function(o) {
            return {
              src: self.getFileUrl(o.mp4),
              video: o.mp4,
              // thumbUrl: self.imgBaseUrl + o.photo,
              sub: o.name,
              type: 'video'
            }
          });
          console.log(self.videos);
        }
      }
    });
  }
  this.getFileUrl = function(fileName) {
    //return self.imgBaseUrl + encodeURI(fileName);
    return $sce.trustAsResourceUrl(self.imgBaseUrl + encodeURI(fileName));
  }
  var currentItem;
  $scope.downloadFlag = true;
  $scope.itemAction = function(item) {
    currentItem = item;
    console.log(item);
    var html = ""
    if (item.type === 'image') {
      html = "<img src='" + item.src + "' width='100%' />";
      if (item.sub) {
        html += '<strong>' + item.sub + '</strong>';
      }
      // html+="<a class='btn btn-info' ng-click='ctrl.download(item)'><i class='fa fa-download'></i></a>"
    } else if (item.type === 'video') {
      html = "<video controls width='100%' > <source src='" + item.src + "' type='video/mp4'> </video>";
    }
    CommonService.showHTMLDialog($scope, html);
  }
  $scope.download = function() {
    console.log('download');
    console.log(currentItem);
    var url = currentItem.src;
    var filename = currentItem.photo || currentItem.video;
    CommonService.downloadFileByUrl(url, filename, function() {
      console.log('success');
      CommonService.showInfo('Download Success!');
    })
  }
  //refurl, fileflag, callback, addressflag
  $scope.accesscamera = function(fileflag) {
    console.log("camera ..");
    closePopover();
    var url = "/advinfo/"
    CommonService.shotandUpload(url, fileflag, function(url) {
      console.log("-------shotandUpload---------");
      var imageName = url.split('/').pop();
      if (!self.item.photos) {
        self.item.photos = [];
      }
      self.item.photos.push({
        photo: imageName,
        name: imageName
      });
      update();
    }, true);
  }

  function update() {
    var object = {};
    for (var key in self.item) {
      if (self.item[key] != tmp[key]) {
        object[key] = self.item[key];
      }
    }
    delete object._id;
    var info = {
      action: "updatealbum",
      object: object,
      type: self.item.type,
      id: self.id,
    };
    ApiService.post('/advinfo', info).then(function(result) {
      if (result.data.success) {
        console.log(result.data.data);
        getInfo();
      }
    })
  };

  function closePopover() {
    $scope.popover.hide();
  };
});