angular.module('bamboo.class').controller('StudentClassesCtrl', function(MystudyService, loginService, $scope, $ionicPopup, ApiService, $translate) {
  var _self = this;
  MystudyService.getClassInfoForCurrentUser(function(data) {
    _self.classes = data;
    console.log(data);
  });


  function sendmessage(newmessage, userid) {
    var info = {
      action: "sendp2p",
      target: userid,
      message: newmessage,
    }
    ApiService.post('/messages', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        //CommonService.showNoBlockInfo('Send Successful!');
        console.log("OK..");

      }
    });
  }
  $scope.sendMsg = function(idx) {
    var clz = _self.classes[idx];
    if (!clz.teachers.length) {
      return;
    }
    var firstTeacher = clz.teachers[0];
    var teacherInfo = clz.teacherInfos;
    var teacherMap = _.keyBy(teacherInfo, function(o) {
      return o.loginname;
    });
    console.log(clz.teachers);
    var teacherId = teacherMap[firstTeacher]._id;
    console.log(teacherId);
    $scope.openMsgDlg(teacherId);
  }

  function tran(str) {
    if (!angular.isString(str)) {
      throw new TypeError("Parameters type should be string ")
    }

    return $translate.instant(str);
  }

  $scope.openMsgDlg = function(userid) {
    $scope.data = {
      comment: ""
    }
    $scope.clearError = function() {
        $scope.data.error = undefined;
      }
      // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'app/component/addMsgDlg.component.html',
      title: tran('Message'),
      // subTitle: 'Please use normal things',
      scope: $scope,
      buttons: [{
        text: tran('Cancel')
      }, {
        text: tran('Submit'),
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.comment) {
            console.log($scope.data.comment);
            $scope.data.error = tran("Oops,the content is empty !")
            e.preventDefault();
          } else {
            return $scope.data.comment;
          }
        }
      }]
    });
    myPopup.then(function(comment) {
      console.log('Tapped!', comment);
      if (!comment) return;
      sendmessage(comment, userid);
    });
  }
});