(function() {
  'use strict';

  angular
    .module('bamboo')
    .component('cwAudioImage', component());


  function component() {

    function componentController($timeout, ApiService, $sce) {
      var vm = this;

      vm.$onInit = function() {
        init();
      }

      function init() {
        console.log(vm.chapter)
        vm.ResUrl = ApiService.SHOST + '/lcourse/';
        vm.API = null;
        vm.onPlayerReady = function(API) {
          vm.API = API;
        };
        vm.mp4config = {
          sources: [{}],
          // theme: AppConfig.videogular_theme,
          tracks: [{
            src: "",
            kind: "subtitles",
            srclang: "en",
            label: "English",
            default: "true"
          }]
        };
        vm.mp4config.sources[0].src = vm.getMediaUrl();
        vm.mp4config.sources[0].type = 'video/mp4';
        if (vm.chapter.type == 'mp3ppt') {
          vm.mp4config.sources[0].type = 'audio/mp3';
        }
        vm.mp4config.tracks[0].src = vm.getSubUrl();
        vm.topLevelAudio = vm.audio = null;
        console.log("------------");
        console.log(vm.chapter);
        console.log(vm.mp4config);
        if (vm.chapter.type == 'mp4ppt' || vm.chapter.type == 'mp3ppt') {
          vm.uploadedImgs = vm.chapter.ppts;
          var cues = []
          console.info(vm.uploadedImgs);
          for (var i = 0; i < vm.uploadedImgs.length; i += 1) {
            // only care about linked imgs
            if (vm.uploadedImgs[i].linked) {
              var endTime = vm.uploadedImgs[i].cueDuration && (vm.uploadedImgs[i].cueTime + (parseInt(vm.uploadedImgs[i].cueDuration) || 0));
              var cue = {
                timeLapse: {
                  start: vm.uploadedImgs[i].cueTime,
                  end: endTime
                },
                onEnter: vm.onEnterCuePoint2.bind(vm),
                onLeave: vm.onLeaveCuePoint.bind(vm),
                onUpdate: vm.onLeaveCuePoint.bind(vm),
                onComplete: vm.onCompleteCuePoint.bind(vm),
                params: {
                  displayImg: vm.uploadedImgs[i],
                  index: i,
                }
              }
              if (!vm.uploadedImgs[i].cueDuration && vm.uploadedImgs[i].cueDuration != 0) {
                delete cue.timeLapse.end;
              }
              cues.push(cue);
            }
          }
          vm.mp4config.cuePoints = {};
          vm.mp4config.cuePoints.imgswitch = cues;
          //  console.log(cues);
        }
      }


      vm.onEnterCuePoint2 = function(currentTime, timeLapse, params) {
        console.log("onEnterCuePoint", currentTime, timeLapse, params);
        vm.currIndex = params.index;
        $timeout(function() {
          vm.displayImg = params.displayImg;
        }, 500);
      }

      // call back function to cuepoint
      vm.onLeaveCuePoint = function(currentTime, timeLapse, params) {}
      vm.onCompleteCuePoint = function(currentTime, timeLapse, params) {
        console.info("onCompleteCuePoint", currentTime, timeLapse, params);
        if (params.index == vm.currIndex) {
          $timeout(function() {
            vm.displayImg = null;
          }, 500);
        }
      }

      vm.onComplete = function() {
        console.log("---complete---");
        vm.displayImg = undefined;
      }

      vm.getSubUrl = function() {
        var suburl = ApiService.MEDIAPATH + '/lcourse/' + (vm.chapter.rid || vm.chapter.cid) + "/resources/" + vm.chapter.subtitle;
        if (ApiService.MEDIAPATH && vm.chapter.subtitle) {
          return $sce.trustAsResourceUrl(encodeURI(suburl));
        } else {
          return null;
        }
      }

      vm.getMediaUrl = function() {
        var fullurl = vm.ResUrl + (vm.chapter.rid || vm.chapter.cid) + "/resources/" + encodeURI(vm.chapter.content);
        console.log(fullurl);
        return $sce.trustAsResourceUrl(fullurl);
      };

      vm.getPPtPicUrl = function(url) {
        return $sce.trustAsResourceUrl(vm.ResUrl + (vm.chapter.rid || vm.chapter.cid) + "/resources/" + encodeURI(url));
      };

    }

    componentController.$inject = ['$timeout', 'ApiService', '$sce'];

    return {
      bindings: {
        chapter: "="
      },
      controller: componentController,
      controllerAs: 'ctrl',
      templateUrl: 'app/component/courseware/courseware-audio-image/courseware-audio-image.tpl.html'
    }

  }


}());