// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.config', ['ionic','ionic.native']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.config', {
    url: '/config',
    views: {
      'Content@app': {
        templateUrl: 'app/config/config.html',
        controller: "ConfigCtrl as ctrl",
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.schoolselect', {
    url: '/school',
    views: {
      'Content@app': {
        templateUrl: 'app/config/select_school.html',
        controller: 'SchoolSelectCtrl as ctrl',
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.sync', {
    url: '/sync',
    views: {
      'Content@app': {
        templateUrl: 'app/login/sync.html',
        controller: 'SyncCtrl as ctrl',
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.roleselect', {
    url: '/role',
    views: {
      'Content@app': {
        templateUrl: 'app/config/select_role.html',
        controller: 'RoleSelectCtrl as ctrl',
        //controller: 'ConfigCtrl as ctrl',
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.language', {
    url: '/language',
    views: {
      'Content@app': {
        templateUrl: 'app/config/language.html',
        controller: 'ConfigCtrl as ctrl',
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.about', {
    url: '/about',
    views: {
      'Content@app': {
        templateUrl: 'app/config/about.html'
      }
    }
  }).state('app.config.debug', {
    url: '/debug',
    views: {
      'Content@app': {
        templateUrl: 'app/config/debug.html',
        controller: 'DebugSelectCtrl as ctrl',
      }
    }
  }).state('app.config.download', {
    url: '/download',
    views: {
      'Content@app': {
        templateUrl: 'app/config/download.html',
        controller: 'DownloadCtrl as ctrl',
      }
    }
  }).state('app.config.logininfo', {
    url: '/logininfo',
    views: {
      'Content@app': {
        templateUrl: 'app/config/logininfo.html',
        controller: 'ConfigLoginCtrl as ctrl',
      }
    },
  }).state('app.config.login', {
    url: '/login',
    views: {
      'Content@app': {
        templateUrl: 'app/config/login.html',
        controller: 'ConfigLoginCtrl as ctrl',
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.register', { //state and can be not the same with package(directory reading)
    url: '/register', //html url (register.html)
    views: {
      'Content@app': {
        templateUrl: 'app/login/register.html', //full path of view(html file, should be same with the package(directory reading))
        controller: 'RegisterCtrl as ctrl'
      }
    },
    resolve: {
      school: function(ApiService) {
        return ApiService.getSchoolInfo();
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.forgot', {
    url: '/forgot/:card',
    views: {
      'Content@app': {
        templateUrl: 'app/login/forgot.html',
        controller: 'ForgetPasswordCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.subdomain', {
    url: '/subdomain',
    views: {
      'Content@app': {
        templateUrl: 'app/config/advancedomain.html',
        controller: 'AdvanceDomainCtrl as ctrl',
      },
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.domain', {
    url: '/domain',
    views: {
      'Content@app': {
        templateUrl: 'app/config/domain.html',
        controller: 'DomainCtrl as ctrl',
      },
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.config.terms', {
    url: '/terms_conditions',
    views: {
      'Content@app': {
        templateUrl: 'app/config/terms_conditions.html',
        controller: 'ConfigTermCtrl as ctrl',
      },
    }
  }).state('app.config.privacy', {
    url: '/privacy',
    views: {
      'Content@app': {
        templateUrl: 'app/config/privacy.html',
      },
    }
  }).state('app.config.changepassword', {
    url: '/changepassword/:state',
    views: {
      'Content@app': {
        templateUrl: 'app/config/changepassword.html',
        controller: 'ChangePasswordCtrl as ctrl'
      }
    },
    resolve: {
      school: function(ApiService) {
        return ApiService.getSchoolInfo();
      }
    },
  }).state('app.config.update', {
    url: '/update/:backShow',
    views: {
      'Content@app': {
        templateUrl: 'app/config/updateprofile.html',
        controller: 'UpdateProfileCtrl as ctrl'
      }
    }
  }).state('app.config.viewprofile', {
    url: '/profile',
    views: {
      'Content@app': {
        templateUrl: 'app/config/viewprofile.html',
        controller: 'UpdateProfileCtrl as ctrl'
      }
    }
  }).state('app.config.avatar', {
    url: '/avatar',
    views: {
      'Content@app': {
        templateUrl: 'app/config/newavatar.html',
        controller: 'UpdateProfileCtrl as ctrl'
      }
    }
  }).state('app.config.create', {
    url: '/create',
    views: {
      'Content@app': {
        templateUrl: 'app/login/create.html',
        controller: 'CreateUserCtrl as ctrl'
      }
    }
  })
});
