angular.module('bamboo.course').service('CourseApi', function($state, $stateParams, CommonService, $cordovaDevice, $sce, $q, $localstorage, ApiService, $ionicNavBarDelegate, $timeout) {
  var self = this;
  var _platform;
  var isAndroid = null;
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }
  this.lcApi = function(info, callback) {
    ApiService.post('/lcourses', info).then(function(result) {
      if (result.data.success) {
        if (!callback) {
          //   CommonService.showNoBlockInfo('Update Successful!');
          $state.reload();
        } else {
          callback(result.data.data);
        }
      } else {
        var error = result.data.error || '' + result.data.info || '';
        //  CommonService.showError("Update failed: " + error);
      }
    });
  };

  function lookforFile(path, file) {
    var deferred = $q.defer();
    var promise = deferred.promise;
    console.log(path);
    console.log(file);
    // console.log(window.resolveLocalFileSystemURL);
    window.resolveLocalFileSystemURL(path, function(fileSystem) {
      var reader = fileSystem.createReader();
      reader.readEntries(function(entries) {
        console.log(entries);
        var nextDirs = [];
        var foundURL;
        for (var i = 0; i < entries.length; i++) {
          var item = entries[i];
          if (item.isDirectory) {
            nextDirs.push(item.nativeURL);
          } else if (item.nativeURL.indexOf(file) > 0) {
            console.log('Found !');
            console.log(item)
            foundURL = item.nativeURL;
            break;
          }
        }
        var result = {
          file: foundURL,
          dirs: nextDirs,
        }
        console.log(result);
        deferred.resolve(result)
      }, function(err) {
        console.log('err2', err);
        deferred.reject(err);
      });
    }, function(err) {
      console.log('err1', err);
      deferred.reject(err);
    });
    return promise;
  }

  function searchFolders(folders, file, callback) {
    var promises = [];
    angular.forEach(folders, function(folder) {
      var promise = lookforFile(folder, file);
      promises.push(promise);
    });
    $q.all(promises).then(function(results) {
      console.log('results', results);
      var dirs = [];
      for (var i = 0; i < results.length; i++) {
        var result = results[i];
        if (result.file) {
          return callback(null, result.file);
        }
        if (result.dirs && result.dirs.length) {
          dirs = dirs.concat(result.dirs);
        }
        if (dirs.length) {
          return searchFolders(dirs, file, callback);
        } else {
          return callback('Not found')
        }
      }
    })
  }
  this.getMediaPath = function(id, path, dir,defaultHtml,callback) {
    if (window.cordova) {
      _platform = $cordovaDevice.platform;
      if (_platform && _platform.indexOf('iOS') > -1) {
        _systemroot = cordova.file.dataDirectory;
      } else if (_platform && _platform.indexOf('Android') > -1) {
        _systemroot = cordova.file.externalRootDirectory;
        // window.screen.orientation.lock('portrait');
      }
      var localExist = $localstorage.getResource(id);
      console.log(localExist);
      if (localExist) {
        var localfolder = _systemroot + 'bamboo/' + id;
        console.log(localfolder);
        var folders = [localfolder];
        searchFolders(folders, defaultHtml, function(err, file) {
          console.log(err);
          console.log(file);
          return callback(file);
        });
      }
    }else{
      var fullurl = path + dir + "/" + defaultHtml;
      console.log(fullurl);
      return callback(fullurl);
    }

  }
  this.getInfo = function(id, callback, flag) {
    var cid = $stateParams.cid;
    if (!self.mvid || id != self.mvid || flag) {
      var url = '/mvsubjectbrief/' + id;
      if (cid) {
        url += "/" + cid;
      }
      self.mvid = id;
      CommonService.showLoading();
      ApiService.get(url).then(function(result) {
        CommonService.stopLoading();
        self.mvsubject = result.data;
        callback(result.data);
      });
    } else if (callback) {
      console.log("reasone for pass " + self.mvid + " id : " + id);
      callback(self.mvsubject);
    }
  };
  this.mvApi = function(info, callback) {
    var lid = $stateParams.lid;
    if (!info.lid) {
      info.lid = $stateParams.lid;
    }
    CommonService.showLoading();
    ApiService.post('/mvsubjects', info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        if (!callback) {
          $state.reload();
        } else {
          callback(result.data.data);
        }
      } else {
        var error = result.data.error || '' + result.data.info || '';
        // CommonService.showError("Update failed: " + error);
      }
    });
  };

  this.rotateScreen = function() {
    isAndroid && 　window.screen.orientation.lock('landscape');
    console.log('rotateScreen');
    $timeout(function() {
      window.addEventListener('orientationchange', doOnOrientationChange);
    }, 100);
  }

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }

  this.recordUsage = function(cid,rid,mvid,_lasttime,mp4time,pass){
    var len = ((new Date()) - _lasttime)/1000;
    var _historyDetail = {};
    _historyDetail[rid] = {
      len : len,
      mp4time : mp4time,
      pass : pass
    };
    var info = {
      action: "resourceusage",
      ids: [rid],
      detail: _historyDetail,
      total: len,
      cid: cid,
      rid: rid,
      mvid: mvid,
    };
    console.log(info);
    self.mvApi(info, function(data) {
      console.log('progress updated');
    });
  }


});