angular.module('bamboo.course').controller('CourseBuyCtrl', function($scope, CommonService, $stateParams, $ionicHistory, loginService, ApiService, CourseApi, $state, $timeout, $rootScope) {
  var _self = this;
  this.id = $stateParams.cid;
  console.log("---- course CourseBuyCtrl -----");
  _self.identity = 'person';
  _self.isBill = false;
  var enterMode = 'normal';
  this.bookFlag = false;
  this.change = function() {
    console.log(_self.bookFlag);
  }

  function getInfo() {
    $scope.id = _self.id;
    CommonService.showLoading();
    ApiService.get('/course/' + _self.id).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        _self.course = result.data.data;
        console.log(_self.course);
      } else {
        $state.go('index.404');
      }
    });
  }
  getInfo();
  this.closeBuy = function() {
    $ionicHistory.goBack();
  }
  this.buyQuery = function() {
    enterMode = 'payment';
    if (_self.bookFlag) {
      if (!_self.address) {
        CommonService.showInfoWithTitle("提示", "请填写收货地址！");
        return;
      }
      if (!_self.contact) {
        CommonService.showInfoWithTitle("提示", "请输入联系人！");
        return;
      }
      if (!_self.tel) {
        CommonService.showInfoWithTitle("提示", "请输入联系电话！");
        return;
      }

      if (!(/^1[3456789]\d{9}$/.test(_self.tel))) {
        CommonService.showInfoWithTitle("提示", "联系电话有误，请重新填写");
        return ;
      }
    }
    if (_self.isBill) {
      if (_self.identity == 'company') {
        if (!_self.company) {
          CommonService.showInfoWithTitle("提示", "请输入发票抬头！");
          return;
        }
        if (!_self.billDuty) {
          CommonService.showInfoWithTitle("提示", "请输入税号！");
          return;
        }
      }
      if (!_self.email) {
        CommonService.showInfoWithTitle("提示", "请输入邮箱或者邮箱格式错误！");
        return;
      }
      if (_self.email && !(/^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/.test(_self.email)) ) {
        CommonService.showInfoWithTitle("提示", "邮箱格式不正确，请重新输入！");
        return;
      }
    }
    var info = {
      action: 'weidongPrepareSingleCourse',
      lid: _self.id,
      invoiceInfo: {
        bookFlag: _self.bookFlag,
        address: _self.address,
        contact:_self.contact,
        tel:_self.tel,
        isBill: _self.isBill, //是否需要发票
        identity: _self.identity, //请确认开票身份
        company: _self.company, //发票抬头
        billDuty: _self.billDuty, //税号
        email: _self.email //邮箱
      }
    }
    CommonService.showLoading();
    ApiService.post('/payment', info).then(function(result) {
      //CommonService.stopLoading();
      if (result.data.success && result.data.data) {
        if (result.data.data.enrolled) {
          CommonService.stopLoading();
          CommonService.showInfoWithTitle("提示", "已经注册！");
          $state.reload();
          return;
        }
        if (result.data.data.orderInfo) {
          CommonService.stopLoading();
          console.log(result.data.data.orderInfo)
          if (MainActivity) {
            console.log('-- call pay order --');
            enterMode = 'payment';
            var tinfo = result.data.data.orderInfo;
            // var str=JSON.stringify(result.data.data.orderInfo);
            $timeout(function() {
              var result = MainActivity.payOrder(tinfo, function(_result) {
                enterMode = 'success';
                console.log(_result);
                if (_result == 1 || _result == 2) {
                  CommonService.showInfoWithTitle("提示", "购买成功！");
                  // checkExsit()
                }
                console.log('go back to info page');
                $state.go('app.course.info', {
                  cid: _self.id
                });
                // checkExsit()
              }, function(err) {
                enterMode = 'fail';
                console.log('error', err)
                $state.go('app.course.info', {
                  cid: _self.id
                });
              });
            }, 10);
          } else {
            CommonService.showInfoWithTitle("提示", "不支持购买功能！");
          }
        }
      } else {
        CommonService.stopLoading();
        CommonService.showInfoWithTitle("提示", result.data.error);
        $state.go('app.course.info', {
          cid: _self.id
        });
      }
    });
  }

  function checkExsit() {
    if (loginService.user) {
      loginService.getMyProfile(true).then(function(result) {
        if (result) {
          var mycourses = result.courses;
          console.log(mycourses);
          if (mycourses.indexOf(_self.id) > -1) {
            _self.mycourseFlag = true;
            $state.go('app.course.info', {
              cid: _self.id
            });
          }
        }
      });
    }
  }
  $scope.$on('$ionicView.enter', function() {
    console.log("enter event", enterMode);
    if (enterMode == 'payment') {
      checkExsit();
    }
  })
  $scope.$on('$ionicView.beforeLeave', function() {
    console.log('lost focus')
  });
});
