angular.module('bamboo.course').controller('AudioExpChapterCtrl', function($scope, $stateParams, ApiService, CommonService, $timeout, CourseApi, $ionicPlatform, $cordovaDevice) {
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.mvId=$stateParams.mvid;
  var resUrl = this.resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';
  console.log("--- AudioExpChapterCtrl");
  var self = this;
  this.index = 0;
  this.currentPPT;
  this.slidePages = [];
  CourseApi.rotateScreen();

  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.log(result);
      $scope.chapter = self.chapter = result;
      resUrl = self.resUrl = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      self.slidePages.push({
        ntype: 'title',
      });
      if(self.chapter.convertFlag&&self.chapter.options&&self.chapter.options.country&&self.chapter.options.country.val) {
        self.selectLang = self.chapter.options.country;
      } else if(self.chapter.convertFlag&&self.chapter.options) {
        self.selectLang = self.chapter.options.language;
      } 
      angular.forEach(self.chapter.ppts, function(ppt, index) {
        ppt.ntype = "word";
        ppt.index = index;
        self.slidePages.push(ppt);
      });
      self.show(0);
    });
  }

  getInfo();

  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  var myAudio;

  this.playAudio = function(file) {
    if (!file) {
      return;
    }
    var filename = resUrl + file;
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }

  this.nextPage = function() {
    self.index++;
    if (self.index >= self.slidePages.length) {
      self.index = 0;
    }
    self.show(self.index);
  }

  this.lastPage = function() {
    self.index--;
    if (self.index < 0) {
      self.index = self.slidePages.length - 1;
    }
    self.show(self.index);
  }

  this.show = function(index) {
    self.index = index;
    self.currentPPT = self.slidePages[index];
    console.log(self.currentPPT);
    self.clear();
    self.playAudio(self.currentPPT.audio);
  }



  function playEffect(success) {
    var filename = "audio/success.mp3";
    if (!success) {
      filename = "audio/fail.mp3";
    }
    try {
      var playAudio = new Audio(filename);
      playAudio.play();
    } catch (e) {}
  }

  //.......... Audio Record .................
 function startRecognition() {
    if (!self.selectLang) {
      CommonService.showError('No Language selected!')
    }
    else 
    {
         var  _platform = $cordovaDevice.platform;
         if (_platform && _platform.indexOf('Android') > -1) {
           var langList = ["af-ZA", "id-ID", "ms-MY", "ca-ES", "cs-CZ", "da-DK", "de-DE", "en-AU", "en-CA",
              "en-001", "en-IN", "en-IE", "en-NZ", "en-PH", "en-ZA", "en-GB", "en-US", "es-AR",
              "es-BO", "es-CL", "es-CO", "es-CR", "es-EC", "es-US", "es-SV", "es-ES", "es-GT",
              "es-HN", "es-MX", "es-NI", "es-PA", "es-PY", "es-PE", "es-PR", "es-DO", "es-UY",
              "es-VE", "eu-ES", "fil-PH", "fr-FR", "gl-ES", "hr-HR", "zu-ZA", "is-IS", "it-IT",
              "lt-LT", "hu-HU", "nl-NL", "nb-NO", "pl-PL", "pt-BR", "pt-PT", "ro-RO", "sl-SI",
              "sk-SK", "fi-FI", "sv-SE", "vi-VN", "tr-TR", "el-GR", "bg-BG", "ru-RU", "sr-RS",
              "uk-UA", "he-IL", "ar-IL", "ar-JO", "ar-AE", "ar-BH", "ar-DZ", "ar-SA", "ar-KW",
              "ar-MA", "ar-TN", "ar-OM", "ar-PS", "ar-QA", "ar-LB", "ar-EG", "fa-IR", "hi-IN",
              "th-TH", "ko-KR", "cmn-Hans-CN", "cmn-Hans-HK", "cmn-Hant-TW", "yue-Hant-HK",
              "ja-JP"];
         } else {
            var langList =["nl-NL","es-MX","zh-TW","fr-FR","it-IT","vi-VN","en-ZA","ca-ES","es-CL","ko-KR",
              "ro-RO","fr-CH","en-PH","en-CA","en-SG","en-IN","en-NZ","it-CH","fr-CA","da-DK",
              "de-AT","pt-BR","yue-CN","zh-CN","sv-SE","es-ES","ar-SA","hu-HU","fr-BE","en-GB",
              "ja-JP","zh-HK","fi-FI","tr-TR","nb-NO","en-ID","en-SA","pl-PL","id-ID","ms-MY",
              "el-GR","cs-CZ","hr-HR","en-AE","he-IL","ru-RU","de-CH","en-AU","de-DE","nl-BE",
              "th-TH","pt-PT","sk-SK","en-US","en-IE","es-CO","uk-UA","es-US"];
         }
      
        // window.plugins.speechRecognition.getSupportedLanguages(function(langList){
          console.log(langList);
          console.log(self.selectLang.val);
          if(langList&&langList.indexOf(self.selectLang.val) !== -1)
          {
            var options = {
            language: self.selectLang.val,
            showPopup: true
          }
          console.log(options);
          plugins.speechRecognition.startListening(function(result){
              console.log(result);
              if(result&&result[0])
              {
                $timeout(function() {
                  self.interim_transcript = result[0];
                  if(self.interim_transcript.toLowerCase()==self.currentPPT.word.toLowerCase().trim())
                  {
                    self.final_result = "Correct";
                    playEffect(true);
                  }
                  else
                  {
                    self.final_result = "Wrong";
                    playEffect(false);
                  }
                }, 10);
              }
              // By default just 5 options
              // ["Hello","Hallou", "Hellou" ...]
          }, function(err){
              console.log(err);
              CommonService.showInfo('Nothing decoded');
          }, options);
        } else {
           CommonService.showInfo('Language is not supported');
        }
      // },function(error){
      //   console.log(error);
      // });
   }
}

this.clear = function() {
  self.final_result = false;
  self.interim_transcript="";
}

  this.checkPermission = function() {
    console.log('checkPermission');
    if (window.cordova) {
      console.log('cordova');
      $ionicPlatform.ready(function() {
        window.plugins.speechRecognition.isRecognitionAvailable(function(available){
            if(!available){
                console.log("Sorry, not available");
            }

            // Check if has permission to use the microphone
            window.plugins.speechRecognition.hasPermission(function (isGranted){
                if(isGranted){
                    startRecognition();
                }else{
                    // Request the permission
                    window.plugins.speechRecognition.requestPermission(function (){
                        // Request accepted, start recognition
                        startRecognition();
                    }, function (err){
                        console.log(err);
                        CommonService.showError(err);
                    });
                }
            }, function(err){
                console.log(err);
                CommonService.showError(err);
            });
        }, function(err){
            console.log(err);
            CommonService.showError(err);
        });
      });      
    }
  }

});