angular.module('bamboo.course').controller('ChapterItemCtrl', function($scope, $timeout, $sce, CommonService, $ionicNavBarDelegate, $cordovaDevice, $stateParams, ApiService, CourseApi, $state) {
  var self = this;
  this.cid = $stateParams.cid;
  this.mvId=$stateParams.mvid;
  this.id = $stateParams.rid;
  // this.chapter = {};
  console.log("---- chapter Item -----");
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  var _last_rid;
  var _lasttime = new Date();
  var _historydetail = {};
  var _total = 0;
  var _platform;
  var isAndroid = null;
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    var completed = (self.chapter&&self.chapter.type=='pdf')?true:false;
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime,0,completed);
  });

  function youtube_id_from_url(url) {
    var id = '';
    url = url.replace(/(>|<)/gi, '').split(/(vi\/|v=|\/v\/|youtu.be\/|\/embed\/)/);
    if (url[2] !== undefined) {
      id = url[2].split(/[^0-9a-z_]/i);
      id = id[0];
    } else {
      id = url;
    }
    return id;
  };

  function getMediaUrl(url) {
    console.log(encodeURI(url));
    return $sce.trustAsResourceUrl(encodeURI(url));
  };

  function getAudioUrl(url) {
    console.log(self.mediapath + url);
    return $sce.trustAsResourceUrl(self.mediapath + encodeURI(url));
  };
  this.getPPtPicUrl = getAudioUrl;

  function openPDF(url) {
    console.log(url);
    window.open(encodeURI(url), '_system', 'location=no');
    console.log("in appp open");
  }
  this.barFlag = true;

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }

  function rotateScreen() {
    isAndroid && 　window.screen.orientation.lock('landscape');
    console.log('rotateScreen');
    $timeout(function() {
      window.addEventListener('orientationchange', doOnOrientationChange);
    }, 100);
  }
  this.toggleBar = function() {
    if (self.barFlag) {
      self.barFlag = true;
      $ionicNavBarDelegate.showBar(true);
    } else {
      self.barFlag = true;
      $ionicNavBarDelegate.showBar(true);
    }
  }

  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.dir(result);
      self.chapter = result;
      if (self.chapter.cid != self.cid) {
        self.mediapath = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      }
      switch (self.chapter.type) {
        case 'html':
          //self.chapter.content = self.chapter.content.replace('"//', '"http://');
          self.chapter.content = CommonService.replaceImgLink(self.chapter.content);
          break;
        case 'vimeo':
          rotateScreen();
          var strings = self.chapter.content.split('vimeo.com/');
          var idstr = strings[1].split('/');
          var id = idstr[idstr.length - 1];
          // self.mediaurl = $sce.trustAsResourceUrl("https://player.vimeo.com/video/" + id);
          self.mediaurl = $sce.trustAsResourceUrl(ApiService.HOST + "/vimeovideo/" + id);
          console.log(ApiService.HOST + "/vimeovideo/" + id);
          break;
        case 'youtube':
          rotateScreen();
          $scope.youtubeid = youtube_id_from_url(self.chapter.content);
          console.log($scope.youtubeid);
          var fullurl = "https://www.youtube.com/embed/" + $scope.youtubeid + '?&controls=1&showinfo=0';
          self.mediaurl = getMediaUrl(fullurl);
          console.log(self.mediaurl);
          break;
        case 'pdf':
          //rotateScreen();
          console.log("--- pdf ---");
          // console.dir(window.cordova);
          $scope.pdfUrl = encodeURI(self.mediapath + self.chapter.content);
          /*if(isAndroid){
            openPDF(self.mediapath + self.chapter.content);
          } */
          // self.mediaurl = getMediaUrl(self.mediapath + self.chapter.content);
          break;
        case 'mp4':
        case 'mp4ppt':
          rotateScreen();
          CommonService.showLoadingWithSpinner(' ', 5000);
          $timeout(function() {
            console.log("--- mp4 ---");
            // window.addEventListener('orientationchange', doOnOrientationChange);
            self.mediaurl = getMediaUrl(self.mediapath + self.chapter.content);
            // console.log(self.mediaurl);
          }, 3000);
          break;
        case 'flash':
          rotateScreen();
          self.mediaurl = self.mediapath + self.chapter.content;
          var flashplayer = angular.element(document.querySelector('#flashplayer'))
          flashplayer.html('<object  type="application/x-shockwave-flash" width="100%" height="500" data="' + self.mediaurl + '" ></object>');
          break;
      }
      if (self.chapter.audio) {
        self.audiourl = getAudioUrl(self.chapter.audio);
        console.log(self.audiourl);
      }
    });
  }
  getInfo();
  var pptindex = 0;

  function getYoutubeUrl(newId) {
    return $sce.trustAsResourceUrl('//www.youtube.com/embed/' + newId + '?&controls=1&showinfo=0&autoplay=1');
  };
  $scope.resulticon = {
    Correct: "icon ion-checkmark correct_ans",
    Wrong: "icon ion-close wrong_ans",
    Miss: "icon ion-alert missedQuestion"
  };
  self.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  $scope.showVideo = function(title, url, isOnlineVideo) {
    if (url.indexOf('//') > -1) {
      url = url.replace(new RegExp("//"), 'http://');
    }
    console.log(url);
    var videos = [];
    if (isOnlineVideo) {
      url = url + '?autoplay=1&showinfo=0';
    }
    var thisVideo = {
      caption: title,
      type: isOnlineVideo ? 'tube' : 'notTube',
      url: $sce.trustAsResourceUrl(encodeURI(url))
    }
    videos.push(thisVideo);
    console.log(videos);
    CommonService.showVideo($scope, videos);
  }
  $scope.showWiki = function(_key) {
    console.log(_key);
    var info = {
      action: 'getwikibykey',
      key: _key,
      sid: ApiService.gid,
    };
    //console.log(info);
    ApiService.post('/wiki', info).then(function(result) {
      //console.log(result);
      if (result.data.success) {
        $scope.wiki = result.data.wiki;
        var _pages = $scope.wiki.pages;
        //console.log(self.videos);
        var _wk = [];
        var mindex = 0;
        var sindex = 0;
        for (var i = 0; i < _pages.length; i++) {
          var page = _pages[i];
          if (!page.level || page.level == 0) {
            mindex++;
            sindex = 0;
          } else {
            sindex++;
          }
          var idx = '' + mindex;
          if (sindex > 0) {
            idx += '-' + sindex;
          }
          var info = {
            title: page.title,
            content: page.content,
            level: page.level,
            idx: idx,
          };
          _wk.push(info);
        }
        $scope.pages = _wk;
        $scope.photourl = ApiService.SHOST + "/public/" + ApiService.RES + "/wiki/" + ApiService.gid + '/' + $scope.wiki.key + "/" + $scope.wiki.photo;
        CommonService.showWiki($scope);
      }
    });
  };
  this.getvideoUrl = function(url) {
    //var _url = url;
    return $sce.trustAsResourceUrl(self.mediapath + encodeURI(url));
  };
});