angular.module('bamboo.course').controller('ChooseAnswerChapterCtrl', function($scope, $stateParams, ApiService, CourseApi, $sce) {
  var self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  var resUrl = this.resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';  
  this.page = 0;
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  CourseApi.rotateScreen();
  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      console.log(result);
      if(result){
        self.chapter = result;
        self.answers = _.shuffle(angular.copy(self.chapter.options));
        self.submitted = false;
        self.page = (!self.chapter.audio&&!self.chapter.photo)?1:0;
        if(self.chapter.audio){
          assignAudio();
        }
      }
    });
  } 
  getInfo();

  function assignAudio() {
    var audio = angular.element('#playAudio');
    self.playAudio = $sce.trustAsResourceUrl(resUrl + encodeURI(self.chapter.audio));
    console.log(self.playAudio);
    if (audio[0]) {
      audio[0].src = self.playAudio;
    }
  }

  this.closeAudio = function() {
    var audio = angular.element('#playAudio');
    if (audio[0]) {
      audio[0].pause();
    }
    self.playAudio = null;
  }

  this.nextPage = function(){
    if(self.chapter.audio){
      self.closeAudio();
    }
    self.page=self.page?0:1;
  }

  this.previousIndex = -1;
  $scope.onDropCompleteInput = function(data, evt, item) {
    if(self.previousIndex!=-1)
    {
      self.chapter.ppts[self.previousIndex].dropAns = item.dropAns;
      console.log(self.previousIndex);
    }  else if(item.dropAns){
      item.dropAns.drop = false;
    }
    item.dropAns = data;
    data.drop = true;
    self.previousIndex = -1;
  }

  $scope.onDragSuccess1 = function (data, evt, index) {
      console.log(index);
      self.previousIndex = index;
  }

  this.submit = function(){
    self.ans = 0;
    angular.forEach(self.chapter.ppts,function(ppt,idx){
      if(ppt.dropAns&&ppt.ans==ppt.dropAns.text){
        self.ans+=1;
        ppt.match = true;
      } else if(ppt.dropAns) {
        ppt.match = false;
      }
    });
    console.log(self.chapter.ppts);
    self.submitted = true;
  }

  this.reset = function(){
    self.answers = _.shuffle(angular.copy(self.chapter.options));
    angular.forEach(self.chapter.ppts, function(ppt, index) {
        ppt.dropAns = {};
        ppt.match = null;
    });
    self.submitted = false;
  }

  var myAudio;
  this.audioPlay = function(file) {
    if (!file) {
      return;
    }
    var filename = resUrl + file;
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }

});