angular.module('bamboo.course').controller('DragFillChapterCtrl', function($scope, $stateParams, ApiService, CourseApi, $sce) {
  var self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  var resUrl = this.resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/'; 
  
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  CourseApi.rotateScreen();
  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      console.log(result);
      if(result){
        self.chapter = result;
        self.answers = _.shuffle(angular.copy(self.chapter.options));
        //angular hack to html decode
        // let decoded = angular.element('<div />').html(self.chapter.description).text();
        // $scope.decodedData = $sce.trustAsHtml(decoded);
        var regex = /<br\s*[\/]?>/gi;
        var encodedStr = self.chapter.description.replace(regex, "########");
        console.log(encodedStr);
        var parser = new DOMParser;
        var dom = parser.parseFromString(
            '<!doctype html><body>' + encodedStr,
            'text/html');
        var regex1 = /########/gi;
        $scope.decodedData = dom.body.textContent.replace(regex1, "<br />");
        console.log($scope.decodedData);

        self.submitted = false;
        initTargetList();
      }
    });
  } 
  getInfo();

  function initTargetList() {
    $scope.multiTargetList = [];
    for (var i = 0; i < self.chapter.options.length; i++) {
      $scope.multiTargetList.push({});
    }
  }

  this.submit = function(){
    self.ans = 0;
    angular.forEach(self.chapter.options,function(val,idx){
      if($scope.multiTargetList[idx]&&val.text==$scope.multiTargetList[idx].text){
        $scope.multiTargetList[idx].match = true;
        self.ans+=1;
      } else {
        $scope.multiTargetList[idx].match = false;
      }
    });
    self.submitted = true;
  }

  this.reset = function(){
    self.answers = _.shuffle(angular.copy(self.chapter.options));
    initTargetList();
    self.submitted = false;
  }
  
}).filter('filterStringSpace', function() {
    return function(input) {
      var len = input.length || 0;
      return new Array((len*2) + 1).join('&nbsp;');
    }
});