angular.module('bamboo.course').controller('EWordChapterCtrl', function($scope, $stateParams, ApiService, CourseApi, $filter) {
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.mvId=$stateParams.mvid;
  var resUrl = this.resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';
  console.log("--- EWordChapterCtrl");
  var self = this;
  this.index = 0;
  this.currentPPT;
  this.slidePages = [];
  this.pptTestCount = 0;
  CourseApi.rotateScreen();
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.log(result);
      $scope.chapter = self.chapter = result;
      resUrl = self.resUrl = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      self.slidePages.push({
        ntype: 'title',
      });      
      angular.forEach(self.chapter.ppts, function(ppt, index) {
        ppt.ntype = "word";
        ppt.index = index;
        self.slidePages.push(ppt);
      });
      if(self.chapter.options&&self.chapter.options.single){
        angular.forEach(angular.copy(self.chapter.ppts), function(ppt, index) {
          if (ppt.test) {
            self.pptTestCount+=1;
            ppt.ntype = "matchsingle";
            ppt.index = self.slidePages.length+1;
            ppt.refIndex = index;
            ppt.ans = {};
            self.slidePages.push(ppt);
          }
        });
      } else {
        if(!self.chapter.options.dropOption||self.chapter.options.dropOption=='default'||self.chapter.options.dropOption=='image'){
          self.slidePages.push({
            ntype: 'matchpic'
          });
        }
        if(self.chapter.options.dropOption=='default'||self.chapter.options.dropOption=='text'){
          self.slidePages.push({
            ntype: 'matchtext'
          });
        }
      }      
      self.show(0);
    });
  }

  getInfo();

  var myAudio;

  this.playAudio = function(file) {
    if (!file) {
      return;
    }
    var filename = resUrl + file;
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }

  this.nextPage = function() {
    self.index++;
    if (self.index >= self.slidePages.length) {
      self.index = 0;
    }
    self.show(self.index);
  }

  this.lastPage = function() {
    self.index--;
    if (self.index < 0) {
      self.index = self.slidePages.length - 1;
    }
    self.show(self.index);
  }

  this.show = function(index) {
    self.index = index;
    self.currentPPT = self.slidePages[index];
    console.log(self.currentPPT);
    if(self.currentPPT.ntype=='word') {
      self.playAudio(self.currentPPT.audio);
    } else if(self.currentPPT.ntype=='matchpic'||self.currentPPT.ntype=='matchtext'||self.currentPPT.ntype=='matchsingle') {
      generateArrays();
      self.result = false;
    }
  }

  function playEffect(success) {
    var filename = "audio/success.mp3";
    if (!success) {
      filename = "audio/fail.mp3";
    }
    try {
      var playAudio = new Audio(filename);
      playAudio.play();
    } catch (e) {}
  }

  function random() {
    return .5 - Math.random();
  }
  
  function generateArrays() {
    var source = [];
    var dragOption = (self.chapter.options&&self.chapter.options.dragOption)?self.chapter.options.dragOption:0;
    if(self.currentPPT.ntype=='matchsingle'&&dragOption<=self.pptTestCount){
      var currentOpt = angular.copy(self.currentPPT);
      currentOpt.index = 0;
      currentOpt.selected = false;
      currentOpt.selectIndex = -1;
      currentOpt.drag = true;
      source.push(currentOpt);
      angular.forEach(angular.copy(self.chapter.ppts), function(ppt, index) {
        if(dragOption!=1&&ppt.test&&index!=self.currentPPT.refIndex){
           dragOption = dragOption-1;
           ppt.index = dragOption;
           ppt.selected = false;
           ppt.selectIndex = -1;
           ppt.drag = true;
           source.push(ppt);
        }
      });
    } else {
      angular.forEach(angular.copy(self.chapter.ppts), function(ppt, index) {
        if (ppt.test) {
          ppt.index = index;
          ppt.selected = false;
          ppt.selectIndex = -1;
          ppt.drag = true;
          source.push(ppt);
          console.log(ppt);
        }
      });
   }
   console.log(angular.copy(source));

    var source1 = [];
    if(self.currentPPT.ntype=='matchsingle'){
      var ppt = angular.copy(self.currentPPT);
      ppt.index = 0;
      ppt.selected = false;
      ppt.selectIndex = -1;
      ppt.ans = {};
      ppt.drag = true;
      ppt.match = '';
      source1.push(ppt);
    } else {
      angular.forEach(self.chapter.ppts, function(ppt, index) {
        if (ppt.test) {
          ppt.index = index;
          ppt.selected = false;
          ppt.selectIndex = -1;
          ppt.ans = {};
          ppt.drag = true;
          ppt.match = '';
          source1.push(ppt);
          console.log(ppt);
        }
      });
    }
    self.forAarray = [];
    self.forAarray = self.forAarray.concat(source1);
    self.forAarray.sort(random);    
    $scope.list5 = [];
    $scope.list5 = $scope.list5.concat(source);
    $scope.list5.sort(random);
    console.log(self.forAarray);
    console.log($scope.list5);
    self.finish = false;
    self.pass = false;
  }

  this.previousIndex = -1;
  $scope.onDropCompleteInput = function(data, evt, item) {
    if(self.previousIndex!=-1)
    {
      self.forAarray[self.previousIndex].ans = item.ans;
      console.log(self.previousIndex);
    }    
    item.ans = data;
    self.previousIndex = -1;
    hideAudio();
    checkAns();
  }

  $scope.onDragSuccess1 = function (data, evt, index) {
      //console.log(item);
      console.log(index);
      self.previousIndex = index;
      //item.ans = data;
  }

  function hideAudio()
  { 
    var obj = $filter('filter')($scope.list5, {drag: false}, true);
    angular.forEach(obj, function(arr, index) {
      arr.drag = true;
    });   
    angular.forEach(self.forAarray, function(arr, index) {
      if(arr.ans.audio){
        var index = $scope.list5.indexOf(arr.ans);
        //console.log('-------------'+index);
        $scope.list5[index].drag = false;
      }
    });
  }

  function checkAns()
  {
    var right = 0;
    var wrong = 0;
    self.result = false;
    console.log(self.forAarray);
    angular.forEach(self.forAarray, function(arr, index) {
      console.log(arr.ans.index);      
      if(arr.ans.index||arr.ans.index===0)
      { 
        if(arr.ans.index==arr.index){
          arr.match = true;
          right++;
        } else {
          arr.match = false;
          wrong++;
        }
      } else {
        arr.match = '';
      }
    });
    if(self.forAarray.length==right) {
      playEffect(true);
      self.result = true;
    } else if(self.forAarray.length==(right+wrong)) {
      playEffect(false);
    }
  }

  this.refresh = function(){
    self.result = false;
    generateArrays();  
  }

});