angular.module('bamboo.course').controller('IdiomChapterCtrl', function($scope, $sce, $timeout, $stateParams, ApiService, CourseApi, $cordovaDevice) {
  this.cid = $stateParams.cid;
  console.log("--- IdiomChapterCtrl");
  var self = this;
  var resUrl = this.resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';
  this.index = 0;
  self.id = $stateParams.rid;
  CourseApi.rotateScreen();

  this.init = function(chapter) {   
    self.chapter = chapter||{};
    self.chapter.mainppts = [];
    self.chapter.extppts = [];
    angular.forEach(self.chapter.ppts, function(item) {
      if (item.ext) {
        self.chapter.extppts.push(item);
      } else {
        self.chapter.mainppts.push(item);
      }
    })
    if (!self.chapter.size) {
      self.chapter.size = 2;
    }
      self.playChapterAudio();
  }

  var _platform;
  var _systemroot;
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    if (window.cordova) {
      _platform = $cordovaDevice.platform;
      if (_platform && _platform.indexOf('iOS') > -1) {
        _systemroot = cordova.file.dataDirectory;
      } else if (_platform && _platform.indexOf('Android') > -1) {
        _systemroot = cordova.file.externalRootDirectory;
      }
    }
    _lasttime = new Date();
  });

  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  function getInfo() {
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      //CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      resUrl = self.resUrl = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      self.init(result);
    });
  }
  getInfo();

  this.mode = 'all';
  this.hints = {
    'explain': '解释',
    'example': '例句',
    'english': '英文',
    'similar': '同义词',
    'source': '来源',
    'opposite': '反义词',
  }
  this.currentPPT;
  this.code;
  var myAudio;
  var playoutTimer;
  this.playWord = function(word) {
    var file = self.chapter.libs[word];
    if (!file) {
      return;
    }

    var filename = resUrl + file;
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }
  this.index = 0;
  $scope.$on("$destroy", function() {
    self.index = 999;
    if (myAudio) {
      myAudio.pause();
    }
  });

  function playNext() {
    console.log(self.index);
    if (self.index < self.chapter.ppts.length) {

      var word = self.chapter.ppts[self.index].word;
      console.log(word);
      self.playWord(word);
      self.currentPPT = self.chapter.ppts[self.index];
      if (playoutTimer) {
        $timeout.cancel(playoutTimer);
        playoutTimer = null;
      }
      playoutTimer = $timeout(playNext, 3500);
    }
    self.index++;
  }
  this.playAll = function() {
    self.index = 0;
    playNext();
  }

  this.mediaRec = "";  
  this.recordingMode = 'idle';
  this.recordAudio = function() {
    var src = _systemroot + 'bamboo/' +"myrecording.mp3";
    self.recordingMode = "recording";
    self.mediaRec = new Media(src, function(){
      self.playbacksrc = src;
    }, function(err){
      CommonService.showError(err);
      console.log(err);
    });
    // Record audio
    self.mediaRec.startRecord();
  }

  this.stopRecording = function(){
    self.recordingMode = 'idle';
    self.mediaRec.stopRecord();
  }

  this.playbacksrc;

  this.playUserAudio = function() {
    if (!self.playbacksrc) {
      return;
    }
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(self.playbacksrc);
      myAudio.play();
    } catch (e) {}
  }
  this.playChapterAudio = function() {
    self.index = 999;
    if (!self.chapter.audio) {
      self.index = 0;
      playNext();
      return;
    }
    var filename = resUrl + self.chapter.audio;
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(filename);
      myAudio.play();
    } catch (e) {}
  }
  this.playAudio = function(charactor, ppt) {
    self.currentPPT = ppt;
    console.log(charactor, ppt);
    self.index = 100;
    if (!ppt || !ppt.word) {
      return;
    }
    console.log(ppt);
    var word = ppt.word;
    self.charactor = charactor;
    self.code = charactor.charCodeAt(0).toString(16);

    // var file = self.chapter.libs[ppt.word];
    if (self.mode == 'single') {
      if (!charactor) {
        return;
      }
      word = charactor;
    }
    self.playWord(word);

  };

  this.get24Placement = function(index) {
    var remainder = index % 2;
    if (remainder == 0) {
        return 'right';
    } else if (remainder == 1) { 
        return 'left'; 
    }
  }

  this.get34Placement = function(index) {
    var remainder = index % 3;
    if (remainder == 0) {
      if (index < 3) {
        return 'bottom-left';
      } else {
        return 'right';
      }
    } else if (remainder == 1) {
      if (index < 3) {
        return 'bottom-right';
      } else {
        return 'left';
      }
    } else if (remainder == 2) {
      if (index < 3) {
        return 'bottom-right';
      } else {
        return 'left';
      }
    }
  }

  this.get44Placement = function(index) {
    var remainder = index % 4;
    if(index>15){
      return 'top';
    }
    if (remainder == 0) {
      if (index < 4) {
        return 'bottom-left';
      } else {
        return 'right';
      }
    } else if (remainder == 1) {
      if (index < 4) {
        return 'bottom-left';
      } else {
        return 'right';
      }
    } else if (remainder == 2) {
      if (index < 4) {
        return 'bottom-right';
      } else {
        return 'left';
      }
    } else if (remainder == 3) {
      if (index < 4) {
        return 'bottom-right';
      } else {
        return 'left';
      }
    }
  }



});