angular.module('bamboo.course').controller('IVChapterCtrl', function ($scope, $ionicHistory, $timeout, $window, $sce, CommonService, $ionicNavBarDelegate, $cordovaDevice, $stateParams, ApiService, CourseApi, $state, ExamQuestionBizModel, $ionicScrollDelegate, CoursewareService, ExamService, $filter) {
  var _self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.contentInfo = [];
  this.wheight = $window.innerWidth - 24 + 'px';
  console.log("---- chapter Item -----");
  this.mediapath = ApiService.SHOST + '/lcourse/' + _self.cid + '/resources/';
  this.pptpicurl = this.pptaudiourl = this.ResUrl = ApiService.SHOST + '/lcourse/';
  var _platform;
  var isAndroid = null;
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }
  var startTime = new Date();
  //$ionicHistory.removeBackView();
  // CourseApi.rotateScreen();
  // window.addEventListener('orientationchange', doOnOrientationChange);
  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = false;
        $ionicNavBarDelegate.showBar(false);
        break;
      default:
        console.log('portrait');
        //  self.barFlag = true;
        // $ionicNavBarDelegate.showBar(true);
        break;
    }
  }
  CommonService.stateInfo = {
    complete: false
  }
  this.typename = {
    'single': 'Multiple Choice',
    'fill': 'Fill In Blanks',
    'mfill': '填空题',
    'tof': 'True or False',
    'multiple': 'Multiple Answers',
    'mquestion': 'Question Group',
    "short": 'Essay Question',
    "typing": 'Typing',
    "mDD": 'Multiple Match D&D',
    "info": 'Information',
    "sDD": 'Single Match D&D',
    "order": 'Order Question'
  };
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  this.API = null;
  this.onPlayerReady = function(API) {
    _self.API = API;
  };
  this.goBackPage = function() {
    //$ionicHistory.goBack();
    //$state.go('app.course.home',({ cid: _self.cid}))
    leaveFunctions();
    $ionicHistory.goBack(-2);
  }

  function getInfo() {
    _self.displayImg = null;
    var info = {
      action: 'getresource',
      id: _self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.log(result);
      _self.chapter = result;
      _self.mp4config = {
        sources: [{}],
        // theme: AppConfig.videogular_theme,
        tracks: [{
          src: "",
          kind: "subtitles",
          srclang: "en",
          label: "English",
          default: "true"
        }],
        cuePoints: {},
      };
      _self.resulticon = {
        Correct: "fa fa-check",
        Wrong: "fa fa-times",
        'Not Attempted': "fa fa-times miss"
      };
      if (_self.chapter.subType == 'youtube') {
        _self.mp4config.sources[0].src = $sce.trustAsResourceUrl(encodeURI(_self.chapter.content));
      } else if (_self.chapter.subType == 'vimeo') {
        _self.mp4config.sources[0].src = $sce.trustAsResourceUrl(encodeURI(_self.chapter.content));
      } else {
        _self.mp4config.sources[0].src = _self.getMediaUrl();
        _self.mp4config.sources[0].type = 'video/mp4';
        _self.mp4config.tracks[0].src = _self.getSubUrl();
      }
      _self.flag = false;
      console.log(_self.chapter);
      _self.configVideo();
    });
  }
  this.configVideo = function() {
    _self.chapter.ppts = _.sortBy(_self.chapter.ppts, function(o) {
      return o.cueTiming
    });
    console.log(_self.chapter.ppts);
    if (_self.chapter.ppts && _self.chapter.ppts.length > 0) {
      var cues = [];
      var qIds = [];
      _self.contentInfo = _self.chapter.ppts;
      for (var i = 0; i < _self.contentInfo.length; i++) {
        if (_self.contentInfo[i].linked) {
          if (_self.contentInfo[i].type == 'question') {
            qIds.push(_self.contentInfo[i].id);
          }
          var cue = {
            timeLapse: {
              start: _self.contentInfo[i].cueTiming,
              end: _self.contentInfo[i].cueTiming + 0.5
            },
            onEnter: _self.onEnterCuePoint.bind(_self),
            onComplete: _self.onCompleteCuePoint.bind(_self),
            params: {
              displayQuiz: _self.contentInfo[i],
              index: i
            }
          };
          cues.push(cue);
        }
      }
      _self.mp4config.cuePoints.quizSwitch = cues;
      (qIds.length > 0) && getQuestionInfo(qIds);
    }
  }

  function getQuestionInfo(qIds) {
    var obj = {
      action: 'getPaperByQuestionIds',
      ids: qIds
    }
    console.log(obj);
    ExamService.api(obj, function(result) {
      console.log(result);
      if (result) {
        var qstList = result.qstList;
        angular.forEach(qstList, function(item) {
          item = ExamService.convertQ(item);
          var arr = $filter('filter')(_self.contentInfo, {
            id: item._id
          });
          if (arr.length != 0) {
            var index = _self.contentInfo.indexOf(arr[0]);
            _self.contentInfo[index].quest = item;
          }
        });
        console.log(_self.contentInfo);
      }
    });
  }
  this.onEnterCuePoint = function(currentTime, timeLapse, params) {
    console.log('.............enter cuepoint...........', currentTime, timeLapse);
    _self.currIndex = params.index;
    if (!_self.contentInfo[_self.currIndex].quest) {
      console.log('the question is not existed!');
      return;
    }
    _self.submit = false;
    if (_self.API.currentState == 'play') {
      _self.API.pause();
    }
    $timeout(function() {
      _self.flag = true;
      $ionicScrollDelegate.scrollTop();
      _self.contentInfo[params.index].viewed = true;
      _self.displayQuiz = params.displayQuiz;
      if (_self.displayQuiz.type == 'question') {
        $scope.question = _self.displayQuiz.quest;
      }
      console.log(_self.displayQuiz);
      _self.show_overlay = false;
    }, 100);
  }
  this.onCompleteCuePoint = function(currentTime, timeLapse, params) {
    console.info("onCompleteCuePoint", currentTime, timeLapse, params);
    if (params.index == _self.currIndex) {
      $timeout(function() {
        _self.flag = false;
        _self.displayQuiz = null;
      }, 500);
    }
  }
  this.getSubUrl = function() {
    var suburl = ApiService.MEDIAPATH + '/lcourse/' + (_self.chapter.rid || _self.chapter.cid) + "/resources/" + _self.chapter.subtitle;
    if (ApiService.MEDIAPATH && _self.chapter.subtitle) {
      return $sce.trustAsResourceUrl(encodeURI(suburl));
    } else {
      return null;
    }
  }
  this.getPPtPicUrl = function(url) {
    var suburl = ApiService.MEDIAPATH + '/lcourse/' + (_self.chapter.rid || _self.chapter.cid) + "/resources/" + encodeURI(url);
    return $sce.trustAsResourceUrl(suburl);
  };
  this.getMediaUrl = function() {
    var fullurl = _self.ResUrl + (_self.chapter.rid || _self.chapter.cid) + "/resources/" + encodeURI(_self.chapter.content);
    return $sce.trustAsResourceUrl(fullurl);
  };
  this.continueVideo = function() {
    _self.flag = false;
    _self.API.play();
  }
  this.goBack = function(item) {
    console.log(item);
    var cueTiming = item.cueTiming || 0;
    _self.submit = false;
    _self.flag = true;
    _self.API.seekTime(cueTiming - 0.5, false);
    _self.API.play();
  }
  getInfo();
  this.videoCanPlay = function() {
    if (!toRecord) {
      return;
    }
    if (!_self.flag) {
      return;
    }
    $timeout(function() {
      _self.API.play();
    }, 500);
  };
  var toRecord = true;
  this.onVideoFinished = function() {
    console.log("-------------------   video play finished : ");
    _self.complete = true;
    CommonService.stateInfo.complete = true;
    CommonService.stopListen();
    $timeout(function() {
      CommonService.showInfo('视频已结束，将返回到课程内容列表。', function(_res) {
        CommonService.stopListen();
        window.screen.orientation.unlock();
        //$state.go('app.course.home', { cid: $stateParams.cid, mvid: $stateParams.mvid, rid: $stateParams.rid }); // TODO: 预留参数用于还原页面
        $ionicHistory.goBack(-2);
      });
    }, 10);
  };

  var hitFifteenMark = false;

  this.onUpdateTimeMp4 = function(currentTime, duration) {
    console.log(duration - currentTime)
    if((duration - currentTime) < 15 && !hitFifteenMark && !videoComplete) {
      hitFifteenMark = true;
      videoComplete = true;
      var mp4time = (_self.API.totalTime != _self.API.currentTime) ? parseInt(_self.API.currentTime / 1000) : 0;
      CourseApi.recordUsage(_self.cid, _self.id, $stateParams.mvid, _lasttime, mp4time, videoComplete);
      addLearningRecord();
      console.log("15 seconds mark hit!")
    }
  }

  this.submitQuiz = function(q) {
    var result = ExamService.calQuestionResult(q.quest);
    console.log(result);
    q.correct = result.correct;
    q.answered = true;
  }
  this.retest = function(q) {
    q.answered = false;
    console.log(q);
    if (q.quest) {
      var _q = q.quest;
      if (_q._options) {
        angular.forEach(_q._options, function(opt) {
          delete opt.selection;
        });
      }
      delete _q.select;
      delete _q.selection;
    }
  }
  this.reply = function() {
    _self.submit = false;
    _self.saved = false;
    _self.flag = false;
    _self.displayQuiz = null;
    $scope.question = {};
    _self.contentInfo = [];
    _self.API.seekTime(0, false);
    getInfo();
  }
  var _lasttime = new Date();
  var videoComplete = false;
  var toRecord = true;
  $scope.$on("$ionicView.enter", function(scopes, states) {
    hitFifteenMark = false;
    _lasttime = new Date();
    console.log("--- enter ---");
    toRecord = true;
    CourseApi.rotateScreen();
    window.addEventListener('orientationchange', doOnOrientationChange);
    getRecordUsage();
    CommonService.startListen(function() {
      console.log('abnormal time out');
      toRecord = false;
      if (_self.API && _self.API.currentState == 'play') {
        console.log('need to stop any playing media 1');
        _self.API.stop();
      }
      $state.go('^.^');
    }, 120);
  });

  var leaveCalled=false;

  function leaveFunctions(){
    if(leaveCalled){
      return;// avoid double called
    }
    console.log('leaveFunctions');

    leaveCalled=true;
    CommonService.stopListen();

    if (!toRecord) {
      if (_self.API && _self.API.currentState == 'play') {
        console.log('need to stop any playing media 2');
        _self.API.stop();
      }
      return;
    }
    console.log("-- $ionicView.beforeLeave leave 2");

    if(!hitFifteenMark && !videoComplete) {
      var mp4time = (_self.API.totalTime != _self.API.currentTime) ? parseInt(_self.API.currentTime / 1000) : 0;
      CourseApi.recordUsage(_self.cid, _self.id, $stateParams.mvid, _lasttime, mp4time, videoComplete);
      addLearningRecord();
    }

    if (_self.API && _self.API.currentState == 'play') {
      console.log('need to stop any playing media 3');
      _self.API.stop();
    }
  }
  $scope.$on('$ionicView.beforeLeave', function() {
    console.log("-- $ionicView.beforeLeave leave 1");
    leaveFunctions();
    window.screen.orientation.unlock();
  });

  function addLearningRecord() {
    var info = {
      lid: _self.cid,
      mid: $stateParams.mvid,
      rid: _self.id,
      //   photo: _self.imageFile,
      action: 'addCourseLearningRecord',
      type: "exit",
      vtime: parseInt(_self.API.currentTime/1000),
      start: startTime,
      // deviceId: $cordovaDevice.uuid,
    }
    if (videoComplete) {
      info.complete = true;
    }
    console.log(_self.API);
    // var mp4time = (_self.API.totalTime != _self.API.currentTime) ? parseInt(_self.API.currentTime / 1000) : 0;
    var len = parseInt(((new Date()) - startTime) / 1000);
    info.len = len;
    if (CommonService.getSysSleepLen()) {
      info.len = info.len - CommonService.getSysSleepLen();
      console.log("len reduced ", CommonService.getSysSleepLen());
    }
    // info. = startTime;
    console.log(info);
    CourseApi.mvApi(info, function(result) {
      console.log(result);
      //  $state.go("^");
    });
  }

  function getRecordUsage() {
    var info = {
      action: "getResourceUsage",
      rid: _self.id
    };
    console.log(info);
    CourseApi.mvApi(info, function(data) {
      console.log(data);
      if (data && data.mp4time) {
        console.log("--1");
        //CommonService.showConfirm('Will you resume the previous progress?', function(_res) {
        _self.API.seekTime(data.mp4time, false);
        //});
      }
      if (data && data.pass) {
        $timeout(function() {
          _self.complete = true;
        }, 500);
      }
    });
  }
});
