angular.module('bamboo.course').controller('MP3PPTCtrl', function($scope, $timeout, $sce, CommonService, $ionicNavBarDelegate, $cordovaDevice, $stateParams, ApiService, CourseApi, $state) {
  var self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  // this.chapter = {};
  console.log("---- chapter Item -----");
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  this.pptpicurl = this.pptaudiourl = this.ResUrl = ApiService.SHOST + '/lcourse/';
  var _platform;
  CourseApi.rotateScreen();
  window.addEventListener('orientationchange', doOnOrientationChange);

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }
  var isAndroid = null;
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }
  var _lasttime = new Date();
  var videoComplete = false;
  var toRecord = true;
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
    toRecord = true;
    getRecordUsage();
    CommonService.startListen(function() {
      console.log('abnormal time out');
      toRecord = false;
      console.log(self.API.currentState);
      if (self.API && self.API.currentState == 'play') {
        console.log('need to stop any playing media 1');
        self.API.stop();
      }
      $state.go('^.^');
    }, 120);
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CommonService.stopListen();
    console.log(self.API.currentState);
    if (self.API && self.API.currentState == 'play') {
      console.log('need to stop any playing media 2');
      self.API.stop();
    }
    if (!toRecord) {
      return;
    }
    var mp4time = (self.API.totalTime != self.API.currentTime) ? parseInt(self.API.currentTime / 1000) : 0;
    CourseApi.recordUsage(self.cid, self.id, $stateParams.mvid, _lasttime, mp4time, videoComplete);
  });
  this.getMediaUrl = function() {
    var fullurl = self.ResUrl + (self.chapter.rid || self.chapter.cid) + "/resources/" + encodeURI(self.chapter.content);
    // flashplayer.html('<object type="application/x-shockwave-flash" width="100%" height="450" data="' + fullurl + '" > </object>');
    return $sce.trustAsResourceUrl(fullurl);
  };
  this.getSubUrl = function() {
    // var suburl=ApiService.MEDIAPATH+ '/lcourse/'+ ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + $scope.chapter.subtitle;
    var suburl = ApiService.MEDIAPATH + '/lcourse/' + (self.chapter.rid || self.chapter.cid) + "/resources/" + self.chapter.subtitle;
    console.log(suburl);
    if (ApiService.MEDIAPATH && self.chapter.subtitle) {
      return $sce.trustAsResourceUrl(encodeURI(suburl));
    } else {
      return null;
    }
  }
  this.getPPtPicUrl = function(url) {
    //   console.log(url);
    return $sce.trustAsResourceUrl(self.ResUrl + (self.chapter.rid || self.chapter.cid) + "/resources/" + encodeURI(url));
  };

  function getAudioUrl(url) {
    console.log(self.mediapath + url);
    return $sce.trustAsResourceUrl(self.mediapath + encodeURI(url));
  };
  self.API = null;
  this.onPlayerReady = function(API) {
    self.API = API;
  };
  this.videoCanPlay = function() {
    console.log("--- can play ?");
    if (!toRecord) {
      return;
    }
    $timeout(function() {
      self.API.play();　
    }, 500);
  };
  this.audioPptFinish = function() {
    self.displayImg = undefined;
  }
  this.onVideoFinished = function() {
    console.log("-------------------   video play finished : ");
    videoComplete = true;
    CommonService.stateInfo.complete=true;
  };

  function getInfo() {
    self.displayImg = null;
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      if (self.chapter.cid != self.cid) {
        self.mediapath = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      }
      self.mp4config = {
        sources: [{}],
        // theme: 'css/videogular-themes-default/videogular.min.css',
        tracks: [{
          src: "",
          kind: "subtitles",
          srclang: "en",
          label: "English",
          default: "true"
        }]
      };
      self.mp4config.sources[0].src = self.getMediaUrl();
      self.mp4config.sources[0].type = 'video/mp4';
      if (self.chapter.type == 'mp3ppt') {
        self.mp4config.sources[0].type = 'audio/mp3';
      }
      self.mp4config.tracks[0].src = self.getSubUrl();
      $scope.topLevelAudio = $scope.audio = null;
      if (self.chapter.type == 'mp4ppt' || self.chapter.type == 'mp3ppt') {
        self.uploadedImgs = self.chapter.ppts;
        var cues = []
        console.info(self.uploadedImgs);
        for (var i = 0; i < self.uploadedImgs.length; i += 1) {
          // only care about linked imgs
          //var endTime = getNextLinkCuePoint(i,_self.uploadedImgs);
          //var endTime = null;
          //console.log(endTime);
          if (self.uploadedImgs[i].linked) {
            var endTime = self.uploadedImgs[i].cueDuration && (self.uploadedImgs[i].cueTime + (parseInt(self.uploadedImgs[i].cueDuration) || 0));
            if (self.uploadedImgs[i].forever) {
              endTime = self.uploadedImgs[i].cueDuration;
            }
            var cue = {
              timeLapse: {
                start: self.uploadedImgs[i].cueTime,
                end: endTime
              },
              onEnter: self.onEnterCuePoint2.bind(self),
              onLeave: self.onLeaveCuePoint.bind(self),
              onUpdate: self.onLeaveCuePoint.bind(self),
              onComplete: self.onCompleteCuePoint.bind(self),
              params: {
                displayImg: self.uploadedImgs[i],
                index: i,
              }
            }
            if (!self.uploadedImgs[i].cueDuration && self.uploadedImgs[i].cueDuration != 0) {
              delete cue.timeLapse.end;
            }
            cues.push(cue);
          }
        }
        self.mp4config.cuePoints = {};
        self.mp4config.cuePoints.imgswitch = cues;
        //  console.log(cues);
      }
      if (self.chapter.audio) {
        self.audiourl = getAudioUrl(self.chapter.audio);
        console.log(self.audiourl);
      }
    });
  }
  getInfo();
  this.onLeaveCuePoint = function(currentTime, timeLapse, params) {}
  this.onCompleteCuePoint = function(currentTime, timeLapse, params) {
    console.info("onCompleteCuePoint", currentTime, timeLapse, params);
    if (params.index == self.currIndex) {
      $timeout(function() {
        self.displayImg = null;
      }, 500);
    }
  }
  this.onEnterCuePoint2 = function(currentTime, timeLapse, params) {
    console.log("onEnterCuePoint", currentTime, timeLapse, params);
    self.currIndex = params.index;
    $timeout(function() {
      self.displayImg = params.displayImg;
    }, 500);
  }

  function getRecordUsage() {
    var info = {
      action: "getResourceUsage",
      rid: self.id
    };
    console.log(info);
    CourseApi.mvApi(info, function(data) {
      if (data && data.mp4time) {
        self.API.seekTime(data.mp4time, false);　
      }
    });
  }
});