angular.module('bamboo.course').controller('Mp4QuizChapterCtrl', function($scope, $timeout, $sce, CommonService, $ionicNavBarDelegate, $cordovaDevice, $stateParams, ApiService, CourseApi, $state, ExamQuestionBizModel, CoursewareService) {
  var _self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  // this.chapter = {};
  console.log("---- chapter Item -----");
  this.mediapath = ApiService.SHOST + '/lcourse/' + _self.cid + '/resources/';
  this.pptpicurl = this.pptaudiourl = this.ResUrl = ApiService.SHOST + '/lcourse/';
  var _platform;
  var isAndroid = null;
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }
 // CourseApi.rotateScreen();
 // window.addEventListener('orientationchange', doOnOrientationChange);

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  this.API = null;
  this.onPlayerReady = function(API) {
    _self.API = API;
  };

  function getInfo() {
    _self.displayImg = null;
    var info = {
      action: 'getresource',
      id: _self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.log(result);
      _self.chapter = result;
      _self.mp4config = {
        sources: [{}],
        // theme: AppConfig.videogular_theme,
        tracks: [{
          src: "",
          kind: "subtitles",
          srclang: "en",
          label: "English",
          default: "true"
        }],
        cuePoints: {},
      };
      _self.resulticon = {
        Correct: "fa fa-check",
        Wrong: "fa fa-times",
        'Not Attempted': "fa fa-times miss"
      };
      _self.mp4config.sources[0].src = _self.getMediaUrl();
      _self.mp4config.sources[0].type = 'video/mp4';
      _self.mp4config.tracks[0].src = _self.getSubUrl();
      _self.topLevelAudio = _self.audio = null;
      _self.flag = false;
      _self.typename = {
        'single': 'Select one answer',
        'fill': 'Fill in the blank',
        'mfill': 'Fill in all the blanks',
        'tof': 'True or False',
        'multiple': 'Multiple Choices, You can select more than one answer!',
      };
      console.log(_self.chapter);
      _self.configVideo();
    });
  }
  this.configVideo = function() {
    _self.chapter.ppts = _.sortBy(_self.chapter.ppts, function(o) {
      return o.cueTiming
    });
    console.log(_self.chapter.ppts);
    if (_self.chapter.ppts && _self.chapter.ppts.length > 0) {
      var cues = [];
      var lastCuePot;
      for (var i = 0; i < _self.chapter.ppts.length; i++) {
        // config videogular for one cue point
        var j = i - 1;
        var lastCueTime = (j >= 0) ? cues[j].timeLapse : undefined;
        var cue = {
          timeLapse: {
            // avoid the 0 start time, videogular will trigger call even if the video is not playing
            // and if the cueTiming is missing, set the cue point to -1 to make sure it will not show
            start: _self.chapter.ppts[i].cueTiming === 0 ? 0.1 : (_self.chapter.ppts[i].cueTiming - 1) || -1
          },
          //onEnter: this.onEnterCuePoint.bind(this),
          //onLeave   : this.onEnterCuePoint.bind(this),
          onComplete: _self.onEnterCuePoint.bind(this),
          params: {
            displayQuiz: _self.chapter.ppts[i],
            lastCue: lastCuePot ? lastCuePot.timeLapse : undefined
          }
        };
        console.log(lastCuePot);
        lastCuePot = cue;
        cues.push(cue);
      }
      _self.mp4config.cuePoints.quizSwitch = cues;
    }
  }
  this.onEnterCuePoint = function(currentTime, timeLapse, params) {
    console.log('.............enter cuepoint...........', timeLapse);
    _self.lastCuePointTime = params.lastCue ? params.lastCue.end : 0;
    console.log(_self.lastCuePointTime);
    if (params.displayQuiz.linked) {
      // pause video play if needed
      $timeout(function() {
        console.log("---1", _self.API.currentState);
        if (_self.API.currentState == 'play') {
          console.log("---2");
          _self.API.pause();
        }
        _self.flag = true;
        _self.displayQuizs = _self.getQuestionsByQuiz(params.displayQuiz);
        _self.displayQuizName = params.displayQuiz.quizname;
        console.log(_self.displayQuizs);
      }, 300);
    }
    // disable show overlay
    $timeout(function() {
      _self.show_overlay = false;
    }, 0);
  }
  this.getQuestionById = function(id) {
    for (var q in _self.chapter.questions) {
      if (_self.chapter.questions[q].q_id == id) {
        return _self.chapter.questions[q];
      }
    }
    return null;
  }
  this.getQuestionsByQuiz = function(quiz) {
    var ques = [];
    angular.forEach(quiz.questions, function(val, idx) {
      var q = _self.getQuestionById(val);
      ExamQuestionBizModel.convertQ(q);
      if (q != null) {
        ques.push(q);
      }
    });
    return ques;
  }
  this.getSubUrl = function() {
    var suburl = ApiService.MEDIAPATH + '/lcourse/' + (_self.chapter.rid || _self.chapter.cid) + "/resources/" + _self.chapter.subtitle;
    if (ApiService.MEDIAPATH && _self.chapter.subtitle) {
      return $sce.trustAsResourceUrl(encodeURI(suburl));
    } else {
      return null;
    }
  }
  this.getMediaUrl = function() {
    var fullurl = _self.ResUrl + (_self.chapter.rid || _self.chapter.cid) + "/resources/" + encodeURI(_self.chapter.content);
    return $sce.trustAsResourceUrl(fullurl);
  };
  this.replay = function() {
    ExamQuestionBizModel.clearresult(_self.displayQuizs);
    _self.flag = false;
    _self.submit = false;
    console.log("reply");
    _self.API.seekTime(_self.lastCuePointTime, false);
    _self.API.play();
  }
  this.submitChapterTestForVideoQuiz = function(quiz) {
    //chapter, questions, _historydetail, views
    CoursewareService.checkresult(_self.chapter, quiz, _self._historydetail, _self.views);
    _self.chapter.showresult = true;
    _self.submit = true;
  }
  this.continueVideo = function() {
    ExamQuestionBizModel.clearresult(_self.displayQuizs);
    _self.flag = false;
    _self.submit = false;
    _self.API.play();
  }
  this.retestChapter = function(quiz) {
    ExamQuestionBizModel.clearresult(quiz);
    _self.chapter.showresult = false;
    _self.submit = false;
  }
  getInfo();
  this.videoCanPlay = function() {
    if (!toRecord) {
      return;
    }
    if (!_self.flag) {
      return;
    }
    $timeout(function() {
      _self.API.play();　
    }, 500);
  };
  var toRecord = true;
  this.onVideoFinished = function() {
    console.log("-------------------   video play finished : ");
    videoComplete = true;
    _self.complete=true;
    CommonService.stateInfo.complete=true;
  };
  var _lasttime = new Date();
  var videoComplete = false;
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
    getRecordUsage();
    toRecord = false;
    CommonService.startListen(function() {
      console.log('abnormal time out');
      toRecord = false;
      console.log(_self.API.currentState);
      if (_self.API && _self.API.currentState == 'play') {
        console.log('need to stop any playing media 1');
        _self.API.stop();
      }
      $state.go('^.^');
    }, 120);
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CommonService.stopListen();
    if (self.API && self.API.currentState == 'play') {
      console.log('need to stop any playing media 2');
      _self.API.stop();
    }
    if (!toRecord) {
      return;
    }
    var mp4time = (_self.API.totalTime != _self.API.currentTime) ? parseInt(_self.API.currentTime / 1000) : 0;
    CourseApi.recordUsage(_self.cid, _self.id, $stateParams.mvid, _lasttime, mp4time, videoComplete);
  });

  function getRecordUsage() {
    var info = {
      action: "getResourceUsage",
      rid: _self.id
    };
    console.log(info);
    CourseApi.mvApi(info, function(data) {
      if (data && data.mp4time) {
        console.log("--1");
        //CommonService.showConfirm('Will you resume the previous progress?', function(_res) {
          _self.API.seekTime(data.mp4time, false);　
        //});
      }
    });
  }
});
