angular.module('bamboo.course').controller('PPTsCtrl', function($scope, $timeout, $sce, CommonService, $ionicNavBarDelegate, $cordovaDevice, $stateParams, ApiService, CourseApi, $state, $filter) {
  var self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  // this.chapter = {};
  console.log("---- chapter Item -----");
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  this.pptpicurl = this.pptaudiourl = this.ResUrl = ApiService.SHOST + '/lcourse/';
  this.mvsubject = {};
  this.chapters = [];
  this.seekTimeFlag = false;
  var _platform;
  var isAndroid = null;
  var _last_rid;
  var _historydetail = {};
  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      isAndroid = true;
    }
  }

  
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };

  this.barFlag = true;

  function doOnOrientationChange() {
    console.log("--- rotation detected --");
    switch (window.orientation) {
      case -90:
      case 90:
        console.log('landscape');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
      default:
        console.log('portrait');
        self.barFlag = true;
        $ionicNavBarDelegate.showBar(true);
        break;
    }
  }

  function rotateScreen() {
    isAndroid && 　window.screen.orientation.lock('landscape');
    console.log('rotateScreen');
    $timeout(function() {
      window.addEventListener('orientationchange', doOnOrientationChange);
    }, 100);

  }
  function getInfo() {
    self.displayImg = null;
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      console.log(result);
      $scope.chapter = self.chapter = result;
      if (self.chapter.cid != self.cid) {
         self.mediapath = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      }
      self.topAudioPlaying = false;
      // save the top level audio if any
      $scope.topLevelAudio = self.chapter.audio;
      rotateScreen();
      showppt(0);
    });
  }
  getInfo();

  this.getPPtPicUrl = function(url) {
    console.log(url);
    return $sce.trustAsResourceUrl(self.ResUrl + ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + encodeURI(url));
  };

  var pptindex = 0;
  function showppt(i) {
    console.log($scope.chapter);
    if(i==$scope.chapter.ppts.length-1){
      pptsComplete = true;
    }
    if ($scope.chapter && $scope.chapter.type == 'ppts' && $scope.chapter.ppts && $scope.chapter.ppts.length > 0) {
      $scope.ppt = $scope.chapter.ppts[i];
      console.log($scope.ppt);
      //dealy to update video resource
      pptindex = i;
      //config mp4 type page for video player
      if ($scope.ppt.type == 'mp4') {
        // if mp4 file exist
        if ($scope.ppt.mp4) {
          $scope.ppt.mp4config = {};
          $scope.ppt.mp4config.sources = [{}];
          $scope.ppt.mp4config.sources[0].src = self.getPPtPicUrl($scope.ppt.mp4);
          $scope.ppt.mp4config.sources[0].type = 'video/mp4';
          // and if subtitle file exist
          if ($scope.ppt.mp4sub) {
            $scope.ppt.mp4config.tracks = [{}];
            $scope.ppt.mp4config.tracks[0].src = self.getPPtPicUrl($scope.ppt.mp4sub);
            $scope.ppt.mp4config.tracks[0].kind = "subtitles";
            $scope.ppt.mp4config.tracks[0].srclang = "en";
            $scope.ppt.mp4config.tracks[0].label = "English";
            $scope.ppt.mp4config.tracks[0].default = 'true';
          }
        }
      } else if ($scope.ppt.type == 'youtube') {
         $scope.ppt.youtubeurl=CommonService.getYoutubeLinkfromUrl($scope.ppt.content);
      } else {
        if ($scope.ppt.type == 'test') {
          angular.forEach($scope.ppt.questions, function(q, index) {
            // console.log('q to convert', index);
            convertQ(q);
          })
        }
        console.log($scope.ppt);
        var _mp4 = $scope.ppt.mp4;
        $scope.ppt.mp4 = null;
        $timeout(function() {
          $scope.ppt.mp4 = _mp4;
        }, 300);
      }
      if ($scope.ppt) {
        $scope.audio = $scope.ppt.audio;
      }
      $scope.pptindex = pptindex;
    }
    // console.log($scope.ppt);
    if ($scope.audio && $scope.ppt.type != 'mp4') {
      self.topAudioPlaying = false;
      setTimeout(showAudio, 100); // play individual ppt audio if available
    } else if ($scope.topLevelAudio && self.topAudioPlaying == false && $scope.ppt.type != 'mp4') {
      self.topAudioPlaying = true;
      setTimeout(showTopAudio, 100); // play toplevel ppt audio if available
    }
    showFlash();
  }

  function convertQ(q) {
    if (q.ver && q.ver == 1) {
      return q;
    }
    console.log(q);
    q.ver = 1;
    q._options = [];
    switch (q.type) {
      case 'single':
        if (q.options && q.options.length) {
          angular.forEach(q.options, function(opt, index) {
            var info = opt;
            if (opt.text == q.ok_answer) {
              info.correct = true;
            }
            q._options.push(info);
          })
        } else {
          angular.forEach(q.answer, function(text, index) {
            var info = {
              text: text,
              correct: true,
            }
            q._options.push(info);
          })
          angular.forEach(q.references, function(text, index) {
            var info = {
              text: text,
            }
            q._options.push(info);
          })
        }
        delete q.ok_answer;
        break;
      case 'multiple':
        if (q.options && q.options.length) {
          angular.forEach(q.options, function(opt, index) {
            q._options.push(opt);
          })
        } else {
          angular.forEach(q.answer, function(text, index) {
            var info = {
              text: text,
              correct: true,
            }
            q._options.push(info);
          })
          angular.forEach(q.references, function(text, index) {
            var info = {
              text: text,
            }
            q._options.push(info);
          })
        }
        break;
      case 'fill':
      case 'mfill':
        angular.forEach(q.answer, function(text, index) {
          var info = {
            texts: [{
              text: text
            }],
          }
          q._options.push(info);
        })
        angular.forEach(q.options, function(val, index) {
          var _text = {
            text: val.text,
          }
          var info = {
            texts: [_text],
          }
          q._options.push(info);
        })
        break;
      case 'tof':
        if (q.tof_answer) {
          var info = {
            correct: q.tof_answer,
          }
          q._options.push(info);
          delete q.tof_answer;
        } else if (q.answer) {
          var info = {
            correct: q.answer[0],
          }
          q._options.push(info);
        }
        // console.log(q);
        break;
    }
    delete q.answer;
    delete q.references;
    delete q.options;
    return q;
  }
  
  function showFlash() {
    if ($scope.chapter.type == 'flash') {
      $timeout(function() {
        var flashplayer = angular.element('#flashplayer');
        var fullurl = self.ResUrl + ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + encodeURI($scope.chapter.content);
        flashplayer.html('<object type="application/x-shockwave-flash" width="100%" height="' + ($scope.maxFlag ? 600 : 450) + '" data="' + fullurl + '" > </object>');
      }, 50)
    } else if ($scope.chapter.type == 'ppts' && $scope.ppt.type == 'flash') {
      $timeout(function() {
        var flashplayer = angular.element('#flashppt');
        var fullurl = self.ResUrl + ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + $scope.ppt.flash;
        flashplayer.html('<object type="application/x-shockwave-flash" width="100%" height="' + ($scope.maxFlag ? 600 : 450) + '" data="' + fullurl + '" > </object>');
      }, 50)
    }
  }

  this.getvideoUrl = function(url) {
    //var _url = url;
    return $sce.trustAsResourceUrl(self.ResUrl + ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + encodeURI(url));
  };

  this.submitPPTTest = function(index) {
    if ($scope.ppt.type != 'test') {
      return console.log('wrong type ppt');
    }
    //console.log($scope.ppt.questions);
    var ppt = angular.copy($scope.ppt);
    checkresult(ppt.questions);
    ppt.showresult = true;
    $scope.ppt = ppt;
  };

  var _lasttime = new Date();
  var pptsComplete = false;
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });

  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime,0,pptsComplete);
  });

  function checkresult(questions) {
    //  console.log(questions);
    var correct = 0;
    var wrong = 0;
    for (var i = 0; i < questions.length; i += 1) {
      var q = questions[i];
      checkQResult(q);
      if (q.judgement == 'Correct') {
        correct++;
      } else {
        wrong++;
      }
    }
    if (!wrong) {
      pptsComplete = true;
    }
  }

  function checkQResult(q) {
    switch (q.type) {
      case 'single':
        // console.log(q)
        angular.forEach(q._options, function(opt, index) {
          // console.log(opt);
          // console.log(index);
          if (opt.correct && index == q.select) {
            q.judgement = 'Correct';
            q.selection = opt.text;
            console.log('correct');
          }
        })
        if (q.judgement != 'Correct') {
          if (q.select || q.select == 0) {
            q.judgement = 'Wrong';
            q.selection = q._options[q.select].text;
          } else {
            q.judgement = 'Not Attempted';
          }
        }
        break;
      case 'multiple':
        var opts = q._options;
        console.log("--------multiple---------");
        // console.log(opts);
        var _selected = 0;
        var _correct = true;
        for (var j = 0; j < opts.length; j += 1) {
          var opt = opts[j];
          console.log(opt);
          if (opt.selection) {
            _selected++;
          }
          if ((opt.selection && opt.correct) || (!opt.selection && !opt.correct)) {} else {
            _correct = false;
            console.log('wrong selection');
          }
        }
        console.log(_selected);
        console.log(_correct);
        if (_selected) {
          if (_correct) {
            q.judgement = 'Correct';
          } else {
            q.judgement = 'Wrong';
          }
        } else {
          q.judgement = 'Not Attempted';
        }
        break;
      case 'tof':
        console.log("--------tof---------");
        console.log(q);
        q.tof_answer = q._options[0] && q._options[0].correct;
        if (!q.selection) {
          q.judgement = 'Not Attempted';
        } else if (q.selection == 'true' && q.tof_answer) {
          q.judgement = 'Correct';
        } else if (q.selection == 'false' && !q.tof_answer) {
          q.judgement = 'Correct';
        } else {
          q.judgement = 'Wrong';
        }
        break;
      case 'fill':
      case 'mfill':
        console.log(q);
        var opts = q._options;
        console.log("---------M Fills--------");
        // console.log(opts);
        q.judgement = 'Correct';
        var _selected = 0;
        var _correct = true;
        for (var j = 0; j < opts.length; j += 1) {
          var opt = opts[j];
          if (opt.selection) {
            _selected++;
            var _result = false;
            for (var n = 0; n < opt.texts.length; n++) {
              if (opt.selection == opt.texts[n].text) {
                _result = true;;
                break;
              }
            }
            if (_result) {} else {
              _correct = false;
              console.log(opt);
            }
          } else {
            _correct = false;
          }
        }
        if (_selected) {
          if (_correct) {
            q.judgement = 'Correct';
          } else {
            q.judgement = 'Wrong';
          }
        } else {
          q.judgement = 'Not Attempted';
        }
        break;
    }
    return q;
  }

  this.retestPPT = function(index) {
    $scope.ppt.showresult = false;
  };

  this.submitPPTTest = function(index) {
    if ($scope.ppt.type != 'test') {
      return console.log('wrong type ppt');
    }
    //console.log($scope.ppt.questions);
    var ppt = angular.copy($scope.ppt);
    checkresult(ppt.questions);
    ppt.showresult = true;
    $scope.ppt = ppt;
  };

  self.API = null;
  this.onPlayerReady = function(API) {
    self.API = API;
  };

  this.leftclick = function() {
    if (pptindex <= 0) {
      pptindex = $scope.chapter.ppts.length - 1;
    } else {
      pptindex -= 1;
    }
    showppt(pptindex);
  };

  this.rightclick = function() {
    if (pptindex >= ($scope.chapter.ppts.length - 1)) {
        CommonService.showConfirm($filter('trans')({
          eng: 'You have reached the end. Do you want to go back to the beginning?',
          chn: '这已经是最后一页。您想要回到课件首页吗？'
        }), function(result) {
            pptindex = 0;
            showppt(pptindex);
        });      
    } else {
      pptindex += 1;
      showppt(pptindex);
    }
  };

  function showAudio() {
    var doc = angular.element($('#pptaudiodiv'));
    doc.empty();
    if ($scope.audio) {
      // console.log('show audio');
      $scope.audiourl = getAudioUrl($scope.audio);
      var audioElement = document.createElement('audio');
      audioElement.src = $scope.audiourl;
      audioElement.autoplay = true;
      audioElement.controls = 'controls';
      doc.append(audioElement);
    }
  }

  function getAudioUrl(url) {
    return $sce.trustAsResourceUrl(self.ResUrl + ($scope.chapter.rid || $scope.chapter.cid) + "/resources/" + encodeURI(url));
  }

  function showTopAudio() {
    var doc = angular.element($('#pptaudiodiv'));
    doc.empty();
    if ($scope.topLevelAudio) {
       console.log('show audio');
      $scope.audiourl = getAudioUrl($scope.topLevelAudio);
      var audioElement = document.createElement('audio');
      audioElement.src = $scope.audiourl;
      audioElement.autoplay = true;
      audioElement.controls = 'controls';
      doc.append(audioElement);
    }
  }

});