angular.module('bamboo.course').controller('ReadingChapterCtrl', function($scope, $sce, $timeout, CommonService, $stateParams, ApiService, CourseApi, $cordovaDevice) {
  this.cid = $stateParams.cid;
  console.log("--- WordChapterCtrl");
  console.log($stateParams);
  var self = this;
  var resUrl = ApiService.SHOST + '/lcourse/' + this.cid + '/resources/';
  self.id = $stateParams.rid;

  function getInfo() {
    // CommonService.showLoading();
    var info = {
      action: 'getresource',
      id: self.id,
    };
    CourseApi.mvApi(info, function(result) {
      //CommonService.stopLoading();
      console.log(result);
      self.chapter = result;
      resUrl = ApiService.SHOST + '/lcourse/' + self.chapter.cid + '/resources/';
      self.readingImageUrl = ApiService.SHOST + "/public/" + ApiService.RES + '/lcourse/' + self.chapter.cid + '/resources/';
      self.init(result);
      if (self.chapter.ppts && self.chapter.ppts.length > 0) {
        self.activeIndex = 1;
      } else {
        self.activeIndex = 0;
      }
    });
  }
  getInfo();
  var _platform;
  var _systemroot;
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    if (window.cordova) {
      _platform = $cordovaDevice.platform;
      if (_platform && _platform.indexOf('iOS') > -1) {
        _systemroot = cordova.file.dataDirectory;
      } else if (_platform && _platform.indexOf('Android') > -1) {
        _systemroot = cordova.file.externalRootDirectory;
      }
    }
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  this.init = function(chapter) {
    self.chapter = chapter;
    console.log(self.chapter);
    self.Bishun = [];
    if (self.chapter.ppts && self.chapter.ppts[0] && self.chapter.lang=='eng') {
      showAwsPPT();
    }
  }

  var myAudio;
  this.audioStatus="idle";

  function audioEnded(){
    console.log("audio ended");
    $timeout(function(){
      self.audioStatus="idle";
    },100)
  }
  this.stopPlay=function(){
    try {
      if (myAudio) {
        myAudio.pause();
        self.audioStatus="idle";
      }
    } catch (e) {}
  }
  this.currentIndex=-1;
  this.playAudio = function(file,index) {
    console.log('play',index);
    if (!file) {
      return;
    }
    var filename = resUrl + file;
    self.currentIndex=index;
    try {
      if (myAudio) {
        myAudio.pause();
      }
      myAudio = new Audio(filename);
      myAudio.play();
      myAudio.addEventListener("ended",audioEnded);
      self.audioStatus='play';
    } catch (e) {}
  };
  this.toggolePlay=function(file,index){
    if(self.audioStatus!='play'||index!=self.currentIndex){
      self.playAudio(file,index);
    }else{
      self.stopPlay();
    }
  }
  this.fullTexts = [];
  this.onEnterCuePoint2 = function(currentTime, timeLapse, params) {
    // console.log("onEnterCuePoint", currentTime, timeLapse, params);
    self.currIndex = params.index;
  }
  this.replay = function(index) {
    console.log(index);
    var time = (self.chapter.ppts[0].data[index].time - 100) / 1000;
    self.API.seekTime(time, false);
    self.API.play();
  }
  self.API;
  this.onPlayerReady = function(API) {
    self.API = API;
  };
  this.videoReady = false;

  function showAwsPPT() {
    var ppt = self.chapter.ppts[0];
    var cues = [];
    self.mp4config = {
      sources: [{}],
      cuePoints: {},
    };
    self.mp4config.sources[0].src = resUrl + ppt.audio;
    self.mp4config.sources[0].type = 'audio/mp3';
    angular.forEach(ppt.data, function(item, index) {
      console.log(item);
      var cue = {
          timeLapse: {
            start: (item.time + 50) / 1000,
          },
          onEnter: self.onEnterCuePoint2.bind(self),
          params: {
            index: index,
          }
        }
        /*  if (ppt.data[index + 1]) {
            cue.timeLapse.end = ppt.data[index + 1].time
          } */
      cues.push(cue);
      self.fullTexts.push(item.value);
    })
    console.log(cues);
    self.mp4config.cuePoints.textCues = cues;
    console.log(self.mp4config);
  }

  this.mediaRec = "";  
  this.recordingIndex = 'idle';
  this.recordAudio = function(ppt,index) {
    var src = _systemroot + 'bamboo/' +"myrecording"+index+".mp3";
    ppt.mode = "recording";
    self.recordingIndex = index;
    self.mediaRec = new Media(src, function(){
      ppt.playbacksrc = src;
    }, function(err){
      CommonService.showError(err);
      console.log(err);
    });
    // Record audio
    self.mediaRec.startRecord();
  }

  this.stopRecording = function(ppt){
    ppt.mode = 'idle';
    self.recordingIndex = 'idle';
    self.mediaRec.stopRecord();
  }
  
  this.currentRecIndex=-1;
  this.playUserAudio = function(ppt,index) {
    if (!ppt.playbacksrc) {
      return;
    }
    self.currentRecIndex=index;
    try {
      if (myAudio) {
        myAudio.pause();
      }

      myAudio = new Audio(ppt.playbacksrc);
      myAudio.play();
      myAudio.addEventListener("ended",audioEnded);
      self.audioStatus='playrec';
    } catch (e) {}
  }

  this.toggoleRec=function(ppt,index){
    if(self.audioStatus!='playrec'||index!=self.currentRecIndex){
      self.playUserAudio(ppt,index);
    }else{
      self.stopPlay();
    }
  }
  $scope.$on("$destroy", function() {
    if (myAudio) {
      myAudio.pause();
    }
  });  

});