angular.module('bamboo.course').controller('TestChapterCtrl', function(CourseApi, ExamService, $sce, ApiService, CommonService, $stateParams, $scope) {
  var self = this;
  self.chapter = '';
  this.cid = $stateParams.cid;
  this.id = $stateParams.rid;
  this.mediapath = ApiService.SHOST + '/lcourse/' + self.cid + '/resources/';
  function getInfo() {
    // CommonService.showLoading();
    var info = {
      action: 'getresource',
      id: self.id
    };
    CourseApi.mvApi(info, function(result) {
      // CommonService.stopLoading();
      //  console.dir(result);
      self.chapter = result;
      // console.log(self.chapter.questions);
      angular.forEach(self.chapter.questions, function(q, index) {
        console.log('q to convert', index);
        ExamService.convertQ(q);
      })
      if (self.chapter.audio) {
        self.audiourl = getAudioUrl(self.chapter.audio);
        console.log(self.audiourl);
      }
    });
  }
  var _lasttime = new Date();
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    CourseApi.recordUsage(self.cid,self.id,$stateParams.mvid,_lasttime);
  });
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  getInfo();

  function getAudioUrl(url) {
    console.log(self.mediapath + url);
    return $sce.trustAsResourceUrl(self.mediapath + encodeURI(url));
  };
  this.submitChapterTest = function(index) {
    if (self.chapter.type != 'test') {
      return console.log('wrong type ppt');
    }
    //console.log($scope.ppt.questions);
    var chapter = angular.copy(self.chapter);
    checkresult(chapter.questions);
    chapter.showresult = true;
    self.chapter = chapter;
  };

  function clearresult(questions) {
    console.log("length:" + questions.length);
    for (var i = 0; i < questions.length; i++) {
      var q = questions[i];
      console.log(i);
      console.log(questions[i]);
      switch (q.type) {
        case 'single':
          q.selection = null;
          q.judgement = null;
        case 'multiple':
          var opts = q.options;
          q.judgement = null;
          if (opts && opts.length > 0) {
            for (var j = 0; j < opts.length; j += 1) {
              opts[j].selection = null;
            }
          }
          break;
        case 'tof':
          q.selection = null;
          break;
        case 'fill':
          q.selection = null;
          q.judgement = null;
          break;
        case 'mfill':
          var opts = q.options;
          q.judgement = null;
          if (opts && opts.length > 0) {
            for (var j = 0; j < opts.length; j++) {
              opts[j].selection = null;
            }
          }
      }
    }
  }
  this.retestChapter = function(index) {
    clearresult(self.chapter.questions);
    self.chapter.showresult = false;
  };

  function checkQResult(q) {
    switch (q.type) {
      case 'single':
        // console.log(q)
        angular.forEach(q._options, function(opt, index) {
          // console.log(opt);
          // console.log(index);
          if (opt.correct && index == q.select) {
            q.judgement = 'Correct';
            q.selection = opt.text;
            console.log('correct');
          }
        })
        if (q.judgement != 'Correct') {
          if (q.select || q.select == 0) {
            q.judgement = 'Wrong';
            q.selection = q._options[q.select].text;
          } else {
            q.judgement = 'Not Attempted';
          }
        }
        break;
      case 'multiple':
        var opts = q._options;
        console.log("--------multiple---------");
        // console.log(opts);
        var _selected = 0;
        var _correct = true;
        for (var j = 0; j < opts.length; j += 1) {
          var opt = opts[j];
          console.log(opt);
          if (opt.selection) {
            _selected++;
          }
          if ((opt.selection && opt.correct) || (!opt.selection && !opt.correct)) {} else {
            _correct = false;
            console.log('wrong selection');
          }
        }
        console.log(_selected);
        console.log(_correct);
        if (_selected) {
          if (_correct) {
            q.judgement = 'Correct';
          } else {
            q.judgement = 'Wrong';
          }
        } else {
          q.judgement = 'Not Attempted';
        }
        break;
      case 'tof':
        console.log("--------tof---------");
        console.log(q);
        if (!q.selection) {
          q.judgement = 'Not Attempted';
        } else if (q.selection == 'true' && q._options[0].correct) {
          q.judgement = 'Correct';
        } else if (q.selection == 'false' && !q._options[0].correct) {
          q.judgement = 'Correct';
        } else {
          q.judgement = 'Wrong';
        }
        break;
      case 'fill':
      case 'mfill':
        console.log(q);
        var opts = q._options;
        console.log("---------M Fills--------");
        // console.log(opts);
        q.judgement = 'Correct';
        var _selected = 0;
        var _correct = true;
        for (var j = 0; j < opts.length; j += 1) {
          var opt = opts[j];
          if (opt.selection) {
            _selected++;
            var _result = false;
            for (var n = 0; n < opt.texts.length; n++) {
              if (opt.selection == opt.texts[n].text) {
                _result = true;;
                break;
              }
            }
            if (_result) {} else {
              _correct = false;
              console.log(opt);
            }
          } else {
            _correct = false;
          }
        }
        if (_selected) {
          if (_correct) {
            q.judgement = 'Correct';
          } else {
            q.judgement = 'Wrong';
          }
        } else {
          q.judgement = 'Not Attempted';
        }
        break;
    }
    return q;
  }

  function checkresult(questions) {
    console.log(questions)
    for (var i = 0; i < questions.length; i += 1) {
      var q = questions[i];
      checkQResult(q);
    }
  }
  $scope.resulticon = {
    Correct: "icon ion-checkmark",
    Wrong: "icon ion-close",
    Miss: "icon ion-alert"
  };
  self.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  this.typename = {
    'single': 'Select one answer',
    'fill': 'Fill in the blank',
    'mfill': 'Fill in all the blanks',
    'tof': 'True or False',
    'short': 'Essay Question',
    'multiple': 'Select ALL the correct answers'
  };
});