angular.module('bamboo.course').controller('ChapterListCtrl', function ($scope, $cordovaDevice, $cordovaInAppBrowser, CommonService, ApiService, $window, $timeout, $cordovaFileTransfer, $stateParams, $localstorage, CourseApi, $state, $sce) {
  var _self = this;
  this.cid = $stateParams.cid;
  this.id = $stateParams.mvid;
  console.log("---- chapter List -----");
  this.mediapath = ApiService.SHOST + '/lcourse/' + _self.cid + '/resources/';
  this.ResUrl = ApiService.SHOST + '/lcourse/';
  var _platform;
  var _systemroot;

  if (window.cordova) {
    _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('iOS') > -1) {
      _systemroot = cordova.file.dataDirectory;
    } else if (_platform && _platform.indexOf('Android') > -1) {
      _systemroot = cordova.file.externalRootDirectory;
      window.screen.orientation.lock('portrait');
    }
  }

  this.iconlist = {
    youtube: "icon ion-social-youtube dark",
    youku: "icon ion-social-yahoo dark",
    vimeo: "icon ion-social-vimeo dark",
    mp4: "icon ion-ios-videocam dark",
    ppts: "icon ion-social-buffer dark",
    flash: "icon ion-social-foursquare dark",
    pdf: "icon ion-document-text dark",
    test: "icon ion-android-clipboard dark",
    mp4ppt: "icon ion-easel dark",
    exam: "icon ion-clipboard dark",
    chapterexam: "icon ion-clipboard dark",
    quiz: "icon ion-ios-paper dark",
    html: "icon ion-ios-browsers-outline dark",
    assignment: "icon ion-ios-list dark",
    html5: "icon ion-social-html5 dark",
    mp4quiz: "icon ion-compose dark",
    mp3ppt: "icon ion-music-note dark",
    ebook: "icon ion-ipad dark",
    reading: "icon ion-speakerphone dark",
    idiom: "icon ion-chatbubble-working dark",
    bishun: "icon ion-edit dark",
    word: "icon ion-ios-bookmarks dark",
    poetry: "icon ion-ios-list-outline",
    fillblank: "icon ion-android-exit",
    msoffice: "icon ion-social-windows",
    audioexp: "icon ion-android-microphone",
    lms2004: "icon ion-ios-folder",
    lms: "icon ion-ios-folder-outline dark"
  };

  function getMvsubjectInfo() {
    $scope.id = _self.id;
   // CommonService.showLoading();
    CourseApi.getInfo(_self.id, function (result) {
     // CommonService.stopLoading();
      console.log(result.data);
      _self.mvsubject = result;
      _self.chapters = result.chapters;
      //console.log(_self.chapters);
      if (!_self.chapters || _self.chapters.length == 0) {
        return;
      }
      var tindex = 0;
      var sindex = 0;
      var findex = 0;
      var lindex = 0;
      var leveldata = [];
      for (var i = 0; i < _self.chapters.length; i += 1) {
        var page = _self.chapters[i];
        if (!page.level || page.level == 0) {
          findex += 1;
          sindex = 0;
          tindex = 0;
          lindex = 0;
          page.level = 0;
        } else if (page.level == 1) {
          sindex += 1;
          tindex = 0;
          lindex = 0;
        } else if (page.level == 2) {
          tindex += 1;
          lindex = 0;
        } else {
          lindex += 1;
        }
        if (_self.mvsubject.manualindex) {
          page.title = page.name;
        } else {
          var idx = '' + findex;
          if (sindex > 0 || tindex > 0) {
            idx += '-' + sindex;
          }
          if (tindex > 0) {
            idx += '-' + tindex;
          }
          if (lindex > 0) {
            idx += '-' + lindex;
          }
          page.title = idx + '.' + page.name;
        }
        page.findex = findex;
        page.sindex = sindex;
        page.tindex = tindex;
        page.lindex = lindex;
        var info = {
          rid: page._id,
          title: page.title,
          level: page.level,
          file: page.content,
          type: page.type,
          cid:page.cid,
          items: [],
          index: i,
          extFlag: false,
        };
        if (window.cordova) {
          switch (info.type) {
            case "mp4":
            case "pdf":
            case "mp4ppt":
            case "mp4quiz":
              if ($localstorage.getResource(info.rid)) {
                info.play = true;
              } else {
                console.log("--- to be download");
                console.log(info.rid);
                info.download = true;
              }
              break;
            default:
              info.play = true;
          }
        } else {
          info.play = true;
        }
        leveldata.push(info);
      }
      $scope.items = leveldata;
      console.log(leveldata);
    });
  }

  getMvsubjectInfo();
  this.playchapter = function (item) {
    console.log(item);
    switch (item.type) {
      case "mp4":
      case "pdf":
      case "mp4ppt":
      case "mp4quiz":
        if (!window.cordova) {
          $state.go("" +
            "." + item.type, {
            rid: item.rid
          });
          return;
        }
        var options = {
          location: 'no',
          clearcache: 'no',
          toolbar: 'yes'
        };
        var target = "_system";
        if (item.download) {
          if (item.type == "mp4" ||item.type == "mp4ppt" || item.type == "mp4quiz") {
          //  _self.directplay(item);
            $state.go("app.course.home.chapterslist." + item.type, {
              rid: item.rid
            });
            return;
          } else {
            _self.downloadchapter(item);
            return;
          }
        }
        var targetPath = _systemroot + 'bamboo/' + encodeURI(item.file);
        console.log(targetPath);
        $cordovaInAppBrowser.open(targetPath, target, options).then(function (event) {
          console.log("--- open success --");
        }).catch(function (event) {
          console.log("--- open err --");
          console.dir(event);
        });
        $cordovaInAppBrowser.close();
        break;
      case "flash":
        CommonService.showInfo("Flash not supported on Mobile Device, Please use Destop Browser to see the full version courseware!");
        break;
      case "assignment":
        $state.go("app.course.home.chapterslist.assignment", {
          aid: item.file
        });
        break;
      case "exam":
        $state.go("app.exam.start", {
          id: item.file,
          type: item.type
        });
        break;
      case "chapterexam":
        $state.go("app.exam.start", {
          id: item.rid,
          type: 'course',
        });
        break;
      case "quiz":
        $state.go("app.exam.start", {
          id: item.file,
          type: 'test'
        });
        break;
      case 'html5':
        console.log(item);
        console.log(item.cid);
        $state.go("app.course.home.chapterslist.html5", {
          rid: item.rid
        });
        break;
      case 'lms':
        console.log(item);
        console.log(item.cid);
        //var fullurl = $sce.trustAsResourceUrl(_self.ResUrl + (item.cid||_self.cid) + "/resources/" + item.file+'/index_lms_html5.html');
        $state.go("app.course.home.chapterslist.lms", {
          rid: item.rid
        });
        break;
      default:
        $state.go("app.course.home.chapterslist." + item.type, {
          rid: item.rid
        });
    }
  };
  this.directplay = function (item) {
    if (window.cordova) {
      switch (item.type) {
        case "mp4":
        case "pdf":
        case "mp4ppt":
          if(item.cid){
            _self.mediapath = ApiService.SHOST + '/lcourse/' + item.cid + '/resources/';
          } 
          var targetPath = _self.mediapath + encodeURI(item.file);
          var options = {
            location: 'no',
            clearcache: 'no',
            toolbar: 'yes',
          //  hidden:'yes',
            
          };
          console.log(targetPath);
          $cordovaInAppBrowser.open(targetPath, '_system', options).then(function (event) {
            console.log("--- open success --");
          }).catch(function (event) {
            console.log("--- open err --");
            console.dir(event);
          });
          $cordovaInAppBrowser.close();
          break;
        default:
          console.log(" type not supported ");
          break;
      }
    } else {
      console.log("host path");
    }
  }
  this.downloadchapter = function (item) {
    if(item.cid){
      _self.mediapath = ApiService.SHOST + '/lcourse/' + item.cid + '/resources/';
    }
    console.log(item.file);
   // console.log(encodeURI(item.file));
    var url = _self.mediapath + item.file;
    console.log('264',url);
    var targetPath = _systemroot + 'bamboo/' + encodeURI(item.file);
    console.log(targetPath);
    var trustHosts = true;
    var options = {};
    CommonService.download(url,targetPath,options,function(result) {
   // $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
      console.log("download success");
      console.log(item.rid);
      item.play = true;
      item.download = false;
      item.progress = 0;
      $localstorage.setResource(item.rid, true);
      console.log($window.localStorage.resource);
    }, function (err) {
      console.log("download fail" + err);
      console.dir(err);
    }, function (progress) {
      $timeout(function () {
        var _pro = parseInt((progress.loaded / progress.total) * 100);
        if (!item.progress || _pro > item.progress) {
          item.progress = _pro;
          console.log(item.progress);
        }
        //$scope.downloadProgress = (progress.loaded / progress.total) * 100;
      });
    });
  }
});
