angular.module('bamboo.course').controller('CourseHomeCtrl', function($scope, CommonService, $cordovaDevice, $cordovaFileTransfer, $stateParams, $localstorage, loginService, ApiService, CourseApi, $state, $ionicPopover, $ionicPopup, $cordovaInAppBrowser, DlgService, $timeout, $window, $translate, $sce) {
  var _self = this;
  this.id = $stateParams.cid;

  console.log("---- course home -----");
  console.log(DlgService);
  $scope.user = loginService.user;
  this.avatar_url = ApiService.SHOST + '/public/images/defaultteacher.png';
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  this.teacherPicUrl = ApiService.SHOST + "/photo/" + ApiService.RES + "/teachers/";
  this.relatedCoursePhotoUrl = ApiService.SHOST + '/lcourse/';
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.coursephoto) {
      _self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });
  var colorlist = ['color-one', 'color-two', 'color-three', 'color-four', 'color-five', 'color-six', 'color-seven'];
  this.items = [];
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/' + _self.id + "/";
  this.imgdefault = ApiService.SHOST + '/public/images/videos.png';
  this.favourites = [];
  this.favCourseList = [];
  this.groups = [];
  loadFavourites();
  var _platform;
  var _systemroot;
  $scope.$on("$ionicView.enter", function(scopes, states) {
    if (window.cordova) {
      _platform = $cordovaDevice.platform;
      if (_platform && _platform.indexOf('iOS') > -1) {
        _systemroot = cordova.file.dataDirectory;
      } else if (_platform && _platform.indexOf('Android') > -1) {
        _systemroot = cordova.file.externalRootDirectory;
        window.screen.orientation.lock('portrait');
      }
    }
    CommonService.stopListen();
  });
  this.iconlist = {
    youtube: "icon ion-social-youtube dark",
    youku: "icon ion-social-yahoo dark",
    vimeo: "icon ion-social-vimeo dark",
    mp4: "icon ion-ios-videocam dark",
    ppts: "icon ion-social-buffer dark",
    flash: "icon ion-social-foursquare dark",
    pdf: "icon ion-document-text dark",
    test: "icon ion-android-clipboard dark",
    mp4ppt: "icon ion-easel dark",
    exam: "icon ion-clipboard dark",
    chapterexam: "icon ion-clipboard dark",
    quiz: "icon ion-ios-paper dark",
    html: "icon ion-ios-browsers-outline dark",
    assignment: "icon ion-ios-list dark",
    html5: "icon ion-social-html5 dark",
    mp4quiz: "icon ion-compose dark",
    mp3ppt: "icon ion-music-note dark",
    ebook: "icon ion-ipad dark",
    reading: "icon ion-speakerphone dark",
    idiom: "icon ion-chatbubble-working dark",
    bishun: "icon ion-edit dark",
    word: "icon ion-ios-bookmarks dark",
    poetry: "icon ion-ios-list-outline dark",
    fillblank: "icon ion-android-exit dark",
    msoffice: "icon ion-social-windows dark",
    audioexp: "icon ion-android-microphone dark",
    lms2004: "icon ion-ios-folder dark",
    lms: "icon ion-ios-folder-outline dark",
    onlinequizvimeo: 'fa fa-question fa-vimeo dark',
    onlinequizyoutube: 'fa fa-question fa-youtube-play dark',
    dragfill: "fa fa-pencil-square-o dark",
    fillblank: "fa fa-pencil-square-o dark",
    chooseans: 'fa fa-pencil-square-o dark',
    eword: 'fa fa-cubes dark',
    openoffice: "fa fa-file dark",
    coursesurvey: "fa fa-check-square-o dark",
    iv: "fa fa-question fa-file-video-o fa-fw"
  };
  $scope.$on('$ionicView.beforeEnter', function () {
    $scope.isCollect = false;
  })

  function loadFavourites() {
    loginService.getMyProfile(true).then(function(result) {
      _self.favourites = result.favourites;
      console.log("---------self.favourites---------------");
      console.log(_self.favourites);
      console.log(result);
      angular.forEach(_self.favourites, function(val, idx) {
        if (val.id == _self.id && val.type == 'course') {
          $scope.isFav = true;
        }
      });
      //loadFavCourseList();
    }, function(res) {
      console.log("error:" + res);
    });
  };

  function getMvSubjects(contents) {
    //var _pages = _self.course.contents;
    console.log(contents);
    var _pages = contents;
    var _wk = [];
    var _row = {};
    var mindex = 0;
    var sindex = 0;
    var tablelist = [];
    for (var i = 0; i < _pages.length; i++) {
      var page = _pages[i];
      if (!page.level || page.level == 0) {
        if (_row.main) {
          _wk.push(_row);
        }
        _row = {};
        mindex++;
        sindex = 0;
      } else if (page.level == 1) {
        sindex++;
      } else { // page.level>1
        continue;
      }
      var idx = '' + mindex;
      if (sindex > 0) {
        idx += '-' + sindex
      }
      var id = page.id;
      var info = {
        id: id,
        mindex: mindex,
        title: page.name,
        level: page.level,
        idx: idx,
        description: page.description,
        photo: page.photo,
        defaultpage: page.defaultpage,
        disable: page.disable,
      };
      tablelist.push(info);
      if (!page.level || page.level == 0) {
        var _row = {
          main: info,
        };
      } else {
        if (mindex < 1) {
          continue;
        }
        if (!_row.sub) {
          _row.sub = [];
        }
        _row.sub.push(info);
      }
    }
    if (tablelist.length > 0) {
      var chapters = [];
      var cidx = cidx = tablelist[0].mindex;
      var cinfo = new Array();
      for (var p = 0; p < tablelist.length; p++) {
        if (tablelist[p].mindex != cidx) {
          var sinf = {
            cidx: cidx,
            cinfo: cinfo,
          };
          chapters.push(sinf);
          cidx = tablelist[p].mindex;
          cinfo = new Array();
        }
        cinfo.push(tablelist[p]);
      }
      var sinf = {
        cidx: cidx,
        cinfo: cinfo,
      };
      chapters.push(sinf);
    }
    if (_row.main) {
      _wk.push(_row);
    }
    $scope.tablelist = tablelist;
    $scope.charpters = chapters;
    $scope.coursesrow = _wk;
    console.log($scope.tablelist);
    console.log($scope.charpters);
  }

  function getCourseLastRes() {
    var info = {
      id: _self.id,
      action: 'getCourseLastRes',
    }
    console.log(info);
    CourseApi.lcApi(info, function(result) {
      console.log('getCourseLastRes', result);
      if (result) {
        console.log(result);

        console.log("TCL: getCourseLastRes -> CommonService", CommonService)

        if(!CommonService.hasOwnProperty('stateInfo')) {
          CommonService.showConfirm('Will you resume the previous progress?', function(_res) {
            if (result.res.type == "mp4" || result.res.type == "iv" ||result.res.type == "mp4ppt" || result.res.type == "mp4quiz") {
              result.res.rid = result.res._id;
              CommonService.lookVideo = result.res;
              CommonService.stateInfo = {
                lid: _self.id,
                start:new Date(),
                mvid: result.mvid,
                state: 'start',
                len: 0,
                rid: result.rid,
              }
              $state.go(".takephoto", {
                isSign: 1
              });
              //$state.go("app.course.home.chapterslist." + result.res.type, {
              //  rid: result.res.rid,
              //  mvid:result.mvid,
              //});
            } else {
              $state.go("app.course.home.chapterslist." + result.res.type, {
                rid: result.rid,
                mvid: result.mvid,
              });
            }
          })
        }
      }
    })
  }

  function getInfo() {
    $scope.id = _self.id;
    CommonService.showLoading();
    ApiService.get('/lcourse/' + _self.id).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        _self.course = result.data.data;
        _self.courseTitle = result.data.data.name;

        if (_self.course.video) {
          //config course video
          _self.courseVideoConfig = {
            sources: [{}],
            tracks: [{}],
            cuePoints: {}
          };
          _self.courseVideoConfig.sources = [{}];
          _self.courseVideoConfig.sources[0].src = $sce.trustAsResourceUrl(_self.coursePhotoUrl + encodeURI(_self.course.video));
          _self.courseVideoConfig.sources[0].type = 'video/mp4';
        }
        getCourseLastRes();
        console.log(_self.course.contents);
        console.log(result);
        if (_self.course.assessment) {
          //  checkassessmentexit();
          if (_self.course.rating) {
            $scope.averageRating = _self.course.rating.toString().substring(0, 3);
          }
        }
        if (_self.course.visitercounter) {
          _self.visitercounter = _self.course.visitercounter;
        }
        var editors = _self.course.editors;
        var names = [];
        names.push(_self.course.creater);
        angular.forEach(editors, function(val, idx) {
          names.push(val);
        });
        var favouritenews = [];
        loginService.getMyProfile(true).then(function (_result) {
          var favourites = _result.favourites;
          console.log(favourites);
          $scope.courseIndex=0;
          angular.forEach(favourites, function (_item) {
            if (_item.type == "course" && _item.id == _self.id) {
              _self.course.favourite = true;
              _self.course.courseIndex =  $scope.courseIndex;
            }
            $scope.courseIndex++;
          })
        });
        // getEditorInfo(names);
       // console.log(_self.course.contents);
       // console.log(_self.course.contents);
        _self.course.contents = result.data.sections;
        _self.groups = angular.copy(_self.course.contents);
        getMvSubjects(_self.course.contents);
        //getRelatedCourses();
      } else {
        $state.go('app.home');
      }
    });
  }
  getInfo();
  $ionicPopover.fromTemplateUrl('app/course/coursemenupopover.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });
  $scope.closePopover = function() {
    $scope.popover.hide();
  };
  $scope.gohome = function() {
    $state.go('app.home');
  }
  // $scope.share = function() {
  //   var link = ApiService.HOST + '/#/courselist//info/' + _self.id + '?share=true';
  //   var imageUrl = _self.course.photo ? _self.coursePhotoUrl + _self.course.photo : _self.defaultpic;
  //   console.log(link);
  //   CommonService.showShareDialog($scope, _self.course.name, imageUrl, link, _self.course.description);
  // }
  $scope.favourite = function() {
    console.log(_self.id);
    //if (_self.favourites.indexOf(_self.id) < 0) {
    var object = {
      type: 'course',
      id: _self.id
    };
    var info = {
      action: "addfavourite",
      object: object
    };

      ApiService.post("/user", info).then(function(result) {
      if (result.data.success) {
        _self.course.favourite=true;
        CommonService.showInfo("收藏成功")
        CommonService.stopLoading();
        loginService.getMyProfile(true).then(function (_result) {
          var favourites = _result.favourites;
          console.log(favourites);
          $scope.courseIndex=0;
          angular.forEach(favourites, function (_item) {
            if (_item.type == "course" && _item.id == _self.id) {
              _self.course.favourite = true;
              _self.course.courseIndex =  $scope.courseIndex;
            }
            $scope.courseIndex++;
          })
        });
      } else {
        CommonService.showInfo("收藏失败，请重试！")
        //_self.course.favourite=true;
        CommonService.stopLoading();
      }
    });
  };

  $scope.delFavourite = function () {   // 收藏
    console.log(_self.course.courseIndex);
    var info = {
      action: "delfavourite",
      index: _self.course.courseIndex
    };
    ApiService.post("/user", info).then(function (result) {
      if (result.data.success) {
        _self.course.favourite = false;
        CommonService.showInfo("取消收藏成功");
        CommonService.stopLoading();
      } else {
        CommonService.showInfo("取消收藏失败，请重试！")
        CommonService.stopLoading();
      }
    });
  }
  this.coursetopics = [];
  var commentstart = 0;
  this.resourcesItems={};

  $scope.toggleGroup = function(group) {
    group.show = !group.show;
    if (group.show)
      getMvsubjectInfo(group.id);

    // angular.forEach(_self.groups, function(grp, idx) {
    //   // console.log(grp);
    //   if (grp != group) {
    //     grp.show = false;
    //   }
    // });
  };
  $scope.isGroupShown = function(group) {
    return group.show;
  };
  var currentMvid;

  function getMvsubjectInfo(_id) {
    //$scope.id = _self.id;
    //CommonService.showLoading();
    currentMvid = _id;
    CourseApi.getInfo(_id, function(result) {
      //CommonService.stopLoading();
      console.log(result.data);
      _self.mvsubject = result;
      _self.chapters = result.chapters;
      console.log(_self.chapters);
      if (!_self.chapters || _self.chapters.length == 0) {
        return;
      }
      var tindex = 0;
      var sindex = 0;
      var findex = 0;
      var lindex = 0;
      var leveldata = [];
      for (var i = 0; i < _self.chapters.length; i += 1) {
        var page = _self.chapters[i];
        if (!page.level || page.level == 0) {
          findex += 1;
          sindex = 0;
          tindex = 0;
          lindex = 0;
          page.level = 0;
        } else if (page.level == 1) {
          sindex += 1;
          tindex = 0;
          lindex = 0;
        } else if (page.level == 2) {
          tindex += 1;
          lindex = 0;
        } else {
          lindex += 1;
        }
        if (_self.mvsubject.manualindex) {
          page.title = page.name;
        } else {
          //var idx = '' + findex;
          //if (sindex > 0 || tindex > 0) {
          //  idx += '-' + sindex;
          //}
          //if (tindex > 0) {
          //  idx += '-' + tindex;
          //}
          //if (lindex > 0) {
          //  idx += '-' + lindex;
          //}
          //page.title = idx + '.' + page.name;
          page.title =  page.name;
        }
        page.findex = findex;
        page.sindex = sindex;
        page.tindex = tindex;
        page.lindex = lindex;
        var info = {
          rid: page._id,
          title: page.title,
          level: page.level,
          file: page.content,
          type: page.type,
          subType: page.subType,
          pass: page.pass,
          read: page.read,
          cid: page.cid,
          zipFile: page.zipFile,
          items: [],
          index: i,
          extFlag: false,
          audio: (page.audio) ? page.audio : '',
          finished: page.finished
        };
        if (window.cordova) {
          switch (info.type) {
            case "mp4":
              // case "pdf":
            case "mp4ppt":
            case "mp4quiz":
            case "html5":
            case "ebook":
            case "lms":
            case "lms2004":
              if ($localstorage.getResource(info.rid)) {
                info.play = true;
              } else {
                console.log("--- to be download");
                console.log(info.rid);
                info.download = true;
              }
              break;
            default:
              info.play = true;
          }
        } else {
          info.play = true;
        }
        leveldata.push(info);
      }
      _self.resourcesItems[_id]=leveldata;
      _self.groupitems = leveldata;
      console.log(_self.groupitems);
    }, true);
  }
  //--------------chapter ctrl-------------------------
  this.playchapter = function(item) {
    console.log(item);
    switch (item.type) {
      case "mp3ppt":
        $state.go("app.course.home.chapterslist.mp3ppt", {
          rid: item.rid,
          mvid: currentMvid,
        });
        break;
      case "mp4":
      case "mp4ppt":
      case "mp4quiz":
      case "iv":
        CommonService.lookVideo = item;
        CommonService.stateInfo = {
          lid: _self.id,
          start:new Date(),
          mvid: currentMvid,
          state: 'start',
          len: 0,
          rid: item.rid,
        }
         CommonService.currentMvid = currentMvid;
         CommonService.id = _self.id;
         CommonService.state='start';
        $state.go(".takephoto", {
          isSign: 1
        });
        ////$state.go("app.course.home.chapterslist." + item.type, {
        //  rid: item.rid,
        //  mvid: currentMvid,
        //});
        break;
      case "pdf":
        $state.go("app.course.home.chapterslist.pdf", {
          rid: item.rid,
          mvid: currentMvid,
        });
        break;
      case "flash":
        CommonService.showInfo("Flash not supported on Mobile Device, Please use Desktop Browser to see the full version courseware!");
        break;
      case "idiom":
      case "bishun":
      case "poetry":
      case "fillblank":
      case "reading":
      case "word":
        // case "chooseans":
        // case "dragfill":
        CommonService.showInfo($translate.instant("This type are not supported on this version, Please use Desktop Browser to see the full version courseware!"));
        break;
      case "assignment":
        $state.go("app.course.home.chapterslist.assignment", {
          aid: item.file,
          mvid: currentMvid,
        });
        break;
      case "exam":
        $state.go("app.exam.start", {
          id: item.file,
          type: item.type
        });
        break;
      case "chapterexam":
        $state.go("app.exam.start", {
          id: item.rid,
          type: 'course',
        });
        break;
      case "quiz":
        $state.go("app.exam.start", {
          id: item.file,
          type: 'test'
        });
        break;
        // case "lms":
        // case "lms2004":
      case 'ebook':
      case 'html5':
      case "lms":
      case "lms2004":
        console.log(item);
        console.log(item.cid);
        $state.go("app.course.home.chapterslist." + item.type, {
          rid: item.rid,
          mvid: currentMvid,
        });
        return;
      default:
        $state.go("app.course.home.chapterslist." + item.type, {
          rid: item.rid,
          mvid: currentMvid,
        });
    }
  };

  function getFolderURL(item) {
    if (item.cid) {
      return ApiService.SHOST + '/lcourse/' + item.cid + '/resources/'
    } else {
      return ApiService.SHOST + '/lcourse/' + _self.id + '/resources/';
    }
  }
  this.directplay = function(item) {
    if (window.cordova) {
      switch (item.type) {
        case "mp4":
        case "pdf":
        case "mp4ppt":
          _self.mediapath = getFolderURL(item);
          var targetPath = _self.mediapath + encodeURI(item.file);
          var options = {
            location: 'no',
            clearcache: 'no',
            toolbar: 'yes',
            //  hidden:'yes',
          };
          console.log(targetPath);
          $cordovaInAppBrowser.open(targetPath, '_system', options).then(function(event) {
            console.log("--- open success --");
          }).catch(function(event) {
            console.log("--- open err --");
            console.dir(event);
            CommonService.showError("File Access Error, Please check the permission for File!");
          });
          $cordovaInAppBrowser.close();
          break;
        default:
          console.log(" type not supported ");
          break;
      }
    } else {
      console.log("host path");
    }
  }


  _self.currTab = "uncompleted";
  this.selectTab = function(tab) {
    _self.currTab = tab;
  }
  this.audioCourseDetail = function(item) {
    var info = {
      action: 'getresource',
      id: item.rid,
    };
    CourseApi.mvApi(info, function(result) {
      var mediapath = getFolderURL(item);
      console.log(result);
      _self.audioItem = result;
      _self.audioImage = (result.photo) ? $sce.trustAsResourceUrl(mediapath + encodeURI(result.photo)) : '';
      CommonService.showdetail($scope, 'app/course/chapter/audiocourse_detail.html');
      var myEl = angular.element(document.querySelector('body'));
      myEl.addClass('audio_pan');
    });
  }
  this.assignAudio = function(item) {
    console.log(item);
    if (item.audio) {
      var video = angular.element('#playAudio');
      if (video[0]) {
        video[0].pause();
      }
      var mediapath = getFolderURL(item);
      _self.playAudio = $sce.trustAsResourceUrl(mediapath + encodeURI(item.audio));
      console.log(item.audio);
      if (video[0]) {
        video[0].src = _self.playAudio;
        video[0].play();
      }
    } else {
      CommonService.showInfoWithTitle('Info', 'No Audio in the Content');
    }
  }
  this.closeAudio = function() {
    var video = angular.element('#playAudio');
    if (video[0]) {
      video[0].pause();
    }
    _self.playAudio = '';
  }
});
