angular.module('bamboo.course').controller('CourseInfoCtrl', function($scope, CommonService, $stateParams, $ionicHistory, loginService, ApiService, CourseApi, $state, $timeout, $rootScope, $ionicPopup) {
  var _self = this;
  this.id = $stateParams.cid;
  console.log("---- course home -----");
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  this.teacherPicUrl = ApiService.SHOST + "/photo/" + ApiService.RES + "/teachers/";
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.coursephoto) {
      _self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });
  this.mycourseFlag = false;
  var colorlist = ['color-one', 'color-two', 'color-three', 'color-four', 'color-five', 'color-six', 'color-seven'];
  this.items = [];
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/' + _self.id + "/";
  _self.identity = 'person';
  _self.isBill = 'yes';

  function getMvSubjects(contents) {
    //var _pages = _self.course.contents;
    var _pages = contents;
    var _wk = [];
    var _row = {};
    var mindex = 0;
    var sindex = 0;
    var tablelist = [];
    for (var i = 0; i < _pages.length; i++) {
      var page = _pages[i];
      if (!page.level || page.level == 0) {
        if (_row.main) {
          _wk.push(_row);
        }
        _row = {};
        mindex++;
        sindex = 0;
      } else if (page.level == 1) {
        sindex++;
      } else { // page.level>1
        continue;
      }
      var idx = '' + mindex;
      if (sindex > 0) {
        idx += '-' + sindex
      }
      var id = page.id;
      var info = {
        id: id,
        mindex: mindex,
        title: page.name,
        level: page.level,
        idx: idx,
        description: page.description,
        photo: page.photo,
        defaultpage: page.defaultpage
      };
      tablelist.push(info);
      if (!page.level || page.level == 0) {
        var _row = {
          main: info
        };
      } else {
        if (mindex < 1) {
          continue;
        }
        if (!_row.sub) {
          _row.sub = [];
        }
        _row.sub.push(info);
      }
    }
    if (tablelist.length > 0) {
      var chapters = [];
      var cidx = cidx = tablelist[0].mindex;
      var cinfo = new Array();
      for (var p = 0; p < tablelist.length; p++) {
        if (tablelist[p].mindex != cidx) {
          var sinf = {
            cidx: cidx,
            cinfo: cinfo,
          };
          chapters.push(sinf);
          cidx = tablelist[p].mindex;
          cinfo = new Array();
        }
        cinfo.push(tablelist[p]);
      }
      var sinf = {
        cidx: cidx,
        cinfo: cinfo
      };
      chapters.push(sinf);
    }
    if (_row.main) {
      _wk.push(_row);
    }
    $scope.tablelist = tablelist;
    $scope.charpters = chapters;
    $scope.coursesrow = _wk;
  }

  function getInfo() {
    $scope.id = _self.id;
    CommonService.showLoading();
    ApiService.get('/fcourse/' + _self.id).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        _self.course = result.data.data;
        console.log(_self.course);
        if (_self.course.assessment) {
          //  checkassessmentexit();
          if (_self.course.rating) {
            $scope.averageRating = _self.course.rating.toString().substring(0, 3);
          }
        }
        if (_self.course.visitercounter) {
          _self.visitercounter = _self.course.visitercounter;
        }
        var editors = _self.course.editors;
        var names = [];
        names.push(_self.course.creater);
        angular.forEach(editors, function(val, idx) {
          names.push(val);
        });
        // getEditorInfo(names);
        //  console.log(names);
        _self.course.contents = result.data.sections;
        getMvSubjects(_self.course.contents);
      } else {
        $state.go('index.404');
      }
    });
  }
  getInfo();
  // function getEditorInfo(names) {
  //   var info = {
  //     names: names,
  //     action: 'getteachersinfo'
  //   };
  //   ApiService.post('/user', info).then(function(result) {
  //     if (result.data.success) {
  //       var data = result.data.data;
  //       console.log(data);
  //       _self.editors = [];
  //       angular.forEach(data, function(val, idx) {
  //         // if (val.avatar && (!val.photo || (typeof val.avatarflag !== 'undefined' && val.avatarflag))) {
  //         //   var info = {
  //         //     _id: val.userid,
  //         //     avatar: val.avatar
  //         //   };
  //         //   val.avatar_url = CommonService.getAvatarSrc(info);
  //         //   val.avatarflag = true;
  //         // }
  //         if(val.photov1){
  //           val.photourl = _self.teacherPicUrl + val._id + "/" + val.photov1;
  //         }else if (val.photo ) {
  //           val.photourl = _self.teacherPicUrl + (val.refId || val._id)  + "/" + val.photo;
  //         } else {
  //           var info = {
  //             _id: val.userid,
  //             avatar: val.avatar
  //           };
  //           val.photourl = CommonService.getAvatarSrc(info);
  //         }
  //         _self.editors.push(val);
  //         // CourseService.setEditorInfo(_self.editors);
  //       });
  //       console.log(_self.editors);
  //     }
  //   });
  // }
  _self.tempitems = [];
  this.enroll = function() {
    var info = {
      action: "enroll",
      lid: _self.id
    };
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      if (result.approved) {
        loginService.getMyProfile(true);
        $state.go("app.course.home", {
          cid: _self.id
        });
      } else if (result.apply) {
        CommonService.showInfoWithTitle("Remainder", "Course Application submitted. You currently do not have access right. Please wait for the approval.");
        $state.reload();
      }
    });
  };
  this.buy = function() {
    $ionicPopup.confirm({
      title: '温馨提示',
      template: '<p style="text-indent: 25px;text-align: justify;">尊敬的驾驶员朋友，国家《生产经营单位安全培训规定》《道路旅客运输企业安全管理规范》规定生产企业须列支年度培训资金，支持驾驶员参加专项教育考核培训等安全培训，请确认您本次课程购买费用是否由公司承担，如公司不承担相关费用，请慎重考虑是否继续购买课程（可参阅省交通厅422、162、197号文件规定）</p> <p>安全行车，幸福万家！</p> <p><i style="color:green;font-size: 20px;" class="ion-android-checkmark-circle"></i> 本人已详细阅读以上提示。</p>',
      okText: '确定',
      cancelText: '取消'
    }).then(function(res) {
      if (res) {
        $state.go('app.course.info.paybill', {
          cid: _self.id
        });
      }
    });

    // $state.go('app.course.info.paybill', {
    //   cid: _self.id
    // });
  }
  this.enroll = function() {
    var info = {
      action: "enroll",
      lid: _self.id
    };
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      if (result.approved) {
        loginService.getMyProfile(true);
        $state.go("app.course.home", {
          cid: _self.id
        });
      } else if (result.apply) {
        CommonService.showInfoWithTitle("Remainder", "Course Application submitted. You currently do not have access right. Please wait for the approval.");
        $state.reload();
      }
    });
  };
  this.enroll = function() {
    var info = {
      action: 'weidongPrepareSingleCourse',
      lid: _self.id,
    }
    CommonService.showLoading();
    ApiService.post('/payment', info).then(function(result) {
      console.log(result)
      //CommonService.stopLoading();
      if (result.data.success && result.data.data) {
        if (result.data.data.enrolled) {
          CommonService.stopLoading();
          CommonService.showInfoWithTitle("提示", "申请成功！");
          checkExsit()
          $state.reload();
          return;
        }else{
          $state.go('app.course.info.paybill', {
            cid: _self.id
          });
        }
      }
    })
  }

  function getErollExist() {
    var info = {
      action: "checkenrollexist",
      lid: _self.id,
    };
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      if (result) {
        _self.enrollinprocess = true;
      }
    });
  }
  this.popupMsg = function() {
    if( _self.course.price){
      CommonService.showInfoWithTitle('Info', 'Please enroll first before get started.')
    }else{
      CommonService.showInfoWithTitle('Info', '请先申请/进入课程，再继续学习！')
    }

  }
  this.getMvsubjectInfo = function(item) {
    if (item.id) {
      CourseApi.getInfo(item.id, function(result) {
        console.log(result);
        _self.audioContents = result.chapters || {};
      });
    }
  }

  function checkExsit() {
    if (loginService.user) {
      //   console.log('go back to info page');
      // $state.go('app.course.info', {
      //   cid: _self.id
      // });
      // getErollExist();
      loginService.getMyProfile(true).then(function(result) {
        if (result) {
          _self.allowenroll = true;
          var mycourses = result.courses;
          console.log(mycourses);
          if (mycourses.indexOf(_self.id) > -1) {
            _self.mycourseFlag = true;
          }
        }
      });
    }
  }
  $scope.$on('$ionicView.enter', function() {
    console.log("enter event");
    checkExsit();
  })
});
