angular.module('bamboo.course').controller('CourseListCtrl', function ($scope, $ionicScrollDelegate, $stateParams, loginService, ApiService, CommonService, $timeout, CourseApi, $state, $rootScope, utilService, $localstorage) {
    var self = this;
    console.log("---- course list -----");
    $rootScope.hideSettings = true;
    this.cat = $stateParams.cat;
    console.log(this.cat);
    this.dynamicTypes = [];
    this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
    ApiService.getSchoolInfo().then(function () {
        self.dynamicTypes = ApiService.school.dynamicTypes || [];
        console.log(self.dynamicTypes);
        if (ApiService.school.coursephoto) {
            self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
        }
    });
    $scope.islogin = false;
    if (loginService.user) {
        $scope.islogin = true;
    }
    this.moreData = true;
    this.inspectorFlag = false;
    self.mydepartments = [];
    this.isshow = false;
    this.items = [];
    this.tempitems = [];
    this.searchmethod = null;
    this.page = 0;
    this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
    this.sortmethod = 'privacy';
    var weekago = new Date();
    console.log(weekago);
    weekago.setDate(weekago.getDate() - 7);
    console.log(weekago);
    var mycourses = [];
    var counter = 0;
    var userflag;
    this.subdomain = $localstorage.get('subdomain');
    $scope.$on('$ionicView.enter', function () {
        console.log("enter event");
        console.log("userflag", userflag);
        loginService.getLoginInfo().then(function (user) {
            // console.log(user);
            var newuserflag = false;
            if (!user) {
                console.log('Not login user');
                self.needlogin = true;
            } else {
                newuserflag = true;
                self.needlogin = false;
                if (counter > 5) {
                    userflag = false; // force to check
                }
            }
            console.log('newuserflag', newuserflag);
            if (newuserflag != userflag) {
                console.log("fire api call");
                self.tempitems = [];
                getCourses(0);
                counter = 0;
                if (newuserflag) {
                    //  getMyDepartments();
                    loginService.getMyProfile().then(function (result) {
                        mycourses = result.courses;
                        //compareMyCourses();
                    });
                } else {
                    mycourses = [];
                    self.inspectorFlag = false;
                    self.mydepartments = [];
                }
            }
            userflag = newuserflag;
        });
        counter++;
    });
    this.topindex = 0;
    $scope.getScrollPosition = function () {
        self.topindex = parseInt($ionicScrollDelegate.getScrollPosition().top / 100);
    };

    function compareMyCourses() {
        console.log('--- compare my courses --');
        if ($state.current.name == "app.course.latest") {
            angular.forEach(self.tempitems, function (item, index) {
                item.courseurl = "app.course.home";
            });
            $scope.items = self.tempitems;
            return;
        }
        if (!loginService.user) {
            angular.forEach(self.tempitems, function (item, index) {
                if (compareDate(item.update)) {
                    item.newflag = true;
                }
                item.courseurl = "app.course.info";
            })
            $scope.items = self.tempitems;
            return;
        }
        // console.log("Mycourses", mycourses);
        if (mycourses && mycourses.length > 0) {
            console.log("-- check --");
            console.log("-- timeout --");
            angular.forEach(self.tempitems, function (item, index) {
                var id = item._id;
                if (mycourses.indexOf(id) > -1) {
                    item.mycourseFlag = true;
                }
            })
        }
        self.isshow = true;
        CommonService.stopLoading();
        angular.forEach(self.tempitems, function (item, index) {
            if (compareDate(item.update)) {
                item.newflag = true;
            }
            if (self.inspectorFlag || item.mycourseFlag || (item.did && self.mydepartments.indexOf(item.did) > -1)) {
                item.courseurl = "app.course.home";
            } else {
                item.courseurl = "app.course.info";
            }
        })
        $scope.items = self.tempitems;
    }

    function compareDate(courseDate) {
        var cd = new Date(courseDate);
        if (cd > weekago) return true;
        else return false;
    };
    if ($state.current.name == "app.course.latest") {
        this.searchmethod = {
            update: {
                $gte: weekago.getTime()
            },
        }
    }
    this.doRefresh = function () {
        self.page = 0;
        self.nextPage();
        $scope.$broadcast('scroll.refreshComplete');
    }

    function getCourses(page) {
        console.log(page);
        var info = {
            action: "getcourselist",
            start: (page) * 15,
            limit: 15,
            //sort: 'update',
        };
        if ($rootScope.srchCourse) {
            self.q = $rootScope.srchCourse;
            self.searchmethod = {
                searchname: self.q
            };
            $rootScope.srchCourse = null;
        }
        if (self.searchmethod) {
            info.search = self.searchmethod;
        }
        if (self.sortmethod) {
            if (self.sortmethod == 'required') {
                info.action = "getSystemCourselist";
            } else {
                info.sort = {
                    predicate: self.sortmethod,
                    reverse: true,
                }
            }
        }
        if (self.cat) {
            if (!info.search) {
                info.search = {};
            }
            info.search.industry = self.cat;
        }
        console.log(info);
        CommonService.showLoading();
        ApiService.post('/lcourses', info).then(function (result) {
            // console.log("-- course list ---");

            console.log(result);
            if (!self.tempitems || page == 0) {
                self.tempitems = [];
            }
            var items = [];
            self.totalCount = 0;
            if (result.data.data) {
                items = result.data.data.items;
                self.totalCount = result.data.data.counter;
                self.tempitems = self.tempitems.concat(result.data.data.items);
            }

            angular.forEach(self.tempitems, function (item, index) {
                if (compareDate(item.update)) {
                    item.newflag = true;
                }
            })
            console.log(self.tempitems);

            self.moreData = ((self.totalCount - self.tempitems.length) > 0);
            // self.totalCount = result.data.counters;
            $timeout(function () {
                compareMyCourses();
            }, 2000)
            $rootScope.totalCourseCounter = self.totalCount;
            $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    }

    //getCourses(0);
    this.nextPage = function () {
        getCourses(self.page);
        self.page++;
    };
    this.searchByName = function (q) {
        console.log("--- by name " + q);
        self.searchmethod = null;
        if (q) {
            self.searchmethod = {
                searchname: q
            };
        }
        self.tempitems = [];
        self.page = 0;
        getCourses(0);
    };
    this.searCategory = function (cate) {
        self.catShow = false;
        self.cat = cate.key;
        self.searchmethod = null;
        self.tempitems = [];
        self.page = 0;
        getCourses(0);
    }
    /*   if (self.searchmethod) {
     info.search = self.searchmethod;
     }
     if (self.sortmethod) {
     info.sort = self.sortmethod;
     } */
    function getNewSort(method) {
        self.sortmethod = method;
        self.tempitems = [];
        self.cat = null;
        self.searchmethod = null;
        self.page = 0;
        getCourses(0);
    }

    this.getHotestCourses = function () {
        getNewSort("visitercounter");
    };
    this.PublicCourses = function () {
        self.sortmethod = 'privacy';
        self.tempitems = [];
        self.cat = null;
        self.searchmethod = {
            privacy: 'public'
        };
        self.page = 0;
        getCourses(0);
    };
    this.getNewCourses = function () {
        getNewSort("update");
    };
    this.getRequiredCourses = function () {
        self.tempitems = [];
        $scope.items = [];
        getNewSort("required");
    };
    this.getTopCourses = function () {
        getNewSort("top");
    };
    this.searchCourseByType = function (type) {
        self.sortmethod = type;
        self.searchmethod = {
            dynamicType: type
        };
        self.page = 0;
        getCourses(0);
    }
    utilService.watchScroll($scope);

    function getCourseCategory() {
        ApiService.getSchoolInfo().then(function () {
            if (ApiService.category) {
                self.category = ApiService.category;
                var catList = [];
                getArray(self.category, catList, 0, '');
                $scope.catitems = catList;
                console.log($scope.catitems);
            }
        });
    }

    getCourseCategory();

    function getArray(obj, array, level, parent) {
        if ((typeof obj) === "object") {
            for (var key in obj) {
                var fullkey;
                if (parent == '') {
                    fullkey = key;
                } else {
                    fullkey = parent + "," + key;
                }
                var _i = {
                    key: fullkey,
                    value: level,
                    title: key,
                    items: [],
                };
                array.push(_i);
                var info = obj[key];
                if (typeof info === "object") {
                    getArray(info, _i.items, level + 1, fullkey);
                }
            }
        }
    }

    this.courseInfo = function (url, cid) {
        //Ƿ¼
        if (!$scope.islogin) {
            $state.go('app.config.login');
        } else {
            //ǷΪѿγ
            $state.go(url, {
                cid: cid
            });
        }
    }
});
angular.module('bamboo.course').directive('ngEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if (event.which === 13) {
                scope.$apply(function () {
                    scope.$eval(attrs.ngEnter);
                });
                event.preventDefault();
            }
        });
    };
});