// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.course', ['ionic', "ionic.native", "ionic.utils"]).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.course', {
    url: '/course/:cat',
    views: {
      'Content@app': {
        templateUrl: 'app/course/courselist.html',
        controller: 'CourseListCtrl as ctrl',
      }
    },
  }).state('app.course.latest', {
    url: '/latest',
    views: {
      'Content@app': {
        templateUrl: 'app/course/latestlist.html',
        controller: 'CourseListCtrl as ctrl',
      }
    }
  }).state('app.course.category', {
    url: '/category',
    views: {
      'Content@app': {
        templateUrl: 'app/course/category.html',
        controller: 'CategoryCtrl as ctrl',
      }
    }
  }).state('app.course.profile', {
    url: '/teacherprofile/:teacherloginname',
    views: {
      'Content@app': {
        templateUrl: 'app/course/teacherprofile.html',
        controller: 'TeacherProfileCtrl as ctrl'
      }
    }
  }).state('app.course.categorySublist', {
    url: '/categorySublist',
    views: {
      'Content@app': {
        templateUrl: 'app/course/category_sublist.html',
      }
    }
  }).state('app.course.home', {
    url: '/home/:cid',
    params: { "cid":null, "mvid": null, "rid": null },
    cache: false,
    views: {
      'Content@app': {
        templateUrl: 'app/course/course_home.html',
        controller: 'CourseHomeCtrl as ctrl',
      }
    },
    // data_rightbutton: {
    //   skip: true
    // }
  }).state('app.course.audiohome', {
    url: '/audiohome/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/course_home2.html',
        controller: 'CourseHomeCtrl as ctrl',
      }
    },
    // data_rightbutton: {
    //   skip: true
    // }
  }).state('app.course.info', {
    url: '/info/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/courseinfo.html',
        controller: 'CourseInfoCtrl as ctrl'
      }
    }
  }).state('app.course.info.paybill', {
    url: '/paybill',
    views: {
      'Content@app': {
        templateUrl: 'app/course/course_pay_bill.html',
        controller: 'CourseBuyCtrl as ctrl'
      }
    }
  }).state('app.course.infoparent', {
    url: '/infoparent/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/courseinfo_parent.html',
        controller: 'CourseInfoCtrl as ctrl'
      }
    }
  }).state('app.course.home.chapterslist', {
    url: '/chapters/:mvid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapterlist.html',
        controller: 'ChapterListCtrl as ctrl',
      }
    }

  }).state('app.course.home.chapterslist.mp4', {
    url: '/mp4/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/mp4.html',
       // controller: "MP3PPTCtrl as ctrl"
        controller: "IVChapterCtrl as ctrl"

      }
    }
  }).state('app.course.home.chapterslist.mp3ppt', {
    url: '/mp4/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/mp3ppt.html',
        controller: "MP3PPTCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.mp4quiz', {
    url: '/mp4quiz/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/mp4quiz.html',
        controller: "Mp4QuizChapterCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.html', {
    url: '/html/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/html.html',
        controller: "ChapterItemCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.html5', {
    url: '/html5/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/html5.html',
        controller: "Html5Ctrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.ebook', {
    url: '/ebook/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/html5.html',
        controller: "Html5Ctrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.lms', {
    url: '/lms/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/lms.html',
        controller: "LMSCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.lms2004', {
    url: '/scorm2004/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/scorm2004.html',
        controller: "Scorm2004Ctrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.pdf', {
    url: '/pdf/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/pdf.html',
        controller: "ChapterItemCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.ppts', {
    url: '/ppts/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/ppts.html',
        controller: "PPTsCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.flash', {
    url: '/flash/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/flash.html',
        controller: "ChapterItemCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.youtube', {
    url: '/youtube/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/youtube.html',
        controller: "ChapterItemCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.vimeo', {
    url: '/vimeo/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/youtube.html',
        controller: "ChapterItemCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.test', {
    url: '/test/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/test.html',
        controller: "TestChapterCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.assignment', {
    url: '/assignment/:aid',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/assignment.html',
        controller: "AssignmentCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.exam', {
    url: '/exam/:type/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/exampaper.html',
        controller: "ExamPaperCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.quiz', {
    url: '/quiz/:type/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/exam/exampaper.html',
        controller: "ExamPaperCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.reading', {
    url: '/reading/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/reading.html',
        controller: "ReadingChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.mp4ppt', {
    url: '/mp4/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/mp4ppt.html',
        controller: "MP3PPTCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.idiom', {
    url: '/idiom/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/idiom.html',
        controller: "IdiomChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.bishun', {
    url: '/bishun/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/bishuns.html',
        controller: "BishunChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.word', {
    url: '/word/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/word.html',
        controller: "WordChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.msoffice', {
    url: '/msoffice/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/msoffice.html',
        controller: "MSOfficeCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.poetry', {
    url: '/poetry/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/poetry.html',
        controller: "PoetryChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.fillblank', {
    url: '/fillblank/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/fillblank.html',
        controller: "IdiomFillBlankChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.audioexp', {
    url: '/audioexp/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/audioexp.html',
        controller: "AudioExpChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.eword', {
    url: '/eword/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/eword.html',
        controller: "EWordChapterCtrl as wctrl"
      }
    }
  }).state('app.course.home.chapterslist.onlinequiz', {
    url: '/onlinequiz/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/mp4quiz.html',
        controller: "Mp4QuizChapterCtrl as ctrl"
      }
    }
  }).state('app.course.home.chapterslist.chooseans', {
    url: '/chooseans/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/chooseans.html',
        controller: "ChooseAnswerChapterCtrl as wctrl"
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.course.home.chapterslist.dragfill', {
    url: '/dragfill/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/dragfill.html',
        controller: "DragFillChapterCtrl as wctrl"
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.course.home.chapterslist.iv', {
    url: '/iv/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/course/chapter/iv.html',
        controller: "IVChapterCtrl as ctrl"
      }
    }
  }).state('app.course.home.takephoto', {
    url: '/takephoto/:isSign',
    views: {
      'Content@app': {
        templateUrl: 'app/course/takephoto.html',
        controller: "TakePhotoCtrl as ctrl"
      }
    }
  });
});