'use strict';
angular.module('bamboo.course').controller('TeacherProfileCtrl', function ($scope, UserService, $stateParams, CommonService, ApiService, $ionicModal, $state, $rootScope, loginService) {
  var _self = this;
  var _userloginname = $stateParams.teacherloginname;
  console.log("_userloginname" + _userloginname);
  _self.teacherdefault = ApiService.SHOST + '/public/images/defaultteacher.png';
  _self.teacherPicUrl = ApiService.SHOST + "/photo/" + ApiService.RES + "/teachers/";
  this.defaultpic = ApiService.SHOST + "/public/images/videos.png";
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.subjectPicUrl = ApiService.SHOST + "/public/" + ApiService.RES;
  var teacherinfoId;
  var weekago = new Date();
  console.log(weekago);
  weekago.setDate(weekago.getDate() - 7);
  console.log(weekago);
  var mycourses = [];
  this.topics = [];
  $scope.activeTab = "EditorInfo";
  this.teacher = {};
  _self.page = 0;
  _self.loadMoreDataCount = 3;

  this.loadMore = function () {
    _self.loadMoreDataCount = _self.teacherinfo.coursesinfo.length;
  };

  $scope.activateTab = function (tab) {
    $scope.activeTab = tab;
  };
  this.review = function () {
    $ionicModal.open({
      templateUrl: "components/dialog/rating-dlg.html",
      controller: "RatingDlgCtrl",
      controllerAs: 'ctrl',
      resolve: {
        title: function () {
          return _userloginname;
        },
        types: function () {
          return ["Knowledge", "Attraction", "Content"];
        }
      }
    }).result.then(function (result) {
        console.log(result);
        var info = {
          action: "addteacherassessment",
          value: result.averageRating,
          object: result,
          id: teacherinfoId
        };
        ApiService.post('/rating', info).then(function (result) {
          if (result.data.success) {
            console.log(result.data);
            _self.showassessment = false;
          }
        });
      });
  };

  function compareMyCourses() {
    console.log('--- compare my courses --');

    loginService.getMyProfile().then(function (result) {
      console.log(result);
      mycourses = result.courses;
      console.log("Mycourses", mycourses);
      //  callback(mycourses);
      if (mycourses && mycourses.length > 0) {
        console.log("-- check --");
        console.log("-- timeout --");
        angular.forEach(_self.tempitems, function (item, index) {
          var id = item._id;
          if (mycourses.indexOf(id) > -1) {
           
      console.log("check and check again");
            item.mycourseFlag = true;
          }
        })
      }
      angular.forEach(_self.tempitems, function (item, index) {
        if (compareDate(item.update)) {
          item.newflag = true;
        }
        if (_self.inspectorFlag || item.mycourseFlag || (item.did && _self.mydepartments.indexOf(item.did) > -1)) {
          item.courseurl = "app.course.home";
        } else {
          item.courseurl = "app.course.info";
        }
      });
      $scope.items = _self.tempitems;
      // $scope.$apply();
      console.log($scope.items);
    });
  }

  _self.init = function () {
    UserService.getTeacherInfoByLoginname(_userloginname, function (data) {
      console.log(data);
      _self.teacherinfo = data;
      if (_self.teacherinfo.photov1) {
        _self.teacherinfo.avatarSrc = _self.teacherPicUrl + _self.teacherinfo._id + "/" + _self.teacherinfo.photov1;
      }else if (_self.teacherinfo.photo) {
        _self.teacherinfo.avatarSrc = _self.teacherPicUrl + (_self.teacherinfo.refId||_self.teacherinfo._id) + "/" + _self.teacherinfo.photo;
      } else {
        _self.teacherinfo.avatarSrc = CommonService.getAvatarSrc(_self.teacherinfo);
     // console.log("vatar" + _self.teacherinfo.avatarSrc)
      }
      
      teacherinfoId = data._id;
      if (data.rating) {
        $scope.averageRating = data.rating.toString().substring(0, 3);
      }

      // get teacher's topic
      /*  UserService.getUserTopicByID(_self.teacherinfo._id, function(data) {
       _self.teacherinfo.topics = data;
       })*/
      // get teacher's courses
      CommonService.showLoading();
      UserService.getTeacherCoursesByLoginname(_self.teacherinfo.username, function (result) {
        console.log(result);
        _self.teacherinfo.coursesinfo = result.items;
        console.log(result);
        console.log(_self.teacherinfo.coursesinfo);

        CommonService.stopLoading();
        console.log("-- course list ---");
        // console.log(result.data.data);
        if (!_self.tempitems) {
          _self.tempitems = [];
        }
        console.log(result);
        _self.tempitems = _self.tempitems.concat(result);
        angular.forEach(_self.tempitems, function (item, index) {
          console.log(item);
          if (compareDate(item.update)) {
            // console.log("new");
            item.newflag = true;
          }
        });
        console.log(_self.tempitems);
        //  console.log(result.data);
        _self.totalCount = result.counters;
        _self.moreData = ((_self.totalCount - _self.tempitems.length) > 0);
        console.log(_self.moreData)
        if (_self.totalCount < result.counters) {
          _self.totalCount = result.counters;
        }
        compareMyCourses();
        $rootScope.totalCourseCounter = _self.totalCount;
      });
      // get teacher's classes
      UserService.getTeacherClassesByLoginname(_self.teacherinfo.username, function (data) {
        _self.teacherinfo.classesinfo = data;
      });
      UserService.getUserProfileByLoginname(_userloginname, function (data) {
        console.log(data);
        _self.teacherinfo.user = data;
        var id = data.id;
        UserService.getTeacherOnePageBlog(id, _self.page, '*', 'all', function (data) {
          console.log(data);
          _self.totalBlogCnt = data.counters;
          _self.topics = data.data;
          _self.page += 1;
        });
      });
    });
  };

  this.displayNum = 5;

  _self.loadMoreBlog = function () {
    _self.displayNum = _self.displayNum + 5;
  };

  /*  _self.loadMoreBlog = function () {
   UserService.getUserProfileByLoginname(_userloginname, function (data) {
   UserService.getTeacherOnePageBlog(data.id, _self.page, 5, 'all', function (data) {
   console.log(data);
   _self.totalBlogCnt = data.counters;
   _self.topics = data.data;
   _self.page += 1;
   });
   });
   };*/


  function compareDate(courseDate) {
    var cd = new Date(courseDate);
    //  console.log(courseDate);
    //  console.log(weekago);
    if (cd > weekago) return true;
    else return false;
  }

  if ($state.current.name == "app.course.latest") {
    this.searchmethod = {
      update: {
        $gte: weekago.getTime()
      }
    }
  }
  _self.init(); //init this controller
});
