angular.module('bamboo.coursebundle').controller('CourseBundleInfoCtrl', function($scope, CommonService, $stateParams, loginService, ApiService, $translate, $state, $rootScope, $ionicPopup) {
  var self = this;
  this.id = $stateParams.bid;
  this.photoUrl = ApiService.SHOST + '/bundlephotos/' + self.id + "/";
  this.defaultUrl = ApiService.SHOST + '/public/images/videos.png';
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  if (loginService.school&&loginService.school.coursephoto) {
    this.defaultUrl = ApiService.SHOST + "/site/" + loginService.school.coursephoto;
  }
  function getInfo() {
    var info = {
      action: 'getBundleInfo',
      id: self.id,
    }
    ApiService.post('/coursebundle', info).then(function(data) {
      console.log(data);
      var result = data.data.data;
      self.item = result.bundle;
      $rootScope.bundleName= self.item.name;
      self.imageUrl = self.item.photo ? self.picUrl + self.item.photo : null;
      self.courses = result.courses;
      checkMyBundle();
    });
  }
  getInfo();
  function checkMyBundle()
  {
    var info = {
      action: 'checkMyBundle',
      bid: self.id,
    }
    ApiService.post('/coursebundle', info).then(function(result) {
      console.log(result.data.data);
      if (result.data.success && result.data.data) {
        self.enrolled = result.data.data.enrolled;
        self.applied = result.data.data.apply;
      }
    });
  }

  this.apply = function() {
    var info = {
      action: "apply",
      bid: self.id,
    }
    console.log(info);
    ApiService.post('/coursebundle', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        CommonService.showInfo($translate.instant('Application submitted!'));
        checkMyBundle();
      } else {
        CommonService.showError(result.data.error);
      }
    });
  }

  this.coupon = function(){
    $scope.data = {
      comment: ""
    }
    $scope.clearError = function() {
      $scope.data.error = undefined;
    }
    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'app/component/addCouponDlg.component.html',
      title: 'Enter Your Coupon Code',
      // subTitle: 'Please use normal things',
      scope: $scope,
      buttons: [{
        text: 'Cancel'
      }, {
        text: '<b>Submit</b>',
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.code||$scope.data.code.length < 6) {
            console.log($scope.data.code);
            $scope.data.error = "Invalid code!"
            e.preventDefault();
          } else {
            return $scope.data.code;
          }
        }
      }]
    });
    myPopup.then(function(code) {
      console.log('Tapped!', code);
        if (!code) return;
        applyCode(code);
      });
  }

  function applyCode(code)
  {
    var info = {
      action: "activeByCoupon",
      bid: self.id,
      code: code,
    }
    console.log(info);
    ApiService.post('/coursebundle', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        CommonService.showInfo('Coupon code successfully registered,...');
        checkMyBundle();
      } else {
        CommonService.showError(result.data.error);
      }
    }); 
  }

});