angular.module('bamboo.coursebundle').controller('BundleRecordDetailCtrl', function($scope, CommonService, $stateParams, loginService, ApiService, $translate, $state, $rootScope, $ionicPopup, UserService) {
  var self = this;
  this.rid = $stateParams.id;

  function bundleApi(info, callback) {
    ApiService.post('/coursebundle', info).then(function(data) {
      console.log(data);
      if (data.data.success) {
        return callback(data.data.data);
      }
    });
  }
  console.log('BundleRecordDetailCtrl', this.id);

  function getInfo() {
    var info = {
      action: 'getRecord',
      id: self.rid,
    }
    bundleApi(info, function(result1) {
      console.log(result1);
      self.record = result1;
      if (!self.record.selectedCourses) {
        self.record.selectedCourses = [];
      }
      self.id = self.record.bundleId;
      var info = {
        action: 'getBundle',
        id: self.id,
      }
      console.log(info);
      bundleApi(info, function(result) {
        console.log(result);
        getUserCourseIds(self.record.userId)
        self.bundle = self.item = result.bundle;
        $rootScope.bundleName = self.item.name;
        self.courses = result.courses;
        if (self.bundle.required) {
          for (var id in self.bundle.required) {
            if (self.record.selectedCourses.indexOf(id) < 0) {
              self.record.selectedCourses.push(id);
            }
          }
        }
        angular.forEach(self.courses, function(item) {
          if (self.bundle.required && self.bundle.required[item._id]) {
            item.required = true;
          }
          courseInfo[item._id] = item;
        })
        console.log(self.bundle);
        changeCourses()
      });
    });
  }

  getInfo();
  this.bundle = {};
  var _change = false;
  this.toUpdateFlag = false;
  var courseInfo = {};
  this.selectedCourses = [];
  this.candidates = [];

  function getUserCourseIds(id) {
    var info = {
      action: 'getUserStudyCourseIds',
      id: id,
    }
    UserService.UserApi(info, function(result) {
      for (var id in courseInfo) {
        if (result.indexOf(id) > -1) {
          courseInfo[id].enrolled = true;
        } else {
          courseInfo[id].enrolled = false;
        }
      }
    });
  }
  this.selectedOptionCourseCounter = 0;
  this.update = function() {
    var info = {
      action: 'updateBundleRecord',
      id: self.rid,
      courses: self.record.selectedCourses,
      allset: true,
    }
    bundleApi(info, function(result) {
      console.log(result);
      getInfo();
     //$state.go('app.home');
    });
  }

  function changeCourses() {
    self.selectedCourses = [];
    self.candidates = [];
    self.selectedOptionCourseCounter = 0;
    angular.forEach(self.record.selectedCourses, function(id) {
      if (courseInfo[id]) {
        self.selectedCourses.push(courseInfo[id]);
        if (!courseInfo[id].required) {
          self.selectedOptionCourseCounter++;
        }
      }
    })
    for (var id in courseInfo) {
      if (self.record.selectedCourses.indexOf(id) < 0) {
        self.candidates.push(courseInfo[id]);
      }
    }
    console.log(self.selectedCourses);
    console.log(self.candidates);
  }
  this.add = function(id) {

    if (self.record.selectedCourses.indexOf(id) < 0) {
      self.record.selectedCourses.push(id);
      changeCourses();
      _change = true;
    }
    if (self.bundle.optionNumber == self.selectedOptionCourseCounter && _change) {
      self.toUpdateFlag = true;
    }
  }
  this.remove = function(id) {
    var pos = self.record.selectedCourses.indexOf(id);
    if (pos > -1) {
      self.record.selectedCourses.splice(pos, 1);
      changeCourses();
    }
  }
});