angular.module('bamboo.coursebundle').controller('BundleRecordsCtrl', function($scope, ApiService, CommonService, utilService) {
  var self = this;
  this.defaultUrl = ApiService.SHOST + '/public/images/videos.png';
  this.moreData = true;
  this.items = [];
  this.tempitems = [];
  this.page = 0;
  this.photoUrl = ApiService.SHOST + "/bundlephotos/";
  
  this.doRefresh = function()
  {
    self.page = 0;
    self.nextPage();
    $scope.$broadcast('scroll.refreshComplete');
  }

  $scope.$on('$ionicView.enter', function() {
    console.log("enter event");
    getItems(0);
  });

  function getItems(page) {
    console.log(page);
    var info = {
      action: "getMyBundleRecords",
      start: (page) * 8,
      limit: 8,
    };
    console.log(info);
    CommonService.showLoading();
    ApiService.post('/coursebundle', info).then(function(result) {
      CommonService.stopLoading();
      console.log(result);
      if (!self.tempitems||page==0) {
        self.tempitems = [];
      }
      self.tempitems = self.tempitems.concat(result.data.data.items);
      self.totalCount = result.data.data.counter;
      self.moreData = ((self.totalCount - self.tempitems.length) > 0);
      $scope.items = self.tempitems;
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  this.nextPage = function() {
    getItems(self.page);
    self.page++;    
  };
 
  utilService.watchScroll($scope);

});