angular.module('bamboo.blog').controller('MyEventsDetail', function(loginService, $cordovaGeolocation, $cordovaDevice, $scope, ApiService, $sce, CommonService, $state, $stateParams, $filter, $ionicPopover, $translate, $ionicPopup) {
  var _self = this;
  this.id = $stateParams.id;
  this.contentModel = {};
  var _favourites = [];
  this.publicUrl = ApiService.SHOST + "/public/images/";
  this.contentModelPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolevent/" + _self.id + "/";
  _self.defaultEventPhoto = ApiService.SHOST + "/public/images/details.png";
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.eventphoto) {
      _self.defaultEventPhoto = ApiService.SHOST + "/site/" + ApiService.school.eventphoto;
    }
  });
  loginService.getLoginInfo().then(function() {
    if (loginService.user) {
      _self.allowfaviorate = true;
    };
  });
  this.favourite = function() {
    console.log(_self.contentModel);
    if (_favourites.indexOf(_self.id) < 0) {
      var object = {
        type: 'event',
        id: _self.id,
      };
      var info = {
        action: "addfavourite",
        object: object,
      }
      ApiService.post("/user", info).then(function(result) {
        if (result.data.success) {
          loginService.getMyProfile(true);
          _self.contentModel.favourite = true;
        }
      });
    }
  }

  function getInfo() {
    ApiService.get("/myevents/" + _self.id).then(function(result) {
      if (result.data.success) {
        console.log(result.data.data);
        var item = _self.event = result.data.data.event;

        var timecounts = result.data.data.timecounts;
        _self.countMap = _.keyBy(timecounts, function(o) {
          return o._id;
        });
        console.log(_self.countMap);
        console.log(_self.event);
        _self.contentModel = _self.event;
        console.log(_self.contentModel);
        if (_self.event.albums) {
          _self.albums = _self.event.albums.map(function(o) {
            return {
              url: _self.eventAlbumPicUrl + o.photo,
              thumbUrl: _self.eventAlbumPicUrl + o.photo,
              caption: o.name
            }
          });
          console.log(_self.albums);
        }

        if (_self.event.registrationFlag) {
          if (_self.event.registrationEnd) {
            var end = new Date(_self.event.registrationEnd);
            var now = new Date();
            if (end > now) {
              _self.event.enroll = true;
            }
          } else {
            _self.event.enroll = true;
          }
        }
        var appInfo = {};
        angular.forEach(result.data.data.records, function(item, index) {
          //  console.log(app);
          var key = item.time;
          appInfo[key] = true;
        })
        console.log(appInfo);
        var eventdata = [];
        for (var i = 0; i < item.repeatCounter; i++) {
          var time = item.start;
          switch (item.repeatType) {
            case 'week':
              time = moment(item.start).add(i, 'weeks').toDate();
              break;
            case 'month':
              time = moment(item.start).add(i, 'months').toDate();
              break;
            case 'day':
              time = moment(item.start).add(i, 'days').toDate();
              break;
          }
          var info = {
            title: item.name,
            start: time,
            isoTimeStr: new Date(time).toISOString(),
            stick: true,
            id: item._id,
            address: item.address,
          }
          console.log(time);
          var key = new Date(time).toISOString();

          console.log(key);
          if (appInfo[key]) {
            info.selected = true;
          }
          eventdata.push(info);
        }
        _self.dateList = eventdata || [];
        _self.isMultiple = _self.dateList.length > 1;
        _self.isSingle = _self.dateList.length === 1;
        _self.eventSources = [eventdata];
        console.log(eventdata);
        _self.eventsready = true;
        if (_self.isSingle) {
          initSingleSession(_self.dateList);
        }
        _self.imageUrl = _self.event.photo ? _self.eventPicUrl + _self.event._id + '/' + _self.event.photo : _self.defaultEventPhoto;
      }
    });
  }

  function initSingleSession(list) {
    _self.singleSession = list[0];
    console.log(_self.singleSession);
    var LEN = _self.event.len;
    _self.singleSession.startTime = new Date(_self.singleSession.start);
    _self.singleSession.endTime = new Date(_self.singleSession.startTime);
    _self.singleSession.endTime.setHours(_self.singleSession.startTime.getHours() + LEN);

    console.log(_self.singleSession);
  }

  getInfo();

  function enroll(time) {
    console.log(_self.event);
    if (!_self.event.enroll) {
      return;
    }

    var info = {
      id: _self.id,
      action: 'addrecord',
      time: time,
    };

    ApiService.post("/event", info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        CommonService.showInfo,$translate.instant('Enroll Application submited!');
        $state.reload();
      } else {
        CommonService.showError(result.data.error);
      }
    })
  }


  this.Enroll = function(item) {

    if (_self.myPopup) {
      _self.myPopup.close();
    }
    var info = $translate.instant('Do you really want to book the session ?');
    CommonService.showConfirm(
      info,
      function() {
        enroll(item.start);
      })
  };

  this.submit = function() {
    var info = {
      id: _self.id,
      action: 'addattendancerecord',
      platform: $cordovaDevice.platform,
      deviceId: $cordovaDevice.getUUID(),
    };

    var posOptions = { timeout: 10000, enableHighAccuracy: false };
    $cordovaGeolocation
      .getCurrentPosition(posOptions)
      .then(function(position) {
        info.lat = position.coords.latitude;
        info.lng = position.coords.longitude;
        // CommonService.showLoading();
        CommonService.showLoading();
        ApiService.post("/event", info).then(function(result) {
          CommonService.stopLoading();
          if (result.data.success) {
            CommonService.showInfo,$translate.instant('Enroll Application submited!');
          } else {
            CommonService.showError(result.data.error);
          }
        });
      }, function(err) {
        CommonService.showError("Get Location error, Please check permission ! " + err);
      });
  };
  this.share = function() {
    var link = ApiService.HOST + '/#/events/detail/' + _self.contentModel._id + "?share=true";
    var imageUrl = _self.contentModel.photo ? _self.contentModelPicUrl + _self.contentModel.photo : null;
    console.log(link);
    console.log(imageUrl);
    console.log(_self.contentModel.name);
    CommonService.showShareDialog($scope, _self.contentModel.name, imageUrl, link, _self.contentModel.description);
  };

  $ionicPopover.fromTemplateUrl('app/event/menupopover.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });

  $scope.closeEventPopover = function() {
    $scope.popover.hide();
  };



  // Triggered on a button click, or some other target
  $scope.showPopup = function() {
    $scope.data = {}

    // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'app/event/sessionpopover.html',
      title: 'Book your session',
      scope: $scope,
      buttons: [
        { text: 'Cancel' },
      ]
    });
    _self.myPopup = myPopup;
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
  };
});