angular.module('bamboo.myspace').controller('MyEventsCtrl', function ($scope, ApiService, loginService, $state, $stateParams, CommonService, $filter,utilService, $translate) {
  var _self = this;
  this.page = parseInt($stateParams.page) || 0;
  this.pageSize = 4;
  _self.contentModelPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolevent/";
  this.moreData = false;
  this.items = [];
  this.itemlist = [];
  this.nextPage = function () {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  };
  _self.defaultEventPhoto = ApiService.SHOST + "/public/images/details.png";
  ApiService.getSchoolInfo().then(function () {
    if (ApiService.school.eventphoto) {
      _self.defaultEventPhoto = ApiService.SHOST + "/site/" + ApiService.school.eventphoto;
    }
  });
  getInfo(0);
  this.enroll = function (id) {
    var info = {
      id: id,
      action: 'addrecord'
    };
    CommonService.showLoading();
    ApiService.post("/event", info).then(function (result) {
      CommonService.stopLoading();
      if (result.data.success) {
        CommonService.showInfo,$translate.instant('Enroll Application submited!');
      } else {
        CommonService.showError(result.data.error);
      }
    })
  }

  function getInfo(page) {
    var info = {
      start: page * 8,
      limit: 8,
      action: "getvalidevents"
    }
    CommonService.showLoading();
    ApiService.post("/event", info).then(function (result) {
      CommonService.stopLoading();
      if (result.data.success) {
        if (!_self.items) {
          _self.items = [];
        }
        _self.items = _self.items.concat(result.data.data.items);
        var now = new Date();
        angular.forEach(_self.items, function (item, index, the) {
          if (item.registrationFlag) {
            if (item.registrationEnd) {
              var end = new Date(item.registrationEnd);
              if (end > now) {
                item.enroll = true;
              }
            } else {
              item.enroll = true;
            }
          }
          var startDate = $filter('date')(item.start, "yyyy/MM/d");
          var endDate = $filter('date')(item.time, "yyyy/MM/d");
          if (startDate == endDate) {
            _self.itemlist.push({index: index, display: startDate})
          } else {
            _self.itemlist.push({
              index: index, display: startDate +
              ' - ' + endDate
            });
          }
        });
        _self.totalCount = result.data.data.counter;
        _self.moreData = ((_self.totalCount - _self.items.length) > 0);
        console.log(_self.totalCount, _self.items.length, _self.moreData);
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  utilService.watchScroll($scope);
});
