angular.module('bamboo.favourite').controller('MyFavouriteCtrl', function ($scope,$localstorage, ApiService, loginService, $state, $stateParams, CommonService, $filter, $timeout) {
  var _self = this;
  this.eventpath = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolevent/";
  this.newspath = ApiService.SHOST + '/public/' + ApiService.RES + '/schoolnews/';
  this.consultation = [];
  this.guide = [];
  this.usecase = [];
  this.tab = 0;
  //if($localstorage.get('tabSelectFav')){
  //  _self.tab=parseInt($localstorage.get('tabSelectFav'));
  //}

  this.defaultUsecasePhoto = "img/usecase.jpg";  //"assets/images/addinvo.jpg";
  this.defaultNewsPhoto  = "images/newsinfo.png";
  this.defaultCoursePhoto = ApiService.SHOST + '/public/images/videos.png';
  this.shownews = '';
  ApiService.getSchoolInfo().then(function () {
    if (ApiService.school.newsphoto) {
      _self.defaultNewsPhoto = ApiService.SHOST + "/site/" + ApiService.school.newsphoto;
    }
  });

  this.delete = function (id, type) {
    console.log(id, type);
    CommonService.showConfirm("确定取消此收藏?", function () {
      loginService.getMyProfile().then(function (_result) {
        console.log(_result)
        // console.log("--- return ---");
        var favourites = _result.favourites;
        var index = -1;
        for (var i = 0; i < favourites.length; i++) {
          var item = favourites[i];
          console.log("----------------")
          console.log(item.type)
          console.log(item.id)
          console.log(type)
          console.log(id)
          if (item.type == type && item.id == id) {
            index = i;
            break;
          }
        }
        if (index > -1) {
          var info = {
            action: 'delfavourite',
            index: index,
          }
          console.log(info);
          ApiService.post("/user", info).then(function (result) {
            console.log(result);
            if (result.data.success) {
              CommonService.showInfo("取消收藏成功")
              loginService.getMyProfile(true).then(function () {
                getInfo();
              })
            }else{
              CommonService.showInfo("取消收藏失败,请重试！")
            }
          });
        }
      });
    });
  }

  function getInfo() {
    var info = {
      action: "getmyfavourite"
    }
    CommonService.showLoading();
    ApiService.post("/user", info).then(function (result) {
      //  console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log(result.data.data);
        _self.courses = result.data.data.courses;
        _self.usecase = result.data.data.usecases;
        angular.forEach(_self.courses, function (news) {
          news.picurl = news.photo ? ApiService.SHOST + '/lcourse/' + news._id + "/" + news.photo : _self.defaultCoursePhoto;
        });
        angular.forEach(_self.usecase, function (news) {
          news.picurl = news.photo ? ApiService.SHOST + '/advinfo/' + news.photo : _self.defaultUsecasePhoto;
        });
        var news = [];
        angular.forEach(result.data.data.newses, function (item1) {
          if (news.length > 0) {
            var flag = false;
            angular.forEach(news, function (item2) {
              if (item1.category == item2.category) {
                item1.picurl = item1.photo ? ApiService.SHOST + '/public/' + ApiService.RES + '/schoolnews/' + item1._id + "/" + item1.photo : _self.defaultNewsPhoto;
                console.log(item2)
                item2.list.push(item1);
                flag = true;
              }
            });
            if (!flag) {
              item1.picurl = item1.photo ? ApiService.SHOST + '/public/' + ApiService.RES + '/schoolnews/' + item1._id + "/" + item1.photo : _self.defaultNewsPhoto;
              var obj = {
                category: item1.category,
                list: [item1]
              }
              news.push(obj)
            }
          } else {
            item1.picurl = item1.photo ? ApiService.SHOST + '/public/' + ApiService.RES + '/schoolnews/' + item1._id + "/" + item1.photo : _self.defaultNewsPhoto;
            var obj = {
              category: item1.category,
              list: [item1]
            }
            news.push(obj)
          }
        });
        _self.news = news;
        // _self.tab = 0;    // 只要删除就重新定位到第一个tab
        //if($localstorage.get('tabSelectFav')){
        //  _self.tab=parseInt($localstorage.get('tabSelectFav'));
        //}
        _self.shownews = '';

        if(getLastVisitedBookmarkedCate() > 1) {
          $timeout(function() {
            _self.shownews = _self.news[getLastVisitedBookmarkedCate() - 2].list;
          }, 100)
        }

        console.log(_self.news)
      }
    });
  }
  getInfo();

  this.toggle = function (index) {
    _self.tab = index + 2;
    console.log(_self.tab)
    _self.shownews = _self.news[index].list;
    console.log(_self.shownews);
    $localstorage.set('tabSelectFav',_self.tab);
  }

  this.setLastVisitedBookmarkedCate = function(key, type) {
    $localstorage.set('lastVisitedBookmarkedCate', key)
  }
  function getLastVisitedBookmarkedCate() {
    return $localstorage.get('lastVisitedBookmarkedCate') || 0;
  }
  $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
    if(fromState.name === 'app.myspace') {
      _self.tab = 0;
    } else {
      _self.tab = getLastVisitedBookmarkedCate();
    }
  });
});
