'use strict';
angular.module('bamboo.forum').controller('ForumCourseListCtrl', function($scope, ApiService, CommonService) {
  var _self = this;
  console.log("---- Course list -----");
  this.cat = $stateParams.cat;
  function getText(string) {
    return string.replace(/<[^>]*>/g, "")
  }
  var page = 0;
  this.moreData = false;
  $scope.displayedTopics = [];
  this.nextPage = function() {
    page++;
    getInfo(page);
    console.log("--- next page --");
  };

  function handleTopics(result) {
    CommonService.stopLoading();
    if (result.data.success) {
      console.log(result.data.data.items);
      angular.forEach(result.data.data.items, function(topic, index) {
        //console.log(topic);
        var author = {
          id: topic.author_id,
          avatar: topic.user.avatar,
        }
        topic.author_url = CommonService.getAvatarSrc(author);
        topic.content = getText(topic.content);
      });
      $scope.displayedTopics = $scope.displayedTopics.concat(result.data.data.items);
      console.log($scope.displayedTopics);
      $scope.totalcounter = result.data.data.counter;
      console.log($scope.totalcounter);
      _self.moreData = (($scope.totalcounter - $scope.displayedTopics.length) > 0);
    } else {
      CommonService.showError(result.data.error);
    }
    console.log(_self.totalCount, $scope.displayedTopics.length, _self.moreData);
    $scope.$broadcast('scroll.infiniteScrollComplete');
  }

  function getInfo(page) {
    var info = {

      action: "getCoursesTopics",
      start: page*15,
      limit: 15
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/mvtopics", info).then(handleTopics);
  }
  getInfo(0);
});