'use strict';
angular.module('bamboo.forum').controller('CourseForumsCtrl', function($scope,loginService,$state, ApiService, CommonService, $stateParams, utilService) {
  var _self = this;
  console.log("---- Course Topics list -----");
  $scope.getText = function(string) {
    return string.replace(/<[^>]*>/g, "")
  }
  this.id = $stateParams.cid;
  //  this.searchmethod = null;
  this.page = 0;
  this.moreData = false;
  $scope.displayedTopics = [];
  this.nextPage = function() {
    _self.page++;
    getTopics(_self.page);
    console.log("--- next page --");
  };
  /* pending backend support
    this.searchByName = function(q) {
      console.log("--- by name " + q);
      _self.searchmethod = null;
      if (q) {
        _self.searchmethod = {
          searchname: q
        };
      }
      $scope.displayedTopics = [];
      _self.page = 0;
      getTopics(0);
    };
  */
  function getTopics(page) {
    var limit = 6; // page size
    var start = page * limit;
    var info = {
      id: _self.id,
      action: "getLCoursesTopic",
      start: start,
      limit: limit,
    };
    /*    if (_self.searchmethod) {
          info.search = _self.searchmethod;
        }*/
    CommonService.showLoading();
    ApiService.post("/mvtopics", info).then(function(result) {
      CommonService.stopLoading();
      console.log("-- topic list ---");
      //console.log(result.data);
      if (result.data.success) {
        $scope.subjectname = result.data.data.name;
        angular.forEach(result.data.data.topics, function(topic, index) {
          //console.log(topic);
          var author = {
            id: topic.author_id,
            avatar: topic.author.avatar,
          }
          topic.author_url = CommonService.getAvatarSrc(author);
        });
        $scope.displayedTopics = $scope.displayedTopics.concat(result.data.data.topics);
        //console.log(_self.id, $scope.displayedTopics);
        $scope.totalcounter = result.data.data.counter;
        _self.moreData = (($scope.totalcounter - $scope.displayedTopics.length) > 0);
      }
      console.log($scope.totalcounter, $scope.displayedTopics.length, _self.moreData);
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  };
  loginService.getLoginInfo().then(function() {
    if (!loginService.user) {
      $state.go('app.config.login')
      return;
    }
    getTopics(0);
  });

  utilService.watchScroll($scope);
});