'use strict';
angular.module('bamboo.forum').controller('TopicItemCtrl', function($scope, ApiService, loginService, CommonService, $stateParams, $state, TopicApi) {
  var _self = this;
  this.id = $stateParams.id;
  this.page = 0;
  this.replies = [];
  this.attachmentsURL = ApiService.SHOST + "/bbs/attachments/";
  if (window.cordova) {
    this.device = true;
  }
  this.showdialog = function(item) {
    CommonService.showHTMLDialog($scope, item.content);
  }
  loginService.getLoginInfo().then(function() {
    var result = loginService.user;
    if (result) {
      var author = {
        id: result._id,
        avatar: result.avatar,
      }
      $scope.user_avatar = CommonService.getAvatarSrc(author);
    } else {
      $state.go('app.index');
    }
  });
  CommonService.showLoading();
  // $scope.user_avatar = CommonService.getAvatarSrc(author);
  //ApiService.get('/fulltopic/' + _self.id).then(function(_result) {
  ApiService.get('/topics/' + _self.id).then(function(_result) {
    //  console.log(_result);
    console.log("--- get mv topic result ---");
    CommonService.stopLoading();
    if (_result.data.success) {
      $scope.topic = _result.data.data;
      $scope.topic.content = CommonService.replaceImgLink($scope.topic.content);
      var author = {
        id: $scope.topic.author_id,
        avatar: $scope.topic.author.avatar,
      }
      $scope.topic.author_url = CommonService.getAvatarSrc(author);
      $scope.detailName = $scope.topic.title;
      _self.page = 0;
      _self.loadMore(0);
      // post-processing of author's avatar
      // angular.forEach($scope.topic.replies, function(reply, index) {
      //   // console.log(reply);
      //   var author = {
      //     id: reply.author._id,
      //     avatar: reply.author.avatar,
      //   }
      //   reply.avatar_url = CommonService.getAvatarSrc(author);
      //   reply.content=CommonService.replaceImgLink(reply.content);
      // })
      console.log("topic", $scope.topic);
      //   console.log($scope.topic);
    } else {
      console.log(_result.data.error);
      // $scope.error = _result.data.error;
    }
  });
  this.nextPage = function() {
    _self.page++;
    _self.loadMore(_self.page);
    console.log("--- next page --");
  };
  this.loadMore = function(page) {
    console.log(page);
    var info = {
      tid: _self.id,
      start: (page) * 6,
      limit: 6
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post('/getreplies', info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        _self.totalCount = result.data.data.counter;
        _self.moreData = ((_self.totalCount - _self.replies.length) > 0);
        console.log(_self.moreData);
        console.log(_self.totalCount);
        var replys = result.data.data.items;
        // angular.forEach(replys, function(reply, index) {
        //   var author = {
        //     id: reply.user._id,
        //     avatar: reply.user.avatar,
        //   }
        //   reply.avatar_url = CommonService.getAvatarSrc(author);
        // })
        _self.replies = _self.replies.concat(replys);
      }
    });
    $scope.$broadcast('scroll.infiniteScrollComplete');
  }
  this.good = function(id, flag) {
    var params = {
      id: id,
      is_good: flag,
      action: "good",
    };
    TopicApi.ForumApi(params, function(result) {
      $state.reload();
    });
  };
  this.addReply = function(id) {
    if (_self.attachmentFiles || !_self.attachmentFiles.length) {
      // skip
    } else if (_self.r_content || _self.r_content.length < 10) {
      CommonService.showError("Reply length can not less than 10.");
      return;
    }
    var params = {
      r_content: _self.r_content,
      topic_id: id,
      files: _self.attachmentFiles
    };
    console.log(params);
    CommonService.showLoading();
    ApiService.put('/replies', params).then(function(result) {
      // console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        console.log("--- success ");
        $state.reload();
      } else {
        console.log("--error");
        $scope.error = result.data.error;
      }
    });
  }
  this.accesscamera = function(fileflag) {
    var url = '/topic/' + _self.id + "/"
    CommonService.shotandUpload(url, fileflag, function(url) {
      _self.r_content = '<img src="' + url + '" width="100%"/>';
      _self.addReply(_self.id);
    });
  }
  this.download = function(url, name) {
    console.log(url);
    CommonService.downloadFileByUrl(url, name, function() {
      console.log('success');
      CommonService.showInfo('Download Success!');
    });
  }
  this.attachmentFiles = [];
  this.replyAttachmentURL = ApiService.SHOST + "/reply/" + _self.id + "/";
  this.videoRecord = function() {
    var url = "reply/" + _self.id + "/";
    CommonService.recordVideoAndUpload(url, function(res) {
      console.log(res);
      _self.attachmentFiles.push(res.result);
    });
  }
  this.addAttachment = function(fileflag) {
    var url = "reply/" + _self.id + "/";
    CommonService.attachmentUpload(url, fileflag, function(res) {
      console.log(res);
      _self.attachmentFiles.push(res.result);
    });
  }
  this.deleteAttach = function(index) {
    CommonService.showConfirm('Are you sure to delete this attachment?', function() {
      _self.attachmentFiles.splice(index, 1);
    });
  }
  this.replyComments = function(id) {
    _self.replyCommentId = id;
  }
  this.addReplyComment = function(replyID) {
    if (!_self.replyComment) {
      CommonService.showError("Reply can not be empty");
      return;
    }
    var params = {
      r_content: _self.replyComment,
      topic_id: $scope.topic._id,
      reply_id: replyID
    };
    console.log(params);
    ApiService.put('/replies', params).then(function(result) {
      console.log(result);
      if (result.data.success) {
        $state.reload();
      } else {
        $scope.error = result.data.error;
      }
    });
  };
}).directive('focusMe', function($timeout) {
  return {
    scope: {
      trigger: '=focusMe'
    },
    link: function(scope, element) {
      scope.$watch('trigger', function(value) {
        if (value === true) {
          //console.log('trigger',value);
          $timeout(function() {
            element[0].focus();
            scope.trigger = false;
          });
        }
      });
    }
  };
});