'use strict';
angular.module('bamboo.forum').controller('TopicNewCtrl', function($scope, $state, $cordovaCamera, CommonService, $cordovaFileTransfer, $stateParams, BBSService, ApiService) {
  var _self = this;
  this.cid = $stateParams.cid;
  this.attachmentsURL = ApiService.SHOST + "/bbs/attachments/";
  this.topic = {};
  if (window.cordova) {
    this.device = true;
  }
  this.add = function() {
      if (!_self.topic.title || _self.topic.title.length < 2) {
        CommonService.showError("Title Length not enough! ");
        return;
      }
      if (!_self.topic.content || _self.topic.content.length < 3) {
        CommonService.showError("Content Length not enough! ");
        return;
      }
      var info = {
        lid: _self.cid,
        title: _self.topic.title,
        t_content: _self.topic.content,
        files:_self.topic.files
      }
      ApiService.put('/topics', info).then(function(result) {
        if (result.data.success) {
          console.log(result.data.data);
          $state.go('app.forums.list.detail',{cid:_self.cid,id:result.data.data});
        } else {
          CommonService.showError('Update Fail!');
          //console.log(result.data);
        }
      });
    }
    //var PictureUrl = "public/" + ApiService.RES + "/bbs/" + _self.id + "/"
    // var forumurl = ApiService.PSURL + '/bbs/' + _self.id + "/";
  this.accesscamera = function(fileflag) {
    var url = "/topic/picture/"
    CommonService.shotandUpload(url, fileflag, function(url) {
      if (!_self.topic.content) {
        _self.topic.content = "";
      }
      _self.topic.content = _self.topic.content + '<img src="' + url + '" width="100%"/>';
      _self.add();
    });
  }
  
  this.videoRecord = function() {
    var url = "/bbs/attachments/";
    CommonService.recordVideoAndUpload(url, function(res) { 
      console.log(res);
      if (!_self.topic.files) {
        _self.topic.files = [];
      }
      _self.topic.files.push(res);
    });
  }

  this.addAttachment = function(fileflag) {
    var url = "/bbs/attachments/";
    CommonService.attachmentUpload(url, fileflag, function(res) {
      console.log(res);
      if (!_self.topic.files) {
        _self.topic.files = [];
      }
      _self.topic.files.push(res);
    });
  }

  this.deleteAttach = function(index) {
    CommonService.showConfirm('Are you sure to delete this attachment?',function(){
        _self.topic.files.splice(index, 1);
    });    
  }
});