angular.module('bamboo.grade').controller('gradeDetailCtrl', function($scope, $stateParams, ApiService, CommonService,$sce) {
  var self = this;
  this.id = $stateParams.id;
  this.papertype = $stateParams.type;
  this.papertype = $stateParams.type;
  this.paperid = $stateParams.pid;
  getInfo(this.id);

  function getInfo(id) {
    var _info = {
      id: id,
      action: 'getdexamrecordbyid'
    };
    if (self.papertype == "Paper") {
      _info.action = 'getexamrecordbyid';
      // getReport(self.paperid);
    }
    console.log(_info);
    examApi(_info, function(_record) {
      console.log("-------_record-------");
      console.log(_record);
      self.comments = _record.comments;
      self.commentAuthor = _record.commentAuthor;
      self.knowledgeresults = _record.knowledgeresult;
      console.log(self.knowledgeresults);
      angular.forEach(self.knowledgeresults, function(item, key) {
        self.showknowledge = true;
        // console.log(item);
        // console.log(key);
        var total = item.correct + item.wrong;
        item.rate = parseInt(item.correct * 100 / total);
      })
      console.log(_record);
      userresult = _record.questions;
      if (self.papertype == "Paper") {
        var _r = {
          action: 'getfullpaper',
          id: self.paperid
        };
        // console.log(_r);
        // console.log(_record);
        examApi(_r, function(paper) {
          //console.log(paper);
          self.paper = paper.paper;
          self.qstList = paper.qstList;
          self.part = handleResult(_record, paper);
          //getReport(self.paperid);
        });
      } else {
        self.paper = _record.paper;
        var info = {
          paper: _record.paper,
          qstList: _record.questions
        };
        self.part = handleResult(_record.record, info);
      }
    });
  }

  function handleResult(record, paper) {
    console.log(record);
    record = record || {};
    paper = paper || {};
    paper.paper = paper.paper || {};
    self.title = paper.paper.title;
    self.correct = record.correct;
    self.miss = record.miss;
    self.score = record.score;
    self.wrong = record.wrong;
    var neededData = [];
    var _qsts = {};
    var _result = record.questions;
    var line = [];
    self.totalscore = 0;
    var questionIds = [];
    if (self.papertype == "Paper") {
      angular.forEach(paper.paper.questions, function(val, idx) {
        self.totalscore += val.score || 0;
        if (questionIds.indexOf(val.id) < 0) {
          questionIds.push(val.id);
        }
      });
    } else {
      // console.log(paper);
      angular.forEach(paper.paper.contents, function(val, idx) {
        self.totalscore += (val.score || 0) * (val.counter || 0);
      });
    }
    angular.forEach(paper.qstList, function(val, idx) {
      var id = val._id;
      _qsts[id] = val;
    });
    var csvstr = "";
    angular.forEach(_result, function(val, key) {
      var id = key;
      if (questionIds.indexOf(id) < 0) {
        questionIds.push(id);
      }
      var q = _qsts[id] || {};
      if (q.comments && typeof q.comments[0] != 'object') {
        q.comments = null;
      } else {
        console.log(q.comments);
        angular.forEach(q.comments, function(comment) {
          var user = {
            id: comment.uid,
            avatar: comment.avatar,
          }
          comment.user_avatar = CommonService.getAvatarSrc(user);
        });
      }
      if (q.audio) {
        q.audiourl = $sce.trustAsResourceUrl(ApiService.SHOST + "/exam/audio/" + encodeURI(q.audio));
      }
      if (q.file) {
        q.fileurl = ApiService.SHOST + "/exam/file/" + q.file;
      }
      var r = val;
      //  console.log(r);
      for (var key in record.reviewresult) {
        var value = record.reviewresult[key];
        if (key == id) {
          r.teacherScore = value;
        }
      }
      if (r.userAnswer) {
        if (q.type == 'multiple' && r.userAnswer.length < 1) {
          delete r.userAnswer;
        } else
        if (q.type == 'mfill' && r.userAnswer.length < 1) {
          delete r.userAnswer;
        }
      }
    });
    var _index = 1;
    angular.forEach(questionIds, function(id) {
        var q = _qsts[id] || {};
        if (q.type != "mquestion") {
          q._index = _index;
          _index++;
        }
        var r = _result[id];
        neededData.push({
          q: q,
          r: r
        })
      })
       console.log(neededData);
    return neededData;
  }

  function examApi(info, callback) {
    ApiService.post('/exam', info).then(function(result) {
      if (result.data.success) {
        if (!callback) {
          console.log("-- api success ---");
          //CommonService.showNoBlockSuccess('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  }
});