angular.module('bamboo.history').controller('VoiceDebugCtrl', function($timeout, $scope, CommonService, RtcService) {
  var self = this;
  this.allowStart = false;
  this.state="wait";
  RtcService.checkMicPermission(function(data) {
    if (!data) {
      CommonService.showError("Mic Access Permission is not turned on", function() {});
    } else {
      console.log('mic ready');
      flag = true;
      //init();
    }
  });
  var audio_stream;
  var timer;
  var speechEvents
  $scope.$on("$ionicView.enter", function(scopes, states) {
    _lasttime = new Date();
  });
  $scope.$on('$ionicView.beforeLeave', function() {
    if (speechEvents) {
      speechEvents.stop();
    }
  });
  var startTime = new Date();

  function init() {
    var audioObj = {
      audio: true,
    }
    var errBack = function(error) {
      console.log('Error', error);
      return;
    };
    navigator.getUserMedia = (navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia);
    if (navigator.getUserMedia) { // Standard
      console.log("--chrome--");
      navigator.getUserMedia(audioObj, function(stream) {
        console.log("audio detected");
        audio_stream = stream;
        var options = {};
        if (!speechEvents) {
          speechEvents = hark(stream, options);
          setTimeout(startRecord, 100);
          speechEvents.on('speaking', speaking);
          speechEvents.on('stopped_speaking', stopSpeaking);
        }
       self.state='listen';
        startToListen();
      }, errBack);
    } else {
      console.log("--- not supported---");
      return;
    }
  }
  this.language = 'Chinese';
  var playAudio;
  this.analystList = [];

  function audioFinish(){
    self.state='listen';
    startToListen();
  }
  function startToListen(){
    if(window.audioVideoRecorder){
      stop();
    }
    setTimeout(startRecord,10);
  }
  function playResult(success,callback) {
    self.state='playsound';
    var filename;
    if (self.language == 'English') {
      filename = "audio/successenglish.mp3";
      if (!success) {
        filename = "audio/failenglish.mp3";
      }
    } else {
      filename = "audio/successchinese.mp3";
      if (!success) {
        filename = "audio/failchinese.mp3";
      }
    }
    try {
      console.log('--- stop  1');
      stop();
      if (playAudio) {
        playAudio.pause();
        playAudio.src = filename;
      } else {
        playAudio = new Audio(filename);
      }
      playAudio.currentTime = 0;
      playAudio.addEventListener("ended", function() {
        playAudio.currentTime = 0;
        audioFinish();
      });
      playAudio.play();
    } catch (e) {
      audioFinish();
    }
  }
  this.start = function() {
    this.startFlag = true;
    self.state='listen';
   // if (!speechEvents) {
    init();
   // }
  }
  this.stop = function() {
    this.startFlag = false;
    self.state='wait';
  }

  function startRecord(flag) {
    console.log('--- startRecord');
    if (!self.startFlag) {
      console.log('can not start')
      return;
    }
    if(self.state!='listen'&&self.state!='recording'){
      console.log('Wrong State called!',self.state);
      return;
    }
    self.state='recording';
   // 
    console.log('-------------------- started!');
    if(!window.audioVideoRecorder){
      window.audioVideoRecorder = window.RecordRTC(audio_stream, {
        type: 'audio',
      });
      
    }
    if(window.audioVideoRecorder.getState()!=='recording'){
      window.audioVideoRecorder.startRecording();
      if(flag){
        timer = setTimeout(stop, 2000);
      }
      startTime = new Date();
    }
    
    
  }
  function stop() {
    console.log('--- stop');
    window.audioVideoRecorder.stopRecording(function(url) {
      console.log('no sound detected', url);
      if (self.state=='recording') {
        setTimeout(startRecord, 100);
      }
    });
  }

  function speaking() {
    console.log('speaking');
    if (timer) {
      clearTimeout(timer);
      timer = null;
    }
    if (self.state=='listen') {
      startRecord(true);
    }else if(self.state=='recording'&&window.audioVideoRecorder.getState()=='stopped'){
      self.state='listen';
      startRecord(true);
    }
  }

  function stopSpeaking() {
    console.log('stopped_speaking',self.state);
    if (self.state=='recording') {
      var time = new Date();
      if (time - startTime < 1500) {
        console.log('too short!');
        return;
      }
      self.state=='upload';
      console.log('stop 2');
      window.audioVideoRecorder.stopRecording(function(url) {
        console.log('speaking file', url);
        if (!self.startFlag) {
          console.log('stop already!');
          return;
        }
        window.audioVideoRecorder.getDataURL(function(dataUrl) {
          console.log('get url');
          CommonService.voiceToText(dataUrl, self.language, function(err, result) {
            console.log(result);
            self.state=='received';
            if (err) {
              console.log("Error", err);
            }
            if (result && result.length) {
              self.state=='resultgood';
              self.analystList = self.analystList.concat(result);
              return playResult(true);
            }
            self.state=='resultbad';
            return playResult(false);

          })
        });
      },function(err){
        console.log(err);
      });
    } else {
      console.log('No recording presented!',self.state);
    }
  }
});