angular.module('bamboo.job').controller('JobApplicationCtrl', function($scope, ApiService, CommonService, $stateParams, loginService, $state) {
  var _self = this;
  this.id = $stateParams.jid;
  this.application = {};
  this.editmode;
  this.photoPath = ApiService.SHOST + '/job/' + this.id + "/";
  this.resumePath = ApiService.SHOST + "/resume/";
  this.defaultPhoto ="img/jobs.png";

  loginService.getMyProfile(true).then(function(result) {
    $scope.user = result;
    console.log($scope.user);
  });

  function getInfo() {
    ApiService.get("/job/" + _self.id).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        _self.item = result.data.data || {};
        _self.imageUrl = _self.item.photo ? _self.photoPath + _self.item.photo : _self.defaultPhoto;
      }
    });
  }
  getInfo();

  this.updateapplication = function() {
    var object = {
      brief: _self.application.brief,
      defaultresume: true,
      skillSets:_self.application.skillSets,
    }
    if (object.defaultresume) {
      object.resumeurl = _self.resumePath + $scope.user.id + '/' + $scope.user.resume;
      object.resumename = $scope.user.resume;
    }
    console.log(object);
    var info = {
      object: object,
      action: "createapplication",
      jid: _self.id,
      owner: loginService.school.name,
    }
    console.log(info);
    if (_self.application._id) {
      info.action = "updateapplication";
      info.id = _self.application._id;
    }
    ApiService.post("/job", info).then(function(result) {
      if (result.data.success) {
        CommonService.showInfo("Your Application Submitted Successfully.");
        $state.reload();
      } else {
        CommonService.showError(result.data.error);
      }
    })
  }

  function getMyApplication() {
    var info = {
      jid: _self.id,
      action: 'getmyapplication'
    };
    ApiService.post("/job", info).then(function(result) {
      if (result.data.success) {
        console.log(result.data.data);
        if (result.data.data) {
          _self.application = result.data.data;
          if(_self.application.brief){
            _self.application.brief = _self.application.brief.replace(/&nbsp;/g, '').replace(/<[^>]*>/g, "").replace(/\./g, ',');
          }
        }
      } else {
        CommonService.showError(result.data.error);
      }
    })
  }
  getMyApplication();
});