angular.module('bamboo.job').controller('JobDetailCtrl', function($scope, CommonService, $cordovaDevice, $stateParams, loginService, ApiService, $state, $translate, $sce, CourseApi) {
  var _self = this;
  this.id = $stateParams.jid;
  this.item = {};
  this.editmode;
  this.jobPath = ApiService.SHOST + '/job/' + this.id + "/";
  this.courseURL = ApiService.SHOST + '/lcourse/';
  this.companypath = ApiService.SHOST + '/company/';
  this.defaultJobPhoto = "img/jobs.png";
  this.defaultCompanyPhoto = "img/company.png";
  this.tab = 0;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  this.edit = function() {
    _self.editmode = true;
  }

  function getInfo() {
    ApiService.get("/job/" + _self.id).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        _self.item = result.data.data || {};
        if (_self.item.audio) {
          _self.item.audiourl = $sce.trustAsResourceUrl(_self.photoPath + encodeURI(_self.item.audio));
        }
        _self.imageUrl = _self.item.photo ? _self.photoPath + _self.item.photo : _self.defaultPhoto;
        if (_self.item.companyId) {
          getCompanyInfo(_self.item.companyId);
        }
        if(_self.item.certificates&&_self.item.certificates.length){
          var info = {
            ids: _self.item.certificates,
            action: "getPublishCourseByIds",
          };
          // console.log(ids);
          CourseApi.lcApi(info, function(data) {
            console.log(data);
            _self.relatedcourses=data;
          });
        }
        if (!_self.item.salary && _self.item.lsalary && _self.item.hsalary) {
          _self.item.salary = +_self.item.lsalary + 'SGD/Month -' + _self.item.hsalary + 'SGD/Month';
        }
      }
    });
  }

  function getCompanyInfo(id) {
    var info = {
      action: "getcompany",
      id: id,
    }
    ApiService.post("/business", info).then(function(result) {
      if (result.data.success) {
        _self.company = result.data.data || {};
        console.log(_self.company);
        _self.companyUrl = _self.company.photo ? _self.companypath + _self.company._id + '/' + _self.company.photo : _self.defaultCompanyPhoto;
      }
    });
  }
  getInfo();
 
});