angular.module('bamboo.job').controller('JobListCtrl', function($scope, $stateParams, $ionicScrollDelegate, loginService, ApiService, CommonService, $timeout, $state, $rootScope, utilService,$localstorage) {
  var self = this;
  console.log("---- job list -----");
  this.cat = $stateParams.cat;
  this.moreData = true;
  this.items = [];
  this.tempitems = [];
  this.searchmethod = null;
  this.page = 0;
  this.photoUrl = ApiService.SHOST + '/job/';
  this.defaultPhoto ="img/jobs.png";
  var counter = 0;
  var userflag;
  this.topindex = 0;
  $scope.getScrollPosition = function() {
    self.topindex = parseInt($ionicScrollDelegate.getScrollPosition().top / 100);
  };

  this.doRefresh = function()
  {
    self.page = 0;
    self.nextPage();
    $scope.$broadcast('scroll.refreshComplete');
  }

  function getJobs(page) {
    console.log(page);
    var info = {
      action: "getvalidjobs",
      start: (page) * 8,
      limit: 8,
      //sort: 'update',
    };
    if (self.searchmethod) {
      info.search = self.searchmethod;
    }
    if (self.cat) {
      if (!info.search) {
        info.search = {};
      }
      info.search.category = self.cat;
    }
    if (self.sortmethod) {
      info.sort = {
        predicate:self.sortmethod,
        reverse: true,
      }
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post('/job', info).then(function(result) {
      CommonService.stopLoading();
      console.log(result);
      if (page==0) {
        self.tempitems = result.data.data.items;
      } else {
        self.tempitems = self.tempitems.concat(result.data.data.items);
      }      
      $scope.items = self.tempitems;
      console.log(self.tempitems);
      self.totalCount = result.data.data.counter;
      self.moreData = ((self.totalCount - self.tempitems.length) > 0);
      $rootScope.totalCourseCounter = self.totalCount;
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  //getCourses(0);
  this.nextPage = function() {
    getJobs(self.page);
    self.page++;    
  };
  this.searchByName = function(q) {
    console.log("--- by name " + q);
    self.searchmethod = null;
    if (q) {
      self.searchmethod = {
        searchname: q
      };
    }
    self.page = 0;
    getJobs(0);
  };
  this.getLatestHot = function(flag) {   
    self.sortmethod = flag;
    self.searchmethod = null;
    self.q = '';
    self.page = 0;
    getJobs(0);
  };
  utilService.watchScroll($scope);
});

angular.module('bamboo.job').directive('ngEnter', function () {
    return function (scope, element, attrs) {
        element.bind("keydown keypress", function (event) {
            if(event.which === 13) {
                scope.$apply(function (){
                    scope.$eval(attrs.ngEnter);
                });
                event.preventDefault();
            }
        });
    };
});