angular.module('bamboo.material').controller('MaterialDetailCtrl', function(ApiService, $scope, CommonService, $sce, $stateParams) {
  var _self = this;
  this.id = $stateParams.id;
  this.item = {};
  this.photoPath = ApiService.SHOST + '/material/';
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  this.tab = 0;

  this.share = function() {
    console.log("--- share ---");
    var link = ApiService.HOST + '/#/material//detail/' + _self.item._id + "?share=true";
    console.log(link);
    var imageUrl = _self.item.photo ? _self.photoPath + _self.item._id + '/' + encodeURIComponent(_self.item.photo) : _self.defaultPhoto;
    console.log(link);
    console.log(imageUrl);
    console.log(_self.item.name);
    CommonService.showShareDialog($scope, _self.item.name, imageUrl, link, _self.item.description);
  };

  function getInfo() {
    var info = {
      action: "getmaterial",
      id: _self.id
    };
    CommonService.showLoading();
    ApiService.post("/material", info).then(function(result) {
      CommonService.stopLoading();
      console.log(result.data.data);
      if (result.data.success) {
        _self.item = result.data.data || {};
        if (_self.item.audio) {
          _self.item.audiourl = $sce.trustAsResourceUrl(_self.photoPath + _self.item._id + '/' + encodeURI(_self.item.audio));
        }
        _self.imageUrl = _self.item.photo ? _self.photoPath + _self.item._id + '/' + _self.item.photo : _self.defaultPhoto;
        if (_self.item.pages) {
          console.log(_self.item.pages);
          angular.forEach(_self.item.pages, function(page, index) {
            if (page.type == "Video" && page.video) {
              page.videourl = $sce.trustAsResourceUrl(_self.photoPath + _self.id + '/' + encodeURI(page.video));
            } else if (page.type == "Photo" && page.photo) {
              page.photourl = _self.photoPath + _self.id + '/' + page.photo;
            } else if (page.type == "YouTube" && page.tubeid) {
              page.tubelink = $sce.trustAsResourceUrl("https://www.youtube.com/embed/" + page.tubeid);
            }
            if (page.type == 'Text') {
              page.detail = CommonService.replaceImgLink(page.detail);
            }
          })
        }
      }
    });
  }
  getInfo();
});