angular.module('bamboo.course').controller('AssignmentCtrl', function($scope, ApiService, CommonService, $sce, CourseService, $stateParams, $filter, utilService) {
  this.id = $stateParams.id;
  this.cid = $stateParams.cid;
  this.aid = $stateParams.aid;
  console.log(this.aid);
  if (window.cordova) {
    this.device = true;
  }
  this.assignment = {};
  this.assignmentrecord = {};
  this.content = '';
  this.audio;
  $scope.tabs = 'doc';
  var _self = this;
  this.audiourl = ApiService.SHOST + '/assignment/' + _self.aid + '/';
  this.newAudioUrl = ApiService.SHOST + '/lcourse/' + _self.cid + '/';

  function showAudio(version) {
    _self.audio = {};
    if (version == 'v1') {
      _self.audio = $sce.trustAsResourceUrl(_self.audiourl + encodeURI(_self.assignment.audio));
    } else if (version == 'v2') {
      _self.audio = $sce.trustAsResourceUrl(_self.newAudioUrl + encodeURI(_self.assignment.audioFile));
      console.log(_self.newAudioUrl + _self.assignment.audioFile);
    }
    /*console.log(_self.audiourl + _self.assignment.audio);
    var doc = angular.element($('#audiodiv'));
    doc.empty();
    var audioElement = document.createElement('audio');
    audioElement.src = _self.audio;
    // audioElement.autoplay = true;
    audioElement.controls = 'controls';
    doc.append(audioElement);*/
  }
  this.accesscamera = function(fileflag) {
    var url = 'assignment/' + _self.aid + '/';
    CommonService.shotandUpload(url, fileflag, function(url, filename) {
      var info = {
        file: filename,
        type: 'img',
        mimeType: 'mpeg/mp3',
        fileName: 'audio.mp3',
      }
      if(!_self.assignmentrecord){
        _self.assignmentrecord = {};
      }
      if(!_self.assignmentrecord.files){
        _self.assignmentrecord.files = [];
      }
      _self.assignmentrecord.files.push(info);
      var object = {
        files: _self.assignmentrecord.files,
        //  content: _self.assignmentrecord.content
      };
      var info = {
        object: object,
        action: "updateassignmentrecord",
        id: _self.assignmentrecord._id,
        cid: _self.assignment.cid,
        aid: _self.aid,
      };
      CourseService.post('/exam', info);
      //  updateAssignmentRecord(object);
    }, true);
  }
  this.record = function() {
    var url = 'assignment/' + _self.aid + '/';
    CommonService.recordandUpload(url, function(error, filename) {
      if (error) {
        CommonService.showError(error);
        return;
      }
      console.log(filename);
      var object = {
        audio: filename,
        //  content: _self.assignmentrecord.content
      };
      var info = {
        object: object,
        action: "updateassignmentrecord",
        id: _self.assignmentrecord._id,
        cid: _self.assignment.cid,
        aid: _self.aid,
      };
      CourseService.post('/exam', info);
      //  updateAssignmentRecord(object);
    });
  }

  function getInfo() {
    var info = {
      action: 'getassignment',
      id: _self.aid
    };
    CourseService.post('/exam', info, function(result) {
      console.log(result);
      _self.assignment = result;
      _self.cid = result.cid;
      _self.newAudioUrl = ApiService.SHOST + '/lcourse/' + _self.cid + '/';
      _self.assignment.content = CommonService.replaceImgLink(_self.assignment.content);
      if (result.timecontrol) {
        _self.assignmentValid = utilService.validateTime(result.start, result.stop);
      } else {
        _self.assignmentValid = true;
      }
      console.log(_self.assignment);
      if (_self.assignment.audio) {
        showAudio('v1');
      } else if (!_self.assignment.audio && _self.assignment.audioFile) {
        showAudio('v2');
      }
    });
    var inforecord = {
      action: "getuserassignmentrecordv1",
      aid: _self.aid
    };
    CourseService.post('/exam', inforecord, function(result) {
      console.log(result);
      _self.assignmentrecord = result;
      if (_self.assignmentrecord) {
        if (_self.assignmentrecord.audio) {
          console.log(_self.audiourl + _self.assignmentrecord.audio);
          _self.assignmentrecord.audiourl = $sce.trustAsResourceUrl(_self.audiourl + _self.assignmentrecord.audio);
        }
        _self.imgs = [];
        angular.forEach(result.files, function(item, index) {
          if (item.type == 'img') {
            _self.imgs.push(item);
          }
        })
        _self.assignmentrecord.content = $filter('htmlToPlaintext')(_self.assignmentrecord.content);
      }
    });
  }
  getInfo();
  this.update = function() {
    var info = {
      object: {
        content: _self.assignmentrecord.content
      },
      action: "updateassignmentrecord",
      id: _self.assignmentrecord._id,
      aid: _self.aid,
      cid: _self.assignment.cid,
    };
    CourseService.post('/exam', info);
  };
  this.download = function(url, name) {
    console.log(url);
    CommonService.downloadFileByUrl(url, name, function() {
      console.log('success');
      CommonService.showInfo('Download Success!');
    });
  }
  this.publish = function() {
    var info = {
      action: "publishAssignmentRecord",
      id: _self.assignmentrecord._id,
    };
    CourseService.post('/exam', info, function() {
      CommonService.showInfo('Submit Successful!');
      getInfo();
    });
  }
});