'use strict';
angular.module('bamboo.myspace').controller('MessagethreadCtrl', function($scope, $ionicScrollDelegate, ApiService, $timeout, CommonService, $stateParams, $q, loginService) {
  var self = this;
  var target = $stateParams.target;
  console.log(loginService);
  var userId = loginService.user && loginService.user._id;
  self.user1 = {};
  self.user2 = {};

  function getDisplayInfo(info) {
    switch (info.type) {
      case 'reply':
      case 'blogreply':
      case 'bbsreply':
      case 'feedbackreply':
      case 'feedbackreply':
        info.icon = "fa fa-commenting-o";
        info.action = "Reply";
        break;
      case 'accesscard':
        info.icon = "fa fa-sign-in";
        info.action = "Card Record";
        break;
      case 'announcement':
        info.icon = "fa fa-bullhorn";
        info.action = "Announced";
        break;
      case 'courseapply':
        info.icon = "fa fa-tasks";
        info.action = "Apply for Course Public Access";
        break;
      case 'follow':
        info.icon = "fa fa-user";
        info.action = "Follow";
        break;
      case 'p2p':
        info.icon = "fa fa-envelope-o";
        info.action = "MSG";
        break;
      case 'Following':
        info.icon = "fa fa-envelope-o";
        info.action = "Following User";
        break;
      case 'course':
        info.icon = "fa fa-book";
        info.action = "COURSE";
        break;
      case 'feedback':
        info.icon = "fa fa-envelope-o";
        info.action = "Feedback";
        break;
      default:
        console.log("-- unknown type");
        break;
    }
    return info;
  }

  function sortByTime(a, b) {
    var atime = new Date(a.time);
    var btime = new Date(b.time);
    return atime - btime;
  }

  function getTargetThreadMsgs() {
    var info = {
      action: 'getusertargemsgs',
      target: target,
    }
    console.log(info);
    ApiService.post("/messages", info).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        var messages = result.data.data;
        self.messages = [];
        self.sysMessages = [];
        angular.forEach(messages, function(message) {
          getDisplayInfo(message);
          //  console.log(message.type);
          if (message.type == 'p2p' || message.type == 'multiple') {
            self.messages.push(message);
          } else {
            self.sysMessages.push(message);
          }
        })
        self.messages.sort(sortByTime);
        self.sysMessages.sort(sortByTime);
        console.log(self.messages);
        var userKeys = _.keys(_.groupBy(self.messages, 'author_id'));
        console.log(userKeys);

        extendId2User(self.user1, self.user2, userId, userKeys);
        self.getAvatarById(self.user1.id).then(function(avatarUrl) {
          self.user1.avatarUrl = avatarUrl;
          console.log(avatarUrl);
        })
        self.getAvatarById(self.user2.id).then(function(avatarUrl) {
          self.user2.avatarUrl = avatarUrl;
          console.log(avatarUrl);
        })
        $ionicScrollDelegate.scrollBottom();

      }
    });
  }
  getTargetThreadMsgs();

  //login user's message should be in right side
  function extendId2User(user1, user2, userId, userKeyList) {
    if (userId) {
      userKeyList.forEach(function(item, idx) {
        if (item === userId) {
          user2.id = item;
        } else {
          user1.id = item;
        }
      });
    }
  }

  this.addReply = function() {
    if (self.r_content.length < 2) {
      CommonService.showError('Message is too short!');
      return;
    }
    var info = {
      action: "sendp2p",
      target: target,
      message: self.r_content,
    }
    console.log(info);
    ApiService.post('/messages', info).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        //CommonService.showNoBlockInfo('Send Successful!');
        self.r_content = "";
        getTargetThreadMsgs();
      }
    });
  }

  this.getAvatarById = function(id) {
    var deferred = $q.defer();
    if (!id) {
      deferred.reject();
    };
    ApiService.get('/useravatar/' + id).then(function(result) {
      console.log(result);
      if (result.data.success) {
        var targetUser = result.data.data;
        targetUser.avatarUrl = CommonService.getAvatarSrc(targetUser);
        deferred.resolve(targetUser.avatarUrl);
      } else {

      }
    }, function(error) {
      deferred.reject(error);
    });
    return deferred.promise;
  };
});