angular.module('bamboo.myspace').controller('MyActivitiesCtrl', function($scope, UserService, AppConfig, ApiService, $translate) {
  var _self = this;

  function getId(){
     ApiService.get('/profile/').then(function(result) {
      console.log(result);
      if (result.data.success) {
        this.id = result.data.data.id;
        getActivitySummary();
      }
    });
  }
  function getActivitySummary() {
   
    var info = {
      action: 'getuseractivity',
      id: this.id,
    }
    console.log(info);
    UserService.UserApi(info, function(result) {
      if (!result) {
        return;
      }
      $scope.totalminutes = parseInt(result.total / 60);
      //console.log(result.history);
      var history = result.history;
      var label = [];
      var shortLabel = [];
      var data = [];
      var now = new Date;
      var len = 1000 * 60 * 60 * 24 * 60;
      for (var key in history) {
        var time = new Date(key);
        if (now - time < len) {
          label.push(key);
          // shortLabel.push(key.substring(5));
        }
      }
      label.sort();
      for (var i = 0; i < label.length; i++) {
        var key = label[i];
        data.push(parseInt(history[key].total / 60));
        shortLabel.push(key.substring(5));
      }
      console.log(shortLabel);
      var _colorstr = '24,164,107';
      var _data = {
        labels: shortLabel,
        datasets: [{
          fillColor: 'rgba(' + _colorstr + ',1)',
          strokeColor: 'rgba(' + _colorstr + ',1)',
          pointColor: 'rgba(' + _colorstr + ',1)',
          pointStrokeColor: '#fff',
          pointHighlightFill: '#fff',
          pointHighlightStroke: 'rgba(' + _colorstr + ',1)',
          data: data,
        }]
      };
      $scope.activitydata = _data;
      console.log($scope.activitydata);
      var label1 = [];
      var data1 = [];
      console.log(result.summary);
      for (var key in result.summary) {
        console.log($translate.instant(capitalizeFirstLetter(key)));
        label1.push($translate.instant(capitalizeFirstLetter(key)));
        data1.push(parseInt(result.summary[key] / 60));
      }
      //console.log(label1);
      console.log(data1);
      var _colorstr = '24,164,107';
      var _data1 = {
        labels: label1,
        datasets: [{
          // label: legendlabel,
          fillColor: 'rgba(' + _colorstr + ',1)',
          strokeColor: 'rgba(' + _colorstr + ',1)',
          pointColor: 'rgba(' + _colorstr + ',1)',
          pointStrokeColor: '#fff',
          pointHighlightFill: '#fff',
          pointHighlightStroke: 'rgba(' + _colorstr + ',1)',
          data: data1,
        }]
      };
      $scope.categorydata = _data1;
      console.log($scope.categorydata);
    });
  }
  $scope.options = AppConfig.CHARTOPTIONS;
  getId();
  function capitalizeFirstLetter(string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
  }
});