angular.module('bamboo.myspace').controller('MyAssignmentCtrl', function($scope, ApiService, CommonService, MystudyService,AppConfig, loginService, CourseService, $filter) {
  var _self = this;

  this.gotoAssignment = function(exam) {
    if (AppConfig.Role != 'parent') {
      $state.go('app.myspace.assignment', {
        aid: exam._id
      });
    }
  }

  function getcount() {
    var examinfo = {
      action: 'getmyassignments',
    }
    console.log(examinfo);
    ApiService.post('/lcourses', examinfo).then(function(result) {
      console.log(result.data.data);
      var assignmentitems = result.data.data;
      var completed = 0;
      angular.forEach(assignmentitems, function(item) {
        if (item.donecounter || item.commentscounter) {
          completed++;
        }
      })
      _self.completed = completed;
      _self.uncomplete = assignmentitems.length - completed;
      $scope.totalcount = assignmentitems.length;
      //$scope.displayList = addDateLabel2List(assignmentitems)
    });
  }

  function isToday(dateStr) {
    var todayStr = new Date().toDateString();
    return dateStr === todayStr;
  }

  function addDateLabel2List(assignmentitems) {
    assignmentitems = _.sortBy(assignmentitems, function(o) {
      return -o.created;
    });
    var list = _.groupBy(assignmentitems, function(item) {
      var date = new Date(item.created);
      return date.toDateString();
    });
    console.log(list);
    var displayList = [];
     
    var keys = _.keys(list);
    keys = _.sortBy(keys, function(o) {
      return -new Date(o);
    });
    keys.forEach(function(datestr) {
      date = $filter('date')(new Date(datestr), 'yyyy-MM-dd')
      if (isToday(datestr)) {
        date = 'Today'
      }
      displayList.push({
        isDate: true,
        date: date
      });
      console.log(list[datestr]);
      displayList = displayList.concat(list[datestr]);
    });
    console.log(displayList);
    return displayList;
  }
  getcount();
  this.filterCompleted = function() {
    var examinfo = {
      action: 'getmyassignments',
    }
    var res = [];
    ApiService.post('/lcourses', examinfo).then(function(result) {
      var assignmentitems = result.data.data;
      console.log(assignmentitems);
      angular.forEach(assignmentitems, function(item) {
        if (item && 　(item.donecounter > 0 || item.commentscounter > 0)) {
          res.push(item);
        }
      })
      console.log(res);
      $scope.displayList = addDateLabel2List(res);
      console.log($scope.assignmentitems);
    });
  }
  this.filterTodo = function() {
    var examinfo = {
      action: 'getmyassignments',
    }
    var res = [];
    ApiService.post('/lcourses', examinfo).then(function(result) {
      var assignmentitems = result.data.data;
      console.log(assignmentitems);
      angular.forEach(assignmentitems, function(item) {
        if (item && (!item.donecounter) && (!item.commentscounter)) {
          res.push(item);
        }
      })
      console.log(res);
      $scope.displayList = addDateLabel2List(res);
    });
  }
  this.filterTodo();
});