'use strict';
angular.module('bamboo.myspace').controller('MyCalendarCtrl', function(ApiService, loginService, $stateParams, $scope, $filter) {
  var _self = this;  
  $scope.calendar = {};
  $scope.changeMode = function (mode) {
      $scope.calendar.mode = mode;
  };

  $scope.onEventSelected = function (event) {
      console.log('Event selected:' + event.startTime + '-' + event.endTime + ',' + event.title);
  };

  $scope.onViewTitleChanged = function (title) {
      $scope.viewTitle = title;
  };

  $scope.today = function () {
      $scope.calendar.currentDate = new Date();
  };

  $scope.isToday = function () {
      var today = new Date(),
          currentCalendarDate = new Date($scope.calendar.currentDate);
      today.setHours(0, 0, 0, 0);
      currentCalendarDate.setHours(0, 0, 0, 0);
      return today.getTime() === currentCalendarDate.getTime();
  };

  $scope.onTimeSelected = function (selectedTime, events, disabled) {
      console.log('Selected time: ' + selectedTime + ', hasEvents: ' + (events !== undefined && events.length !== 0) + ', disabled: ' + disabled);
  };

  $scope.calendar.eventSources=[];

  function getEvents()
  {
    var info = {
      action: 'getMyNewEventRecords',
    }
    ApiService.post("/event", info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        var events = result.data.data;
        $scope.eventsdata = [];
        angular.forEach(events, function(item, index) {
        var stop = new Date(item.time);
        stop.setTime(stop.getTime() + (2*60*60*1000));
        $scope.calendar.eventSources.push({
            title: "(E)"+item.eventName,
            startTime: new Date(item.time),
            endTime: new Date(stop),
            hint:'Event<br/>'+item.eventName,
            type:'Event'
          });
        });
        //$scope.eventSources = [$scope.eventsdata];
        //$scope.eventSources.push($scope.eventsdata);
       // console.log($scope.eventsdata);
      }

    });
  }

  function getSession()
  {
    var info = {
      action: 'getUserCourseSessionRecords'
    };
    ApiService.post('/session', info).then(function(result) {
      console.log(result);
        if (result.data.success) {
          var _sessions = result.data.data || [];   
          angular.forEach(_sessions, function(item, idx) {
            var stop = moment(new Date(item.time)).add((item.session.len || 2), 'hours');
            $scope.calendar.eventSources.push({
              title: "(S) "+item.session.name,
              hint:'Session<br/>Course: '+item.courseName+'<br/> Session : '+item.session.name,
              startTime: new Date(item.time),
              endTime: new Date(stop),
              type:'Session'
            });
          });
          console.log($scope.calendar.eventSources);
       }
    });
  }

  function getMeeting()
  {
    var info = {
      action: 'getmymeetings',
    };
    ApiService.post("/vmeeting", info).then(function(result) {
     if (result.data.success) {
        var _meetings = result.data.data.items;
        console.log(_meetings);
        angular.forEach(_meetings, function(item) {
          var stop = new Date(item.start);
          stop.setTime(stop.getTime() + (2*60*60*1000));
          $scope.calendar.eventSources.push({
            title: "(V) "+ item.name,
            startTime: new Date(item.start),
            endTime: new Date(stop),
            hint:"Video Meeting<br/>"+item.name,
            type:'Meeting'
          });
        });
      }
    });
  }

  function getTimerTasks(){
    var info={
      action:"getUserTimeTasks",
    }
    ApiService.post("/user", info).then(function(result) {
      //console.log(result);
      if (result.data.success&&result.data.data) {
          console.log(result.data.data);
          angular.forEach(result.data.data.exams,function(exam){
            var stop = new Date(exam.stop);
            stop.setTime(stop.getTime() + (2*60*60*1000));
            $scope.calendar.eventSources.push({
              startTime:new Date(exam.stop),
              endTime: new Date(stop),
              title:"(E) "+exam.name,
              hint:"Exam<br/>"+exam.name,
              type:'Exam'
            })
          })
          angular.forEach(result.data.data.assignments,function(exam){
            var stop = new Date(exam.stop);
            stop.setTime(stop.getTime() + (2*60*60*1000));
            $scope.calendar.eventSources.push({
              startTime:new Date(exam.stop),
              endTime: new Date(stop),
              title:"(A) "+exam.title,
              hint:"Assignment<br/>"+exam.title,
              type:'Assignment'
            })
          })
          //$scope.eventSources.push(examData);
          $scope.eventsready = true;
      }
    })
  }


      getEvents();
      getSession();
      getMeeting();
      getTimerTasks();

      console.log($scope.calendar.eventSources);

});