angular.module('bamboo.myspace').controller('MyClassAssignmentRecordCtrl', function($scope, $stateParams, ApiService, CommonService, examService, MystudyService, AppConfig, loginService, CourseService, $filter, $ionicPopover, $sce) {
  var self = this;
  var aid = $stateParams.aid;

  self.showMore = false;

  self.baseImageUrl = ApiService.SHOST + "/assignment/" + aid + "/";

  function getRecords() {
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      aid: aid,
      action: 'getclassmatesassignmentrecords',
    };
    console.log(info);

    examService.examApi(info).then(function(data) {
      console.log(data);
      $scope.assignrecords = data.data.data.items || [];
      angular.forEach($scope.assignrecords, function(item) {
        var author = item.author || {};
        item.author_url = CommonService.getAvatarSrc(author);

        var teacher = item.teacheruser || {};
        item.teacher_url = CommonService.getAvatarSrc(teacher);
      })
      console.log($scope.assignrecords);
      $scope.counter = data.data.data.counter;
      collectImages($scope.assignrecords);
    });
  }



  function collectImages(records) {
    if (records.length <= 0) return;

    var audioList = [];
    records.forEach(function(item) {
      var imageList = [];
      var fileList = [];
      var audioList = [];
      var videoList = [];
      var files = item.files || [];

      files.forEach(function(file) {
        if (file.type === 'img') {
          imageList.push(file);
        } else if (file.type === 'pdf' || file.type === 'doc') {
          if (file.type === 'doc') {
            file.type = 'word';
          }
          fileList.push(file);
        } else if (file.type === 'mp3') {
          audioList.push(file);
        } else if (file.type === 'mp4') {
          videoList.push(file);
        }
      });

      item.imageList = imageList;
      item.fileList = fileList;
      item.videoList = videoList;
      item.audioList = audioList;
      item.lenForClass = imageList.length <= 5 ? imageList.length : 5;
      console.log(item);
    });
  }

  getRecords();

  self.showMore = function() {
    self.showMore = true;
  }

  // .fromTemplateUrl() method
  $ionicPopover.fromTemplateUrl('app/component/gallerypopover.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
    // $scope.openPopover();
  });


  $scope.openPopover = function($event, assign) {
    console.log($event);
    console.log(assign);
    $scope.popover.imageList = assign.imageList;
    $scope.popover.username = assign.user;
    $scope.popover.show($event);
  };


  $scope.closePopover = function() {
    $scope.popover.hide();
  };
  //Cleanup the popover when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.popover.remove();
  });
  // Execute action on hidden popover
  $scope.$on('popover.hidden', function() {
    // Execute action
  });
  // Execute action on remove popover
  $scope.$on('popover.removed', function() {
    // Execute action
  });

  $scope.trustSrc = function(src) {
    return $sce.trustAsResourceUrl(src);
  }


});