'use strict';
angular.module('bamboo.myspace').controller('MyCoursesCtrl', function($scope, CommonService, ApiService, CourseApi, utilService) {
  var _self = this;
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.subjectPicUrl = ApiService.SHOST + "/public/" + ApiService.RES;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  this.tab = 'progress';
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.coursephoto) {
      _self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });
  /*
  this.test = function() {
    console.log(ApiService);  
    console.log($scope.setting);
  }
  */
  $scope.setting = {
    page: 0,
    numProgress: 0,
    page_items: [],
    items: []
  };
  this.moreData = false;

  this.nextPage = function() {
    if(_self.tab=='progress'){
      $scope.setting.page++;
      _self.getMyCourses($scope.setting.page);
    } else {
      _self.cPage++;
      _self.getCompletedCourses(_self.cPage);
    }    
    console.log("--- next page --");
  };

  var courseInfo={};

  this.getMyCourses = function(page) {
    var info = {
      action: "getMyAccessedCourses",
      page: page,
      limit: 8 // page size
    };
    CommonService.showLoading();
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      $scope.setting.page_items = result.courses;
      $scope.setting.totalCount = result.count;
      getMyProgress();
      $scope.setting.items = $scope.setting.items.concat(result.courses);
      _self.moreData = (($scope.setting.totalCount - $scope.setting.items.length) > 0);
      console.log($scope.setting.totalCount, $scope.setting.items.length, _self.moreData);
      console.log($scope.setting.page_items);
      _self.totalCount = result.count;
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  _self.getMyCourses(0);

  function getMyProgress() {
    var info = {
      action: "getmyprogress",
    }
    CourseApi.lcApi(info, function(result) {
      console.log("yyy", result);
      CommonService.stopLoading();
      if (result) {
        var progress = result;
        angular.forEach($scope.setting.page_items, function(course, key) {
          console.log(course);
          var id = course._id;
           if (progress[id] && (course.sysScore||course.offScore)) {
            var totalScore=(course.sysScore||0)+(course.offScore||0);
            var weight=(progress[id].sessionWeight||0)+(progress[id].csessionWeight||0);
          //  course.progressCourse=weight+"/"+totalScore;
            course.progress = parseInt((weight||0 )* 100 / totalScore);
          }
          console.log("zzz", course);
          // if (progress[id] && course.resources) {
          //   course.progress = parseInt(progress[id].chapters * 100 / course.resources);
          //   console.log(progress[id], course);
          //   if (course.progress != 100) {
          //     //console.log(course.progress);
          //     $scope.setting.numProgress++;
          //   }
          // } else {
          //   $scope.setting.numProgress++;
          // }
        });
      } else {
        // no progress record
        $scope.setting.numProgress += $scope.setting.page_items.length;
      }
    });
  }  

  this.getCompletedCourses = function(page) {
    var info = {
      action: "getmycerts",
      page: page,
      limit: 8
    };
    console.log(info);
    ApiService.post('/user', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        _self.completedCourses = result.data.data.items;
        _self.completedCount = result.data.data.counter;
        _self.moreData = ((_self.completedCount - _self.completedCourses.length) > 0);
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }
    });
  }

  this.changeTab = function(tab){
    _self.tab = tab;
    if(_self.tab=='progress'){
       $scope.setting.page = 0;
    } else {
      _self.cPage = 0;
    }
    _self.nextPage();
  }

  utilService.watchScroll($scope);
});