angular.module('bamboo.course').controller('MyExamResultCtrl', function($rootScope, $scope, $filter, $stateParams, $state, CommonService, ApiService, ExamService) {
  var self = this;
  this.id = $stateParams.id;
  this.paperid = $stateParams.paperid;
  this.papertype = $stateParams.type;
  this.part = [];
  this.paper;
  this.activetab = 'individual';
  this.useravatarpath = ApiService.PSURL + "/avatar/";
  console.log(this.useravatarpath);
  this.result;
  this.correct;
  this.miss;
  this.scores;
  this.time;
  self.showResult = true;
  self.nameAndCount = [];
  this.typename = {
    'single': 'Multiple Choice',
    'fill': 'Fill In Blanks',
    'mfill': 'Fill In Blanks',
    'tof': 'True or False',
    'multiple': 'Multiple Answers',
    'mquestion': 'Question Group',
    "short": 'Essay Question',
    "typing": 'Typing',
    "mDD": 'Multiple Match D&D',
  };

  self.var = 1;
  this.clicked = function(num) {
    self.var = num;
  };
  self.showNewNotes = true;
  self.loadAllNotes = 4;
  self.loadMoreNotes = function() {
    self.loadAllNotes = self.loadAllNotes + 2;
    $scope.$broadcast('scroll.infiniteScrollComplete');
  };
  console.log(this.id)
  getInfo(this.id);


  function getInfo(id) {
    var _info = {
      id: id,
      action: 'getdexamrecordbyid'
    };
    if (self.papertype == "Paper") {
      _info.action = 'getexamrecordbyid';
      // getReport(self.paperid);
    }
    examApi(_info, function(_record) {
      console.log(_record);
      if (self.papertype == "Paper") {
        var _r = {
          action: 'getfullpaper',
          id: self.paperid
        };
        console.log(_r);
        // console.log(_record);
        examApi(_r, function(paper) {
          // console.log(paper);
          self.paper = paper.paper;
          self.qstList = paper.qstList;
          for(var i=0;i<self.qstList.length;i++){
            self.qstList[i].content=self.qstList[i].content.replace('src="//', 'src="http://')
          }
          console.log(self.qstList);
          self.part = handleResult(_record, paper);

          getReport(self.paperid);
          console.log(self.part)
        });
      } else {
        self.paper = _record.paper;
        var info = {
          paper: _record.paper,
          qstList: _record.questions
        };
        self.part = handleResult(_record.record, info);
        console.log(self.part)
      }
    });
  }

  function handleResult(record, paper) {
    self.correct = record.correct;
    self.miss = record.miss;
    self.score = record.score;
    self.wrong = record.wrong;
    var neededData = [];
    var _qsts = {};
    var _result = record.questions;
    var line = [];
    angular.forEach(paper.qstList, function(val, idx) {
      val = ExamService.convertV1Question(val);
      var id = val._id;
      _qsts[id] = val;
    });
    console.log(_qsts);
    var csvstr = "";
    angular.forEach(_result, function(val, key) {
      var linestr = "\"";
      var id = key;
      var q = _qsts[id];
      var r = _result[id];
      neededData.push({
        q: q,
        r: r
      })
    });
    return neededData;
  }

  function handleReordData(data) {
    if (!data) {
      return;
    }
    console.log(data);
    self.reportFlag = true;
    var qRecords = data.questionresult;
    var scoreStatistic = data.statistic;
    self.paperTotalScore = 0;
    if (self.paper.questions && self.paper.questions.length > 0) {
      for (var i = 0; i < self.paper.questions.length; i += 1) {
        self.paperTotalScore += self.paper.questions[i].score;
      }
    }
    var qstList = self.qstList;
    if (qstList && qstList.length > 0) {
      for (var i = 0; i < qstList.length; i += 1) {
        qRecords[qstList[i]._id] = qRecords[qstList[i]._id] || {};
        qstList[i].totalAnswerCnt = qRecords[qstList[i]._id].counter;
        qstList[i].totalMissCnt = qRecords[qstList[i]._id].miss;
        qstList[i].totalCorrectCnt = qRecords[qstList[i]._id].correct;
        qstList[i].totalWrongCnt = qstList[i].totalAnswerCnt - qstList[i].totalCorrectCnt - qstList[i].totalMissCnt;
        qstList[i].wronganswers = qRecords[qstList[i]._id].answers;
        qstList[i].answerstr = qstList[i].answer.join(" ");


        qstList[i].totalCorrectCntPercentage = 100 * qstList[i].totalCorrectCnt / qstList[i].totalAnswerCnt;
        qstList[i].totalWrongCntPercentage = 100 * qstList[i].totalWrongCnt / qstList[i].totalAnswerCnt;
        qstList[i].totalMissCntPercentage = 100 * qstList[i].totalMissCnt / qstList[i].totalAnswerCnt;
      }
      self.questionsRecords = self.displayquestionsRecords = qstList;
      console.log(qstList);
      self.displayquestionsRecords = _.filter(self.displayquestionsRecords, function(o) {
        if (o.type !== 'mquestion' && o.type !== 'info')
          return o;
      });
      console.log(self.displayquestionsRecords);
    }
    $scope.counter = data.counter;
    $scope.times = data.times / data.counter;
    $scope.scores = data.scores / data.counter;
  }

  function getReport(id) {
    var info = {
      action: "getpaperreport",
      id: id
    };
    examApi(info, handleReordData);
  }

  function getRandomColorStr() {
    var color = Math.floor(Math.random() * 256).toString(10);
    color += ',';
    color += Math.floor(Math.random() * 256).toString(10);
    color += ',';
    color += Math.floor(Math.random() * 256).toString(10);
    return color;
  }

  function examApi(info, callback) {
    ApiService.post('/exam', info).then(function(result) {
      if (result.data.success) {
        if (!callback) {
          console.log("-- api success ---");
          //CommonService.showNoBlockSuccess('Update Successful!');
        } else {
          callback(result.data.data);
        }
      }
    });
  }
});