angular.module('bamboo.myspace').controller('MyJobsCtrl', function($scope, ApiService, CommonService) {
  var self = this;
  this.moreData = true;
  this.appliedItems = [];
  this.tempitems = [];
  this.page = 0;
  this.photoUrl = ApiService.SHOST + '/job/';
  this.defaultPhoto ="img/jobs.png";

  this.doRefresh = function()
  {
    self.page = 0;
    self.nextPage();
    $scope.$broadcast('scroll.refreshComplete');
  }

  function getAppliedJobs(page) {
    console.log(page);
    var info = {
      action: "getuserapplication",
      start: (page) * 8,
      limit: 8
    };
    console.log(info);
    CommonService.showLoading();
    ApiService.post('/job', info).then(function(result) {
      CommonService.stopLoading();
      console.log(result);
      if (page==0) {
        self.tempitems = result.data.data.items;
      } else {
        self.tempitems = self.tempitems.concat(result.data.data.items);
      }      
      $scope.appliedItems = self.tempitems;
      console.log(self.tempitems);
      self.totalUserAppCount = result.data.data.counter;
      self.moreData = ((self.totalUserAppCount - self.tempitems.length) > 0);
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  this.nextPage = function() {
    getAppliedJobs(self.page);
    self.page++;    
  };

  this.getOppoJobs = function(page){
    var info = {
      action: "getmyjob",
      start: (page) * 4,
      limit: 4
    }
    ApiService.post("/job", info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        $scope.taskItems=result.data.data;
        self.totalOppoCount = ($scope.taskItems)?$scope.taskItems.length:0;
      }
    });
  }

  this.offerHander=function(id, action){
    var txt = 'Are you confirm to accept this offer!..';
    if(action=='offerReject'){
      txt  = 'Are you confirm to reject this offer!..';
    }
    CommonService.showConfirm(txt,function(){
      var info={
        id:id,
        action:"handleOffer",
        sub:action,
      }
      ApiService.post("/job", info).then(function(result) {
        if(result.data.success){
          CommonService.showInfo('Action done!');
          self.page=0;
          self.nextPage()
        }
      });
    });    
  }

});