'use strict';
angular.module('bamboo.myspace').controller('MyMessagesCtrl', function($scope, $state, $ionicScrollDelegate, ApiService, $timeout, CommonService, $stateParams, utilService) {
  var _self = this;
  this.searchType = $stateParams.searchType;
  this.keySearch = "";
  this.unreads = [];
  this.reads = [];
  this.combine = [];
  this.userInfo = [];
  this.canSearch = false;

  function getDisplayInfo(_m) {
    var info = {
      fullname: _m.author.fullname,
      loginname: _m.author.loginname,
      time: _m.create_at,
      type: _m.type,
      message: _m.message,
      sender_id: _m.author_id,
      idx: _m.idx,
      readed:_m.readed
    };
    _m.topic = _m.topic || {};
    _m.content = _m.content || {};
    switch (_m.type) {
      case 'reply':
        info.color = 'color-two';
        info.url = 'index.bbs.tab.detail';
        info.icon = "ion-chatbubble-working";
        info.id = _m.topic._id;
        info.title = _m.topic.title;
        info.action = "回复";
        info.sender_id = _m.author_id
        break;
      case 'blogreply':
        info.color = 'color-one';
        info.url = 'index.blogs.detail';
        info.icon = "ion-ios-chatboxes-outline";
        info.id = _m.topic._id;
        info.title = _m.topic.title;
        info.action = "回复";
        break;
      case 'bbsreply':
        info.color = 'color-one';
        info.url = 'index.bbs.tab.detail';
        info.icon = "ion-chatboxes-outline";
        info.id = _m.topic._id;
        info.title = _m.topic.title;
        info.action = "回复";
        break;
      case 'feedbackreply':
        info.color = 'color-one';
        info.url = 'index';
        info.icon = "ion-ios-chatboxes-outline";
        info.id = _m.topic._id;
        info.title = _m.topic.title;
        info.action = "反馈回复";
        break;
      case 'accesscard':
        info.color = 'color-one';
        info.url = 'index';
        info.icon = "ion-android-walk";
        info.id = _m.topic._id;
        info.title = _m.message;
        info.action = "Card Record";
        break;
      case 'announcement':
        info.color = 'color-three';
        info.url = 'index.announcements.detail';
        info.icon = "ion-chatbox-working";
        info.id = _m.content._id;
        info.title = _m.content.title;
        info.action = "A公告";
        if (_m.content.atype) {
          switch (_m.content.atype) {
            case 'thisweektaskremainder':
              info.icon = 'ion-ios-list-outline';
              break;
            case 'examremainder':
              info.icon = 'ion-android-calendar';
              break;
            case 'assignmentremainder':
              info.icon = 'ion-document-text';
              break;
          }
        }
        break;
      case 'courseapply':
        info.color = 'color-three';
        info.url = 'index.courses.course';
        info.icon = "ion-chatbox-working";
        info.cid = _m.content._id;
        info.id = _m.content._id;
        info.title = "<< " + _m.content.title + " >>";
        info.action = "课程申请";
        break;
      case 'follow':
        info.color = 'color-four';
        // info.url = 'index.setting.profile';
        info.icon = "ion-chatbox-working";
        info.id = info.loginname;
        info.title = "You";
        info.action = "关注";
        break;
      case 'Following':
        info.color = 'color-four';
        info.url = 'index.setting.profile';
        info.icon = "ion-ios-star-half";
        info.id = info.loginname;
        info.title = info.message;
        info.action = "关注用户";
        break;
      case 'p2p':
        info.color = 'color-four';
        info.url = 'index.setting.profile';
        info.icon = "ion-ios-chatbubble-outline";
        info.id = info.loginname;
        info.title = info.message;
        info.action = "MSG";
        info.sender_id = _m.author_id
        break;
      case 'course':
        info.color = 'color-four';
        info.icon = "ion-ios-book";
        info.title = info.message;
        info.action = "课程";
        break;
      case 'feedback':
        info.color = 'color-three';
        info.icon = "ion-chatbox-working";
        info.url = "index";
        info.id = info.loginname;
        info.id = _m.content._id;
        info.title = "[ " + _m.content.title + " ]";
        info.action = "反馈";
        break;
      default:
        console.log("-- unknown type");
        console.log(_m);
        break;
    }
    //console.log(info);
    return info;
  }
  var unread_tempitems = [];
  var read_tempitems = [];
  var sent_tempitems = [];
  this.unread_page = 0;
  this.read_page = 0;
  this.sent_page = 0;
  this.unread_moreData = false;
  this.read_moreData = false;
  this.sent_moreData = false;


  // getUnreadMesages();
  this.getUnreadNotP2p = function() {
    var limit = 6;
    var start = _self.read_page * 6;
    var info = {
      start: start,
      limit: limit,
      exclude: 'p2p',
      action: "getUserMsgs"
    };
    CommonService.showLoading();
    console.log(info);
    ApiService.post("/messages", info).then(function(result) {
      CommonService.stopLoading();
      // console.log(result);
      if (result.data.success) {
        if (result.data.data) {
          console.log(result.data.data);
          //var unreads = result.data.data.items;
          read_tempitems = read_tempitems.concat(result.data.data.items);
          console.log(read_tempitems);
          _self.readMsgs = [];
          for (var i = 0; i < read_tempitems.length; i++) {
            var info = getDisplayInfo(read_tempitems[i]);
            _self.readMsgs.push(info);
          }
          console.log(_self.readMsgs);
          _self.read_page++;
          console.log(_self.totalcounter);
          console.log(read_tempitems.length);
          _self.totalcounter = result.data.data.counter;
          _self.read_moreData = (_self.totalcounter > read_tempitems.length);
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }
      }
      // $timeout(function() {
      $scope.$broadcast('scroll.infiniteScrollComplete');
      // }, 200)
    });
  }
  this.getUnreadNotP2p();
  this.nextPage = function() {
    //_self.sent_page++;
    console.log("nextPage");
    _self.getUnreadNotP2p();
    //getUnreadMesages(_self.page);
    $scope.$broadcast('scroll.infiniteScrollComplete');
    CommonService.stopLoading();
  };
  this.page = 0;

  this.readGroupMsg = function(item) {
    var info = {
      action: 'readUserP2PMsgs',
      author: item.author_id,
    }
    console.log(info);
    ApiService.post("/messages", info).then(function(result) {
      //getUnreadMesages();
      console.log(result);
      $state.go('.messagethread', {
        target: item.author_id
      });
    });
  }
  this.readMsg = function(idx, index) {
    console.log(idx);
    var info = {
      action: 'markread',
      idx: idx,
    }
    console.log(info);
    ApiService.post("/messages", info).then(function(result) {
      unread_tempitems.splice(index, 1);
      _self.unreads.splice(index, 1)
    });
  }
  this.topindex = 0;
  $scope.getScrollPosition = function() {
    _self.topindex = parseInt($ionicScrollDelegate.getScrollPosition().top / 100);
  };
  this.filterMessage = function(toSearch) {
    if (_self.searchType != "") {
      var val = "";
      if (toSearch != "") {
        val = toSearch;
      } else {
        val = undefined;
      }
      switch (_self.searchType) {
        case 'fullname':
          _self.keySearch = {
            fullname: val
          };
          break;
        case 'message':
          _self.keySearch = {
            message: val
          };
          break;
        case 'title':
          _self.keySearch = {
            title: val
          };
          break;
      }
      console.log(_self.keySearch)
    }
  };
  if (_self.searchType != "" && !_self.canSearch) {
    switch (_self.searchType) {
      case 'reply':
        _self.keySearch = 'reply';
        break;
      case 'blogreply':
        _self.keySearch = 'blogreply';
        break;
      case 'bbsreply':
        _self.keySearch = 'bbsreply';
        break;
      case 'feedbackreply':
        _self.keySearch = 'feedbackreply';
        break;
      case 'announcement':
        _self.keySearch = 'announcement';
        break;
      case 'courseapply':
        _self.keySearch = 'courseapply';
        break;
      case 'follow':
        _self.keySearch = 'follow';
        break;
      case 'p2p':
        _self.keySearch = 'p2p';
        break;
      case 'course':
        _self.keySearch = 'course';
        break;
      case 'feedback':
        _self.keySearch = 'feedback';
        break;
    }
    console.log(_self.keySearch)
  }
  this.sendmsgfromctrl = function(msgdetail) {
    CommonService.showmessagefromservice($scope, msgdetail);
  };
  this.showpopmessagefromctrl = function(msgdetail) {
    CommonService.showpopupmessagefromservice($scope, msgdetail);
  };
  _self.isHidden = false;
  this.hideReply = function() {
    _self.isHidden = !_self.isHidden;
  }
  utilService.watchScroll($scope);
});