'use strict';
angular.module('bamboo.myspace').controller('MyNotesCtrl', function($scope, $translate, MystudyService, CourseService, $stateParams, $ionicPopover) {
  var _self = this;
  var coursesid = [];
  var coursewareid = [];
  var keyAndCount = [];
  _self.search = $stateParams.filterType;
  _self.canSearch = true;
  _self.header = $translate.instant('My Notes');
  _self.myNotesList = [];
  if ($stateParams.filterType != "") {
    _self.canSearch = false;
  } else {
    _self.search = undefined
  }
  _self.nameAndCount = [];
  _self.var = 1;
  this.clicked = function(num) {
    _self.var = num;
  };
  _self.loadAllNotes = 4;
  _self.loadMoreNotes = function() {
    _self.loadAllNotes = _self.loadAllNotes + 2;
    $scope.$broadcast('scroll.infiniteScrollComplete');
  };
  _self.showNewNotes = true;
  var current = null;
  var duplicateCourseCount = 0;
  _self.init = function() {
    //get all notes for current user
    MystudyService.getMyNotes(function(data) {
      console.log(data);
      //post processing the received data, looking for { 'created' : xxx , 'content': xxx}
      _self.displayNotesist = [];
      if (data.content) {
        //getNotesFromNestedObj(data.content, _self.myNotesList);
        _self.myNotesList = pareseContent(data.content)
        _self.displayNotesist = _self.myNotesList;
        console.log(_self.displayNotesist);
        if (_self.canSearch) {
          _self.header = $translate.instant('My Notes ') + '( ' + _self.myNotesList.length + ' )';
        } else {
          _self.header = $stateParams.courseName + ' ( ' + $stateParams.courseCount + ' )';
        }
        // cnt the new notes cnt(within 7 days), and old notes cnt(older than 7 days)
        _self.newNotesCnt = 0;
        _self.oldNotesCnt = 0;
        _self.newNotes = [];
        _self.oldNotes = [];
        if (_self.myNotesList) {
          var weekago = new Date();
          weekago.setDate(weekago.getDate() - 7);
          for (var i = 0; i < _self.myNotesList.length; i += 1) {
            var then = new Date(_self.myNotesList[i].created);
            if (weekago <= then) {
              _self.newNotesCnt += 1;
              _self.newNotes.push(_self.myNotesList[i]);
              _self.displaynewNotes = _self.newNotes;
            } else {
              _self.oldNotesCnt += 1;
              _self.oldNotes.push(_self.myNotesList[i]);
              _self.displayoldNotes = _self.oldNotes;
            }
          }
          console.log(_self.displaynewNotes);
        }
        if (coursesid.length > 0) {
          CourseService.getCoursesInfoByIds(coursesid, function(data) {
            //convert arrary to json, index by id
            _self.coursesinfo = {};
            if (data) {
              for (var i = 0; i < ids.length; i++) {
                if (ids[i] != current) {
                  if (duplicateCourseCount > 0) {
                    keyAndCount.push({
                      key: current,
                      value: duplicateCourseCount
                    })
                  }
                  current = ids[i];
                  duplicateCourseCount = 1;
                } else {
                  duplicateCourseCount++;
                }
              }
              if (duplicateCourseCount > 0) {
                keyAndCount.push({
                  key: current,
                  value: duplicateCourseCount
                })
              }
              for (var i = 0; i < data.length; i += 1) {
                _self.coursesinfo[data[i]._id] = data[i];
                console.log(_self.coursesinfo[data[i]._id]._id) //cid
                console.log(_self.coursesinfo[data[i]._id].name); //name
                delete _self.coursesinfo[data[i]._id]._id;
              }
              for (var k = 0; k < keyAndCount.length; k++) {
                for (var item in _self.coursesinfo) {
                  _self.nameAndCount.push({
                    id: keyAndCount[k]['key'],
                    name: _self.coursesinfo[keyAndCount[k]['key']] && _self.coursesinfo[keyAndCount[k]['key']].name,
                    count: keyAndCount[k]['value']
                  });
                  break;
                }
              }
            }
            console.log(_self.nameAndCount);
            classifyNotesByCourse();
          })
        }
        if (coursewareid.length > 0) {
          CourseService.getCoursewareInfoByIds(coursewareid, function(data) {
            //convert array to json, index by id
            _self.coursewareinfo = {};
            if (data) {
              for (var i = 0; i < data.length; i += 1) {
                _self.coursewareinfo[data[i]._id] = data[i];
                console.log(_self.coursewareinfo[data[i]._id]);
                delete _self.coursewareinfo[data[i]._id]._id;
              }
            }
          })
        }
      }
    });
  };

  function classifyNotesByCourse() {
    $scope.groups = [];
    for (var i = 0; i < _self.nameAndCount.length; i++) {
      $scope.groups[i] = {
        name: _self.nameAndCount[i].name,
        items: [],
        show: false,
        count:_self.nameAndCount[i].count
      };
      for (var j = 0; j < _self.displayNotesist.length; j++) {
        if (_self.displayNotesist[j].cid == _self.nameAndCount[i].id) {
          $scope.groups[i].items.push(_self.displayNotesist[i]);
        }
      }
    }
    console.log($scope.groups);
  }

  function getNotesFromNestedObj(root, dest) {
    for (var prop in root) {
      var value = root[prop];
      if (typeof value === 'object' && !value.created && !value.content) {
        getNotesFromNestedObj(value, dest);
      } else {
        dest.push(value);
      }
    }
  }
  var ids = [];

  function pareseContent(content) {
    var result = [];
    //loop through courseid
    angular.forEach(content, function(value1, key1) {
      var cid = key1; // save the cid
      coursesid.push(cid);
      // loop through coursewareid
      angular.forEach(value1, function(value2, key2) {
        var mid = key2;
        coursewareid.push(mid);
        // loop through chapterid
        angular.forEach(value2, function(value3, key3) {
          var rid = key3;
          //loop through array
          if (value3.length > 0) {
            for (var i = 0; i < value3.length; i += 1) {
              if (value3[i].created && value3[i].content) {
                var onenote = {
                  cid: cid,
                  mid: mid,
                  rid: rid,
                  created: value3[i].created,
                  content: value3[i].content
                };
                result.push(onenote);
                ids.push(cid);
              }
            }
          }
        })
      })
    });
    return result;
  }
  _self.init();
  // .fromTemplateUrl() method
  $ionicPopover.fromTemplateUrl('app/myspace/mynotesdetail-popover.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
    console.log($scope.popover)
  });
  $scope.openPopover = function($event, title, content) {
    $scope.popover.show($event);
    console.log(content);
    $scope.note = content;
    $scope.noteTitle = title;
  };
  $scope.closePopover = function() {
    $scope.popover.hide();
  };
  /*
   * if given group is the selected group, deselect it
   * else, select the given group
   */
  $scope.toggleGroup = function(group) {
    group.show = !group.show;
  };
  $scope.isGroupShown = function(group) {
    return group.show;
  };
});