'use strict';
angular.module('bamboo.myspace').controller('MySessionsCtrl', function(ApiService, loginService, $stateParams, $scope, $filter, $ionicPopover) {
  var _self = this;
  this.dayList = [];
  this.cid = $stateParams.cid;
  this.tab = true;
  this.tab = $stateParams.type || undefined;
  console.log($stateParams);
  console.log(this.tab)

  var today = new Date();
  var lastMonth = moment(today).add(-1, 'months').toDate();
  var lastWeek = moment(today).add(-1, 'weeks').toDate();

  this.dayList.push(lastMonth);
  this.dayList.push(lastWeek);
  this.dayList.push(today);
  this._start;

  function countAttendance(list, key, ref) {
    var attendCount = _.filter(list, function(o) { if (o.attended) return o }).length;
    var notAttendCount = list.length - attendCount;
    ref[key] = {};
    ref[key].attendCount = attendCount;
    ref[key].notAttendCount = notAttendCount;
    ref[key].rate = attendCount / list.length;
  }

  function groupByCourse(list) {
    var sessionMap = _.groupBy(list, function(o) {
      return o._id;
    });
    console.log(sessionMap);

    var sessionKeys = _.keys(sessionMap);
    console.log(sessionKeys);

    $scope.sessionMap = sessionMap;
    $scope.sessionKeys = sessionKeys;

    sessionKeys.forEach(function(key) {
      var sessionList = sessionMap[key];
      $scope.countMap = {};
      countAttendance(sessionList, key, $scope.countMap);
      console.log($scope.countMap);
    });
  }

  function getCourseSessionMap(list) {
    var result = _.keyBy(list, function(o) {
      return o._id;
    });
    return result;
  }

  function getMySession() {
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      action: 'getusersessions',
    };
    ApiService.post('/coursesession', info).then(function(data) {
      if (data.data.success) {
        console.log(data);
        var result = data.data.data;
        var _sessions = result.items;
        $scope.courseSessionMap = getCourseSessionMap(_sessions);
        console.log(_sessions);
        var eventdata = [];
        var checkdate;
        if (_self._start) {
          checkdate = new Date(_self._start);
        }
        angular.forEach(_sessions, function(item, idx) {
          for (var i = 0; i < item.repeatCounter; i++) {
            var time = item.start;
            switch (item.repeatType) {
              case 'week':
                time = moment(item.start).add(i, 'weeks').toDate();
                break;
              case 'month':
                time = moment(item.start).add(i, 'months').toDate();
                break;
              case 'day':
                time = moment(item.start).add(i, 'days').toDate();
                break;
            }
            if (!checkdate || checkdate < time) {
              var info = angular.copy(item);
              info.start = time;
              var day = time.toISOString().substring(0, 10);
              if (item.attended && item.attended[day]) {
                info.attend = true;
              }
              delete info.attended;
              eventdata.push(info);
            }
          }
        });
        _self.sessions = eventdata;
        console.log(_self.sessions);
        groupByCourse(_self.sessions);
        $scope.total = _self.sessions.length;
      }
    });
  }
  getMySession();
  _self.loaddata = function() {
    getMySession();
  }


  $ionicPopover.fromTemplateUrl('app/myspace/sessionmenupopover.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });

  $scope.closeEventPopover = function() {
    $scope.popover.hide();
  };
});