'use strict';
angular.module('bamboo.myspace').controller('MyTeacherSessionsCtrl', function(ApiService, loginService, $stateParams, $scope, $filter, $q) {
  var _self = this;
  this.dayList = [];
  this.cid = $stateParams.cid;
  this.tab = true;
  this.tab = $stateParams.type || undefined;
  console.log($stateParams);
  console.log(this.tab)

  var today = new Date();
  var lastMonth = moment(today).add(-1, 'months').toDate();
  var lastWeek = moment(today).add(-1, 'weeks').toDate();

  this.dayList.push(lastMonth);
  this.dayList.push(lastWeek);
  this.dayList.push(today);
  this._start;

  function countAttendance(list, key, ref) {
    var attendCount = _.filter(list, function(o) { if (o.attended) return o }).length;
    var notAttendCount = list.length - attendCount;
    ref[key] = {};
    ref[key].attendCount = attendCount;
    ref[key].notAttendCount = notAttendCount;
    ref[key].rate = attendCount / list.length;
  }

  function groupByCourse(list) {
    console.log()
    var sessionMap = _.groupBy(list, function(o) {
      return o._id;
    });
    console.log(sessionMap);
    var sessionKeys = _.keys(sessionMap);
    console.log(sessionKeys);
    $scope.sessionMap = sessionMap;
    $scope.sessionKeys = sessionKeys;
    sessionKeys.forEach(function(key) {
      var sessionList = sessionMap[key];
      $scope.countMap = {};
      countAttendance(sessionList, key, $scope.countMap);
      console.log($scope.countMap);
    });
    console.log(sessionKeys);
  }

  function getCourseSessionMap(list) {
    var result = _.keyBy(list, function(o) {
      return o._id;
    });
    return result;
  }

  _self.getDateByStr = getDateByStr;

  function getDateByStr(str) {
    var nowDate = new Date(str);
    var date = nowDate.getFullYear() + '/' + (nowDate.getMonth() + 1) + '/' + nowDate.getDate();
    return date;
  }

  $scope.sessionListMap = {};
  _self.cid && getCourseSessionsById(_self.cid);
  //get courses' session
  function getCourseSessionsById(cid) {
    var deferred = $q.defer();
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      lid: cid,
      action: 'getcoursesessiones',
    };
    ApiService.post('/coursesession', info).then(function(data) {
      if (data.data.success) {
        var result = data.data.data;
        console.log(result);
        var countRecords = result.records;
        _self.counterMap = {};
        countRecords.forEach(function(record) {
          var key = record.sessionId + (new Date(record.time)).toISOString().substring(0,10);
          _self.counterMap[key] = record.counter || 0;
        })

      //  console.log(_self.counterMap);

        //$scope.courseSessionMap = getCourseSessionMap(result.items);
       // console.log($scope.courseSessionMap);
        $scope.resourceItems = result.items;
       // console.log($scope.resourceItems);
        angular.forEach($scope.resourceItems, function(item, idx) {
          //item.end = timeHelper.calEndTime(item.start, item.len);
          console.log(item);
          var eventdata = [];
          for (var i = 0; i < item.repeatCounter; i++) {
            var time = item.start;
            switch (item.repeatType) {
              case 'week':
                time = moment(item.start).add(i, 'weeks').toDate();
                break;
              case 'month':
                time = moment(item.start).add(i, 'months').toDate();
                break;
              case 'day':
                time = moment(item.start).add(i, 'days').toDate();
                break;
            }
           // console.log(time);

            var info = {
              title: item.name,
              start: time,
              stick: true,
              id: item._id,
              timestamp: new Date(time).getTime()
            }
            var key=item._id+time.toISOString().substring(0,10);
            if(_self.counterMap[key]){
              info.counter=_self.counterMap[key];
            }

            eventdata.push(info);
          }
          $scope.sessionListMap[item._id] = eventdata;
          console.log(eventdata);

        });
        console.log($scope.sessionListMap);

        //_self.sessions = eventdata;
        // groupByCourse(eventdata);
        // self.eventSources = [eventdata];
        // self.eventsready = true;
        $scope.total = result.counter;
      }
    });
    return deferred.promise;
  }

});