// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.myspace', ['ionic', 'ui.rCalendar']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.myspace', {
    url: '/myspace',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myspace.html',
        controller: 'MySpaceCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspacet1', {
    url: '/myspacet1',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myspace_t1.html',
        controller: 'MySpaceCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.mycourses', {
    url: '/mycourses',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mycourses.html',
        controller: 'MyCoursesCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.mycoursesparent', {
    url: '/mycoursesparent',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mycourses_parent.html',
        controller: 'MyCoursesCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.myexam', {
    url: '/myexam',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myexam.html',
        controller: 'MyExamCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.mytest', {
    url: '/mytest',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mytest.html',
        controller: 'MyTestCtrl as ctrl'
      }
    }
  }).state('app.myspace.blogs', {
    url: '/blogs',
    views: {
      'Content@app': {
        templateUrl: 'app/blog/bloglist.html',
        controller: 'BlogListCtrl as ctrl'
      }
    }
  }).state('app.myspace.bbss', {
    url: '/bbss',
    views: {
      'Content@app': {
        templateUrl: 'app/bbs/bbssublist.html',
        controller: 'BBSSublistCtrl as ctrl'
      }
    }
  }).state('app.myspace.transactions', {
    url: "/transactions",
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/transactions.html',
        controller: "TransactionsCtrl as ctrl",
      }
    }
  }).state('app.myspace.transactions.detail', {
    url: "/detail/:rid",
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/transdetail.html',
        controller: "TransdetailCtrl as ctrl",
      }
    }
  }).state('app.myspace.myassignment', {
    url: '/myassignment',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myassignment.html',
        controller: 'MyAssignmentCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.myassignment.classrecord', {
    url: '/:aid/classrecord',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myclass_assignment_record.html',
        controller: 'MyClassAssignmentRecordCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.assignment', {
    url: '/assignment/:aid',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/assignment.html',
        controller: 'AssignmentCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.videoclasses', {
    url: '/videoclasses',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/videoclasses.html',
        controller: 'MyVideoClassesCtrl as ctrl'
      }
    }
  }).state('app.myspace.videoclasses.meeting', {
    url: '/meeting/:type/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/video/room.html',
        controller: 'DiscussController as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.myspace.videoclasses.youtube', {
    url: '/youtube/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/video/youtube.html',
        controller: 'YoutubeController as ctrl'
      }
    }
  }).state('app.myspace.videoclasses.nimvideo', {
    url: '/nimvideo/:type/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/video/nim.html',
        controller: 'nimController as ctrl'
      }
    }
  }).state('app.myspace.myexamresult', {
    url: '/myexamresult/:type/:id/:paperid',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myexamresult.html',
        controller: 'MyExamResultCtrl as ctrl'
      }
    }
  }).state('app.myspace.myclasses', {
    url: '/myclasses/:teacherUserName',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myclasses.html',
        controller: 'MyClassesCtrl as ctrl'
      }
    }
  }).state('app.myspace.mynotes', {
    url: '/mynotes/:filterType/:courseName/:courseCount',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mynotes.html',
        controller: 'MyNotesCtrl as ctrl'
      }
    },
    data_rightbutton: {
      url: "app.myspace.mynotes.course",
      icon: "ion-ios-more"
    }
  }).state('app.myspace.mynotes.course', {
    url: '/course',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mynotes_course.html',
        controller: 'MyNotesCtrl as ctrl'
      }
    }
  }).state('app.myspace.mymessages', {
    url: '/mymessages',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mymessages.html',
        controller: 'MyMessagesCtrl as ctrl'
      }
    }
  }).state('app.myspace.mymessages.messagethread', {
    url: '/message_thread/:target',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/message_thread.html',
        controller: 'MessagethreadCtrl as ctrl'
      }
    },
  }).state('app.myspace.mymessages.sysmessage', {
    url: '/sysmessage/:target',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/sys_thread.html',
        controller: 'SysMessagethreadCtrl as ctrl'
      }
    },
  }).state('app.myspace.mymessages.search', {
    url: '/search',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/message_search_page.html'
      }
    }
  }).state('app.myspace.mymessages.result', {
    url: '/result',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/message_result.html'
      }
    },
    data_rightbutton: {
      url: "app.myspace.mymessages.search",
      icon: "ion-ios-search-strong",
    }
  }).state('app.myspace.myprofile', {
    url: '/myprofile',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myprofile.html',
        //controller: 'MobileIndexCtrl as ctrl'
      }
    }
  }).state('app.myspace.myactivities', {
    url: '/myactivities',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myactivities.html',
        controller: 'MyActivitiesCtrl as ctrl'
      }
    }
  }).state('app.myspace.feedback', {
    url: '/feedback',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myfeedbacks.html',
        controller: 'MyFeedbackCtrl as ctrl'
      }
    }
  }).state('app.myspace.sessions', {
    url: '/sessions',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mysessions.html',
        controller: 'MySessionsCtrl as ctrl'
      }
    }
  }).state('app.myspace.sessions.list', {
    url: '/:cid/:type/list',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mysessions_list.html',
        controller: 'MySessionsCtrl as ctrl'
      }
    }
  }).state('app.myspace.parentsessions', {
    url: '/parent_session',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mysessions_parent.html',
        controller: 'MySessionsCtrl as ctrl'
      }
    }
  }).state('app.myspace.teachersessions', {
    url: '/teacher_courselist',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mysessions_teachercourse.html',
        controller: 'MyTeacherSessionsCourseCtrl as ctrl'
      }
    }
  }).state('app.myspace.teachersessions.slist', {
    url: '/:cid/teacher_session',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mysessions_teacher.html',
        controller: 'MyTeacherSessionsCtrl as ctrl'
      }
    }
  }).state('app.myspace.teachersessions.slist.studentlist', {
    url: '/:sid/:time/student_list',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mysessions_list_student.html',
        controller: 'MyTeacherSessionsStuListCtrl as ctrl'
      }
    }
  }).state('app.myspace.calendar', {
    url: '/calendar',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/mycalendar.html',
        controller: 'MyCalendarCtrl as ctrl'
      }
    }
  }).state('app.myspace.myjobs', {
    url: '/myjobs',
    views: {
      'Content@app': {
        templateUrl: 'app/myspace/myjobs.html',
        controller: 'MyJobsCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  });
});