'use strict';
angular.module('bamboo.myspace').controller('SysMessagethreadCtrl', function($scope, $ionicScrollDelegate, ApiService, $timeout, CommonService, $stateParams, $q) {
  var self = this;
  var target = $stateParams.target;

  function getDisplayInfo(info) {
    switch (info.type) {
      case 'reply':
      case 'blogreply':
      case 'bbsreply':
      case 'feedbackreply':
      case 'feedbackreply':
        info.icon = "fa fa-commenting-o";
        info.action = "Reply";
        break;
      case 'accesscard':
        info.icon = "fa fa-sign-in";
        info.action = "Card Record";
        break;
      case 'announcement':
        info.icon = "fa fa-bullhorn";
        info.action = "Announced";
        break;
      case 'courseapply':
        info.icon = "fa fa-tasks";
        info.action = "Apply for Course Public Access";
        break;
      case 'follow':
        info.icon = "fa fa-user";
        info.action = "Follow";
        break;
      case 'p2p':
        info.icon = "fa fa-envelope-o";
        info.action = "MSG";
        break;
      case 'Following':
        info.icon = "fa fa-envelope-o";
        info.action = "Following User";
        break;
      case 'course':
        info.icon = "fa fa-book";
        info.action = "COURSE";
        break;
      case 'feedback':
        info.icon = "fa fa-envelope-o";
        info.action = "Feedback";
        break;
      default:
        console.log("-- unknown type");
        break;
    }
    return info;
  }

  function sortByTime(a, b) {
    var atime = new Date(a.time);
    var btime = new Date(b.time);
    return atime - btime;
  }
  this.deleteMsg = function(msg, index) {
    console.log(msg);
    var info = {
      idx: msg.idx,
      action: 'delunread',
    }
    if (msg.group == 'old') {
      info.action = 'delread';
    } else if (msg.group == 'send') {
      info.action = 'delread';
    }
    ApiService.post("/messages", info).then(function(result) {
      if (result.data.success) {
        // _self.unreads.splice(index,1);
        // self.messages.splice(index, 1);
        getTargetThreadMsgs();
        CommonService.showInfoWithTitle('删除成功！');

        // $state.reload();
      }
    });
  }

  function getTargetThreadMsgs(flag) {
    var info = {
      action: 'getusertargemsgs',
      target: target,
    }
    console.log(info);
    ApiService.post("/messages", info).then(function(result) {
      // console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        var messages = result.data.data;
        self.messages = [];
        angular.forEach(messages, function(message) {
          getDisplayInfo(message);
          //  console.log(message.type);
          if (message.type == 'p2p' || message.type == 'multiple') {
            // self.messages.push(message);
          } else {
            self.messages.push(message);
          }
        })
        self.messages.sort(sortByTime);
        if(flag){
           $ionicScrollDelegate.scrollBottom();
        }
       
      }
    });
  }
  getTargetThreadMsgs(true);
  this.addReply = function() {
    if (self.r_content.length < 2) {
      CommonService.showError('Message is too short!');
      return;
    }
    var info = {
      action: "sendp2p",
      target: target,
      message: self.r_content,
    }
    console.log(info);
    ApiService.post('/messages', info).then(function(result) {
      if (result.data.success) {
        self.r_content = "";
        // getTargetThreadMsgs();
      }
    });
  }
  this.deleteMsg = function(msg) {
    console.log(msg);
    var info = {
      idx: msg.idx,
      action: 'delunread',
    }
    if (msg.group == 'old') {
      info.action = 'delread';
    } else if (msg.group == 'send') {
      info.action = 'delread';
    }
    ApiService.post("/messages", info).then(function(result) {
      if (result.data.success) {
        getTargetThreadMsgs();
        CommonService.showInfoWithTitle('删除成功！');

      }
    });
  }
  this.readMsg = function(msg) {
    console.log(msg);
    if (msg.group == 'new') {
      var info = {
        action: 'markread',
        idx: msg.idx,
      }
      console.log(info);
      ApiService.post("/messages", info).then(function(result) {
        if (result.data.success) {
          // console.log(result);
          getTargetThreadMsgs();
          CommonService.showInfoWithTitle('删除成功！');

        }
      });
    }
    
  }
  this.getAvatarById = function(id) {
    ApiService.get('/useravatar/' + id).then(function(result) {
      console.log(result);
      if (result.data.success) {
        self.targetUser = result.data.data;
        self.targetUser.avatarUrl = CommonService.getAvatarSrc(self.targetUser);
      }
    });
  };
  self.getAvatarById(target);
});