angular.module('bamboo.myspace').controller('MyVideoClassesCtrl', function($scope, $timeout, ApiService, CommonService, MystudyService, $sce, loginService, CourseService, $filter, $state) {
  var self = this;
  this.TypeName = {
    videoppt: 'Video Broadcasting',
    audioppt: 'Audio Presentation',
    discuss: 'Webinar',
    videocnfrnc: 'Video Conferance',
  }
  this.chromeIsAvailable = false;
  if (window.cordova) {
    appAvailability.check('com.android.chrome', // URI Scheme
      function() { // Success callback
       // console.log('Chrome is available');
         self.chromeIsAvailable=true;
      },
      function() { // Error callback
        console.log('Chrome is not available');
      });
  }

  function getmymeetings() {
    var info = {
      start: 0,
      limit: 10,
      action: 'getmymeetings',
    };
    ApiService.post("/vmeeting", info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        $scope.displayedItems = result.data.data.items;
        var systemtime = new Date(result.data.data.time);
        // console.log(systemtime);
        var chromeWarning;
        angular.forEach($scope.displayedItems, function(item) {
          var type = item.type;
          if (item.mtype == 'nimvideo') {
            if (self.chromeIsAvailable) {
              item.hrefurl = " googlechrome://navigate?url=" + ApiService.HOST + '/app/#/nimvideo/' + item._id + '/' + loginService.user.accessToken;
              console.log(item.hrefurl);
            } else {
              chromeWarning = true
            }
          }
          var start = new Date(item.start);
          var stop = new Date(item.stop);
          var len = (stop - start) / 3600000;
          item.len = len;
          // console.log(start);
          if (start < systemtime) {
            if (type) {
              item.enterFlag = true;
            }
          }
          if (item.createUser) {
            item.createUser.avatarurl = CommonService.getAvatarSrc(item.createUser);
          }
          if (item.hostUser) {
            item.hostUser.avatarurl = CommonService.getAvatarSrc(item.hostUser);
          }
        })
        if (chromeWarning) {
          CommonService.showError('Please install Chrome Browser First!');
        }
        console.log($scope.displayedItems);
        $scope.total = result.data.data.counter;
        // tableState.pagination.numberOfPages = Math.ceil(result.data.data.counter / limit);
      }
    });
  }
  this.openChromeBrowser = function(url) {
    CommonService.showError('Please install Chrome Browser First!');
  }
  this.openExt=function(item){
    item.hide=true;
    $timeout(function(){
      item.hide=false;
    },5000);
  }
  getmymeetings();

  this.gotoMeeting = function(item) {
    if(item.mtype=='youtube'){
      $state.go('app.myspace.videoclasses.youtube', {
        rid: item._id
      });
      return;
    } else {
      $state.go('app.myspace.videoclasses.meeting', {
        type: item.type,
        rid: item._id
      });
      return;
    }
  }


});