angular.module('bamboo.news').controller('NewsDetailCtrl', function (loginService, $scope, ApiService, $sce, CommonService, $state, $stateParams, $filter) {
  var _self = this;
  this.id = $stateParams.id;
  this.contentModel = {};
  var _favourites = [];
  this.item=null;
  this.publicUrl = ApiService.SHOST + "/public/images/";
  this.contentModelPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolnews/" + _self.id + "/";
  _self.defaultNewsPhoto = ApiService.SHOST + "/public/images/details.png";
  ApiService.getSchoolInfo().then(function () {
    if (ApiService.school.newsphoto) {
      _self.defaultNewsPhoto = ApiService.SHOST + "/site/" + ApiService.school.newsphoto;
    }
  });
  loginService.getLoginInfo().then(function () {
    if (loginService.user) {
      _self.allowfaviorate = true;
    }
  });

  this.showNews = function () {
    ApiService.getSchoolInfo().then(function () {
      if (ApiService.school.newsphoto) {
        _self.defaultPhoto = ApiService.SHOST + "/site/" + encodeURIComponent(ApiService.school.newsphoto);
      }
      //CommonService.showLoading();
      ApiService.get("/newses/" + _self.id).then(function (result) {
        //CommonService.stopLoading();
        if (result.data.success) {
          _self.item = result.data.data;
          console.log(_self.item)
          favouritenews = [];
          loginService.getMyProfile(true).then(function (_result) {

            var favourites = _result.favourites;
            console.log(favourites);
            $scope.newsIndex=0;
            angular.forEach(favourites, function (_item) {
              if (_item.type == "news" && _item.id == _self.id) {
                _self.item.favourite = true;
                _self.item.index = $scope.newsIndex;

              }
              $scope.newsIndex++;
            })
          });
          _self.imageUrl = _self.item.photo ? _self.itemPicUrl + _self.item._id + '/' + encodeURIComponent(_self.item.photo) : _self.defaultPhoto;
          if (_self.item.detail) {
            _self.detail = CommonService.replaceImgLink(_self.item.detail);

          }
        }
      });
    });
  };

  _self.showNews();

  this.share = function () {
    var link = ApiService.HOST + '/#/news/' + _self._id + "?share=true";
    var imageUrl = _self.item.photo ? _self.contentModelPicUrl + _self.item.photo : null;
    console.log(link);
    console.log(imageUrl);
    console.log(_self.item.name);
    CommonService.showShareDialog($scope, _self.contentModel.name, imageUrl, link, _self.contentModel.description);
  }

  this.favourite = function () {   // 收藏
    //$scope.isCollect = true;
    //if ($scope.isCollect) return;
    CommonService.showLoading();
    var object = {
      type: 'news',
      id: _self.id
    };
    var info = {
      action: "addfavourite",
      object: object
    };
    ApiService.post("/user", info).then(function (result) {
      if (result.data.success) {
        _self.item.favourite=true;
        CommonService.showInfo("收藏成功")
        CommonService.stopLoading();
      } else {
        CommonService.showInfo("收藏失败，请重试！")
        CommonService.stopLoading();
      }
    });
  }


  this.delFavourite = function () {   // 收藏
    console.log(_self.item.index);
    var info = {
      action: "delfavourite",
      index: _self.item.index
    };
    ApiService.post("/user", info).then(function (result) {
      if (result.data.success) {
        _self.item.favourite=false;
        CommonService.showInfo("取消收藏成功")
        CommonService.stopLoading();
      } else {
        CommonService.showInfo("取消收藏失败，请重试！")
        CommonService.stopLoading();
      }
    });
  }
  $scope.$on('$ionicView.beforeEnter', function () {
    $scope.isCollect = false;
  })

});
