angular.module('bamboo.product').controller('ProductListInCategoryCtrl', function ($scope, ApiService, $timeout, $stateParams, $state, CommonService, $sce) {
  var _self = this;
  console.log("---- ProductListInCategoryCtrl -----");
  this.key = $stateParams.key;
  this.id = $stateParams.cid;
  this.defaultPhoto = ApiService.SHOST + "/public/images/details.png";
  this.productpath = ApiService.SHOST + '/product/';
  console.log($state.current.name);
  this.page = 0;
  this.moreData = false;
  this.items = [];
  this.passProductId = [];
  this.nextPage = function (val) {
    if (val) {
      _self.page++;
      getInfo(_self.page);
    }
  };

  function getInfo(page) {
    var pagesize = 6;
    var info = {
      start: pagesize * page,
      limit: pagesize
    };

    if ($state.current.name == 'app.product.list') {
      info.action = "getproductsbycategory";
      info.key = _self.key;
    } else if ($state.current.name == 'app.company.list.detail') {
      info.action = "getcompanyproducts";
      info.exId = _self.id;
    }

    CommonService.showLoading();
    ApiService.post("/business", info).then(function (result) {
      // console.log(result);
      CommonService.stopLoading();
      if (result.data.success) {
        if (!_self.items) {
          _self.items = [];
        }
        _self.items = _self.items.concat(result.data.data.items);
        var productId = {};
        angular.forEach(_self.items, function (item, index) {
          productId[index] = item._id
        });
        _self.passProductId = productId;
        _self.totalCount = result.data.data.counter;
        _self.moreData = ((_self.totalCount - _self.items.length) > 0);
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  getInfo(0);

  this.showProduct = function (id, i, fromList) {
    _self.currentId = id;
    _self.hide = i;
    console.log(id)
    var info = {
      action: "getproduct",
      id: id
    };
    ApiService.post("/business", info).then(function (result) {
      if (result.data.success) {
        _self.item = result.data.data || {};
        _self.imageUrl = _self.item.photo ? _self.productpath + _self.item._id + '/' + _self.item.photo : _self.defaultPhoto;
        if (_self.item.audio) {
          _self.item.audiourl = $sce.trustAsResourceUrl(_self.productpath + _self.item._id + '/' + _self.item.audio);
        }
      }
    });

    if (fromList) {
      CommonService.showdetail($scope, 'app/product/product.html');
    }
  };

  this.prevProduct = function (id) {
    _self.clicke = true;
    $timeout(function () {
      _self.clicke = false;
    }, 500);
    angular.forEach(_self.passProductId, function (item, index) {
      if (id == item) {
        var i = parseInt(index) - 1;
        var val = _self.passProductId[parseInt(i)];
        _self.showProduct(val, i, false);
      }
    })
  };

  this.nextProduct = function (id) {
    _self.clicked = true;
    $timeout(function () {
      _self.clicked = false;
    }, 500);
    angular.forEach(_self.passProductId, function (item, index) {
      console.log(index)
      console.log(item)
      //console.log(index)
      if (id == item) {
        var i = parseInt(index) + 1;
        var val = _self.passProductId[parseInt(i)];
        _self.showProduct(val, i, false);
      }
    })
  };
});
