angular.module('bamboo.roomsession').controller('AccessRecordsCtrl', function($scope, ApiService, CommonService, $rootScope, $state, $translate, $cordovaGeolocation) {
  var _self = this;

  function getAccessRecords(){
    var info = {
      action: 'getUserAllOpenAccessRecords'
    };
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        _self.sessions = result.data.data;
      } else {
        CommonService.showError(result.data.error||result.data.info);
      }
    });
  }
  getAccessRecords();
  
  this.exit = function(item){
    console.log(item);
    if(item){
      _self.item = item;
      getLocationInfo();
    }
  }

  function getLocationInfo(){
    CommonService.showLoading();
    var posOptions = { timeout: 5000, enableHighAccuracy: false, maximumAge: 30000 };
    $cordovaGeolocation.getCurrentPosition(posOptions).then(function(position) {
      console.log(position);
      CommonService.stopLoading();
      _self.lat = position.coords.latitude;
      _self.lng = position.coords.longitude; 
      saveInfo()
    }, function(err) {
      console.log(err);
      if(err&&err.code==3){
        getLocationInfo();  
      } else {
        CommonService.showError("Location error! " + err);
      }      
    }); 
  }

  function saveInfo(){
    var info = {
      id: self.item._id,
      action: 'exitAccessRecord',
      lng: _self.lng,
      lat: _self.lat
    };
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        CommonService.showInfo($translate.instant('Exit Successfully'));
        $state.go('app.more');
      } else {
        CommonService.showError(result.data.error||result.data.info);
      }
    });
  }

});