angular.module('bamboo.roomsession').controller('SessionApplicationDetailCtrl', function (loginService, $cordovaGeolocation, $cordovaDevice, $scope, ApiService, $sce, CommonService, $state, $stateParams, $filter) {
    var _self = this;
    this.apid = $stateParams.apid;

    this.start = "";
    this.end = ""
    this.timeRule = loginService.school.sessionAccessRules || {}
    this.status = $stateParams.type == 0 ? "正常" : "异常作废"
    this.imgPath = ApiService.PSURL + "/attendence/" + this.rid + "/";
    if (window.cordova) {
        this.device = true;
    }

    function getInfo() {
        var info = {
            action: 'getRecordApplication',
            id: _self.apid,
        }
        console.log(info);
        ApiService.post('/session', info).then(function (result) {

            if (result.data.success) {
                var data = result.data.data;
                console.log(data);
                _self.session = data.session || {};
                _self.record = data.record || {};
                _self.recordLen = data.record.length;
                _self.course = data.course || {};
                _self.building = data.building || {};
                _self.room = data.room || {};
                _self.app = data.app || {};
                //_self.item = data.record || {};


                // 处理签到和签出时间
                var time1 = new Date(_self.record.time);
                var time2 = new Date(_self.record.time);
                time1.setMinutes(time1.getMinutes() - _self.timeRule.joinEarly || 0);
                _self.start += $filter("date")(time1, "MM-dd HH:mm");
                _self.start += "-"
                time2.setMinutes(time2.getMinutes() + _self.timeRule.joinLate || 0);
                _self.start += $filter("date")(time2, "HH:mm");

                var time3 = new Date(_self.record.time);
                var time4 = new Date(_self.record.time);
                time3.setMinutes(time3.getMinutes() + _self.record.length - _self.timeRule.earlyExit || 0);
                _self.end += $filter("date")(time3, "MM-dd HH:mm");
                _self.end += "-"
                time4.setMinutes(time4.getMinutes() + _self.record.length + _self.timeRule.lateExit || 0);
                _self.end += $filter("date")(time4, "HH:mm");

                if (_self.recordLen && _self.app.time) {
                    var start = (new Date(_self.app.time)).getTime();
                    _self.stop = new Date(start + ( _self.recordLen || 60) * 60000);
                }
            } else {
                CommonService.showError(result.data.error || result.data.info);
            }
        });
    }

    getInfo();
});
