angular.module('bamboo.roomsession').controller('ExitQrCodeCtrl', function($scope, ApiService, CommonService, $rootScope, $state) {
  var _self = this;

  $scope.$on("$ionicView.enter", function(scopes, states) {
    console.log('enter');
    $rootScope.qrcode = true;
    if (window.cordova) {
      openQrCode();
    }
  });

  $scope.$on('$ionicView.beforeLeave', function() {
    $rootScope.qrcode = false;
    if (window.cordova) {
      QRScanner.destroy(function(status){
        console.log(status);
      }); 
    }
  });


  function openQrCode(){
    console.log('qrCode');
    QRScanner.prepare(onDone); // show the prompt 
    function onDone(err, status){
      console.log(status);
      if (err) {
       // here we can handle errors and clean up any loose ends.
       console.error(err);
      }
      if (status.authorized) {
        console.log('authorized');  
        QRScanner.show();      
        QRScanner.scan(displayContents); 
        function displayContents(err, text){
          console.log(err);
          if(err){
            // an error occurred, or the scan was canceled (error code `6`)
          } else {
            // The scan completed, display the contents of the QR code:
            console.log(text);            
            var arr = text.split('$#');
            if(arr.length==2){
              QRScanner.destroy(function(status){
                console.log(status);
              }); 
              $rootScope.qrcode = false;
              _self.roomId = arr[0];
              _self.roomCode = arr[1];
              getSessions(arr[0]);
            } else {
              QRScanner.scan(displayContents); 
              CommonService.showError('Invalid QRCode');
            }           
          }
        }        
      } else if (status.denied) {
        CommonService.showError("Camera permission is not turned on");
       // The video preview will remain black, and scanning is disabled. We can
       // try to ask the user to change their mind, but we'll have to send them
       // to their device settings with `QRScanner.openSettings()`.
      } else {
        // we didn't get permission, but we didn't get permanently denied. (On
        // Android, a denial isn't permanent unless the user checks the "Don't
        // ask again" box.) We can ask again at the next relevant opportunity.
      }
    }
  }

  function getSessions(roomId){
    var info = {
      id: roomId,
      action: 'getUserAllOpenAccessRecords'
    };
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        _self.sessions = result.data.data;
      } else {
        CommonService.showError(result.data.error||result.data.info);
      }
    });
  }

  this.cancel = function(){
    $rootScope.qrcode = false;
    if(window.cordova){
      QRScanner.destroy(function(status){
        console.log(status);
        $state.go('app.more');
      }); 
    } else {
      $state.go('app.more');
    }       
  }

  
});