angular.module('bamboo.roomsession', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.qrcode', {
    url: '/qrcode',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/qrcode.html',
        controller: "QrCodeCtrl as ctrl"
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.qrcode.register', {
    url: '/register/:sid/:rid/:rcode',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/register.html',
        controller: 'SessionRegisterCtrl as ctrl'
      }
    }
  }).state('app.exitqrcode', {
    url: '/exitqrcode',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/exitqrcode.html',
        controller: 'ExitQrCodeCtrl as ctrl'
      }
    }
  }).state('app.mycourses', {
    url: '/mycourses',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/mycourses.html',
        controller: 'MySessionCoursesCtrl as ctrl'
      }
    }
  }).state('app.validbuildings', {
    url: '/validbuildings',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/buildings.html',
        controller: 'BuildingsController as ctrl'
      }
    }
  }).state('app.validbuildings.records', {
    url: '/records/:bid',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/buildingrecords.html',
        controller: 'BuildingSessionRecords as ctrl'
      }
    }
  }).state('app.validbuildings.records.detail', {
    url: '/detail/:rid',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/sessionrecorddetail.html',
        controller: 'SessionRecordDetail as ctrl'
      }
    }
  }).state('app.myvalidapps', {
    url: '/myvalidapp',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/myapps.html',
        controller: 'MyLatestSessionAppsCtrl as ctrl'
      }
    }
  }).state('app.mybookedapps', {
    url: '/mybookedapps',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/mybookedapps.html',
        controller: 'MyBookedSessionAppsCtrl as ctrl'
      }
    }
  }).state('app.mybookedapps.detail', {
    url: '/detail/:apid/:type',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/appdetail.html',
        controller: 'SessionApplicationDetailCtrl as ctrl'
      }
    }
  }).state('app.mycourses.sessionrecords', {
    url: '/records/:lid',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/sessionrecords.html',
        controller: 'MyCourseSessionRecords as ctrl'
      }
    }
  }).state('app.exitqrcode.details', {
    url: '/details/:sid/:rid/:aid/:signType',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/sessiondetails.html',
        controller: 'SessionDetailsCtrl as ctrl'
      }
    }
  }).state('app.accessrecords', {
    url: '/accessrecords',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/accessrecords.html',
        controller: 'AccessRecordsCtrl as ctrl'
      }
    }
  }).state('app.accesshistory', {
    url: '/accesshistory',
    cache: false,
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/accesshistory.html',
        controller: 'UserAccessRecordsCtrl as ctrl'
      }
    }
  }).state('app.accesshistory.detail', {
    url: '/detail/:aid',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/accesshistorydetail.html',
        controller: 'UserAccessRecordsDetailCtrl as ctrl'
      }
    }
  }).state('app.accesshistory.onlinedetail', {
    url: '/onlinedetail/:aid',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/onlinedetail.html',
        controller: 'OnlineRecordDetailCtrl as ctrl'
      }
    }
  }).state('app.accessrecords.details', {
    url: '/details/:sid/:rid/:aid',
    views: {
      'Content@app': {
        templateUrl: 'app/roomsession/sessiondetails.html',
        controller: 'SessionDetailsCtrl as ctrl'
      }
    }
  });
});
