angular.module('bamboo.roomsession').controller('SessionDetailsCtrl', function(loginService, $ionicHistory, $cordovaGeolocation, $cordovaDevice, $scope, ApiService, $sce, CommonService, $state, $stateParams, $filter) {
  var _self = this;
  this.sid = $stateParams.sid;
  this.rid = $stateParams.rid;
  this.aid = $stateParams.aid;
  this.photo = ''
  if(CommonService.signphoto) {
    this.photo = CommonService.signphoto;
    CommonService.signphoto = "";
  }
  this.signType = $stateParams.signType;     // 1签中  2 签出
  this.imgPath = ApiService.PSURL + "/attendence/" + this.rid + "/";
  if (window.cordova) {
    this.device = true;
  }
  function getUserInfo(){
    ApiService.get('/profile/').then(function(result) {
      console.log(result);
      if (result.data.success) {
        $scope.user = result.data.data;
        getInfo();
      }
    });
  }

  function getInfo() {
    var info = {
      action: 'getSessionRecord',
      sid: _self.sid,
      rid: _self.rid
    }
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        var data = result.data.data;
        $scope.session = data.session || {};
        $scope.record = data.record || {};
        $scope.building = data.building || {};
      } else {
        CommonService.showError(result.data.error||result.data.info);
      }
    });
  }
  getUserInfo();

  this.submit = function() {
    if(!_self.photo){
      CommonService.showError("请上传图片");
    } else {
      cordova.plugins.diagnostic.isGpsLocationEnabled(
        function(e) {
          if (e){
              getLocationInfo();
          } else {
            cordova.plugins.diagnostic.switchToLocationSettings();
          }
        },
        function(e) {
            CommonService.showError("获取地址失败： " + e);
        });
    }
  }

  function getLocationInfo(){
    CommonService.showLoading();
    var posOptions = { timeout: 5000, enableHighAccuracy: false, maximumAge: 30000 };
    $cordovaGeolocation.getCurrentPosition(posOptions).then(function(position) {
      console.log(position);
      CommonService.stopLoading();
      _self.lat = position.coords.latitude;
      _self.lng = position.coords.longitude;
      saveInformation();
    }, function(err) {
      console.log(err);
      if(err&&err.code==3){
        getLocationInfo();
      } else {
        CommonService.showError("获取地址失败： " + err);
      }
    });
  }

  function saveInformation(){
    var info = {
      action: 'addAccessRecordPhoto',
      id: _self.aid,
      photo: _self.photo,
      deviceId: $cordovaDevice.uuid,
      lng: _self.lng,
      lat: _self.lat
    }
    if (_self.signType == 2) {
      info.action = 'exitAccessRecord';
    }
    console.log(info);
    ApiService.post('/session', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        CommonService.stopLoading();
        console.log(title)
        var title = _self.signType == 2 ? '签退成功': '签到成功';
        CommonService.showInfo(title);
        $state.go('app.home');
      } else {
        CommonService.stopLoading();
        CommonService.showError(result.data.error||result.data.info);
      }
    });
  }

  this.accesscamera = function(fileflag) {
    var url = "/attendence/"+_self.rid+'/';
    CommonService.shotandUpload(url, fileflag, function(url, filename) {
      console.log(url);
      console.log(filename);
      if(filename){
        _self.photo = filename;
      }
    });
  }

  this.cancel = function(){
    $ionicHistory.goBack();
  }

});
