angular.module('bamboo.myspace').controller('MyCourseSessionRecords', function($scope, ApiService, loginService, $state, $stateParams, CommonService, $filter, utilService, $translate) {
  var _self = this;
  this.page = parseInt($stateParams.page) || 0;
  this.lid = $stateParams.lid
  this.pageSize = 4;
  _self.contentModelPicUrl = ApiService.SHOST + "/public/" + ApiService.RES + "/schoolevent/";
  this.moreData = false;
  this.items = [];
  this.itemlist = [];
  this.nextPage = function() {
    _self.page++;
    getInfo(_self.page);
    console.log("--- next page --");
  };
  getInfo(0);
  this.enroll = function(item) {
    if (item.app) {
      return CommonService.showError('Already Enrolled');
    }
    CommonService.showConfirm('Are you sure to book this session?', function(result) {
      var info = {
        rid: item._id,
        action: 'userAddRecordApplication'
      };
      CommonService.showLoading();
      ApiService.post("/session", info).then(function(result) {
        CommonService.stopLoading();
        if (result.data.success) {
          CommonService.showInfo($translate.instant('Enroll Application submited!'));
          _self.items = [];
          getInfo(0);
          // $state.reload();
        } else {
          CommonService.showError(result.data.error);
        }
      })
    })
  }

  function getInfo(page) {
    var info = {
      start: page * 8,
      limit: 8,
      action: "getMyCourseSessionRecords",
      lid: _self.lid
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/session", info).then(function(result) {
      CommonService.stopLoading();
      if (result.data.success) {
        if (!_self.items) {
          _self.items = [];
        }
        console.log(result.data.data.items);
        if (result.data.data.items) {
          _self.items = _self.items.concat(result.data.data.items);
          var now = new Date();
          angular.forEach(_self.items, function(item, index, the) {
            if (item.registrationFlag) {
              if (item.registrationEnd) {
                var end = new Date(item.registrationEnd);
                if (end > now) {
                  item.enroll = true;
                }
              } else {
                item.enroll = true;
              }
            }
            var startDate = $filter('date')(item.start, "yyyy/MM/d");
          });
          _self.totalCount = result.data.data.counter;
          _self.moreData = ((_self.totalCount - _self.items.length) > 0);
          console.log(_self.totalCount, _self.items.length, _self.moreData);
        }
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }
  utilService.watchScroll($scope);
});