angular.module('bamboo').service('pwdService', function(loginService, ApiService) {
    //strong pwd 
    //Minimum 8 characters at least 1 Uppercase Alphabet, 1 Lowercase Alphabet, 1 Number and 1 Special Character
    //var strongValidateRegex = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[$@$!%*?&])[A-Za-z\d$@$!%*?&]{8,}$/;
    //var strongValidateRegex = /^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[#?!@$%^&*-]).{8,}$/;
    var strongValidateRegex = /^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[0-9])(?=.*?[$&+,:;=?@#|'`~<>.^*()%!-]).{8,}$/;
    //mid level pwd
    //Minimum 8 characters at least 1 Alphabet and 1 Number
    var midValidateRegex = /^(?=.*[A-Za-z])(?=.*\d).{8,}$/;
    //weak pwd 
    //Minimum 8 characters
    var weakValidateRegex = /^.{6,}$/;
    this.getValidateRegex = function(callback) {
        //console.log(loginService.school.passwordScheme);
        ApiService.getSchoolInfo().then(function() {
            var school = ApiService.school;
            var passwordScheme = school && school.passwordScheme;
            passwordScheme = passwordScheme || 'default';
            console.log(passwordScheme);
            switch (passwordScheme) {
                case 'Strong':
                    callback(strongValidateRegex);
                    break;
                case 'middle':
                    callback(midValidateRegex);
                    break;
                case 'default':
                    callback(weakValidateRegex);
                    break;
                default:
                    callback(weakValidateRegex);
                    break;
            }
        });
        //
    }
    this.getValidateRule = function(passwordScheme) {
        //console.log(loginService.school.passwordScheme);
        switch (passwordScheme) {
            case 'Strong':
                return 'strongValidateRule';
                break;
            case 'middle':
                return 'midValidateRule';
                break;
            case 'default':
                return 'weakValidateRule';
                break;
            default:
                return 'weakValidateRule';
                break;
        }
    };
    //}
});