'use strict';
angular.module('bamboo').service('stringHelper', function() {
  var self = this;
  self.stripTags = function(str) {
    return str ? str.replace(/<\/?[^>]+>/g, '') : '';
  }
  self.html2DivDom = function(htmlstr) {
      var tmp = document.createElement('div');
      tmp.innerHTML = htmlstr;
      return tmp;
    }
    // will skip <td>
  var skipArr = ['TD', 'TR', 'TH', 'TABLE', 'THEAD', 'TFOOT', 'TBODY'];
  self.clearDomStyle = function(dom) {
    if (!dom) return;
    var styleElems = dom.querySelectorAll('[style]');
    angular.forEach(styleElems, function(el, idx) {
      console.log(el.nodeName);
      if (skipArr.indexOf(el.nodeName) < 0) {
        el.style = undefined;
      }
    });
    return dom;
  }

  function removePositionFromStr(str) {
    if (!str || !angular.isString(str)) return str;
    var res = str.split('position: absolute;').join("");
    console.log(res);
    return res;
  }
  self.clearDomPositionStyle = function(dom) {
    if (!dom) return;
    var styleElems = dom.querySelectorAll('[style]');
    angular.forEach(styleElems, function(el, idx) {
      console.log(el.nodeName);
      if (el.nodeName == "SPAN") {
        el.style = removePositionFromStr(el.style);
      }
    });
    return dom;
  }
  self.clearHtmlStrStyle = function(str) {
    if (!str) return;
    if (!angular.isString(str)) return str;
    var dom = self.html2DivDom(str);
    self.clearDomStyle(dom);
    return dom.innerHTML;
  }
  self.clearPositionStyle = function(str) {
    if (!str) return;
    if (!angular.isString(str)) return str;
    var dom = self.html2DivDom(str);
    self.clearDomPositionStyle(dom);
    return dom.innerHTML;
  }

  function reverse(str) {
    if (!str) return;
    if (!angular.isString(str)) return str;
    return str.split("").reverse().join("");
  }

  function removeSubStrByIdx(S, bindex, count) {
    if (!S) return;
    if (!angular.isString(S)) return S;
    var result = S.split('');
    result.splice(bindex, count);
    S = result.join('');
    //console.log(S);
    return S;
  }
  self.removeInvalidSymbol = function(str) {
    if (!str) return;
    if (!angular.isString(str)) return str;
    var target = reverse('<p>&nbsp;</p>');
    //console.log(target);
    str = reverse(str);
    var idx = str.indexOf(target);
    //console.log(idx);
    //console.log(str);
    if (idx >= 0) {
      str = removeSubStrByIdx(str, idx, 13);
    }
    var backspace = String.fromCharCode(10);;
    //console.log(reverse(str));
    return reverse(str).split(backspace).join("");
    //return str.replace(/[\x00-\x1F\x7F-\x9F]/g, "").replace('<p>&nbsp;</p>'," ");
  }
});