angular.module('bamboo.sharedrive').controller('DriveListCtrl', function($scope, $ionicScrollDelegate, $stateParams, loginService, ApiService, CommonService, $timeout, CourseApi, $rootScope, utilService, departmentBizModel, $cordovaDevice) {
  var self = this;
  console.log("---- course list -----");
  $rootScope.hideSettings = true;
  this.cat = $stateParams.cat;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  this.moreData = true;  
  this.items = [];
  this.page = 0;
  this.docsUrl = ApiService.SHOST + '/sharedrive/' ;
  var _platform = $cordovaDevice.platform;
  if (_platform && _platform.indexOf('Android') > -1) {
    this.showDownload = true;
  }
  $scope.$on('$ionicView.enter', function() {
    getDrives(0);
    self.driveType = 'school';
    self.department = '';
    if (loginService.user.grole == 'admin' || loginService.user.is_admin) {
      departmentBizModel.getAllDepartment().then(function(deps) {
        self.mydeps = deps || [];
        console.log(deps);
      });
    } else {
      departmentBizModel.getMyDepartment().then(function(mydeps) {
        console.log(mydeps);
        self.mydeps = mydeps;
      });
    }
  });

  this.doRefresh = function()
  {
    self.page = 0;
    self.nextPage();
    $scope.$broadcast('scroll.refreshComplete');
  }

  function getDrives(page) {
    console.log(page);
    var info = {
      action: "getenablesharefiles",
      type: 'school',
      start: (page) * 8,
      limit: 8
    };  
    info.search = info.search || {};
    if(self.cat) {
      info.search.category = self.cat;
    }
    if (self.name) {      
      info.search.displayName = self.name;
    }
    if (self.department) {      
      info.search.department = self.department;
    }
    console.log(info);
    CommonService.showLoading();
    ApiService.post("/drive", info).then(function(result) {
      CommonService.stopLoading();
      console.log(result);
      if (result.data.success) {
        if (page==0) {
          self.items = [];
        }
        self.items = self.items.concat(result.data.data.items);
        self.totalCount = result.data.data.counter;
        self.moreData = ((self.totalCount - self.items.length) > 0);      
        $rootScope.totalCourseCounter = self.totalCount;
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }
    });
  }
  this.nextPage = function() {
    getDrives(self.page);
    self.page++;    
  };
  this.search = function() {
    self.page = 0;
    getDrives(0);
  };

  this.searchType = function(type) {
    self.driveType = type;
    self.page = 0;
    self.name = null;
    getDrives(0);
  }

  utilService.watchScroll($scope);

  this.download = function(item) {
    var url = self.docsUrl+item.groupType+'/'+encodeURI(item.filename);
    console.log(url);    
    CommonService.downloadWithNotification(url, item.filename, function(res) {
      console.log(res);
      CommonService.showInfo('Download Success!');
    });
    // CommonService.downloadFileByUrl(url, item.filename, function() {
    //   console.log('success');
    //   CommonService.showInfo('Download Success!');
    // });
  }

  this.preview = function(item){
    var url = self.docsUrl+item.groupType+'/'+encodeURI(item.filename);
    CommonService.showDetailPreview($scope, item.filename, url); 
  }

});