// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo.study', ['ionic']).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app.study', {
    url: '/study',
    views: {
      'Content@app': {
        templateUrl: 'app/study/study.html',
        controller: "StudyCtrl as ctrl"
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.study.detail', {
    url: '/detail/:id',
    views: {
      'Content@app': {
        templateUrl: 'app/study/detail.html',
        controller: "StudyDetailCtrl as ctrl"
      }
    }
  }).state('app.study.myexam', {
    url: '/myexam/:cid/:examtype',
    views: {
      'Content@app': {
        templateUrl: 'app/study/myexam.html',
        controller: "MyStudyExamCtrl as ctrl"
      }
    }
  }).state('app.study.mypractise', {
    url: '/mypractise/:cid/:examtype',
    views: {
      'Content@app': {
        templateUrl: 'app/study/mypractise.html',
        controller: "MyStudyExamCtrl as ctrl"
      }
    }
  }).state('app.study.number', {
    url: '/number/:isBank/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/study/number.html',
        controller: "ExamNumberCtrl as ctrl"
      }
    }
  }).state('app.study.summary', {
    url: '/summary/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/study/summary.html',
        controller: "ExamChartCtrl as ctrl"
      }
    }
  })
    .state('app.study.practicecenter', {
    url: '/practicecenter/:cid/:examtype',
    views: {
      'Content@app': {
        templateUrl: 'app/study/practicecenter.html',
        controller: "PracticeCenterCtrl as ctrl"
      }
    }
  }).state('app.study.test', {
    url: '/detail/:type/:num/:isBank/:cid',
    views: {
      'Content@app': {
        templateUrl: 'app/study/exampaper.html',
        controller: 'StudyExamPaperCtrl as ctrl'
      }
    }
  }).state('app.study.mypractise.practise', {
    url: '/practise/:type/:num/:isBank/:paperid/:papertype/:paperName',
    views: {
      'Content@app': {
        templateUrl: 'app/study/exampaper.html',
        controller: 'StudyExamPaperCtrl as ctrl'
      }
    }
  })
});
