angular.module('bamboo.study').controller('StudyCtrl', function($scope,$window, loginService, CourseApi, $ionicModal, ApiService, $timeout, $state, CommonService, $ionicPopover, utilService) {
  this.tab = 0;
  this.subtab = 0;
  this.searchName = '';
  this.showSearch = true;
  var _self = this;
  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.subjectPicUrl = ApiService.SHOST + "/public/" + ApiService.RES;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';
  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.coursephoto) {
      _self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });
  $scope.setting = {
    page: 0,
    numProgress: 0,
    page_items: [],
    items: []
  };
  this.moreData = false;
  this.nextPage = function() {
    if(_self.tab== 0){
     // console.log(132132)
        $scope.setting.page++;
        _self.getMyCourses($scope.setting.page);

    }
    console.log("--- next page --");
  };
  this.getMyCourses = function(page) {
    //console.log(11111)
    var info = {
      action: "getMyAccessedCourses",
      page: page,
      limit: 8 // page size
    };
    //CommonService.showLoading();
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      $scope.setting.page_items = result.courses;
      $scope.setting.totalCount = result.count;
      getMyProgress();

      $scope.setting.items = $scope.setting.items.concat(result.courses);
      console.log($scope.setting.items);
      if ($window.innerWidth - $scope.setting.items.length * 118 > 0) {
        $scope.marginRight = 0 + 'px';
      } else {
        $scope.marginRight = ($window.innerWidth - $scope.setting.items.length * 118) + "px";
      }
      //$scope.marginRight=($window.innerWidth- $scope.setting.items.length* 80)+"px";
      _self.moreData = (($scope.setting.totalCount - $scope.setting.items.length) > 0);
      console.log($scope.setting.totalCount, $scope.setting.items.length, _self.moreData);
      console.log($scope.setting.page_items);
      _self.totalCount = result.count;
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $scope.$broadcast('scroll.refreshComplete');
    });
  }

  this.refresh = function() {
    $scope.setting.items = [];
    $scope.setting.page=0;
    _self.getMyCourses(0);
  }

  $scope.$on('$ionicView.beforeEnter', function(){
    $scope.setting.items = [];
    $scope.setting.page=0;
    _self.getMyCourses(0);
  });


  function getMyProgress() {
    var info = {
      action: "getmyprogress",
    }
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      CommonService.stopLoading();
      if (result) {
        var progress = result;
        angular.forEach($scope.setting.page_items, function(course, key) {

          var id = course._id;
          if(course.sysScore||course.offScore){
            console.log(course);
            console.log(course.sysScore);
            var totalScore=(course.sysScore||0)+(course.offScore||0);
            if (progress[id]) {

              console.log(progress[id]);
              //course.sysScore 学时需求
              console.log(progress[id].sessionWeight);

              var weight=(progress[id].sessionWeight||0)+(progress[id].csessionWeight||0);
              // if(!progress[id].sessionWeight){
              //   progress[id].sessionWeight=0;
              // }
              course.progressCourse=weight+"/"+totalScore;
              course.progress = parseInt((weight||0 )* 100 / totalScore);
              console.log(progress[id], course);
              // if (course.progress != 100) {
              //   //console.log(course.progress);
              //   $scope.setting.numProgress++;
              // }
            } else {
              course.progressCourse="0/"+totalScore;
            }
          }
        });
      } else {
        // no progress record
        $scope.setting.numProgress += $scope.setting.page_items.length;
      }
    });
  }

  this.getCompletedCourses = function(page) {
    var info = {
      action: "getmycerts",
      page: page,
      limit: 16
    };
    console.log(info);
    ApiService.post('/user', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        _self.completedCourses = result.data.data.items;
        _self.completedCount = result.data.data.counter;
        _self.moreData = ((_self.completedCount - (_self.completedCourses.length+16)) > 0);
        $scope.$broadcast('scroll.infiniteScrollComplete');
      }
    });
  }

  this.examtypeList = ["chapter", "practice", "questions", "recite", "simulation"]
  this.datatotal = ["error", "exercises", "grade", "total"]

  // 练习中心点击课程
  this.changeSubTab = function(index, item) {
    this.subtab = index;
  }
  this.goMyexam = function(index) {
    if(index == 2) {          //  题库
      //$state.go("app.study.number", {isBank: 1, cid: $scope.setting.items[this.subtab]._id})
      //({ type: "exam", num: number, isBank: ctrl.isBank, cid: ctrl.cid})
      $state.go("app.study.test", {type: "exam",num: 0,isBank: 1, cid: $scope.setting.items[this.subtab]._id})
    } else if(index == 3) {   // 背题
      $state.go("app.study.test", {type: "exam",num: 0,isBank: 0, cid: $scope.setting.items[this.subtab]._id})

      //$state.go("app.study.number", {isBank: 0, cid: $scope.setting.items[this.subtab]._id,})
    } else if(index == 5) {   // 收藏
      $state.go("app.study.test", {isBank: 2, cid: $scope.setting.items[this.subtab]._id,num:0})
    } else if(index == 1||index==0){
      $state.go("app.study.mypractise", { cid: $scope.setting.items[this.subtab]._id, examtype: this.examtypeList[index]})
    } else {
      $state.go("app.study.myexam", { cid: $scope.setting.items[this.subtab]._id, examtype: this.examtypeList[index]})
    }
  }
  this.goErroExam=function(){
    $state.go("app.exam.test", { id: $scope.setting.items[this.subtab]._id, type:'error'})
  }
  this.goDataTotal = function(index) {
    $state.go("app.study.summary",{cid: $scope.setting.items[this.subtab]._id})
  }

  this.goPracticeCenter=function(index){
    $state.go("app.study.practicecenter",{cid: $scope.setting.items[this.subtab]._id,examtype: this.examtypeList[index]})
  }

  this.inputBlur = function() {
    console.log(1111)
    _self.showSearch = true;
  }

  this.inputFocus = function() {
    console.log(2222)
    _self.showSearch = false;
  }
});
