angular.module('bamboo.study').controller('ExamChartCtrl', function ($scope,$window, $stateParams, ApiService, CommonService, $q, MystudyService, loginService) {
  var self = this;
  this.cid = $stateParams.cid;
  this.page = 0;
  // $scope.widthCav=$window.innerWidth-30+'px';
  $scope.widthCav="100%";
  var chartData = {
    labels: [],
    datasets: [{
      label: "",
      backgroundColor: "rgba(255,99,132,0.2)",
      borderColor: "rgba(255,99,132,1)",
      pointBackgroundColor: "rgba(255,99,132,1)",
      pointBorderColor: "#fff",
      pointHoverBackgroundColor: "#fff",
      pointHoverBorderColor: "rgba(255,99,132,1)",
      //scaleLineColor: "rgba(0,0,0,.1)",
      fillColor: "rgba(169,169,169,0.8)",
      scaleFontSize: 14,
      scaleFontColor: "#000",
      data: []
    }]
  };

  function prepareRadarChart(knowledgeSourse) {
    var labels = [];
    var data = [];
    angular.forEach(knowledgeSourse, function (nlg, idx) {
      if (nlg.key) {
        if (nlg.key == "other") {
          nlg.shortkey = "其他"
        }
        var value = nlg.value;
        var strlen = 12
        labels.push(nlg.key.length < strlen ? nlg.shortkey : nlg.shortkey.substring(1, strlen)+ '..');
        if (value.counter) {
          var _result = Math.round(value.correct * 100 / value.counter * 100) / 100;
          // if (flag && _result > 30) { //_result==100
          //   labels.pop();
          // } else {
          data.push(_result);
          // }
        } else {
          labels.pop();
        }
      }
    });
    chartData.labels = labels;
    chartData.datasets[0].data = data;
    chartData.datasets[0].label = '准确率';
    return chartData;
  }

  function getKnowledgeSourse(userknowledges) {
    var displayKnowledges = [];
    var shortKnowledges = [];
    var tmpArray = [];
    angular.forEach(userknowledges, function (value, key) {
      var object = {
        value: value,
        key: key
      };
      tmpArray.push(object);
    })
    // tmpArray.sort(sortByKey);
    console.log(tmpArray);
    angular.forEach(tmpArray, function (object, index) {
      var value = object.value;
      var key = object.key;
      var childPerctg = [];
      var _array = key.split(',');
      var len = _array.length;
      var pos = len - 2;
      if (pos < 0) {
        pos = 0;
      }
      var _array1 = _array.slice(pos);
      var _key = _array1.join(',');
      if (_array1.length > 1 && _array1[1].length > 12) {
        _key = _array1[1];
      }
      var _k = {
        value: value,
        key: key,
        shortkey: _key,
        score: value.correct * 100 / value.counter,
      }
      displayKnowledges.push(_k);
      shortKnowledges.push(_k);
      // /console.log(value);
      for (var i = 0; i <= 5; i++) {
        if (value[i]) {
          displayKnowledges.push({
            level: i,
            value: value[i],
            score: value[i].correct * 100 / value[i].counter,
            percentage: (value[i].correct * 100) / value[i].counter
          });
        }
      }
    });
    return {
      full: displayKnowledges,
      short: shortKnowledges
    };
  }

  function getRadarChartData(uid, lid, flag) {
    var info = {
      cid: self.cid,
      id: loginService.user._id,
      action: "getusercourseknowledges",
      qcounter: true,
    }
    var deferred = $q.defer();
    var promise = deferred.promise;
    ApiService.post('/user', info).then(function (result) {
      ;
      var userscores = [];
      if (result.data.success) {
        var userknowledges = result.data.data || {};
        console.log(userknowledges);
        var temp = getKnowledgeSourse(userknowledges);
        var knowledgeSourse = temp.full;
        var radarChartData = prepareRadarChart(knowledgeSourse);
        deferred.resolve({
          chartData: radarChartData,
          origin: temp
        });
      } else {
        deferred.reject(result);
      }
    });
    return promise;
  }

  function showData() {
    getRadarChartData().then(function (data) {
      console.log(data);
      self.chartData = data.chartData;
      // self.knowledgeSourse = self.displayKnowledges;
      if (data.origin) {
        console.log('--- have data --');
        self.knowledgeSourse = self.displayKnowledges = data.origin.full;
        self.dspyKoldgsWthoutSub = data.origin.short;
        //calKnowledgeCoverPer();
      }
      if (self.chartData && self.chartData.labels && self.chartData.labels.length > 0) {
        if (self.user) {
          self.chartData.datasets[0].label = self.user.fullname;
        }
        console.log("--- show here");
        self.showChart = true;
      }
    });
  }

  showData();
  console.log(loginService.user);

  this.records = [];
  function showRecords(page) {
    var info = {
      lid: self.cid,
      uid: loginService.user.name,
      action: "getUserCourseExamRecords",
      start: page * 10,
      limit: 10,
    }
    console.log(info);
    ApiService.post('/exam', info).then(function (result) {
      console.log(result);
      if (result.data.success) {
        console.log(result.data.data)
        self.totalCount = result.data.data.counter;
        self.records = self.records.concat(result.data.data.items);
        self.moreData = ((self.totalCount - self.records.length) > 0);
        //_self.counter = result.data.data || 0;
      } else {
        // _self.counter = 0;
      }
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  showRecords(self.page);
  this.nextPage = function () {
    console.log("-- next page");
    self.page++;
    showRecords(self.page)
  }
});
