'use strict';
angular.module('bamboo.survey').controller('takesurveyCtrl', function($scope,$rootScope,$translate, ApiService, $cordovaGeolocation, CommonService, $stateParams, $state, $filter, $ionicPopover) {
  var self = this;
  this.contentModel = {};
  self.id = $stateParams.id;
  var info = {
    action: 'get',
    id: self.id
  };
  ApiService.post('/survey', info).then(function(result) {
    console.log(result);
    if (result.data.success) {
      var _result = result.data.data;
      self.contentModel = result.data.data;
      self.item = _result;
    }
    if (self.item.public) {
      console.log("----self.contentModel-------");
      console.log(self.contentModel);
    }
    if (!self.item.public) {
      var infocheck = {
        action: 'checksurveyexist',
        id: self.id
      }
      ApiService.post('/survey', infocheck).then(function(_result) {
        console.log(data)
        if (result.data.success) {
          var data = _result.data.data;
          if (data != 0) {
            $state.go('app.survey', {
              id: self.id
            });
          }
        }
      })
    }
  });
  $scope.numToLetters = function(num) {
    return String.fromCharCode(65 + num);
  };
  var allanswered = true;

  function getResult() {
    var result = {};
    angular.forEach(self.item.questions, function(val, index) {
      console.log(val);
      console.log(getText(val.content));
      var key = getText(val.content);
      if (key.indexOf('.') > -1) {
        key = key.split('.').join('');
      }
      var ans = val.selection;
      if (val.type && val.type == 'multiple') {
        var ans = [];
        angular.forEach(val.options, function(opt, index) {
          if (opt.selection) {
            ans.push(opt.text);
          }
        })
        result[key] = ans;
      } else {
        result[key] = ans;
        if (typeof val.selection == 'undefined') {
          allanswered = false;
        }
      }
    });
    return result;
  }
  var myposition = {};
  this.GPSFlag;

  function shootPicture(callback) {
    var url = '/survey/' + self.id + "/";
    CommonService.shotandUpload(url, false, function(url, filename) {
      callback(filename);
    });
  }
  this.submit = function() {
    allanswered = true;
    // console.log(self.item.questions);
    var result = getResult();
    //  console.log(result);
    if (!allanswered) {
      CommonService.showError('Not all question answered!');
      return;
    }
    var object = {
      result: result,
      username: self.item.username,
      sid: self.id,
      parent: true
    }
    if (myposition.lat) {
      object.lat = myposition.lat;
      object.lng = myposition.lng;
    }
    var info = {
      id: self.id,
      action: 'submitsurvey',
      object: object,
    };
    if (self.item.public) {
      info.action = 'addrecord';
      // info.username = self.item.username;
    }
    if (self.item.photoFlag) {
      shootPicture(function(filename) {
        info.object.photo = filename;
        submit();
      })
    } else {
      submit();
    }

    function submit() {
      CommonService.showLoading();
      ApiService.post('/survey', info).then(function() {
        CommonService.stopLoading();
        var message = 'Thank you for submitting the survey!';
        if (!myposition.lat) {
          message = 'Survey Submited without GPS Infomation, please check your GPS setting!';
        }
        var options = {
          title: 'Thank you!',
          message: message,
        };
        CommonService.showInfoWithTitle(options.title, options.message);
        console.log("survey submitted");
        //  $state.reload();
        //$state.go($rootScope.$previousState, $rootScope.$previousStateParams);
      })
    }
  };
  this.publicsubmit = function() {
    allanswered = true;
    // console.log(self.item.questions);
    var result = getResult();
    //  console.log(result);
    if (!allanswered) {
      CommonService.showError('Not all question answered!');
      return;
    }
    if (self.item.public && (!self.item.username || self.item.username.length < 3)) {
      CommonService.showError('Invalid User Name');
      return;
    }
    var object = {
      result: result,
      username: self.item.username,
      sid: self.id,
      parent: $rootScope.parent == 'parent'
    }
    if (myposition.lat) {
      object.lat = myposition.lat;
      object.lng = myposition.lng;
    }
    var url = '/survey/' + self.id + "/";
    CommonService.shotandUpload(url, false, function(url, filename) {
      object.photo = filename;
      var info = {
        id: self.id,
        action: 'addrecord',
        object: object,
      };
      console.log(info);
      CommonService.showLoading();
      ApiService.post('/survey', info).then(function(result) {
        console.log(result);
        CommonService.stopLoading();
        var message = 'Thank you for submitting the survey!';
        // if(!myposition.lat){
        //   message='Survey Submited without GPS Infomation, please check your GPS setting!';
        // }
        var options = {
          title: 'Thank you!',
          message: message,
        };
        CommonService.showInfoWithTitle(options.title, options.message);
        console.log("survey submitted");
        $state.reload();
        //$state.go($rootScope.$previousState, $rootScope.$previousStateParams);
      })
    });
  }
  var posOptions = {
    timeout: 10000,
    //  enableHighAccuracy: false
  };
  $cordovaGeolocation.getCurrentPosition(posOptions).then(function(position) {
    myposition.lat = position.coords.latitude;
    myposition.lng = position.coords.longitude;
    self.GPSFlag = true;;
    console.log('get gps data');
    //   submitSurvey(true);
  }, function(err) {
    //CommonService.stopLoading();
    // CommonService.showError("Get Location error, Please check permission ! ");
    //  submitSurvey(false);
  });

  function getText(string) {
    return string.replace(/&nbsp;/g, '').replace(/<[^>]*>/g, "");
  };
  //share function to show dialog
  this.share = function() {
    var link = ApiService.HOST + '/#/surveys/detail/' + self.contentModel._id;
    var imageUrl = self.contentModel.photo ? self.contentModelPicUrl + self.contentModel.photo : null;
    console.log("link:");
    console.log(link);
    CommonService.showShareDialog($scope, self.contentModel.name, null, link, null);
  };
  $ionicPopover.fromTemplateUrl('app/event/menupopover_survey.html', {
    scope: $scope,
  }).then(function(popover) {
    $scope.popover = popover;
  });
  $scope.closeEventPopover = function() {
    $scope.popover.hide();
  };
  this.gohome = function() {
    $state.go('app.home');
  }
});