'use strict';
angular.module('bamboo.teacher').controller('teacherAssignmentRecordListCtrl', function($scope, $rootScope, $translate, ApiService, CommonService, $stateParams, $state, $filter, ExamService, $ionicPopover, $sce) {
  var self = this;
  self.tab = 0;
  this.items = [];
  self.aid = $stateParams.aid;

  self.baseImageUrl = ApiService.SHOST + "/assignment/" + self.aid + "/";

  this.getUnreviewed = function() {
    // var search = self.selectedclass && self.selectedclass.id;
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      //search: search,
      action: "getunmarkedassignmentrecords",
      aid: self.aid,
    };
    console.log(info);

    ExamService.api(info, function(result) {
      console.log(result);
      self.displayList = result.items;
      angular.forEach(result.items, function(item) {
        var author = item.author || {};
        item.author_url = CommonService.getAvatarSrc(author);

        var teacher = item.teacheruser || {};
        item.teacher_url = CommonService.getAvatarSrc(teacher);
      })
      console.log(self.displayList);
      $scope.total = result.counter;
      collectImages(self.displayList);
      //tableState.pagination.numberOfPages = Math.ceil(result.counter / limit);
    });
  }
  this.getUnreviewed();

  this.getReviewed = function() {

    // var search = self.selectedclass_review && self.selectedclass_review.id;
    var info = {
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      //  search: search,
      action: "getmarkedassignmentrecords",
      aid: self.aid,
    };

    ExamService.api(info, function(result) {
      console.log(result);
      self.displayList = result.items;
      angular.forEach(result.items, function(item) {
        var author = item.author || {};
        item.author_url = CommonService.getAvatarSrc(author);

        var teacher = item.teacheruser || {};
        item.teacher_url = CommonService.getAvatarSrc(teacher);
      })
      console.log(self.displayList);
      $scope.rtotal = result.counter;
      collectImages(self.displayList);
      //tableState.pagination.numberOfPages = Math.ceil(result.counter / limit);
    });
  }


  function collectImages(records) {
    if (records.length <= 0) return;

    var audioList = [];
    records.forEach(function(item) {
      var imageList = [];
      var fileList = [];
      var audioList = [];
      var videoList = [];
      var files = item.files || [];
      console.log(item);

      files.forEach(function(file) {
        if (file.type === 'img') {
          imageList.push(file);
        } else if (file.type === 'pdf' || file.type === 'doc') {
          if (file.type === 'doc') {
            file.type = 'word';
          }
          fileList.push(file);
        } else if (file.type === 'mp3') {
          audioList.push(file);
        } else if (file.type === 'mp4') {
          videoList.push(file);
        }
      });

      item.imageList = imageList;
      item.fileList = fileList;
      item.videoList = videoList;
      item.audioList = audioList;
      item.lenForClass = imageList.length <= 5 ? imageList.length : 5;
      // console.log(item);
    });
  }


  self.showMore = function() {
    self.showMore = true;
  }

  self.download = function(url, name) {
    CommonService.downloadFileByUrl(url, name);
  }

  // .fromTemplateUrl() method
  $ionicPopover.fromTemplateUrl('app/component/gallerypopover.html', {
    scope: $scope
  }).then(function(popover) {
    $scope.popover = popover;
    // $scope.openPopover();
  });


  $scope.openPopover = function($event, assign) {
    console.log(assign);
    $scope.popover.imageList = assign.imageList;
    $scope.popover.username = assign.user;
    $scope.popover.show($event);
  };


  $scope.closePopover = function() {
    $scope.popover.hide();
  };
  //Cleanup the popover when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.popover.remove();
  });
  // Execute action on hidden popover
  $scope.$on('popover.hidden', function() {
    // Execute action
  });
  // Execute action on remove popover
  $scope.$on('popover.removed', function() {
    // Execute action
  });

  $scope.trustSrc = function(src) {
    return $sce.trustAsResourceUrl(src);
  }

});