'use strict';
angular.module('bamboo.teacher').controller('teacherCourseAttendanceCtrl', function($scope, ApiService, $stateParams, teacherSvc, utilService) {
  var self = this;

  var page = 0;
  var pagesize = 10;
  var search;
  $scope.items = [];

  function getMyClass(cb) {
    teacherSvc.getMyClass().then(function(data) {
      console.log(data);
      var success = data.data.success;
      if (success) {
        var classes = data.data.data;
        self.myClassIds = classes.map(function(o) {
          return o._id;
        });
        console.log(self.myClassIds);
      }
      cb();
    });
  }

  $scope.loadMore = function() {
    var info = {
      //start: page * pagesize,
      //limit: pagesize,
      start: 0,
      limit: Number.MAX_SAFE_INTEGER,
      action: 'getclasseswithattends',
    };
    console.log(info);
    var time;
    if (search && search.time) {
      time = search.time;
      info.day = search.time.toString().substring(0, 10);
      delete search.time;
    }
    ApiService.post("/classes", info).then(function(result) {
      //   console.log(result);
      if (result.data.success) {
        console.log(result.data.data);
        if (time) {
          search.time = time;
        }
        $scope.items = $scope.items.concat(result.data.data.items);
        console.log($scope.items);
        $scope.items = _.filter($scope.items, function(o) {
          return self.myClassIds.indexOf(o._id) >= 0;
        });
        console.log($scope.items);
        $scope.totalcounter = $scope.items.length;
        page++;
        $scope.moreData = false;

        $scope.$broadcast('scroll.infiniteScrollComplete');
      }
    });
  };

  $scope.$on('$stateChangeSuccess', function() {
    getMyClass($scope.loadMore);
  });

  utilService.watchScroll($scope);
});