'use strict';
angular.module('bamboo.teacher').controller('teacherClassStuListCtrl', function($scope, $rootScope, $translate, ApiService, CourseApi, CommonService, $stateParams, ExamService, $state, $filter, $ionicPopover, utilService, MystudyService, loginService, $ionicPopup) {
  var self = this;
  console.log("bamboo.class-------");
  console.log($stateParams);
  self.id = $stateParams.classid;
  self.selectAll = false;

  function getStudents() {
    ApiService.get('/class/' + self.id + "/students").then(function(result) {
      if (result.data.success) {
        self._class = result.data.data._class;
        self.students = result.data.data.users;
        // students post-processing, generate url for avatar
        console.log(self._class);
        console.log(self.students);

        if (self.students) {
          for (var i = 0; i < self.students.length; i += 1) {
            self.students[i].avatarUrl = CommonService.getAvatarSrc(self.students[i]);
          }
        }
        self.stuNameList = self.students.map(function(o) {
          return o._id;
        });
      }
    });
  }

  function filterStudents(stuList) {
    return stuList.filter(function(stu) {
      return stu.selected;
    }).map(function(o) {
      return o._id;
    });
  }

  function isSelectSome(stuList){
    var res = stuList.some(function(o){
      return o.selected;
    });
    if(res){
      self.enableMsg = true;
    }else{
      self.enableMsg = false;
    }
  }

  self.onSelect = function(){
    isSelectSome(self.students);
  }

  function fillStuSelected(val) {
    self.students = self.students.map(function(o) {
      o.selected = val;
      return o;
    });
    console.log(self.students);
    isSelectSome(self.students);
  }

  self.selectAllStu = function() {
    if (!self.selectAll) {
      fillStuSelected(false);
    } else {
      fillStuSelected(true);
    }
  }

  self.sendmsgs = function() {
    CommonService.sendmsgsdlg(self.selectedName);
  }

  function tran(str) {
    if (!angular.isString(str)) {
      throw new TypeError("Parameters type should be string ")
    }

    return $translate.instant(str);
  }
  $scope.openMsgDlg = function() {
    $scope.data = {
      comment: ""
    }
    $scope.clearError = function() {
        $scope.data.error = undefined;
      }
      // An elaborate, custom popup
    var myPopup = $ionicPopup.show({
      templateUrl: 'app/component/addMsgDlg.component.html',
      title: tran('Message'),
      // subTitle: 'Please use normal things',
      scope: $scope,
      buttons: [{
        text: tran('Cancel')
      }, {
        text: tran('Submit'),
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.comment) {
            console.log($scope.data.comment);
            $scope.data.error = tran("Oops,the content is empty !")
            e.preventDefault();
          } else {
            return $scope.data.comment;
          }
        }
      }]
    });
    myPopup.then(function(comment) {
      console.log('Tapped!', comment);
      if (!comment) return;
      self.stuNameList = filterStudents(self.students);
      sendmessage(self.stuNameList, comment);
    });
  }

  function sendmessage(sendTo, newmessage) {
    var info = {
      action: "sendp2ps",
      target: sendTo,
      message: newmessage,
    }
    console.log(info);
    if (sendTo.length === 0) {
      CommonService.showError('You did not select any students !');
      return;
    }

    ApiService.post('/messages', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        CommonService.showInfo('Message Sent Successfully');
        // self.newmessage = "";
        // $scope.$close();
        console.log("ok");
      }
    });

  }

  getStudents();

});