'use strict';
angular.module('bamboo.teacher').controller('teacherRecordListCtrl', function($scope, $rootScope, $translate, ApiService, CourseApi, CommonService, $stateParams, $state, $filter, $ionicPopover, utilService, ExamService) {
  var self = this;

  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.subjectPicUrl = ApiService.SHOST + "/public/" + ApiService.RES;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';

  this.moreData = false;
  var page = 0;

  $scope.items = [];
  this.itemNumber = 10;
  this.maxTime = 0;
  this.showResource = true;
  this.showMileStone = true;
  this.showScores = true;
  this.showTime = true;
  this.showExamScores = true;
  this.showAssignment = true;
  this.maxScore = 0;
  this.maxExamScore = 0;
  this.maxAssignmentScore = 0;
  this.classlist = [];
  this.classstudents = {};

  this.showflag = 'basic';


  var courseid = this.cid = $stateParams.lid;
  // this.viewPrefix='index.news.announcements.detail';
  // this.editPrefix='index.news.announcements.edit';
  console.log($state.current.name);

  self.additions = [];


  var info = {
    id: courseid,
    action: "getcoursescoresconfig",
  }
  CourseApi.lcApi(info, function(result) {
    console.log(result);
    self.score = result;
    self.courseMax = 0;
    if (!self.score.topicMax && self.score.topicMax != 0) {
      self.score.topicMax = 10;
    }

    if (!self.score.replyMax && self.score.replyMax != 0) {
      self.score.replyMax = 10;
    }

    if (!self.score.timeMax && self.score.timeMax != 0) {
      self.score.timeMax = 10;
    }
    self.courseMax += self.score.topicMax;
    self.courseMax += self.score.replyMax;
    self.courseMax += self.score.timeMax;
    self.courseMax += self.score.assignmentMax;
    self.courseMax += self.score.examMax;
    self.additions.push(self.score.addition1 || {});
    self.additions.push(self.score.addition2 || {});
    self.additions.push(self.score.addition3 || {});
    self.addMax = 0;
    self.addMax += self.additions[0].points || 0;
    self.addMax += self.additions[1].points || 0;
    self.addMax += self.additions[2].points || 0;
    self.courseMax += self.addMax;
    console.log(self.additions);
    $scope.additionFlag = isValid();
  })

  function isValid() {
    var res = false;
    angular.forEach(self.additions, function(val, idx) {
      if (val.title && val.description && val.points) {
        res = true;
      }
    });
    return res;
  }

  function getClassList() {
    var info = {
      lid: courseid,
      action: 'getclasslist',
    };
    ExamService.api(info, function(data) {
      console.log(data);
      if (data.length > 0) {
        for (var i = 0; i < data.length; i++) {
          var _class = data[i];
          var info = {
            name: _class.name,
            id: _class._id,
            //  students: _class.students,
          };
          self.classlist.push(info);
          self.classstudents[_class._id] = info;
        }
      }
    });
  }
  getClassList();
  var search;
  $scope.displayedItems = [];


  function getitems() {

    // var search = tableState.search.predicateObject;
    var info = {
      start: page * 6,
      limit: 6,
      cid: courseid,
      action: "getprogreses"
    };

    if ($scope.classid) {
      info.classid = $scope.classid;
    }
    console.log(info);
    CommonService.showLoading();
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      $scope.displayedItems = $scope.displayedItems.concat(result.data);
      $scope.total = result.count;
      //tableState.pagination.numberOfPages = Math.ceil(result.count / limit);
      self.moreData = (($scope.total - $scope.displayedItems.length) > 0);

      CommonService.stopLoading();
      $scope.$broadcast('scroll.infiniteScrollComplete');
      angular.forEach(($scope.displayedItems), function(item, key) {
        // var id
        item.avatar_url = CommonService.getAvatarSrc(item);
        if (item.progress) {
          if (item.progress.chapters && item.progress.resources) {
            item.progressresult = parseInt(item.progress.chapters * 100 / item.progress.resources);
          } else {
            item.progressresult = 0;
          }
          if (item.progress.tasks && item.progress.milestones) {
            item.taskresult = parseInt(item.progress.tasks * 100 / item.progress.milestones);
          } else {
            item.taskresult = 0;
          }
          if (item.progress.activityMax && item.progress.activityMax > self.maxScore) {
            self.maxScore = item.progress.activityMax;
          }
          if (item.progress.examMax && item.progress.examMax > self.maxExamScore) {
            self.maxExamScore = item.progress.examMax;
          }
          if (item.progress.assignmentMax && item.progress.assignmentMax > self.maxAssignmentScore) {
            self.maxAssignmentScore = item.progress.assignmentMax;
          }

          if (item.progress.time && item.progress.time > self.maxTime) {
            self.maxTime = item.progress.time;
          }

        }
        if (!item.addition) {
          item.addition = {};
        }
      });
      angular.forEach(($scope.displayedItems), function(item) {
        if (item.progress.time && self.maxTime) {
          item.timeresult = parseInt(item.progress.time * 100 / self.maxTime);
        } else {
          item.timeresult = 0;
        }
        // console.log(item.progress.scores);
        if (item.progress.scores && self.maxScore) {
          item.scoreresult = parseInt(item.progress.scores * 100 / self.maxScore);
        } else {
          item.scoreresult = 0;
        }
        if (item.progress.examscores && self.maxExamScore) {
          item.examresult = parseInt(item.progress.examscores * 100 / self.maxExamScore);
        } else {
          item.examresult = 0;
        }
        if (item.progress.assginmentscores && self.maxAssignmentScore) {
          item.assignmentresult = parseInt(item.progress.assginmentscores * 100 / self.maxAssignmentScore);
        } else {
          item.assignmentresult = 0;
        }

        if (item.progress.course_score) {
          item.courseresult = parseInt(item.progress.course_score * 100 / self.courseMax);
        } else {
          item.courseresult = 0;
        }
        //  console.log(item.scoreresult);
        //  console.log(self.maxScore);
      });
      console.log($scope.displayedItems);
    });
  }

  this.nextPage = function() {
    page++;
    getitems(page);
  };

  function getData2(page) {
    var info = {
      action: "getMyCourses",
      start: page * 6,
      limit: 6 // page size
    };
    CommonService.showLoading();
    console.log(info)
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      $scope.totalCount = result.counter;

      $scope.items = $scope.items.concat(result.items);
      self.moreData = (($scope.totalCount - $scope.items.length) > 0);

      CommonService.stopLoading();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }


  getitems(0);
  utilService.watchScroll($scope);

});