'use strict';
angular.module('bamboo.teacher').controller('teacherCourseListCtrl', function($scope, $rootScope, $translate, ApiService, CourseApi, CommonService, $stateParams, $state, $filter, $ionicPopover, utilService) {
  var self = this;

  this.coursePhotoUrl = ApiService.SHOST + '/lcourse/';
  this.subjectPicUrl = ApiService.SHOST + "/public/" + ApiService.RES;
  this.defaultpic = ApiService.SHOST + '/public/images/videos.png';

  ApiService.getSchoolInfo().then(function() {
    if (ApiService.school.coursephoto) {
      self.defaultpic = ApiService.SHOST + "/site/" + ApiService.school.coursephoto;
    }
  });

  $scope.setting = {
    page: 0,
    numProgress: 0,
    page_items: [],
    items: []
  };
  this.moreData = false;

  this.nextPage = function() {
    $scope.setting.page++;
    getMyCourses($scope.setting.page);
    console.log("--- next page --");
  };
  //"getMyCourses"
  function getMyCourses(page) {
    var info = {
      action: "getMyCourses",
      //action: "getrelaventcourses",
      // page: page,
      start: page * 6,
      limit: 6 // page size
    };
    CommonService.showLoading();
    console.log(info)
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      //$scope.setting.page_items = result.items;
      $scope.setting.totalCount = result.counter;
      // getMyProgress();

      $scope.setting.items = $scope.setting.items.concat(result.items);
      self.moreData = (($scope.setting.totalCount - $scope.setting.items.length) > 0);
      //console.log($scope.setting.totalCount, $scope.setting.items.length, _self.moreData);
      //console.log($scope.setting.page_items);
      CommonService.stopLoading();
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });
  }

  function getMyProgress() {
    var info = {
      action: "getmyprogress",
    }
    CourseApi.lcApi(info, function(result) {
      console.log(result);
      CommonService.stopLoading();
      if (result) {
        var progress = result;
        angular.forEach($scope.setting.page_items, function(course, key) {
          console.log(course);
          var id = course._id;
          if (progress[id] && course.resources) {
            course.progress = parseInt(progress[id].chapters * 100 / course.resources);
            console.log(progress[id], course);
            if (course.progress != 100) {
              //console.log(course.progress);
              $scope.setting.numProgress++;
            }
          } else {
            $scope.setting.numProgress++;
          }
        });
      } else {
        // no progress record
        $scope.setting.numProgress += $scope.setting.page_items.length;
      }
    });
  }
  getMyCourses(0);
  utilService.watchScroll($scope);

});