angular.module('bamboo.usecase').controller('UsecaseDetailCtrl', function (loginService, $scope, ApiService, $sce, CommonService, $state, $stateParams, $filter) {
    var _self = this;
    this.id = $stateParams.id;
    this.defaultUseCasePhoto = 'img/usecase.jpg';
    this.publicUrl = ApiService.SHOST + "/public/images/";
    this.attachmentsURL = ApiService.SHOST + "/public/" + ApiService.RES + "/advinfo/" + _self.id + "/";
    this.contentModelPicUrl = ApiService.SHOST + '/advinfo';
    this.videoUrl = "";
    var videopath = ApiService.SHOST + "/public/" + ApiService.RES + "/usecase/" + _self.id + "/";

    this.showNews = function () {
        ApiService.get("/usecase/" + _self.id).then(function (result) {
            console.log(_self.id)
            console.log(result)
            if (result.data.success) {
                _self.contentModel = result.data.data || {};
                console.log(_self.contentModel);
                _self.imageUrl = _self.contentModel.photo ? _self.contentModelPicUrl + '/' + _self.contentModel.photo : _self.defaultUseCasePhoto;
                if (_self.contentModel.video) {
                    _self.videoUrl = $sce.trustAsResourceUrl(videopath + _self.contentModel.video);
                }
                loginService.getMyProfile(true).then(function (_result) {
                    var favourites = _result.favourites;
                    console.log(favourites);
                    $scope.courseIndex = 0;
                    angular.forEach(favourites, function (_item) {
                        if (_item.type == "usecase" && _item.id == _self.id) {
                            _self.contentModel.favourite = true;
                            _self.contentModel.index = $scope.courseIndex;
                        }
                        $scope.courseIndex++;
                    })
                });
                console.log(_self.videoLink)
                console.log(_self.videoUrl)
            }
        });
    };

    _self.showNews();

    this.share = function () {
        var link = ApiService.HOST + '/#/usecase/' + _self._id + "?share=true";
        var imageUrl = _self.contentModel.photo ? _self.contentModelPicUrl + _self.contentModel.photo :  _self.defaultPhoto;
        //_self.imageUrl = _self.item.photo ? _self.itemPicUrl + _self.item._id + '/' + encodeURIComponent(_self.item.photo) : _self.defaultPhoto;
        console.log(link);
        console.log(imageUrl);
        console.log(_self.contentModel.name);
        CommonService.showShareDialog($scope, _self.contentModel.name, imageUrl, link, _self.contentModel.description);
    }

    this.favourite = function () {   // 收藏
        if (_self.contentModel.favourite) {
            return CommonService.showInfo("已收藏");
        }
        CommonService.showLoading();
        var object = {
            type: 'usecase',
            id: _self.id
        };
        var info = {
            action: "addfavourite",
            object: object
        };
        ApiService.post("/user", info).then(function (result) {
            if (result.data.success) {
                _self.contentModel.favourite = true;
                CommonService.showInfo("收藏成功")
                CommonService.stopLoading();
                // $scope.isCollect = true;
            } else {
                CommonService.showInfo("收藏失败，请重试！")
                CommonService.stopLoading();
                // $scope.isCollect = true;
            }
        });
    }
    this.delFavourite = function () {   // 收藏
        console.log(_self.contentModel.index);
        var info = {
            action: "delfavourite",
            index: _self.contentModel.index
        };
        ApiService.post("/user", info).then(function (result) {
            if (result.data.success) {
                _self.contentModel.favourite = false;
                CommonService.showInfo("取消收藏成功");
                CommonService.stopLoading();
            } else {
                CommonService.showInfo("取消收藏失败，请重试！")
                CommonService.stopLoading();
            }
        });
    }
    $scope.$on('$ionicView.beforeEnter', function () {
        $scope.isCollect = false;
    })
});
