angular.module('bamboo').constant('AppConfig', {
  Role:'student',// parent, teacher, admin
  LOGINERROR:'Login Failed!',
  IDLECHECKTIMER:10,// 10 second
  CHARTOPTIONS: {
    // Sets the chart to be responsive
    responsive: true,
    ///Boolean - Whether grid lines are shown across the chart
    scaleShowGridLines: true,
    //String - Colour of the grid lines
    scaleGridLineColor: "rgba(0,0,0,.05)",
    //Number - Width of the grid lines
    scaleGridLineWidth: 1,
    //Boolean - Whether the line is curved between points
    bezierCurve: false,
    //Boolean - Whether to show a dot for each point
    pointDot: true,
    //Number - Radius of each point dot in pixels
    pointDotRadius: 4,
    //Number - Pixel width of point dot stroke
    pointDotStrokeWidth: 1,
    //Number - amount extra to add to the radius to cater for hit detection outside the drawn point
    pointHitDetectionRadius: 4,
    //Boolean - Whether to show a stroke for datasets
    datasetStroke: true,
    //Number - Pixel width of dataset stroke
    datasetStrokeWidth: 2,
    //Boolean - Whether to fill the dataset with a colour
    datasetFill: false,
    // Function - on animation progress
    onAnimationProgress: function() {},
    // Function - on animation complete
    onAnimationComplete: function() {},
    //String - A legend template
    legendTemplate: '<ul class="tc-chart-js-legend"><% for (var i=0; i<datasets.length; i++){%><li><span style="background-color:<%=datasets[i].strokeColor%>"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>'
  },
  /* constant for videogular theme file */
  videogular_theme: 'assets/libs/videogular-themes-default/videogular.min.css',
  ErrorSignUp: {
    1001: {
      en: 'Info incompleted',
      cn: '信息不完整'
    },
    1002: {
      en: 'Username need 5 characters at least.',
      cn: '登录名不得少于5个字符'
    },
    1003: {
      en: 'Illegal user name',
      cn: '用户名格式不正确'
    },
    1004: {
      en: 'Invalid email address',
      cn: 'Email格式不正确'
    },
    1005: {
      en: 'Reserved User Name.',
      cn: '用户名不可使用'
    },
    1007: {
      en: 'UserName used',
      cn: '用户名已经注册'
    },
    1008: {
      en: 'Email used',
      cn: 'Email已经使用'
    },
    1009: {
      en: 'Domain used',
      cn: '域名已经使用'
    },
    1010: {
      en: 'Verification info failed',
      cn: '验证失败'
    },
    1011: {
      en: 'Password mismatch',
      cn: '密码不匹配'
    },
    1012: {
      en: 'Invalid SubDomain',
      cn: '域名不正确'
    },
    2001: {
      en: 'School not found!',
      cn: '网站不存在'
    },
    2002: {
      en: 'Exceed user limits!',
      cn: '已经超过用户数限制'
    },
  }
});