// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('bamboo', ['ionic', 'bamboo.company', 'bamboo.nodevelop', 'bamboo.formal', 'bamboo.class', 'bamboo.favourite', 'bamboo.event', 'bamboo.material', 'bamboo.discover', 'bamboo.controllers', 'ionToggleText', 'ionic.utils', 'pascalprecht.translate', 'bamboo.config', 'bamboo.common', 'bamboo.course', 'bamboo.news', 'bamboo.usecase', 'bamboo.addedvalue', 'bamboo.study', 'bamboo.exam', 'bamboo.myspace', 'bamboo.survey', 'bamboo.blog', 'bamboo.user', 'bamboo.grade', 'bamboo.history', 'bamboo.attendance', 'bamboo.sharedrive', 'ui.validate', 'ionic.native', 'tc.chartjs', 'ionic-rating-stars', 'bamboo.task', 'ionic.rating', 'bamboo.teacher', 'bamboo.job', 'bamboo.coursebundle', 'bamboo.roomsession', 'ngDraggable', 'ion-gallery', "com.2fdevs.videogular", "com.2fdevs.videogular.plugins.controls", "com.2fdevs.videogular.plugins.overlayplay", "com.2fdevs.videogular.plugins.buffering", 'pdf', "com.2fdevs.videogular.plugins.poster", 'baiduMap', "angular-bind-html-compile"]).run(function ($ionicPlatform, $ionicPopup, $ionicConfig, $rootScope, $cordovaDevice, $cordovaSplashScreen, $cordovaNetwork, $timeout, $cordovaKeyboard, $ionicHistory, $location, $state) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova) {
      console.log("--- device ready ---" + (new Date()));
      $timeout(function() {
        $cordovaSplashScreen.hide();
      }, 1000)
      $cordovaNetwork.onConnect().subscribe(function() {
        var type = $cordovaNetwork.type;
        if (type == Connection.NONE) {
          $ionicPopup.confirm({
            title: "Internet Disconnected",
            content: "The internet is disconnected on your device."
          }).then(function(result) {
            if (!result) {
              ionic.Platform.exitApp();
            }
          });
        }
      });
      var _platform = $cordovaDevice.platform;
      console.log(_platform);
      if (_platform && _platform.indexOf('iOS') > -1) {
        $rootScope.scrollstyle = {
          'height': '100vh'
        };
        if (window.StatusBar) {
          StatusBar.styleDefault();
        }
        //  cordova.plugins.iosrtc.registerGlobals();
      } else {
        if(_platform){
          console.log("android here!");
        //  StatusBar.backgroundColorByHexString("#333");
        //  StatusBar.styleLightContent();
        }


        $rootScope.scrollstyle = {};
      }
      $cordovaKeyboard.hideKeyboardAccessoryBar(true);
      $cordovaKeyboard.disableScroll(true);
    }

    $ionicConfig.views.transition('none');
  });
  $ionicPlatform.registerBackButtonAction(function (e) {
    e.preventDefault();

    if ($location.path() == "/app/home") {
      return false; // 首页了，没得退了 TODO: 确认后退出
    } else if (/^\/app\/course\/\/home\/(.*)\/chapters\/(.*)\/mp4\/(.*)/ig.test($location.path())) { // 看片时直接回课程首页
      /*var matches = /^\/app\/course\/\/home\/(.*)\/chapters\/(.*)\/mp4\/(.*)/ig.exec($location.path());
      $state.go("app.course.home", {cid: matches[1], mvid: matches[2], rid: matches[3]});*/
      $ionicHistory.goBack(-2);
      return false;
    } else if ($ionicHistory.backView()) {
      $ionicHistory.goBack();
      return false;
    }
    
    return false;
  }, 101);
}).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider.state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl as ctrl',
  }).state('app.startup', {
    url: '/startup',
    views: {
      'Content': {
        templateUrl: 'app/home/startup.html',
        controller: 'StartupCtrl as ctrl'
      }
    }
  }).state('app.more', {
    url: '/more',
    views: {
      'Content': {
        templateUrl: 'app/home/applist.html',
        controller: 'AppListCtrl as ctrl'
      }
    },
  }).state('app.search', {
    url: '/search',
    views: {
      'Content': {
        templateUrl: 'app/home/search.html',
        controller: 'SearchCtrl as ctrl'
      }
    },
  }).state('app.moreparent', {
    url: '/moreparent',
    views: {
      'Content': {
        templateUrl: 'app/home/more_parent.html',
        controller: 'AppListCtrl as ctrl'
      }
    },
  }).state('app.home', {
    url: '/home',
    views: {
      'Content': {
        templateUrl: 'app/home/home.html',
        controller: 'HomeCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.homet1', {
    url: '/homet1',
    views: {
      'Content': {
        templateUrl: 'app/home/homet1.html',
        controller: 'HomeCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.homeparent', {
    url: '/homeparent',
    views: {
      'Content': {
        templateUrl: 'app/home/home_parent.html',
        controller: 'HomeCtrl as ctrl'
      }
    },
    data_rightbutton: {
      skip: true
    }
  }).state('app.help', {
    url: '/help',
    views: {
      'Content': {
        templateUrl: 'app/home/help.html',
        //controller: 'HomeCtrl'
      }
    }
  }).state('app.videoGuide', {
    url: '/videoGuide',
    views: {
      'Content': {
        templateUrl: 'app/home/help_video.html',
        controller: "ChapterItemCtrl as ctrl"
      }
    }
  }).state('app.contactus', {
    url: '/contactus',
    views: {
      'Content': {
        templateUrl: 'app/home/contactus.html',
        //controller: 'HomeCtrl'
      }
    }
  }).state('app.index', {
    url: '/index',
    views: {
      'Content': {
        templateUrl: 'app/home/index.html',
        controller: 'MobileIndexCtrl as ctrl'
      }
    }
  }).state('app.playlists', {
    url: '/playlists',
    views: {
      'Content': {
        templateUrl: 'templates/playlists.html',
        controller: 'PlaylistsCtrl'
      }
    }
  }).state('app.single', {
    url: '/playlists/:playlistId',
    views: {
      'Content': {
        templateUrl: 'templates/playlist.html',
        controller: 'PlaylistCtrl'
      }
    }
  });
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
}).config(['$httpProvider', function($httpProvider) {
  $httpProvider.interceptors.push(['$q', '$injector',
    function($q, $injector) {
      return {
        request: function(config) {
          return config || $q.when(config);
        },
        responseError: function(response) {
          if (response.status === 403) {
            $injector.get('$state').transitionTo('app.config.login');
          }
          // console.log(response.status);
          return $q.reject(response);
        }
      };
    }
  ]);
}]).config(function($translateProvider) {
  $translateProvider.useStaticFilesLoader({
    prefix: 'i18n/', //json文件路径
    suffix: '.json'
  });
  $translateProvider.registerAvailableLanguageKeys(['en_US', 'Chinese'], {
    'en_US': 'en_US',
    'zh_CN': 'Chinese',
    'cn': 'Chinese',
    'en': 'en_US'
  }).preferredLanguage('en_US');
}).config(function(ionGalleryConfigProvider) {
  ionGalleryConfigProvider.setGalleryConfig({
    action_label: 'Close',
    template_gallery: 'templates/gallery.html',
    //template_gallery: 'gallery.html',
    template_slider: 'templates/slider.html',
    toggle: false,
    row_size: 3,
    fixed_row_size: true
  });
}).filter('millToUTCDate', function() {
  return function(input) {
    if (isNaN(input)) return input;
    var date = new Date(input);
    var _utc = new Date(date.getUTCFullYear(), date.getUTCMonth(), date.getUTCDate(), date.getUTCHours(), date.getUTCMinutes(), date.getUTCSeconds());
    return _utc;
  };
}).config(function($compileProvider) {
  $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|ftp|mailto|http|googlechrome):/);
  // whitelists non-http: protocols. specifically we need coui for coherent.
});;
angular.module('ionic.utils', []).factory('$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    removeItem: function(key) {
      $window.localStorage.removeItem(key);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    },
    setResource: function(key, value) {
      if (!$window.localStorage.resource) {
        $window.localStorage.resource = "{}";
      }
      var resource = JSON.parse($window.localStorage.resource);
      resource[key] = value;
      $window.localStorage.resource = JSON.stringify(resource);
    },
    getResource: function(key) {
      if (!$window.localStorage.resource) {
        $window.localStorage.resource = "{}";
      }
      var _resourse = JSON.parse($window.localStorage.resource);
      return _resourse[key];
    },
    setSelectQuestionResult: function(cid, eid, indx, qid, flage) { // 练习
      //cid 课程id  eid：考试id  indx 索引  qid 问题id  flage 这道题是否答错
      if (!$window.localStorage.questionResult) {
        $window.localStorage.questionResult = "{}";
      }
      var resource = JSON.parse($window.localStorage.questionResult);
      if (!resource[cid]) {
        resource[cid] = {};
      }
      if (!resource[cid]['practise']) {
        resource[cid]['practise'] = {};
      }
      if (!resource[cid]['practise'][eid]) {
        resource[cid]['practise'][eid] = {};
      }
      if (!resource[cid]['practise'][eid][indx]) {
        resource[cid]['practise'][eid][indx] = true;
      }
      if (!resource['question']) {
        resource['question'] = {};
      }
      if (!resource['question'][qid]) {
        resource['question'][qid] = flage;
      }
      console.log(resource);
      $window.localStorage.questionResult = JSON.stringify(resource);
    },
    getSelectQuestionResult: function(cid, eid) {
      if (!$window.localStorage.questionResult) {
        $window.localStorage.questionResult = "{}";
      }
      var resource = JSON.parse($window.localStorage.questionResult);
      if (resource[cid]) {
        if (resource[cid].practise) {
          if (resource[cid].practise[eid]) {
            console.log(resource[cid].practise[eid]);
            return resource[cid].practise[eid];
          }
        }
      }
    },
    addCurrentDayExamCounter:function(eid){
      var currentDay=(new Date()).toISOString().substring(0,10);
      var dayExamCounter={};
      if($window.localStorage.dayExamCounter){
        dayExamCounter=JSON.parse($window.localStorage.dayExamCounter);
      }
      if(dayExamCounter.day==currentDay){
        if(!dayExamCounter[eid]){
          dayExamCounter[eid]=1;
        }else{
          dayExamCounter[eid]++;
        }
      }else{
        dayExamCounter={
          day:currentDay,
        }
        dayExamCounter[eid]=1;
      }
      $window.localStorage.dayExamCounter = JSON.stringify(dayExamCounter);
    },
    getCurrentDayExamCounters:function(){
      var currentDay=(new Date()).toISOString().substring(0,10);
      var result={};
      if($window.localStorage.dayExamCounter){
        result=JSON.parse($window.localStorage.dayExamCounter);
      }
      if(currentDay==result.day){
        return result;
      }else {
        return {};
      }
    },
    setSelectQuestionResultLib: function(cid, eid, indx, qid, flage) { // 题库
      //cid 课程id  eid：考试id  indx 索引  qid 问题id  flage 这道题是否答错
      if (!$window.localStorage.questionResultLib) {
        $window.localStorage.questionResultLib = "{}";
      }
      var flagIndex = 0;
      var resource = JSON.parse($window.localStorage.questionResultLib);
      if (!resource[cid]) {
        resource[cid] = {};
      }
      if (!resource[cid]['lib']) {
        resource[cid]['lib'] = {};
      }
      if (!resource[cid]['lib'][eid]) {
        resource[cid]['lib'][indx] = true;
      }
      if (!resource['question']) {
        resource['question'] = {};
      }
      if (!resource['question'][qid]) {
        var info = {};
        flagIndex++;
        info['qide'] = qid;
        info[indx] = flage;
        resource['question'][indx]=info;
      }
      console.log(resource);
      $window.localStorage.questionResultLib = JSON.stringify(resource);
    },
    getSelectQuestionResultLib: function(cid) {
      if (!$window.localStorage.questionResultLib) {
        $window.localStorage.questionResultLib = "{}";
      }
      var resource = JSON.parse($window.localStorage.questionResultLib);
      if (resource[cid]) {
        if (resource[cid].lib) {
          console.log(resource[cid].lib);
          return resource[cid].lib;
        }
      }
    },
    getSelectQuestionResultQib: function(cid) {
      if (!$window.localStorage.questionResultLib) {
        $window.localStorage.questionResultLib = "{}";
      }
      var resource = JSON.parse($window.localStorage.questionResultLib);
      if (resource['question']) {
        console.log(resource[cid].lib);
        return resource['question'];
      }
    },
    setSelectQuestionResultTagging: function(cid, eid, indx, qid, flage) { // 标注
      //cid 课程id  eid：考试id  indx 索引  qid 问题id  flage 这道题是否答错
      if (!$window.localStorage.questionResultTagging) {
        $window.localStorage.questionResultTagging = "{}";
      }
      var resource = JSON.parse($window.localStorage.questionResultTagging);
      if (!resource[cid]) {
        resource[cid] = {};
      }
      if (!resource[cid]['Tagging']) {
        resource[cid]['Tagging'] = {};
      }
      if (!resource[cid]['Tagging'][eid]) {
        resource[cid]['Tagging'][indx] = true;
      }
      if (!resource['question']) {
        resource['question'] = {};
      }
      if (!resource['question'][qid]) {
        resource['question'][qid] = flage;
      }
      console.log(resource);
      $window.localStorage.questionResultTagging = JSON.stringify(resource);
    },
    getSelectQuestionResultTagging: function(cid) {
      if (!$window.localStorage.questionResultTagging) {
        $window.localStorage.questionResultTagging = "{}";
      }
      var resource = JSON.parse($window.localStorage.questionResultTagging);
      if (resource[cid]) {
        if (resource[cid].Tagging) {
          console.log(resource[cid].Tagging);
          return resource[cid].Tagging;
        }
      }
    },
  }
}]);
