angular.module('bamboo.common').service('CommonService', function($ionicPopup, $ionicGesture, $rootScope, $cordovaDevice, $ionicModal, $cordovaCamera, $cordovaMediaCapture, $cordovaNetwork, $cordovaImagePicker, $cordovaSocialSharing, $timeout, $cordovaFileTransfer, $filter, $ionicLoading, $cordovaMedia, ApiService, $ionicPlatform, $cordovaGeolocation, $interval, $sce, $translate,  $q, $http) {
  'use strict';
  console.log("--- common service ---");
  var self = this;
  var timer_loading;
  var modalOpen;
  $rootScope.scrollstyle = {
    'height': '95vh'
  };
  $ionicGesture.on('touch', function() {
    // console.log("点我爪子", idleCounter);
    idleCounter = 0;
  }, angular.element(document));
  var idleInterval;
  var idleCallback;
  var idleCounter = 0;
  var timeLimits = 180; // 180 seconds
  var pauseTime;
  var systemSleepLen=0;
  this.startListen = function(_idleCallback, _timeLimits) {
    console.log("start listen 111");
    idleCounter = 0;
    systemSleepLen=0;
    idleCallback = _idleCallback;
    if (idleInterval) {
      $interval.cancel(idleInterval);
    }
    pauseTime = 0;
    idleInterval = $interval(idleTimeHandler, 1000)
    timeLimits = (ApiService.school.videoCheckTimer || 3) * 60;
  }
  this.stopListen = function() {
    if (idleInterval) {
      $interval.cancel(idleInterval);
    }
    idleInterval = null;
    idleCounter = 0;
  }
  this.getSysSleepLen=function(){
    return systemSleepLen;
  }
  $ionicPlatform.ready(function() {
    $ionicPlatform.on("resume", function(event) {
      if (pauseTime && idleInterval) {

        var timeLen = ((new Date()) - pauseTime)/1000;
        console.log('resume', timeLen);
        idleCounter += timeLen;
        if (idleCounter > timeLimits) {
          console.log('time out exit')
          $interval.cancel(idleInterval);
          idleInterval = null;
          if (idleCallback) {
            $timeout(function() {
              idleCallback();
            }, 1000);
          }
          if (myPopup) {
            myPopup.close();
            myPopup = null;
          }
        }else{
          console.log('need to reduce len',timeLen);
          systemSleepLen=timeLen;
        }
      }
      pauseTime = 0;
      // console.log('pause',pauseTime);
    });
    $ionicPlatform.on("pause", function(event) {
      pauseTime = new Date();
      console.log('pause', pauseTime,timeLimits,idleCounter);
    });
  });
  var myPopup;

  function idleTimeHandler() {
    idleCounter++;
    // console.log("time handler", idleCounter);
    if (idleCounter > timeLimits) {
      var alreadyClosed;
      console.log("-- time out ---");
      myPopup = $ionicPopup.show({
        title: '用户互动监测',
        subTitle: '请在规定时间内点击确认键，才能继续学习！',
        buttons: [{
          text: '<b>确认</b>',
          type: 'button-positive',
          onTap: function(e) {
            console.log("...confirm");
            idleCounter = 0;
            alreadyClosed = true;
            idleInterval = $interval(idleTimeHandler, 1000)
          }
        }]
      });
      $interval.cancel(idleInterval);
      idleInterval = null;
      // if(idleCallback){
      //   idleCallback();
      // }
      idleCounter = 0;
     // idleCallback = null;
      $timeout(function() {
        if (alreadyClosed) {
          console.log("already closed!");
          return;
        }
        myPopup.close();
        myPopup = null;
        if (idleCallback) {
          idleCallback();
        }
      }, 30 * 1000);
    }
  }
  this.replaceImgLink = function(content) {
    var _content;
    // if (content.indexOf(' src="//file.course.jingye.com.sg') > -1) {
    //   _content = content.split(' src="//file.course.jingye.com.sg').join(' src="https://file.course.jingye.com.sg');
    // } else if (content.indexOf(' src="//course.xijing.edu.cn:3500') > -1) {
    //   _content = content.split(' src="//course.xijing.edu.cn:3500').join(' src="https://media.xijing.edu.cn');
    // } else
    if (content.indexOf(' src="//') > -1) {
      _content = content.split(' src="//').join(' src="http://');
    } else {
      _content = content;
    }
    return _content;
  }
  this.showInfo = function(info, callback) {
    var confirmPopup = $ionicPopup.alert({
      title: $filter('translate')('信息'),
      template: $filter('translate')(info),
      okText: $filter('translate')('确定')
    });
    confirmPopup.then(callback);
  };
  this.showConfirm = function(info, callback) {
    var confirmPopup = $ionicPopup.confirm({
      title: $filter('translate')('信息'),
      template: $filter('translate')(info),
      okText: $filter('translate')('确定'),
      cancelText: $filter('translate')('取消')
    });
    confirmPopup.then(function(res) {
      if (res) {
        callback(res);
      }
    });

    return confirmPopup;
  };
  this.showInfoWithTitle = function(title, info, callback) {
    var confirmPopup = $ionicPopup.alert({
      title: $filter('translate')(title),
      template: $filter('translate')(info),
      okText: $filter('translate')('确认'),
    });
    confirmPopup.then(callback);
  };
  this.showError = function(info, callback) {
    var confirmPopup = $ionicPopup.alert({
      title: $filter('translate')('错误'),
      okText: $filter('translate')('确认'),
      template: info
    });
    confirmPopup.then(callback);
  };
  this.showErrorWithTitle = function(title, info, callback) {
    var confirmPopup = $ionicPopup.alert({
      title: $filter('translate')(title),
      template: $filter('translate')(info),
      okText: $filter('translate')('确认')
    });
    confirmPopup.then(callback);
  };
  this.getAvatarSrc = function(user) {
    var userId = user._id || user.id;
    //console.log('userId' + userId)
    if (!user.avatar || user.avatar.indexOf("http://www.gravatar.com") > -1) {
      return "img/default-person-icon.png";
    } else {
      return ApiService.SHOST + "/public/" + ApiService.RES + '/avatar/' + userId + '/' + user.avatar;
    }
  };

  function deg2rad(deg) {
    return deg * (Math.PI / 180)
  }
  this.getDistance = function(lat1, lon1, lat2, lon2) {
    var R = 6371; // Radius of the earth in km
    var dLat = deg2rad(lat2 - lat1); // deg2rad below
    // console.log(dLat);
    var dLon = deg2rad(lon2 - lon1);
    // console.log(dLon);
    var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) + Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) * Math.sin(dLon / 2) * Math.sin(dLon / 2);
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
    var d = R * c; // Distance in km
    return d;
  }
  this.showHTMLDialog = function(_scope, content) {
    var _modal;
    _scope.htmlconent = content;
    _scope.close = function() {
      _modal.hide();
    };
    $ionicModal.fromTemplateUrl('templates/htmldialog.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      /* modal.close=function{
       console.log("-- close --");
       }*/
      modal.show();
    });
  };
  this.showShareDialog = function(_scope, _title, _img, _link, _des) {
    var _modal;
    var img_src = _img || null;
    var title = _title || null;
    var link = _link || null;
    if (link) {
      link = link + '?embeded=true';
    }
    var des = _des || title;

    function hideModel() {
      _modal.hide();
    }
    _scope.close = function() {
      hideModel();
    };
    _scope.facebooksharing = function() {
      console.log("-- face book sharing ---");
      $cordovaSocialSharing.shareViaFacebookWithPasteMessageHint(title, img_src, link, title).then(function(result) {
        console.log(result);
        hideModel();
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        console.log("error in sharing ---");
        console.log(err);
        hideModel();
        self.showError("Please check if you have Facebook Installed");
        // An error occurred. Show a message to the user
      });
    };
    _scope.twittersharing = function() {
      console.log("--  what up sharing ---");
      $cordovaSocialSharing.shareViaTwitter(title, img_src, link
        /*, image, link*/
      ).then(function(result) {
        console.log(result);
        hideModel();
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        console.log("error in sharing ---", err);
        hideModel();
        self.showError("Please check if you have Twitter Installed");
        // An error occurred. Show a message to the user
      });
    };

    function wechatshare(scene, title, img_src, link, des, callback) {
      // if (typeof Wechat === "undefined") {
      //   callback("Wechat plugin is not installed.");
      //   return false;
      // }
      // console.dir(Wechat.Type);
      Wechat.isInstalled(function(installed) {
        var params = {
          scene: scene,
          message: {
            messageAction: "<action>dotalist</action>",
            title: title,
            description: des,
            //mediaTagName: "TEST-TAG-001",
            messageExt: des,
            //thumb: img_src,
            media: {
              type: Wechat.Type.LINK,
              webpageUrl: link,
            }
          }
        }
        if (img_src) {
          params.message.thumb = img_src;
        }
        console.dir(params);
        Wechat.share(params, function() {
          console.log("--- send success ---");
          callback();
        }, function(reason) {
          callback(reason);
        });
        return true;
      }, function(reason) {
        callback("Wechat plugin is not installed.");
        return false;
      });
    }
    _scope.sharewechat = function() {
      hideModel();
      setTimeout(function() {
        wechatshare(0, title, img_src, link, des, function(err) {
          console.log(err);
          if (err) {
            self.showError("Please check if you have Wechat Installed " + err);
          }
        });
      }, 10);
    };
    _scope.sharewechattime = function() {
      wechatshare(1, title, img_src, link, des, function(err) {
        hideModel();
        console.log(err);
        if (err) {
          self.showError("Please check if you have Wechat Installed " + err);
        }
      });
    };
    _scope.sharewechatfavorite = function() {
      wechatshare(2, title, img_src, link, des, function(err) {
        hideModel();
        console.log(err);
        if (err) {
          self.showError("Please check if you have Wechat Installed " + err);
        }
      });
    };
    _scope.shareWeibo = function() {
      hideModel();
      $cordovaSocialSharing.shareVia('com.sina.weibo', "Message by Weibo", title, null, img_src, link
        /*, image, link*/
      ).then(function(result) {
        console.log(result);
        // hideModel();
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        console.log("error in sharing ---", err);
        //hideModel();
        //  self.showError("请检查你的微博是否安装！");
        console.log('请检查你的微博是否安装！');
        $timeout(function() {
          self.showError("请检查你的微博是否安装！");
        }, 500)
        // An error occurred. Show a message to the user
      });
    }
    _scope.whatupsharing = function() {
      console.log("--  what up sharing ---", title + " " + img_src + " " + link);
      var _title;
      var os = $cordovaDevice.platform;
      if (os == 'iOS') {
        _title = null;
      } else {
        _title = title;
      }
      $cordovaSocialSharing.shareViaWhatsApp(title, img_src, link
        /*, image, link*/
      ).then(function(result) {
        hideModel();
        console.log(result);
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        hideModel();
        self.showError("Please check if you have What's UP Installed");
        console.log("error in sharing ---", err);
        // An error occurred. Show a message to the user
      });
    };
    /* _scope.pickImage = function() {
     var options = {
     quality: 40,
     destinationType: Camera.DestinationType.DATA_URL,
     sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
     // sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
     encodingType: Camera.EncodingType.JPEG,
     mediaType: Camera.MediaType.PICTURE,
     popoverOptions: CameraPopoverOptions,
     saveToPhotoAlbum: false,
     targetWidth: 768,
     targetHeight: 1024,
     correctOrientation: true
     };
     $cordovaCamera.getPicture(options).then(function(imageData) {
     _scope.img_src = "data:image/jpeg;base64," + imageData;
     }, function(err) {
     self.showError(err);
     console.log("-- shooted error ---");
     console.log(err);
     });
     }*/
    _scope.sharing = function() {
      console.log("-- direct sharing ---");
      $cordovaSocialSharing.share(title, title, img_src, link
        /*, image, link*/
      ).then(function(result) {
        console.log(result);
        hideModel();
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        hideModel();
        self.showError(err);
        console.log("error in sharing ---", err);
        // An error occurred. Show a message to the user
      });
    };
    _scope.smssharing = function() {
      console.log("-- sms sharing ---");
      $cordovaSocialSharing.shareViaSMS(title + " " + link
        /*, image, link*/
      ).then(function(result) {
        console.log(result);
        hideModel();
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        hideModel();
        self.showError(err);
        console.log("error in sharing ---", err);
        // An error occurred. Show a message to the user
      });
    };
    $ionicModal.fromTemplateUrl('templates/sharedialog.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      /* modal.close=function{
       console.log("-- close --");
       }*/
      modal.show();
    });
  };
  this.showmessagefromservice = function(_scope, msgdetail) {
    _scope.sendTo = msgdetail.fullname;
    _scope.user = msgdetail.sender_id;
    var _modal;
    $ionicModal.fromTemplateUrl('templates/sendmessage.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      modal.show();
    });

    function hideModel() {
      _modal.hide();
    }
    _scope.closemessagefromservice = function() {
      hideModel();
    };
    _scope.sendmessagefromservice = function(newmessage) {
      var info = {
        action: "sendp2p",
        target: _scope.user,
        message: newmessage
      };
      ApiService.post('/messages', info).then(function(result) {
        console.log(result);
        if (result.data.success) {
          self.showInfoWithTitle('Message', 'Message Successfully Sent');
          self.newmessage = newmessage;
          $timeout(function() {
            _scope.closemessagefromservice();
          }, 1000);
        } else {
          alert(result.data.error)
        }
      });
    };
  };
  /*
   this.shownewsdetail = function(_scope) {
   var _modal;
   $ionicModal.fromTemplateUrl('templates/newsdetail.html', {
   scope: _scope
   }).then(function(modal) {
   _modal = modal;
   modal.show();
   });

   function hideModel() {
   _modal.hide();
   }
   _scope.closenewsdetailfromservice = function() {
   removeModal();
   hideModel();
   };

   _scope.removemodalcontent = function() {
   removeModal();
   };

   function removeModal(){
   _scope.$on('$destroy', function() {
   _modal.remove();
   });
   }
   };
   */
  this.showdetail = function(_scope, template) {
    var _modal;
    $ionicModal.fromTemplateUrl(template, {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      modal.show();
    });

    function hideModel() {
      _modal.hide();
    }
    _scope.closedetailfromservice = function() {
      console.log("----closedetailfromservice------");
      removeModal();
      hideModel();
    };
    _scope.removemodalcontent = function() {
      removeModal();
    };

    function removeModal() {
      _scope.$on('$destroy', function() {
        _modal.remove();
      });
    }
  };
  this.showDetailDlg = function(_scope, template, callback) {
    var _modal;
    $ionicModal.fromTemplateUrl(template, {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      modal.show();
    });

    function hideModel() {
      _modal.hide();
    }
    _scope.closedetailfromservice = function() {
      removeModal();
      hideModel();
      callback();
    };
    _scope.removemodalcontent = function() {
      removeModal();
    };

    function removeModal() {
      _scope.$on('$destroy', function() {
        _modal.remove();
      });
    }
  };
  this.showpopupmessagefromservice = function(_scope, msgdetail) {
    _scope.msgdetail = msgdetail;
    _scope.formatTime = Date.parse(msgdetail.time);
    _scope.user = msgdetail.sender_id;
    var _modal;
    $ionicModal.fromTemplateUrl('templates/messagedetail.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      modal.show();
    });

    function hideMsgModal() {
      _modal.hide();
    }
    _scope.closemsgdetailmodal = function() {
      hideMsgModal();
    };
    _scope.sendmessagefromservice = function(newmessage) {
      var info = {
        action: "sendp2p",
        target: _scope.user,
        message: newmessage
      };
      ApiService.post('/messages', info).then(function(result) {
        console.log(result);
        if (result.data.success) {
          self.showInfoWithTitle('Message', 'Message Successfully Sent');
          self.newmessage = newmessage;
          $timeout(function() {
            _scope.closemsgdetailmodal();
          }, 1000);
        } else {
          alert(result.data.error)
        }
      });
    }
  };
  this.showLoading = function(param) {
    if (!param) {
      param = 1;
    }
    if (window.cordova) {
      // console.log($cordovaNetwork.getNetwork);
      $cordovaNetwork.onConnect().subscribe(function() {
        var type = $cordovaNetwork.type;
        if (type == Connection.NONE) {
          $ionicPopup.confirm({
            title: "Internet Disconnected",
            content: "The internet is disconnected on your device."
          }).then(function(result) {
            if (!result) {
              ionic.Platform.exitApp();
            }
          });
        }
      });
    }
    $ionicLoading.show({
      // template: '<ion-spinner icon="lines" class="spinner-calm"></ion-spinner>'
      template: '<div>加载中...</div>'
    });
    if (timer_loading) {
      $timeout.cancel(timer_loading);
      timer_loading = null;
    }
    timer_loading = $timeout(function() {
      $ionicLoading.hide();
      console.log("--- loading timer time out ----");
      if (window.cordova) {
        var type = $cordovaNetwork.type;
        if (type == Connection.NONE) {
          $ionicPopup.confirm({
            title: "Internet Disconnected",
            content: "The internet is disconnected on your device."
          }).then(function(result) {
            if (!result) {
              ionic.Platform.exitApp();
            }
          });
        } else {
          //self.showError("Loading take too long, please check your internet connection!");
          self.showError("等待反应时间过长，请检查网络!");
        }
        /*var type = $cordovaNetwork.getNetwork();
         if (type == Connection.NONE) {
         $ionicPopup.confirm({
         title: "Internet Disconnected",
         content: "The internet is disconnected on your device."
         }).then(function(result) {
         if (!result) {
         ionic.Platform.exitApp();
         }
         });
         } else {
         self.showError("Loading take too long, please check your internet connection!");
         }*/
      }
    }, 20000 * param);
  };
  this.showLoadingWithSpinner = function(text, timeout) {
    text = text || 'Loading...';
    $ionicLoading.show({
      template: '<ion-spinner class="spinner-energized" icon="lines"/>'
    });
    $timeout(function() {
      $ionicLoading.hide();
    }, timeout || 3000);
  };
  this.stopLoading = function() {
    $ionicLoading.hide();
    if (timer_loading) {
      $timeout.cancel(timer_loading);
      timer_loading = null;
    }
  };

  function upload(source, target, options, success, fail, progress) {
    var fileTransfer = new FileTransfer();
    fileTransfer.upload(source, target, success, fail, options);
    if (progress) {
      fileTransfer.onprogress = progress;
    }
  }
  this.Unzip = function(targetPath, url, callback, progress) {
    var permissions = cordova.plugins.permissions;
    permissions.checkPermission(permissions.WRITE_EXTERNAL_STORAGE, function(status) {
      if (status.hasPermission) {
        zip.unzip(targetPath, url, callback, progress);
      } else {
        var list = [permissions.WRITE_EXTERNAL_STORAGE, permissions.READ_EXTERNAL_STORAGE];
        permissions.requestPermissions(list, function(status) {
          if (status) {
            zip.unzip(targetPath, url, callback, progress);
          } else {
            self.showError("Storage Access Permission is not turned on");
          }
        }, function(error) {
          self.showError("Storage Access Permission is not turned on");
          console.log("-- Storage Error ---");
        });
      }
    });
  }
  this.download = function(source, target, options, success, fail, progress) {
    // self.fileDownload(source,target,options,success,fail,progress);
    var permissions = cordova.plugins.permissions;
    permissions.checkPermission(permissions.WRITE_EXTERNAL_STORAGE, function(status) {
      if (status.hasPermission) {
        self.fileDownload(source, target, options, success, fail, progress);
      } else {
        var list = [permissions.WRITE_EXTERNAL_STORAGE, permissions.READ_EXTERNAL_STORAGE];
        permissions.requestPermissions(list, function(status) {
          if (status) {
            self.fileDownload(source, target, options, success, fail, progress);
          } else {
            self.showError("Storage Access Permission is not turned on");
          }
        }, function(error) {
          self.showError("Storage Access Permission is not turned on");
          console.log("-- Storage Error ---");
        });
      }
    });
  }
  this.fileDownload = function(source, target, options, success, fail, progress) {
    var fileTransfer = new FileTransfer();
    var opStr = "";
    angular.forEach(options, function(val, key) {
      if (opStr.length) {
        opStr += '&';
      }
      opStr += key + "=" + val;
    })
    fileTransfer.download(source, target, success, fail, opStr);
    if (progress) {
      fileTransfer.onprogress = progress;
    }
  }
  this.shotandUpload = function(refurl, fileflag, callback, addressflag, allowEdit) {
    var PictureUrl = "public/" + ApiService.RES + refurl;
    var forumurl = ApiService.PSURL + refurl;
    if (addressflag) {
      PictureUrl = refurl;
      forumurl = ApiService.SHOST + refurl;
    }
    console.log("-- access camera here");
    var options = {
      quality: 40,
      destinationType: Camera.DestinationType.DATA_URL,
      sourceType: Camera.PictureSourceType.CAMERA,
      // sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      encodingType: Camera.EncodingType.JPEG,
      mediaType: Camera.MediaType.PICTURE,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false,
      targetWidth: 400,
      targetHeight: 400,
      correctOrientation: true,
      cameraDirection: 1,
      allowEdit: allowEdit
    };
    if (fileflag) {
      options.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
    }
    $cordovaCamera.getPicture(options).then(function(imageData) {
      var random = parseInt(Math.random() * 10000);
      var url = PictureUrl + random;
      var options = {
        params: {
          path: url,
          action: "uploadResOnly"
        }
      };
      console.log("-- shooted picture ---");
      console.log(options);
      var server = ApiService.getUpLoadUrl('/resupload');
      self.showLoading();
      upload("data:image/jpeg;base64," + imageData, server, options, function(result) {
        console.log("upload success");
        var _result = JSON.parse(result.response);
        console.dir(_result);
        var filename = _result.filename || _result.fileName;
        self.stopLoading(filename);
        if (_result.success && callback) {
          return callback(forumurl + random + filename, random + filename);
        }
      }, function(err) {
        self.stopLoading();
        self.showError(err);
        console.log(err);
      });
    }, function(err) {
      self.showError("拍照未完成");
      console.log("-- shooted error ---");
      console.log(err);
    });
  };
  this.uploadSpeachEq = function(text, lang, url, callback) {
    var options = {
      params: {
        text: text,
        lang: lang,
      }
    };
    console.log("-- uploadSpeachEq ---");
    console.log(options);
    var server = ApiService.getUpLoadUrl('/speecheq');
    self.showLoading();
    console.log(server);
    console.log(url);
    upload(url, server, options, function(result) {
      console.log("upload success");
      var _result = JSON.parse(result.response);
      console.dir(_result);
      self.stopLoading();
      if (_result.success && callback) {
        return callback(_result.value);
      }
    }, function(err) {
      self.stopLoading();
      self.showError(err);
      console.log(err);
    });
  };
  this.voiceToText = function(url, lang, callback) {
    // console.log(url);
    var server = ApiService.getUpLoadUrl('/voicetotxt');
    var options = {
      params: {
        lang: lang,
      }
    }
    self.showLoading();
    upload(url, server, options, function(result) {
      console.log("upload success");
      var _result = JSON.parse(result.response);
      console.dir(_result);
      self.stopLoading();
      if (_result.success && callback) {
        return callback(null, _result.result);
      } else {
        return callback(_result, []);
      }
    }, function(err) {
      self.stopLoading();
      self.showError(err);
      console.log(err);
    });
  };
  this.playAudio = function(src, callback) {
    var media = $cordovaMedia.newMedia(src);
    media.play();
    return callback(media);
  }
  this.recordAudio = function(callback) {
    var options = {
      limit: 1,
      duration: 20
    };
    $cordovaMediaCapture.captureAudio(options).then(function(audioData) {
      // Success! Audio data is here
      return callback(audioData);
      // console.log(audioData);
    }, function(err) {
      console.log(err);
      // An error occurred. Show a message to the user
    });
  };
  this.recordandUpload = function(refurl, callback) {
    console.log(refurl);
    // var forumurl = ApiService.SHOST + refurl;
    //console.log(forumurl);
    var options = {
      limit: 1,
      duration: 20
    };
    $cordovaMediaCapture.captureAudio(options).then(function(audioData) {
      // Success! Audio data is here
      //return callback(audioData);
      if (!audioData || audioData.length < 1) {
        return callback('Record not found');
      }
      console.log(audioData[0]);
      // var options = {
      //   params: {
      //     path: refurl,
      //     random:true,
      //     filename:'audio.mp3',
      //     action: "uploadResOnly"
      //   }
      // };
      var options = {
        params: {
          path: refurl,
          directUpload: true,
          random: true,
          filename: 'audio.mp3'
        }
      };
      self.showLoading();
      //var server = ApiService.getUpLoadUrl('/resupload');
      var server = ApiService.getUpLoadUrl('/mp3convert');
      console.log(server);
      upload(audioData[0].fullPath, server, options, function(result) {
        console.log("upload success");
        var _result = JSON.parse(result.response);
        console.dir(_result);
        var filename = _result.filename || _result.fileName;
        self.stopLoading(filename);
        if (_result.success && callback) {
          return callback(null, filename);
        } else {
          return callback(_result.error);
        }
      }, function(err) {
        self.stopLoading();
        self.showError(err);
        console.log(err);
      });
      // console.log(audioData);
    }, function(err) {
      console.log(err);
      // An error occurred. Show a message to the user
    });
  };
  this.downloadFileByUrl = function(url, filename, callback) {
    var targetPath = cordova.file.documentsDirectory + filename;
    var _platform = $cordovaDevice.platform;
    if (_platform && _platform.indexOf('Android') > -1) {
      // isAndroid = true;
      targetPath = cordova.file.externalRootDirectory + 'Download/' + filename;
      var trustHosts = true;
      var options = {};
      console.log("--download--");
      console.log(targetPath);
      // self.showLoading();
      // cordova.plugins.DownloadManager.download(url,function(success){
      //     console.log(success);
      //     cordova.plugins.MediaScannerPlugin.scanFile(targetPath, function(succ){
      //       console.log(succ);
      //     }, function(err) {
      //       console.log(err);
      //     });
      //     self.stopLoading();
      //     return callback();
      // }, function(error) {
      //   console.log(error);
      //   self.stopLoading();
      //   self.showError(error);
      //   return callback();
      // });
      self.showLoading(10);
      //$cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function(result) {
      self.download(url, targetPath, options, function(result) {
        // Success!
        console.log("success!");
        // cordova.plugins.MediaScannerPlugin.scanFile(targetPath, function(success){
        //   console.log(success);
        // }, function(error) {
        //   console.log(error);
        // });
        self.stopLoading();
        return callback();
      }, function(err) {
        // Error
        self.stopLoading();
        self.showError(err);
        console.log("error!");
      }, function(progress) {
        console.log(progress);
      });
    } else {
      console.log('iOS');
      $cordovaSocialSharing.share(filename, filename, encodeURI(url), null
        /*, image, link*/
      ).then(function(result) {
        return callback();
        console.log("--- send success ---");
        // Success!
      }, function(err) {
        self.showError(err);
        console.log("error in sharing ---", err);
        // An error occurred. Show a message to the user
      });
    }
    /* var os = $cordovaDevice.platform;
     if (os == 'iOS') {
     // _title = null;
     } else {
     targetPath = cordova.file.externalRootDirectory + 'Download/'+ filename;
     // _title = title;
     } */
    // var url = "http://cdn.wall-pix.net/albums/art-space/00030109.jpg";
  }
  this.showVideo = function(_scope, video) {
    var _modal;
    _scope.video = video[0];
    _scope.close = function() {
      _modal.hide();
    };
    $ionicModal.fromTemplateUrl('templates/videodialog.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      /* modal.close=function{
       console.log("-- close --");
       }*/
      modal.show();
    });
  };
  this.getYoutubeLinkfromUrl = function(content) {
    var id = '';
    var url = content.replace(/(>|<)/gi, '').split(/(vi\/|v=|\/v\/|youtu.be\/|\/embed\/)/);
    if (url[2] !== undefined) {
      id = url[2].split(/[^0-9a-z-_]/i);
      id = id[0];
    } else {
      id = url;
    }
    return $sce.trustAsResourceUrl('//www.youtube.com/embed/' + id + '?&controls=1&showinfo=0&autoplay=1');
    //return id;
  }
  this.showWiki = function(_scope) {
    console.log(_scope.wiki);
    var _modal;
    if (modalOpen) {
      modalOpen.hide();
    }
    _scope.close = function() {
      _modal.hide();
    };
    $ionicModal.fromTemplateUrl('templates/wiki.dlg.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      modalOpen = _modal;
      /* modal.close=function{
       console.log("-- close --");
       }*/
      modal.show();
    });
  };
  this.recordVideoAndUpload = function(refurl, callback) {
    console.log(refurl);
    var options = {
      limit: 1,
      duration: 20
    };
    $cordovaMediaCapture.captureVideo(options).then(function(videoData) {
      console.log(videoData);
      if (!videoData || videoData.length < 1) {
        return callback('Record not found');
      }
      var options = {
        params: {
          path: refurl,
          directUpload: true,
          random: true
        }
      };
      var size = videoData[0].size || 0;
      self.showLoading();
      var server = ApiService.getUpLoadUrl('/mp4convert');
      console.log(server);
      upload(videoData[0].fullPath, server, options, function(result) {
        console.log("upload success");
        var _result = JSON.parse(result.response);
        console.dir(_result);
        var filename = _result.filename || _result.fileName;
        self.stopLoading(filename);
        if (_result.success && callback) {
          return callback({
            result: filename,
            filesize: size
          });
        } else {
          return callback(_result.error);
        }
      }, function(err) {
        self.stopLoading();
        self.showError(err);
        console.log(err);
      });
    }, function(err) {
      console.log(err);
      // An error occurred. Show a message to the user
    });
  };
  this.attachmentUpload = function(refurl, fileflag, callback, allowEdit) {
    var options = {
      quality: 40,
      destinationType: Camera.DestinationType.DATA_URL,
      sourceType: Camera.PictureSourceType.CAMERA,
      // sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      encodingType: Camera.EncodingType.JPEG,
      mediaType: Camera.MediaType.PICTURE,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false,
      targetWidth: 640,
      targetHeight: 640,
      correctOrientation: true,
      cameraDirection: 1,
      allowEdit: allowEdit
    };
    if (fileflag) {
      options.sourceType = Camera.PictureSourceType.PHOTOLIBRARY;
    }
    $cordovaCamera.getPicture(options).then(function(imageData) {
      var options = {
        params: {
          path: refurl,
          action: "uploadResOnly",
          random: true
        }
      };
      console.log("-- shooted picture ---");
      console.log(options);
      var server = ApiService.getUpLoadUrl('/resupload');
      self.showLoading();
      var blob = new Blob([imageData]);
      var size = blob.size || 0;
      upload("data:image/jpeg;base64," + imageData, server, options, function(result) {
        console.log("upload success");
        var _result = JSON.parse(result.response);
        console.dir(_result);
        var filename = _result.filename || _result.fileName;
        self.stopLoading(filename);
        if (_result.success && callback) {
          return callback({
            result: filename,
            filesize: size
          });
        }
      }, function(err) {
        self.stopLoading();
        self.showError(err);
        console.log(err);
      });
    }, function(err) {
      self.showError("获取照相图片失败，请再试一次!");
      console.log("-- shooted error ---");
      console.log(err);
    });
  };
  this.youtube_id_from_url = function(url) {
    var id = '';
    //  console.log(url);
    url = url.replace(/(>|<)/gi, '').split(/(vi\/|v=|\/v\/|youtu.be\/|\/embed\/)/);
    // console.log(url);
    if (url[2] !== undefined) {
      id = url[2].split(/[^0-9a-z-_]/i);
      id = id[0];
    } else {
      id = url;
    }
    // console.log(id);
    return id;
  }
  // this.getCurrentLocation = function(flag, callback) {
    // if (!flag) {
    //   self.showLoading();
    // }
    // var posOptions = {
    //   timeout: 5000,
    //   enableHighAccuracy: false,
    //   maximumAge: 30000
    // };
    // $cordovaGeolocation.getCurrentPosition(posOptions).then(function(position) {
    //   console.log(position);
    //   self.stopLoading();
    //   if (callback) {
    //     return callback(null, position);
    //   }
    // }, function(err) {
    //   self.stopLoading();
    //   console.log("load gps error", err);
    //   return callback(err);
    // });
  // }
  // this.startRequestGPS = function() {
  //   if (!window.cordova) {
  //     return console.log('-- not device ---')
  //   }
  //   var permissions = cordova.plugins.permissions;
  //   permissions.checkPermission(permissions.ACCESS_FINE_LOCATION, function(status) {
  //     if (status.hasPermission) {
  //       self.getCurrentLocation(true, function(err, cord) {
  //         console.log(err, cord);
  //       })
  //     } else {
  //       var list = [permissions.ACCESS_FINE_LOCATION, permissions.ACCESS_COARSE_LOCATION];
  //       permissions.requestPermissions(list, function(status) {
  //         if (status) {
  //           self.getCurrentLocation(function(err, cord) {
  //             console.log(err, cord);
  //           })
  //         } else {
  //           self.showError("请打开存储权限");
  //         }
  //       }, function(error) {
  //         self.showError("请打开存储权限");
  //         console.log("-- Storage Error ---");
  //       });
  //     }
  //   });
  // }
  this.downloadWithNotification = function(url, filename, callback) {
    var permissions = cordova.plugins.permissions;
    permissions.checkPermission(permissions.WRITE_EXTERNAL_STORAGE, function(status) {
      if (status.hasPermission) {
        fileDownloadManager(url, filename, callback);
      } else {
        var list = [permissions.WRITE_EXTERNAL_STORAGE, permissions.READ_EXTERNAL_STORAGE];
        permissions.requestPermissions(list, function(status) {
          if (status) {
            fileDownloadManager(url, filename, callback);
          } else {
            self.showError("请打开存储权限");
          }
        }, function(error) {
          self.showError("请打开存储权限");
          console.log("-- Storage Error ---");
        });
      }
    });
  }

  function fileDownloadManager(url, filename, callback) {
    var Downloader = window.plugins.Downloader;
    if (Downloader) {
      var options = {
        title: filename, // Download Notification Title
        url: url, // File Url
        path: filename, // The File Name with extension
        description: 'File is downloading', // Download description Notification String
        visible: true, // This download is visible and shows in the notifications while in progress and after completion.
        folder: "Download" // Folder to save the downloaded file, if not exist it will be created
      }
      console.log(options);
      Downloader.download(options, function(res) {
        return callback(res);
      }, function(err) {
        self.showError(err);
      });
    } else {
      self.showError('Download Manager Plugin is not Installed');
    }
  }
  this.showDetailPreview = function(_scope, filename, url) {
    var fileExt = $filter('filterFileExt')(filename);
    _scope.fileGroup = '';
    var refurl = null;
    if (fileExt == 'doc' || fileExt == 'docx' || fileExt == 'ppt' || fileExt == 'pptx' || fileExt == 'xls' || fileExt == 'xlsx') {
      refurl = "https://view.officeapps.live.com/op/embed.aspx?src=" + url;
      _scope.fullURL = $sce.trustAsResourceUrl(refurl);
      _scope.fileGroup = 'office';
    } else if (fileExt == 'mp3') {
      refurl = url;
      _scope.fileGroup = 'audio';
    } else if (fileExt == 'mp4' || fileExt == 'flv' || fileExt == 'avi') {
      refurl = url;
      _scope.fileGroup = 'video';
    } else if (fileExt == 'pdf') {
      _scope.fileGroup = 'pdf';
      _scope.pdfUrl = url;
    }
    _scope.fullURL = $sce.trustAsResourceUrl(refurl);
    var _modal;
    $ionicModal.fromTemplateUrl('app/common/preview.html', {
      scope: _scope
    }).then(function(modal) {
      _modal = modal;
      modal.show();
    });

    function hideModel() {
      _modal.hide();
    }
    _scope.closedetailfromservice = function() {
      console.log("----closedetailfromservice------");
      _scope.fullURL = null;
      if (_scope.fileGroup == 'audio' || _scope.fileGroup == 'video') {
        var audio = angular.element('#playAudio');
        console.log(audio);
        audio.remove();
      }
      removeModal();
      hideModel();
    };
    _scope.removemodalcontent = function() {
      removeModal();
    };

    function removeModal() {
      _scope.$on('$destroy', function() {
        _modal.remove();
      });
    }
  }
  this.secondsToHms = function(d) {
    d = Number(d);
    var h = Math.floor(d / 3600);
    var m = Math.floor(d % 3600 / 60);
    var s = Math.floor(d % 3600 % 60);
    var hDisplay = h > 0 ? h + ($translate.instant('hrs')) : "";
    var mDisplay = m > 0 ? m + ($translate.instant('min')) : "";
    var sDisplay = s > 0 ? s + (s == 1 ? ($translate.instant('second')) : ($translate.instant('seconds'))) : "";
    return (hDisplay + mDisplay + sDisplay).replace(/,\s*$/, "");
  };

  this.verifyFacialProfile = function(urlA, urlB) {
    var deferred = $q.defer();
    if(urlA && urlB) {
      /*$http.defaults.useXDomain = true;
      $http({
        url: ApiService.FACIALRECURL,
        method: 'POST',
        headers: {
          'Content-Type': 'application/json'
        },
        withCredentials: true,
        data : {
          urlA : urlA,
          urlB : urlB
        }
      }).then(function(data) {
        console.log(data)
        deferred.resolve(data.data);
      }, function (err) {
        self.showError("Error occured while getting result of facial recognition, please check you netword and try again");
        deferred.reject(err);
      });*/
      deferred.resolve({
        result: 0,
        score: 1
      });
    } else {
      deferred.reject("UrlA and UrlA are required");
    }
    return deferred.promise;
  }
});
