'use strict';
angular.module('bamboo.common').service('departmentBizModel', function(ApiService, $q) {
  var self = this;
  self.getAllDepartment = function() {
    var info = {
      action: "getalldepartments",
    };
    var deferred = $q.defer();
    ApiService.post('/departments', info).then(function(result) {
      console.log(result);
      if (result.data.success) {
        deferred.resolve(result.data.data);
      } else {
        deferred.reject(result);
      }
    });
    return deferred.promise;
  }

  self.getProfile = function() {
    var deferred = $q.defer();
    ApiService.get('/profile/').then(function(res) {
      deferred.resolve(res.data.data);
    }, function(error) {
      deferred.reject(error);
    });
    return deferred.promise;
  };

  self.getMyDepartment = function() {
    var promose1 = self.getAllDepartment();
    var promise2 = self.getProfile();
    var deferred = $q.defer();
    var promise = deferred.promise;
    $q.all([promose1, promise2]).then(function(res) {
      console.log(res);
      var deps = res[0];
      var dids = res[1].dids || [];
      var did = res[1].did;
      if (did) {
        dids.push(did);
      }
      var mydeps = [];
      deps && angular.forEach(deps, function(dep, idx) {
        if (dids.indexOf(dep._id) >= 0) {
          mydeps.push(dep);
        }
      });
      deferred.resolve(mydeps);
    }, function(error) {
      deferred.reject(error);
    });
    return promise;
  }

});