'use strict';
angular.module('bamboo.common').service('MystudyService', function (ApiService, CommonService) {
  // service to get all classes info for current user
  var self = this;
  this.classApi = function (info, callback) {
    ApiService.post('/classes', info).then(function (result) {
      if (result.data.success) {
        callback(result.data.data);
      } else {
        var _err = result.data.error || '' + result.data.info || '';
        CommonService.showError('Class Api Failed : ' + _err);
      }
    })
  };
  this.getMyNotes = function (callback) {
    //log warning if no callback, as the data get below cannnot pass to controller
    if (!callback) {
      console.log('Try to get all notes for current user without callback!');
    }
    var info = {
      action: 'getmynote'
    };
    ApiService.post('/notes', info).then(function (result) {
      if (result.data.success) {
        if (!callback) {
          CommonService.showError('Get user\'s notes success');
          //$state.reload()
        } else {
          callback(result.data.data);
        }
      } else {
        var _err = result.data.error || '' + result.data.info || '';
        CommonService.showError('Update ChapterNotes failed: ' + _err);
      }
    })
  };
  // service to get the current user attent times for exams
  this.getClassInfoForCurrentUser = function (callback) {
    // log warning if no callback
    if (!callback) {
      console.log('Try to get classes info for current user without callback!');
    }
    var _info = {
      action: 'getstudentclasses'
    };
    self.classApi(_info, callback);
  };
  // service to get the current user attent times for test
  this.getTestAttentTimesForCurrentUserByIds = function (testidarray, callback) {
    var info = {
      ids: testidarray,
      action: 'getmyexamteststatus'
    };
    self.ExamApi(info, callback);
  };
  // service to get the current user attent times for exams
  this.getExamAttentTimesForCurrentUserByIds = function (examidarray, callback) {
    var info = {
      ids: examidarray,
      action: 'getmyexamteststatus'
    };
    self.ExamApi(info, callback);
  };
  this.ExamApi = function (info, callback) {
    ApiService.post('/exam', info).then(function (result) {
      if (result.data.success) {
        if (!callback) {
          // since we are getting data, no need to interrupt/inform user
        } else {
          callback(result.data.data);
        }
      } else {
        var _err = result.data.error || '' + result.data.info || '';
        CommonService.showError('Exam Api failed : ' + _err);
      }
    })
  };
  // service to get the current user submitted status for assignment
  this.getAssignmentSubmitStatusForCurrentUserByIds = function (assignmentidarray, callback) {
    var info = {
      ids: assignmentidarray,
      action: 'getmyassignmentstatus'
    };
    self.ExamApi(info, callback);
  }
});
